include _common_.e
include _search_.e
include _debug_.e
include _sequence_.e
include _dll_.e

constant
  LIB_HANDLE=1, FN_HANDLE=2, FN_LIB=3, FN_NAME=4, FN_PARAMS=5, FN_RETURN=6

constant
  LNX64_PATH = "/usr/lib/x86_64-linux-gnu/",
  LNX32_PATH = "/usr/lib/i386-linux-gnu/",
  WIN64_PATH = ".\\",
  WIN32_PATH = ".\\"

sequence EXTERNAL_LIBRARY_DEFINITION
EXTERNAL_LIBRARY_DEFINITION = {
-- L_NAME, L_LNX_64, L_LNX_32, L_WIN_64, L_WIN_32
  {"libc"    , "", "", 0, 0},
  {"curses"  , "libncurses.so"   , "libncurses.so"   , 0, 0},
  {"resolv"  , "libresolv.so"    , "libresolv.so"    , 0, 0},
  {"mysql"   , "libmysql.so"     , "libmysql.so"     , 0, "libmysql.dll"},
  {"sqlite3" , "libsqlite3.so.0" , "libsqlite3.so.0" , 0, "sqlite3.dll"},
  {"libssh2" , "libssh2.so.1"    , "libssh2.so.1"    , 0, "libssh2.dll"},
  {"libcurl" , "libcurl.so.4"    , "libcurl.so.4"    , 0, "libcurl.dll"},
  {"xlswrite", "libxlsxwriter.so", "libxlsxwriter.so", 0, "libxlsxwriter.dll"}
} 

sequence EXTERNAL_ROUTINE_DEFINITION
EXTERNAL_ROUTINE_DEFINITION = {
  {0, 0, "libc"    , "__errno_location", {}, int},
  {0, 0, "libc"    , "ioctl"           , {int, int, int}, int},
  {0, 0, "libc"    , "accept"          , {int, pointer, pointer}, int},
  {0, 0, "libc"    , "bind"            , {int, pointer, int}, int},
  {0, 0, "libc"    , "close"           , {int}, int},
  {0, 0, "libc"    , "connect"         , {int, pointer, int}, int},
  {0, 0, "libc"    , "dup2"            , {int, int}, int},
  {0, 0, "libc"    , "execv"           , {pointer, pointer}, int},
  {0, 0, "libc"    , "fclose"          , {pointer}, int},
  {0, 0, "libc"    , "fcntl"           , {pointer, int, int}, pointer},
  {0, 0, "libc"    , "fgetc"           , {pointer}, int},
  {0, 0, "libc"    , "fopen"           , {pointer, pointer}, pointer},
  {0, 0, "libc"    , "fork"            , {}, int},
  {0, 0, "libc"    , "fputc"           , {int, pointer}, int},
  {0, 0, "libc"    , "fread"           , {pointer, int, int, pointer}, int},
  {0, 0, "libc"    , "freeaddrinfo"    , {pointer} },
  {0, 0, "libc"    , "fwrite"          , {pointer, int, int, pointer}, int},
  {0, 0, "libc"    , "getaddrinfo"     , {pointer, pointer, pointer, pointer},
                                         int},
  {0, 0, "libc"    , "getchar"         , {}, int},
  {0, 0, "libc"    , "gethostbyname"   , {pointer}, pointer},
  {0, 0, "libc"    , "getpeername"     , {int, pointer, pointer}, int},
  {0, 0, "libc"    , "getpwuid"        , {uint}, pointer},
  {0, 0, "libc"    , "getservbyname"   , {pointer, pointer}, pointer},
  {0, 0, "libc"    , "getsockname"     , {int, pointer, pointer}, int},
  {0, 0, "libc"    , "getsockopt"      , {int, int, int, pointer, pointer},
                                         int},
  {0, 0, "libc"    , "getuid"          , {}, uint},
  {0, 0, "libc"    , "htonl"           , {ulong}, ulong},
  {0, 0, "libc"    , "htons"           , {ushort}, ushort},
  {0, 0, "libc"    , "inet_ntoa"       , {pointer}, pointer},
  {0, 0, "libc"    , "inet_aton"       , {pointer,pointer}, int},
  {0, 0, "libc"    , "inet_ntoa"       , {pointer}, pointer},
  {0, 0, "libc"    , "kill"            , {int, int}, int},
  {0, 0, "libc"    , "listen"          , {int, int}, int},
  {0, 0, "libc"    , "mkdir"           , {pointer, int}, int},
  {0, 0, "libc"    , "ntohl"           , {ulong}, ulong},
  {0, 0, "libc"    , "ntohs"           , {ushort}, ushort},
  {0, 0, "libc"    , "perror"          , {pointer} },
  {0, 0, "libc"    , "pipe"            , {pointer}, int},
  {0, 0, "libc"    , "nanosleep"       , {pointer, pointer}, int},
  {0, 0, "libc"    , "pclose"          , {pointer}, int},
  {0, 0, "libc"    , "poll"            , {pointer, uint, int}, int},
  {0, 0, "libc"    , "popen"           , {pointer, pointer}, pointer},
  {0, 0, "libc"    , "printf"          , {pointer} },
  {0, 0, "libc"    , "read"            , {int, pointer, int}, int},
  {0, 0, "libc"    , "recv"            , {int, pointer, int, int}, int},
  {0, 0, "libc"    , "recvfrom"        , {int, pointer, int, int, pointer,
                                          pointer}, int},
  {0, 0, "libc"    , "recvmsg"         , {int, pointer, int}, int},
  {0, 0, "libc"    , "remove"          , {pointer}, long},
  {0, 0, "libc"    , "rename"          , {pointer, pointer}, int},
  {0, 0, "libc"    , "rmdir"           , {pointer}, int},
  {0, 0, "libc"    , "send"            , {int, pointer, int, int}, int},
  {0, 0, "libc"    , "sendmsg"         , {int, pointer, int}, int},
  {0, 0, "libc"    , "sendto"          , {int, pointer, int, int, pointer, int}, int},
  {0, 0, "libc"    , "setsockopt"      , {int, int, int, pointer, int}, int},
  {0, 0, "libc"    , "shmctl"          , {int, int, pointer}, int},
  {0, 0, "libc"    , "shmdt"           , {pointer}, int},
  {0, 0, "libc"    , "shmget"          , {int, uint, int}, int},
  {0, 0, "libc"    , "shutdown"        , {int, int}, int},
  {0, 0, "libc"    , "signal"          , {int, pointer}, pointer},
  {0, 0, "libc"    , "sleep"           , {int}, int},
  {0, 0, "libc"    , "socket"          , {int, int, int}, int},
  {0, 0, "libc"    , "strlen"          , {pointer}, uint},
  {0, 0, "libc"    , "uname"           , {pointer}, uint},
  {0, 0, "libc"    , "unlink"          , {pointer}, int},
  {0, 0, "libc"    , "wait"            , {pointer}, int},
  {0, 0, "libc"    , "waitpid"         , {int, pointer, int}, int},
  {0, 0, "libc"    , "write"           , {int, pointer, int}, int},

  {0, 0, "curses"  , "box",      {pointer, int, int} },
  {0, 0, "curses"  , "cbreak",   {} },
  {0, 0, "curses"  , "delwin",   {pointer} },
  {0, 0, "curses"  , "echo",     {} },
  {0, 0, "curses"  , "endwin",   {} },
  {0, 0, "curses"  , "initscr",  {}, int},
  {0, 0, "curses"  , "mvwaddch", {pointer, int, int, int} },
  {0, 0, "curses"  , "newwin",   {int, int, int, int}, pointer},
  {0, 0, "curses"  , "nl",       {} },
  {0, 0, "curses"  , "nocbreak", {} },
  {0, 0, "curses"  , "noecho",   {} },
  {0, 0, "curses"  , "nonl",     {} },
  {0, 0, "curses"  , "waddch",   {pointer, int} },
  {0, 0, "curses"  , "wborder",  {pointer, int, int, int, int, int, int, int,
                                  int} },
  {0, 0, "curses"  , "wgetch",   {pointer}, int},
  {0, 0, "curses"  , "wrefresh", {pointer} },

  {0, 0, "resolv"  , "res_query", {pointer, int, int, pointer, int}, int},
  {0, 0, "resolv"  , "dn_expand", {pointer, pointer, pointer, pointer, int},
                                  int},

                                  {0, 0, "mysql"   , "mysql_init",               {pointer}, pointer},
  {0, 0, "mysql"   , "mysql_real_connect",       {pointer, pointer, pointer,
                                                  pointer, pointer, uint,
                                                  pointer, ulong}, pointer},
  {0, 0, "mysql"   , "mysql_close",              {pointer}},
  {0, 0, "mysql"   , "mysql_error",              {pointer}, pointer},
  {0, 0, "mysql"   , "mysql_errno",              {pointer}, int},
  {0, 0, "mysql"   , "mysql_real_query",         {pointer, pointer, ulong},
                                                 int},
  {0, 0, "mysql"   , "mysql_field_count",        {pointer}, uint},
  {0, 0, "mysql"   , "mysql_use_result",         {pointer}, pointer},
  {0, 0, "mysql"   , "mysql_free_result",        {pointer}},
  {0, 0, "mysql"   , "mysql_fetch_row",          {pointer}, pointer},
  {0, 0, "mysql"   , "mysql_num_fields",         {pointer}, uint},
  {0, 0, "mysql"   , "mysql_fetch_lengths",      {pointer}, pointer},
  {0, 0, "mysql"   , "mysql_insert_id",          {pointer}, ulong},
  {0, 0, "mysql"   , "mysql_fetch_field_direct", {pointer, int}, pointer},
  {0, 0, "mysql"   , "mysql_affected_rows",      {pointer}, int},

  {0, 0, "sqlite3" , "+sqlite3_errmsg",            {pointer}, pointer},
  {0, 0, "sqlite3" , "+sqlite3_free",              {pointer} },
  {0, 0, "sqlite3" , "+sqlite3_open",              {pointer, pointer}, int},
  {0, 0, "sqlite3" , "+sqlite3_close",             {pointer} },
  {0, 0, "sqlite3" , "+sqlite3_exec",              {pointer, pointer, pointer,
                                                    pointer, pointer}, int},
  {0, 0, "sqlite3" , "+sqlite3_free_table",        {pointer} },
  {0, 0, "sqlite3" , "+sqlite3_get_table",         {pointer, pointer, pointer,
                                                    int, int, pointer}, int},
  {0, 0, "sqlite3" , "+sqlite3_libversion",        {}, pointer},
  {0, 0, "sqlite3" , "+sqlite3_prepare",           {pointer, pointer, int,
                                                    pointer, pointer}, int},
  {0, 0, "sqlite3" , "+sqlite3_step",              {pointer}, int},
  {0, 0, "sqlite3" , "+sqlite3_reset",             {pointer}, int},
  {0, 0, "sqlite3" , "+sqlite3_finalize",          {pointer}, int},
  {0, 0, "sqlite3" , "+sqlite3_bind_int",          {pointer, int, int}, int},
  {0, 0, "sqlite3" , "+sqlite3_bind_double",       {pointer, int, double}, int},
  {0, 0, "sqlite3" , "+sqlite3_bind_text",         {pointer, int, pointer, int,
                                                    pointer}, int},
  {0, 0, "sqlite3" , "+sqlite3_bind_blob",         {pointer, int, pointer, int,
                                                    pointer}, int},
  {0, 0, "sqlite3" , "+sqlite3_column_int",        {pointer, int}, int},
  {0, 0, "sqlite3" , "+sqlite3_column_bytes",      {pointer, int}, pointer},
  {0, 0, "sqlite3" , "+sqlite3_column_text",       {pointer, int}, pointer},
  {0, 0, "sqlite3" , "+sqlite3_column_blob",       {pointer, int}, pointer},
  {0, 0, "sqlite3" , "+sqlite3_last_insert_rowid", {pointer}, int},

  {0, 0, "libssh2" , "+libssh2_agent_connect",         {pointer}, int},
  {0, 0, "libssh2" , "+libssh2_agent_disconnect",      {pointer}, int},
  {0, 0, "libssh2" , "+libssh2_agent_get_identity",    {pointer} },
  {0, 0, "libssh2" , "+libssh2_agent_init",            {pointer}, pointer},
  {0, 0, "libssh2" , "+libssh2_agent_list_identities", {pointer}, int},
  {0, 0, "libssh2" , "+libssh2_agent_userauth",        {pointer} },
  {0, 0, "libssh2" , "+libssh2_banner_set",            {pointer, pointer}, int},
  {0, 0, "libssh2" , "+libssh2_base64_decode",         {pointer, pointer,
                                                        pointer, pointer, uint},
                                                        int},
  {0, 0, "libssh2" , "+libssh2_channel_close",         {pointer}, int},
  {0, 0, "libssh2" , "+libssh2_channel_direct_tcpip_ex",
                                                       {pointer, pointer, int,
                                                        pointer, int}, pointer},
  {0, 0, "libssh2" , "+libssh2_channel_eof",           {pointer}, int},
  {0, 0, "libssh2" , "+libssh2_channel_exec",          {pointer, pointer}, int},
  {0, 0, "libssh2" , "+libssh2_channel_flush_ex",      {pointer, int}, int},
  {0, 0, "libssh2" , "+libssh2_channel_forward_accept",{pointer}, pointer},
  {0, 0, "libssh2" , "+libssh2_channel_forward_cancel",{pointer}, int},
  {0, 0, "libssh2" , "+libssh2_channel_forward_listen_ex",
                                                       {pointer, pointer, int,
                                                        pointer, int}, pointer},
  {0, 0, "libssh2" , "+libssh2_channel_free",          {pointer}, int},
  {0, 0, "libssh2" , "+libssh2_channel_get_exit_status",
                                                       {pointer}, int},
-- libssh2_channel_get_exit_signal,
  {0, 0, "libssh2" , "+libssh2_channel_handle_extended_data2",
                                                       {pointer, int}, int},
  {0, 0, "libssh2" , "+libssh2_channel_open_ex",       {pointer, pointer, uint,
                                                        uint, uint, pointer,
                                                        uint}, pointer},
  {0, 0, "libssh2" , "+libssh2_channel_open_session",  {pointer}, pointer},
  {0, 0, "libssh2" , "+libssh2_channel_process_startup",
                                                       {pointer, pointer, uint,
                                                        pointer, uint}, int},
  {0, 0, "libssh2" , "+libssh2_channel_read_ex",       {pointer, int, pointer,
                                                        size_t}, int},
  {0, 0, "libssh2" , "+libssh2_channel_receive_window_adjust",
                                                       {pointer, long,
                                                        byte}, long},
  {0, 0, "libssh2" , "+libssh2_channel_receive_window_adjust2",
                                                       {pointer, long, byte,
                                                        pointer}, int},
  {0, 0, "libssh2" , "+libssh2_channel_request_pty_ex",
                                                       {pointer, pointer, uint,
                                                        pointer, uint, int, int,
                                                        int, int}, int},
  {0, 0, "libssh2" , "+libssh2_channel_request_pty_size_ex",
                                                       {pointer, int, int, int,
                                                        int}, int},
  {0, 0, "libssh2" , "+libssh2_channel_send_eof",      {pointer}, int},
  {0, 0, "libssh2" , "+libssh2_channel_setenv_ex",     {pointer, pointer, uint,
                                                        pointer, uint}, int},
  {0, 0, "libssh2" , "+libssh2_channel_set_blocking",  {pointer, uint}},
  {0, 0, "libssh2" , "+libssh2_channel_shell",         {pointer}, int},
  {0, 0, "libssh2" , "+libssh2_channel_subsystem",     {pointer, pointer}, int},
  {0, 0, "libssh2" , "+libssh2_channel_wait_closed",   {pointer}, int},
  {0, 0, "libssh2" , "+libssh2_channel_wait_eof",      {pointer}, int},
  {0, 0, "libssh2" , "+libssh2_channel_window_read_ex",{pointer, pointer,
                                                        pointer}, ulong},
  {0, 0, "libssh2" , "+libssh2_channel_window_write_ex",
                                                       {pointer, pointer},
                                                        ulong},
  {0, 0, "libssh2" , "+libssh2_channel_write_ex",      {pointer, int, pointer,
                                                        ulong}, int},
  {0, 0, "libssh2" , "+libssh2_channel_x11_req_ex",    {pointer, int, pointer,
                                                        pointer, int}, int},
  {0, 0, "libssh2" , "+libssh2_exit",                  {} },
  {0, 0, "libssh2" , "+libssh2_free",                  {pointer, pointer} },
  {0, 0, "libssh2" , "+libssh2_hostkey_hash",          {pointer, int}, pointer},
  {0, 0, "libssh2" , "+libssh2_init",                  {int}, int},
  {0, 0, "libssh2" , "+libssh2_keepalive_send",        {pointer, pointer}, int},
  {0, 0, "libssh2" , "+libssh2_knownhost_add",         {pointer, pointer,
                                                        pointer, pointer,
                                                        size_t, int, pointer},
                                                        int},
  {0, 0, "libssh2" , "+libssh2_knownhost_addc",        {pointer, pointer,
                                                        pointer, pointer,
                                                        size_t, pointer,
                                                        size_t, int, pointer},
                                                        int},
  {0, 0, "libssh2" , "+libssh2_knownhost_check",       {pointer, pointer,
                                                        pointer, size_t, int,
                                                        pointer}, int},
  {0, 0, "libssh2" , "+libssh2_knownhost_checkp",      {pointer, pointer, int,
                                                        pointer, size_t, int,
                                                        pointer}, int},
  {0, 0, "libssh2" , "+libssh2_knownhost_del",         {pointer, pointer}, int},
  {0, 0, "libssh2" , "+libssh2_knownhost_get",         {pointer, pointer,
                                                        pointer}, int},
  {0, 0, "libssh2" , "+libssh2_knownhost_init",        {pointer}, pointer},
  {0, 0, "libssh2" , "+libssh2_knownhost_readfile",    {pointer, pointer, int},
                                                        int},
  {0, 0, "libssh2" , "+libssh2_knownhost_readline",    {pointer, pointer,
                                                        size_t, int}, int},
  {0, 0, "libssh2" , "+libssh2_knownhost_writefile",   {pointer, pointer,
                                                        int}, int},
  {0, 0, "libssh2" , "+libssh2_knownhost_writeline",   {pointer, pointer,
                                                        pointer, size_t,
                                                        pointer, int}, int},
  {0, 0, "libssh2" , "+libssh2_poll",                  {pointer, uint, long},
                                                        int},
  {0, 0, "libssh2" , "+libssh2_poll_channel_read",     {pointer, int}, int},
-- libssh2_publickey_add_ex
-- libssh2_publickey_init,
-- libssh2_publickey_list_fetch,
-- libssh2_publickey_list_free,
-- libssh2_publickey_remove_ex
-- libssh2_publickey_shutdown,
  {0, 0, "libssh2" , "+libssh2_scp_recv",              {pointer, pointer,
                                                        pointer}, pointer},
  {0, 0, "libssh2" , "+libssh2_scp_send64",            {pointer, pointer, int,
                                                        uint64, time_t, time_t},
                                                        pointer},
  {0, 0, "libssh2" , "+libssh2_scp_send_ex",           {pointer, pointer, int,
                                                        size_t, long, long},
                                                        pointer},
  {0, 0, "libssh2" , "+libssh2_session_block_directions",
                                                       {pointer}, int},
  {0, 0, "libssh2" , "+libssh2_session_callback_set",  {pointer, int, pointer},
                                                        pointer},
  {0, 0, "libssh2" , "+libssh2_session_disconnect_ex", {pointer, int, pointer,
                                                        pointer}, int},
  {0, 0, "libssh2" , "+libssh2_session_flag",          {pointer, int, int},
                                                        int},
  {0, 0, "libssh2" , "+libssh2_session_free",          {pointer}, int},
  {0, 0, "libssh2" , "+libssh2_session_get_blocking",  {pointer}, int},
  {0, 0, "libssh2" , "+libssh2_session_handshake",     {pointer, pointer}, int},
  {0, 0, "libssh2" , "+libssh2_session_get_timeout",   {pointer}, long},
  {0, 0, "libssh2" , "+libssh2_session_hostkey",       {pointer, pointer,
                                                        pointer}, pointer},
  {0, 0, "libssh2" , "+libssh2_session_init_ex",       {pointer, pointer,
                                                        pointer, pointer},
                                                        pointer},
  {0, 0, "libssh2" , "+libssh2_session_last_errno",    {pointer}, int},
  {0, 0, "libssh2" , "+libssh2_session_last_error",    {pointer, pointer,
                                                        pointer, int}, int},
  {0, 0, "libssh2" , "+libssh2_session_method_pref",   {pointer, int, pointer},
                                                        int},
  {0, 0, "libssh2" , "+libssh2_session_methods",       {pointer, int}, pointer},
  {0, 0, "libssh2" , "+libssh2_session_set_blocking",  {pointer, int} },
  {0, 0, "libssh2" , "+libssh2_session_set_timeout",   {pointer, long} },
  {0, 0, "libssh2" , "+libssh2_session_startup",       {pointer, int}, int},
-- libssh2_sftp_close_handle",
-- libssh2_sftp_fstat_ex",
-- libssh2_sftp_fstatvfs",
-- libssh2_sftp_init",
-- libssh2_sftp_last_error",
-- libssh2_sftp_mkdir_ex",
-- libssh2_sftp_open_ex",
-- libssh2_sftp_read",
-- libssh2_sftp_readdir_ex",
-- libssh2_sftp_rename_ex",
-- libssh2_sftp_rmdir_ex",
-- libssh2_sftp_seek",
-- libssh2_sftp_seek64",
-- libssh2_sftp_shutdown",
-- libssh2_sftp_stat_ex",
-- libssh2_sftp_statvfs",
-- libssh2_sftp_symlink_ex",
-- libssh2_sftp_tell",
-- libssh2_sftp_tell64",
-- libssh2_sftp_unlink_ex",
-- libssh2_sftp_write",
  {0, 0, "libssh2" , "+libssh2_trace",                 {pointer, int}, int},
  {0, 0, "libssh2" , "+libssh2_trace_sethandler",      {pointer, pointer,
                                                        pointer}, int},
  {0, 0, "libssh2" , "+libssh2_userauth_authenticated",{pointer}, int},
  {0, 0, "libssh2" , "+libssh2_userauth_hostbased_fromfile_ex",
                                                       {pointer, pointer, uint,
                                                        pointer, pointer,
                                                        pointer, pointer, uint,
                                                        pointer, uint}, int},
  {0, 0, "libssh2" , "+libssh2_userauth_keyboard_interactive_ex",
                                                       {pointer, pointer, uint,
                                                        pointer}, int},
  {0, 0, "libssh2" , "+libssh2_userauth_list",         {pointer, pointer, uint},
                                                        pointer},
  {0, 0, "libssh2" , "+libssh2_userauth_password_ex",  {pointer, pointer, uint,
                                                        pointer, uint, pointer},
                                                        int},
  {0, 0, "libssh2" , "+libssh2_userauth_publickey",    {pointer, pointer,
                                                        pointer, pointer,
                                                        pointer, pointer}, int},
  {0, 0, "libssh2" , "+libssh2_userauth_publickey_fromfile_ex",
                                                       {pointer, pointer, uint,
                                                        pointer, pointer,
                                                        pointer}, int},
  {0, 0, "libssh2" , "+libssh2_version",               {int}, pointer},
  {0, 0, "libssh2" , "+libssh2_publickey_init",        {pointer}, pointer},
  {0, 0, "libssh2" , "+libssh2_publickey_add_ex",      {pointer, pointer, ulong,
                                                        pointer, ulong, char,
                                                        ulong, pointer}, int},
  {0, 0, "libssh2" , "+libssh2_publickey_remove_ex",   {pointer, pointer, ulong,
                                                        pointer, ulong}, int},
  {0, 0, "libssh2" , "+libssh2_publickey_list_fetch",  {pointer, pointer,
                                                        pointer}, int},
  {0, 0, "libssh2" , "+libssh2_publickey_list_free",   {pointer, pointer} },
  {0, 0, "libssh2" , "+libssh2_publickey_shutdown",    {pointer}, int},

  {0, 0, "libcurl" , "+curl_strequal",        {pointer, pointer}, int},
  {0, 0, "libcurl" , "+curl_strnequal",       {pointer, pointer, size_t}, int},
  {0, 0, "libcurl" , "+curl_formadd",         {pointer, pointer, pointer}, int},
  {0, 0, "libcurl" , "+curl_formget",         {pointer, pointer, pointer}, int},
  {0, 0, "libcurl" , "+curl_formfree",        {pointer} },
  {0, 0, "libcurl" , "+curl_getenv",          {pointer}, pointer},
  {0, 0, "libcurl" , "+curl_version",         {}, pointer},
  {0, 0, "libcurl" , "+curl_easy_escape",     {pointer, pointer, int}, pointer},
  {0, 0, "libcurl" , "+curl_escape",          {pointer, int}, pointer},
  {0, 0, "libcurl" , "+curl_easy_unescape",   {pointer, pointer, int, pointer},
                                               pointer},
  {0, 0, "libcurl" , "+curl_unescape",        {pointer, int}, pointer},
  {0, 0, "libcurl" , "+curl_free",            {pointer} },
  {0, 0, "libcurl" , "+curl_global_init",     {long}, int},
  {0, 0, "libcurl" , "+curl_global_init_mem", {long, pointer, pointer, pointer,
                                               pointer, pointer}, int},
  {0, 0, "libcurl" , "+curl_global_cleanup",  {} },
  {0, 0, "libcurl" , "+curl_slist_append",    {pointer, pointer}, pointer},
  {0, 0, "libcurl" , "+curl_slist_free_all",  {pointer} },
  {0, 0, "libcurl" , "+curl_getdate",         {pointer, pointer}, time_t},
  {0, 0, "libcurl" , "+curl_version_info",    {pointer}, pointer},
  {0, 0, "libcurl" , "+curl_easy_strerror",   {int}, pointer},
  {0, 0, "libcurl" , "+curl_easy_pause",      {pointer, int}, int},
  {0, 0, "libcurl" , "+curl_easy_init",       {}, pointer},
  {0, 0, "libcurl" , "+curl_easy_setopt",     {pointer, int, pointer}, int},
  {0, 0, "libcurl" , "+curl_easy_perform",    {pointer}, int},
  {0, 0, "libcurl" , "+curl_easy_cleanup",    {pointer} },
  {0, 0, "libcurl" , "+curl_easy_getinfo",    {pointer, int, pointer}, int},
  {0, 0, "libcurl" , "+curl_easy_duphandle",  {pointer}, pointer},
  {0, 0, "libcurl" , "+curl_easy_reset",      {pointer} },
  {0, 0, "libcurl" , "+curl_easy_recv",       {pointer, pointer, size_t,
                                               pointer}, int},
  {0, 0, "libcurl" , "+curl_easy_send",       {pointer, pointer, size_t,
                                               pointer}, int},

  {0, 0, "xlswrite", "+format_set_align",         {pointer, uint8} },
  {0, 0, "xlswrite", "+format_set_bg_color",      {pointer, int32} },
  {0, 0, "xlswrite", "+format_set_bold",          {pointer} },
  {0, 0, "xlswrite", "+format_set_border",        {pointer, uint8} },
  {0, 0, "xlswrite", "+format_set_border_color",  {pointer, int32} },
  {0, 0, "xlswrite", "+format_set_bottom",        {pointer, uint8} },
  {0, 0, "xlswrite", "+format_set_bottom_color",  {pointer, int32} },
  {0, 0, "xlswrite", "+format_set_diag_border",   {pointer, uint8} },
  {0, 0, "xlswrite", "+format_set_diag_color",    {pointer, int32} },
  {0, 0, "xlswrite", "+format_set_diag_type",     {pointer, uint8} },
  {0, 0, "xlswrite", "+format_set_fg_color",      {pointer, int32} },
  {0, 0, "xlswrite", "+format_set_font_charset",  {pointer, uint8} },
  {0, 0, "xlswrite", "+format_set_font_color",    {pointer, int32} },
  {0, 0, "xlswrite", "+format_set_font_condense", {pointer} },
  {0, 0, "xlswrite", "+format_set_font_extend",   {pointer} },
  {0, 0, "xlswrite", "+format_set_font_family",   {pointer, uint8} },
  {0, 0, "xlswrite", "+format_set_font_name",     {pointer, pointer} },
  {0, 0, "xlswrite", "+format_set_font_outline",  {pointer} },
  {0, 0, "xlswrite", "+format_set_font_scheme",   {pointer, pointer} },
  {0, 0, "xlswrite", "+format_set_font_script",   {pointer, uint8} },
  {0, 0, "xlswrite", "+format_set_font_shadow",   {pointer} },
  {0, 0, "xlswrite", "+format_set_font_size",     {pointer, int16} },
  {0, 0, "xlswrite", "+format_set_font_strikeout",{pointer} },
  {0, 0, "xlswrite", "+format_set_hidden",        {pointer} },
  {0, 0, "xlswrite", "+format_set_indent",        {pointer, char} },
  {0, 0, "xlswrite", "+format_set_italic",        {pointer} },
  {0, 0, "xlswrite", "+format_set_left",          {pointer, uint8} },
  {0, 0, "xlswrite", "+format_set_left_color",    {pointer, int32} },
  {0, 0, "xlswrite", "+format_set_num_format",    {pointer, pointer} },
  {0, 0, "xlswrite", "+format_set_num_format_index",
                                                  {pointer, uint8} },
  {0, 0, "xlswrite", "+format_set_pattern",       {pointer, uint8} },
  {0, 0, "xlswrite", "+format_set_reading_order", {pointer, uint8} },
  {0, 0, "xlswrite", "+format_set_right",         {pointer, uint8} },
  {0, 0, "xlswrite", "+format_set_right_color",   {pointer, int32} },
  {0, 0, "xlswrite", "+format_set_rotation",      {pointer, short} },
  {0, 0, "xlswrite", "+format_set_shrink",        {pointer} },
  {0, 0, "xlswrite", "+format_set_text_wrap",     {pointer} },
  {0, 0, "xlswrite", "+format_set_theme",         {pointer, uint8} },
  {0, 0, "xlswrite", "+format_set_top",           {pointer, uint8} },
  {0, 0, "xlswrite", "+format_set_top_color",     {pointer, int32} },
  {0, 0, "xlswrite", "+format_set_underline",     {pointer, uint8} },
  {0, 0, "xlswrite", "+format_set_unlocked",      {pointer} },
  {0, 0, "xlswrite", "+lxw_get_col",              {pointer}, uint32 },
  {0, 0, "xlswrite", "+lxw_get_col_2",            {pointer}, uint32 },
  {0, 0, "xlswrite", "+lxw_get_row",              {pointer}, int16 },
  {0, 0, "xlswrite", "+lxw_get_row_2",            {pointer}, int16 },
  {0, 0, "xlswrite", "+lxw_quote_sheetname",      {pointer}, pointer },
  {0, 0, "xlswrite", "+new_workbook",             {pointer}, pointer },
  {0, 0, "xlswrite", "+new_workbook_opt",         {pointer, pointer}, pointer },
  {0, 0, "xlswrite", "+workbook_add_format",      {pointer}, pointer },
  {0, 0, "xlswrite", "+workbook_add_worksheet",   {pointer, pointer}, pointer },
  {0, 0, "xlswrite", "+workbook_close",           {pointer}, uint8 },
  {0, 0, "xlswrite", "+workbook_define_name",     {pointer, pointer, pointer},
                                                   uint8 },
  {0, 0, "xlswrite", "+worksheet_activate",       {pointer} },
  {0, 0, "xlswrite", "+worksheet_autofilter",     {pointer, uint32, int16,
                                                   uint32, int16}, char },
  {0, 0, "xlswrite", "+worksheet_center_horizontally",
                                                  {pointer} },
  {0, 0, "xlswrite", "+worksheet_center_vertically",
                                                  {pointer} },
  {0, 0, "xlswrite", "+worksheet_fit_to_pages",   {pointer, int16, int16} },
  {0, 0, "xlswrite", "+worksheet_gridlines",      {pointer, uint8} },
  {0, 0, "xlswrite", "+worksheet_merge_range",    {pointer, uint32, int16,
                                                   uint32, int16, pointer,
                                                   pointer}, char },
  {0, 0, "xlswrite", "+worksheet_print_across",   {pointer} },
  {0, 0, "xlswrite", "+worksheet_print_area",     {pointer, uint32, int16,
                                                   uint32, int16}, uint8 },
  {0, 0, "xlswrite", "+worksheet_print_row_col_headers",
                                                  {pointer} },
  {0, 0, "xlswrite", "+worksheet_repeat_columns", {pointer, int16, int16},
                                                   uint8 },
  {0, 0, "xlswrite", "+worksheet_repeat_rows",    {pointer, uint32, uint32},
                                                   uint8 },
  {0, 0, "xlswrite", "+worksheet_select",         {pointer} },
  {0, 0, "xlswrite", "+worksheet_set_column",     {pointer, int16, int16,
                                                   double, pointer, pointer},
                                                   char },
  {0, 0, "xlswrite", "+worksheet_set_footer",     {pointer, pointer}, uint8 },
  {0, 0, "xlswrite", "+worksheet_set_footer_opt", {pointer, pointer}, uint8 },
  {0, 0, "xlswrite", "+worksheet_set_h_pagebreaks",
                                                  {pointer, pointer} },
  {0, 0, "xlswrite", "+worksheet_set_header",     {pointer, pointer}, uint8 },
  {0, 0, "xlswrite", "+worksheet_set_header_opt", {pointer, pointer}, uint8 },
  {0, 0, "xlswrite", "+worksheet_set_landscape",  {pointer} },
  {0, 0, "xlswrite", "+worksheet_set_margins",    {pointer, double, double,
                                                   double, double} },
  {0, 0, "xlswrite", "+worksheet_set_page_view",  {pointer} },
  {0, 0, "xlswrite", "+worksheet_set_paper",      {pointer, uint8} },
  {0, 0, "xlswrite", "+worksheet_set_portrait",   {pointer} },
  {0, 0, "xlswrite", "+worksheet_set_print_scale",{pointer, int16} },
  {0, 0, "xlswrite", "+worksheet_set_row",        {pointer, uint32, double,
                                                   pointer, pointer}, char },
  {0, 0, "xlswrite", "+worksheet_set_start_page", {pointer, int16} },
  {0, 0, "xlswrite", "+worksheet_set_v_pagebreaks",
                                                  {pointer, pointer} },
  {0, 0, "xlswrite", "+worksheet_write_array_formula",
                                                  {pointer, uint32, int16,
                                                   uint32, int16, pointer,
                                                   pointer}, char },
  {0, 0, "xlswrite", "+worksheet_write_blank",    {pointer, uint32, int16,
                                                   pointer}, char },
  {0, 0, "xlswrite", "+worksheet_write_datetime", {pointer, uint32, int16,
                                                   pointer, pointer}, char },
  {0, 0, "xlswrite", "+worksheet_write_formula",  {pointer, uint32, int16,
                                                   pointer, pointer}, char },
  {0, 0, "xlswrite", "+worksheet_write_number",   {pointer, uint32, int16,
                                                   double, pointer}, char },
  {0, 0, "xlswrite", "+worksheet_write_string",   {pointer, uint32, int16,
                                                   pointer, pointer}, char },
  {0, 0, "xlswrite", "+worksheet_write_url",      {pointer, uint32, int16,
                                                   pointer, pointer}, char },
  {0, 0, "xlswrite", "+worksheet_write_url_opt",  {pointer, uint32, int16,
                                                   pointer, pointer, pointer,
                                                   pointer}, char }
} 

-----------------------------------------------------------------------------

function identify_library(sequence path, integer level, integer n, object x)
--  log_printf("  path: '%s', level: %d, n: %d, x: %s\n", {path, level, n, object_dump(x)})
  if level = 0 then
    if n = 1 then return "L_NAME"
    elsif n = 2 then return "L_LNX_64"
    elsif n = 3 then return "L_LNX_32"
    elsif n = 4 then return "L_WIN_64"
    elsif n = 5 then return "L_WIN_32"
    end if
  end if
  return sprintf("%d",n)
end function

-----------------------------------------------------------------------------

global function register_library(sequence name)
--<function>
--<name>register_library</name>
--<digest></digest>
--<desc>
--</desc>
--<param>
--<type>sequence</type>
--<name>name</name>
--<desc></desc>
--</param>
--<param>
--<type>sequence</type>
--<name>library_definition</name>
--<desc></desc>
--</param>
--<return>
--</return>
--<example>
-- libcurl = register_library("libcurl")
--</example>
--<see_also>
--</see_also>
--</function>
  integer l
  atom handle
  sequence lib
  object filename
  
  handle = -1
  filename = 0
  l = find_in_array(name, EXTERNAL_LIBRARY_DEFINITION, { {"search_field", L_NAME} })
  if l = 0 then
    error_message(sprintf("There is no library named %s!", {name}), 1)
  end if
  lib = EXTERNAL_LIBRARY_DEFINITION[l]
--  analyze_object(lib,
--                  sprintf("EXTERNAL_LIBRARY_DEFINITION[%d]", l),
--                  {
--                    {"translator", routine_id("identify_library")}
--                  }
--                )
--  printf(1, "eu_version = %d\n", {eu_version})
  if eu_version = EU_4_1_LNX_64 then
    if atom(lib[L_LNX_64]) then
      error_message(sprintf("No %s library defined for %s!\n", {name, eu_version_name()}), 1)
    end if
    if length(filename) then filename = LNX64_PATH & lib[L_LNX_64] end if
  elsif find(eu_version, {EU_4_1_LNX_32, EU_4_0_LNX, EU_3_1_LNX}) then
    if atom(lib[L_LNX_32]) then
      error_message(sprintf("No %s library defined for %s!\n", {name, eu_version_name()}), 1)
    end if
    if length(filename) then filename = LNX32_PATH & lib[L_LNX_32] end if
  elsif eu_version = EU_4_1_WIN_64 then
    if atom(lib[L_WIN_64]) then
      error_message(sprintf("No %s library defined for %s!\n", {name, eu_version_name()}), 1)
    end if
    filename = WIN64_PATH & lib[L_WIN_64]
  elsif find(eu_version, {EU_4_1_WIN_32, EU_4_0_WIN, EU_3_1_WIN}) then
    if atom(lib[L_WIN_32]) then
      error_message(sprintf("No %s library defined for %s!\n", {name, eu_version_name()}), 1)
    end if
    filename = WIN32_PATH & lib[L_WIN_32]
  end if
  handle = open_dll(filename)
  if handle = 0 then
    error_message(sprintf("The library %s could not be opened!\n", {filename}), 1)
  end if
  log_printf("Library file = %s\n", {filename})
  log_printf("Library handle = #%08x\n", {handle})
  return handle
end function

-----------------------------------------------------------------------------

function identify_routine(sequence path, integer level, integer n, object x)
--  log_printf("  path: '%s', level: %d, n: %d, x: %s\n", {path, level, n, object_dump(x)})
  if level = 0 then
    if n = 1 then return "FN_NAME"
    elsif n = 2 then return "F_LIB"
    elsif n = 3 then return "FN_PARAMS"
    elsif n = 4 then return "FN_RETURN"
    end if
  end if
  return sprintf("%d",n)
end function

-----------------------------------------------------------------------------

function register_routine(sequence name)
  sequence s, errmsg, rtn
  integer r
  atom handle

  handle = -1
  r = find_in_array(name, EXTERNAL_ROUTINE_DEFINITION, { {"search_field", FN_NAME} })
  if r = 0 then
    error_message(sprintf("There is no function named %s!", {name}), 1)
  end if
  rtn = EXTERNAL_ROUTINE_DEFINITION[r]
  if not rtn[LIB_HANDLE] then
    rtn[LIB_HANDLE] = register_library(rtn[FN_LIB])
    for i = 1 to length(EXTERNAL_ROUTINE_DEFINITION) do
      if equal(EXTERNAL_ROUTINE_DEFINITION[i][FN_LIB], name) then
        EXTERNAL_ROUTINE_DEFINITION[i][LIB_HANDLE] = handle
      end if
    end for
  end if
  analyze_object(rtn, "rtn", {{"output", f_debug}})
  errmsg = {}
  s = {}
  if equal(rtn[FN_PARAMS],{{}}) then
    rtn[FN_PARAMS] = {}
  end if
--  log_printf("lib = %d\n", rtn[LIB_HANDLE])
  if length(rtn) < FN_RETURN then
    -- log_printf("link_c_proc(%d, \"%s\", %s)\n", {rtn[LIB_HANDLE], name, hex_sequence(convert_c_sequence(rtn[FN_PARAMS]))})
    handle = link_c_proc(rtn[LIB_HANDLE], name, convert_c_sequence(rtn[FN_PARAMS]))
  else
    -- log_printf("link_c_func(%d, \"%s\", %s, #%x)\n", {rtn[LIB_HANDLE], name, hex_sequence(convert_c_sequence(rtn[FN_PARAMS])), convert_c_type(rtn[FN_RETURN])})
    handle = link_c_func(rtn[LIB_HANDLE], name, convert_c_sequence(rtn[FN_PARAMS]), convert_c_type(rtn[FN_RETURN]))
  end if
  if handle = -1 then
    errmsg &= sprintf("\nThe routine %s using %s failed !"&
          "\n\nIf you have recently added this routine to the"&
          " definition list then verify that"&
          "\nthe parameters, definition format, and DLL name are"&
          " all correct."&
          "\n\nCheck if the correct DLL is available on this system."&
          "\n\nCheck if the name requires any Ex, A, or W modifier.",
          {rtn[FN_NAME], rtn[LIB_HANDLE]})
    errmsg &= "\n\n-- This routine definition is expecting the following"&
          " parameters :\n\n"
    if length(rtn[FN_PARAMS]) then
      s = vlookup(rtn[FN_PARAMS][1], CTYPE_NAMES, 1, 2, "?")
      errmsg &= s
      for i = 2 to length(rtn[FN_PARAMS]) do
        s = vlookup(rtn[FN_PARAMS][i], CTYPE_NAMES, 1, 2, "?")
        errmsg &= ", " & s
      end for
    else
      errmsg &= "    -- No Parameters --"
    end if
    if length(rtn < FN_RETURN) then
      errmsg &= "\n\n-- This function definition's return value is : "
      s = vlookup(rtn[FN_RETURN], CTYPE_NAMES, 1, 2, "?")
      errmsg &= s
    else
      errmsg &= " No Return Value"
    end if
    errmsg &= "\n\n"
    error_message(errmsg, 1)
  end if
--  log_printf("Function handle = #%08x\n", {handle})
  EXTERNAL_ROUTINE_DEFINITION[r][FN_HANDLE] = handle
  return r
end function

--------------------------------------------------------------------------------

global function exec_func(integer fn_num, sequence params, sequence fn_name)
--<function>
--<name>exec_func</name>
--<digest></digest>
--<desc>
--</desc>
--<param>
--<type>integer</type>
--<name>fn_num</name>
--<desc></desc>
--</param>
--<param>
--<type>sequence</type>
--<name>params</name>
--<desc></desc>
--</param>
--<param>
--<type>sequence</type>
--<name>fn_name</name>
--<desc></desc>
--</param>
--<return>
--</return>
--<example>
--</example>
--<see_also>
--</see_also>
--</function>
  if not fn_num then
    fn_num = register_routine(fn_name)
  end if
  return c_func(EXTERNAL_ROUTINE_DEFINITION[fn_num][FN_HANDLE], params)
end function

--------------------------------------------------------------------------------

global procedure exec_proc(integer fn_num, sequence params, sequence fn_name)
--<procedure>
--<name>exec_proc</name>
--<digest></digest>
--<desc>
--</desc>
--<param>
--<type>integer</type>
--<name>fn_num</name>
--<desc></desc>
--</param>
--<param>
--<type>sequence</type>
--<name>params</name>
--<desc></desc>
--</param>
--<param>
--<type>sequence</type>
--<name>fn_name</name>
--<desc></desc>
--</param>
--<example>
--</example>
--<see_also>
--</see_also>
--</procedure>
  if not fn_num then
    fn_num = register_routine(fn_name)
  end if
  c_proc(EXTERNAL_ROUTINE_DEFINITION[fn_num][FN_HANDLE], params)
end procedure

