--
-- Copyright (C) 2009,2010 by Jeremy Cowgar <jeremy@cowgar.com>
--
-- This file is extracted from edbi. It has been slightly modified by
-- Jean-Marc Duro <jean-marc.duro@orange.fr>.
--
-- edbi is free software: you can redistribute it and/or modify
-- it under the terms of the GNU Lesser General Public License as
-- published by the Free Software Foundation, either version 3 of
-- the License, or (at your option) any later version.
--
-- edbi is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU Lesser General Public
-- License along with edbi.  If not, see <http://www.gnu.org/licenses/>.
--

include dll.e
include machine.e
include _common_.e
include _machine_.e
include _external_.e

global constant
  MYSQL_TYPE_DECIMAL     =   0,
  MYSQL_TYPE_TINY        =   1,
  MYSQL_TYPE_SHORT       =   2,
  MYSQL_TYPE_LONG        =   3,
  MYSQL_TYPE_FLOAT       =   4,
  MYSQL_TYPE_DOUBLE      =   5,
  MYSQL_TYPE_NULL        =   6,
  MYSQL_TYPE_TIMESTAMP   =   7,
  MYSQL_TYPE_LONGLONG    =   8,
  MYSQL_TYPE_INT24       =   9,
  MYSQL_TYPE_DATE        =  10,
  MYSQL_TYPE_TIME        =  11,
  MYSQL_TYPE_DATETIME    =  12,
  MYSQL_TYPE_YEAR        =  13,
  MYSQL_TYPE_NEWDATE     =  14,
  MYSQL_TYPE_VARCHAR     =  15,
  MYSQL_TYPE_BIT         =  16,
  MYSQL_TYPE_TIMESTAMP2  =  17,
  MYSQL_TYPE_DATETIME2   =  18,
  MYSQL_TYPE_TIME2       =  19,
  MYSQL_TYPE_JSON        = 245,
  MYSQL_TYPE_NEWDECIMAL  = 246,
  MYSQL_TYPE_ENUM        = 247,
  MYSQL_TYPE_SET         = 248,
  MYSQL_TYPE_TINY_BLOB   = 249,
  MYSQL_TYPE_MEDIUM_BLOB = 250,
  MYSQL_TYPE_LONG_BLOB   = 251,
  MYSQL_TYPE_BLOB        = 252,
  MYSQL_TYPE_VAR_STRING  = 253,
  MYSQL_TYPE_STRING      = 254,
  MYSQL_TYPE_GEOMETRY    = 255
--<constant>
--<name>MYSQL_TYPE_DECIMAL</name>
--<value>0</value>
--<desc></desc>
--</constant>
--<constant>
--<name>MYSQL_TYPE_TINY</name>
--<value>1</value>
--<desc></desc>
--</constant>
--<constant>
--<name>MYSQL_TYPE_SHORT</name>
--<value>2</value>
--<desc></desc>
--</constant>
--<constant>
--<name>MYSQL_TYPE_LONG</name>
--<value>3</value>
--<desc></desc>
--</constant>
--<constant>
--<name>MYSQL_TYPE_FLOAT</name>
--<value>4</value>
--<desc></desc>
--</constant>
--<constant>
--<name>MYSQL_TYPE_DOUBLE</name>
--<value>5</value>
--<desc></desc>
--</constant>
--<constant>
--<name>MYSQL_TYPE_NULL</name>
--<value>6</value>
--<desc></desc>
--</constant>
--<constant>
--<name>MYSQL_TYPE_TIMESTAMP</name>
--<value>7</value>
--<desc></desc>
--</constant>
--<constant>
--<name>MYSQL_TYPE_LONGLONG</name>
--<value>8</value>
--<desc></desc>
--</constant>
--<constant>
--<name>MYSQL_TYPE_INT24</name>
--<value>9</value>
--<desc></desc>
--</constant>
--<constant>
--<name>MYSQL_TYPE_DATE</name>
--<value>10</value>
--<desc></desc>
--</constant>
--<constant>
--<name>MYSQL_TYPE_TIME</name>
--<value>11</value>
--<desc></desc>
--</constant>
--<constant>
--<name>MYSQL_TYPE_DATETIME</name>
--<value>12</value>
--<desc></desc>
--</constant>
--<constant>
--<name>MYSQL_TYPE_YEAR</name>
--<value>13</value>
--<desc></desc>
--</constant>
--<constant>
--<name>MYSQL_TYPE_NEWDATE</name>
--<value>14</value>
--<desc></desc>
--</constant>
--<constant>
--<name>MYSQL_TYPE_VARCHAR</name>
--<value>15</value>
--<desc></desc>
--</constant>
--<constant>
--<name>MYSQL_TYPE_BIT</name>
--<value>16</value>
--<desc></desc>
--</constant>
--<constant>
--<name>MYSQL_TYPE_TIMESTAMP2</name>
--<value>17</value>
--<desc></desc>
--</constant>
--<constant>
--<name>MYSQL_TYPE_DATETIME2</name>
--<value>18</value>
--<desc></desc>
--</constant>
--<constant>
--<name>MYSQL_TYPE_TIME2</name>
--<value>19</value>
--<desc></desc>
--</constant>
--<constant>
--<name>MYSQL_TYPE_JSON</name>
--<value>245</value>
--<desc></desc>
--</constant>
--<constant>
--<name>MYSQL_TYPE_NEWDECIMAL</name>
--<value>246</value>
--<desc></desc>
--</constant>
--<constant>
--<name>MYSQL_TYPE_ENUM</name>
--<value>247</value>
--<desc></desc>
--</constant>
--<constant>
--<name>MYSQL_TYPE_SET</name>
--<value>248</value>
--<desc></desc>
--</constant>
--<constant>
--<name>MYSQL_TYPE_TINY_BLOB</name>
--<value>249</value>
--<desc></desc>
--</constant>
--<constant>
--<name>MYSQL_TYPE_MEDIUM_BLOB</name>
--<value>250</value>
--<desc></desc>
--</constant>
--<constant>
--<name>MYSQL_TYPE_LONG_BLOB</name>
--<value>251</value>
--<desc></desc>
--</constant>
--<constant>
--<name>MYSQL_TYPE_BLOB</name>
--<value>252</value>
--<desc></desc>
--</constant>
--<constant>
--<name>MYSQL_TYPE_VAR_STRING</name>
--<value>253</value>
--<desc></desc>
--</constant>
--<constant>
--<name>MYSQL_TYPE_STRING</name>
--<value>254</value>
--<desc></desc>
--</constant>
--<constant>
--<name>MYSQL_TYPE_GEOMETRY</name>
--<value>255</value>
--<desc></desc>
--</constant>

--------------------------------------------------------------------------------

integer h_mysql_init
h_mysql_init = 0

function mysql_init(atom dbh)
  return exec_func(h_mysql_init, {dbh}, "mysql_init")
end function

--------------------------------------------------------------------------------

integer h_mysql_real_connect
h_mysql_real_connect = 0

global function mysql_open(object host, sequence user, object passwd, object db,
                             integer port)
--<function>
--<name>mysql_open</name>
--<digest>Attempts to establish a connection to a MySQL database engine running on host.</digest>
--<desc>
--</desc>
--<param>
--<type>object</type>
--<name>host</name>
--<desc></desc>
--</param>
--<param>
--<type>sequence</type>
--<name>user</name>
--<desc></desc>
--</param>
--<param>
--<type>object</type>
--<name>passwd</name>
--<desc></desc>
--</param>
--<param>
--<type>object</type>
--<name>db</name>
--<desc></desc>
--</param>
--<param>
--<type>integer</type>
--<name>port</name>
--<desc></desc>
--</param>
--<return>
--</return>
--<example>
--</example>
--<see_also>
--</see_also>
--</function>
  atom socket, dbh, p_mysql, p_user, p_passwd, p_db
  integer flags

  socket = 0
  flags = 0

  if port = 0 then port = 3306 end if

  if sequence(host) then
    host = allocate_string(host)
  end if

  p_user = allocate_string(user)

  if sequence(passwd) then
    p_passwd = allocate_string(passwd)
  end if

  if sequence(db) then
    p_db = allocate_string(db)
  end if

  dbh = mysql_init(0)
  p_mysql = exec_func(h_mysql_real_connect, {dbh, host, p_user, p_passwd, p_db,
                      port, socket, flags}, "mysql_real_connect")

  free(host)
  free(p_user)
  if p_passwd then free(p_passwd) end if
  if p_db then free(p_db)end if
  if socket then free(socket) end if

  return p_mysql
end function

--------------------------------------------------------------------------------

integer h_mysql_close
h_mysql_close = 0

global procedure mysql_close(atom dbh)
--<procedure>
--<name>mysql_close</name>
--<digest>Closes a previously opened connection.</digest>
--<desc>
--</desc>
--<param>
--<type>atom</type>
--<name>dbh</name>
--<desc></desc>
--</param>
--<example>
--</example>
--<see_also>
--</see_also>
--</procedure>
  exec_proc(h_mysql_close, {dbh}, "mysql_close")
end procedure

--------------------------------------------------------------------------------

integer h_mysql_errno
h_mysql_errno = 0

global function mysql_error_code(atom dbh)
--<function>
--<name>mysql_error_code</name>
--<digest>Returns the error code for the most recently invoked API function that can succeed or fail.</digest>
--<desc>
--</desc>
--<param>
--<type>atom</type>
--<name>dbh</name>
--<desc></desc>
--</param>
--<return>
-- An error code value for the last mysql_xxx() call, if it failed.
-- zero means no error occurred.
--</return>
--<example>
--</example>
--<see_also>
--</see_also>
--</function>
  return exec_func(h_mysql_errno, {dbh}, "mysql_errno")
end function

--------------------------------------------------------------------------------

integer h_mysql_error
h_mysql_error = 0

global function mysql_error_message(atom dbh)
--<function>
--<name>mysql_error_message</name>
--<digest>Returns a null-terminated string containing the error message for the most recently invoked API function that failed.</digest>
--<desc>
--</desc>
--<param>
--<type>atom</type>
--<name>dbh</name>
--<desc></desc>
--</param>
--<return>
--</return>
--<example>
--</example>
--<see_also>
--</see_also>
--</function>
  sequence message
  atom p_error

  message = ""
  p_error = exec_func(h_mysql_error, {dbh}, "mysql_error")
  if p_error != NULL then
    -- Memory is free'd by MySQL when connection is closed
    message = peek_string(p_error)
  end if
  return message
end function

--------------------------------------------------------------------------------

integer h_mysql_insert_id
h_mysql_insert_id = 0

global function mysql_last_insert_id(atom dbh, sequence seq_name)
--<function>
--<name>mysql_last_insert_id</name>
--<digest>Returns the value generated for an AUTO_INCREMENT column by the previous INSERT or UPDATE statement.</digest>
--<desc>
--</desc>
--<param>
--<type>atom</type>
--<name>dbh</name>
--<desc></desc>
--</param>
--<param>
--<type>sequence</type>
--<name>seq_name</name>
--<desc></desc>
--</param>
--<return>
--</return>
--<example>
--</example>
--<see_also>
--</see_also>
--</function>
  seq_name = seq_name -- not used
  return exec_func(h_mysql_insert_id, {dbh}, "mysql_insert_id")
end function

--------------------------------------------------------------------------------

integer h_mysql_field_count
h_mysql_field_count = 0

function mysql_field_count(atom dbh)
  return exec_func(h_mysql_field_count, {dbh}, "mysql_field_count")
end function

--------------------------------------------------------------------------------

integer h_mysql_use_result
h_mysql_use_result = 0

function mysql_use_result(atom dbh)
  return exec_func(h_mysql_use_result, {dbh}, "mysql_use_result")
end function

-- Matt's second update for 64 bit euphoria compatibility
--ifdef BITS32 then
  constant MYSQL_FIELD_type = 76
--elsedef
--  constant MYSQL_FIELD_type = 112
--end ifdef

--------------------------------------------------------------------------------

integer h_mysql_fetch_field_direct
h_mysql_fetch_field_direct = 0

-- Matt's new mysql_fetch_field_direct
function mysql_fetch_field_direct(atom dbr, integer idx) 
  atom p_f
  sequence name
  integer typ

  p_f = exec_func(h_mysql_fetch_field_direct, { dbr, idx }, "mysql_fetch_field_direct")
  name = peek_string(peek_pointer(p_f))
  typ = peek4u(p_f + MYSQL_FIELD_type)
  return { name, typ }
end function 

--------------------------------------------------------------------------------

integer h_mysql_free_result
h_mysql_free_result = 0

global procedure mysql_free_result(atom dbr)
--<procedure>
--<name>mysql_free_result</name>
--<digest>Frees the memory allocated for a result.</digest>
--<desc>
--</desc>
--<param>
--<type>atom</type>
--<name>dbr</name>
--<desc></desc>
--</param>
--<example>
--</example>
--<see_also>
--</see_also>
--</procedure>
  exec_proc(h_mysql_free_result, {dbr}, "mysql_free_result")
end procedure

--------------------------------------------------------------------------------

integer h_mysql_num_fields
h_mysql_num_fields = 0

function mysql_num_fields(atom dbr)
  return exec_func(h_mysql_num_fields, {dbr}, "mysql_num_fields")
end function

--------------------------------------------------------------------------------

integer h_mysql_fetch_lengths
h_mysql_fetch_lengths = 0

function mysql_fetch_lengths(atom dbr)
  return exec_func(h_mysql_fetch_lengths, {dbr}, "mysql_fetch_lengths")
end function

--------------------------------------------------------------------------------

-- Extra routine needed for Matt's update to mysql_next
function peek_longu( object ptr ) 
--  ifdef LONG32 then
    return peek4u( ptr )
--  elsedef
--    return peek8u( ptr )
--  end ifdef
end function 

--------------------------------------------------------------------------------

integer h_mysql_fetch_row
h_mysql_fetch_row = 0

-- Matt's update for mysql_next to work with both 32 and 64 bit euphoria
global function mysql_next(atom dbr, atom row)
--<function>
--<name>mysql_next</name>
--<digest>Retrieves the next row of a result set.</digest>
--<desc>
--</desc>
--<param>
--<type>atom</type>
--<name>dbr</name>
--<desc></desc>
--</param>
--<param>
--<type>atom</type>
--<name>row</name>
--<desc></desc>
--</param>
--<return>
--</return>
--<example>
--</example>
--<see_also>
--</see_also>
--</function>
  atom p_lengths, p_row
  integer field_count, row_offset, len_offset
  object data
 
  p_row = exec_func(h_mysql_fetch_row, {dbr}, "mysql_fetch_row")
  data = {}
  row = row -- not used
 
  if p_row = 0 then return 0 end if
 
  p_lengths = mysql_fetch_lengths(dbr)
  field_count = mysql_num_fields(dbr)
 
  row_offset = 0
  len_offset = 0
  for i = 0 to (field_count - 1) * size_of( pointer ) by size_of( pointer ) do
    data &= {peek({peek_pointer(p_row + row_offset), peek_longu(p_lengths + len_offset)})}
    row_offset += size_of( pointer )
    len_offset += size_of( C_LONG )
  end for
 
  return data
end function 

--------------------------------------------------------------------------------

integer h_mysql_real_query
h_mysql_real_query = 0

global function mysql_execute(atom dbh, sequence sql)
--<function>
--<name>mysql_execute</name>
--<digest>Executes an SQL statement.</digest>
--<desc>
--</desc>
--<param>
--<type>atom</type>
--<name>dbh</name>
--<desc></desc>
--</param>
--<param>
--<type>sequence</type>
--<name>sql</name>
--<desc></desc>
--</param>
--<return>
--</return>
--<example>
--</example>
--<see_also>
--</see_also>
--</function>
  atom p_sql
  integer result

  p_sql = allocate_string(sql)
  result = exec_func(h_mysql_real_query, {dbh, p_sql, length(sql)}, "mysql_real_query")
  free(p_sql)
  return result
end function

--------------------------------------------------------------------------------

integer h_mysql_affected_rows
h_mysql_affected_rows = 0

global function mysql_total_changes(atom dbh)
--<function>
--<name>mysql_total_changes</name>
--<digest></digest>
--<desc>
-- Returns the number of rows changed, deleted, or inserted by the last statement if it was an UPDATE, DELETE, or INSERT.
-- For a SELECT statement, returns the number of rows in the result set.
--</desc>
--<param>
--<type>atom</type>
--<name>dbh</name>
--<desc></desc>
--</param>
--<return>
--</return>
--<example>
--</example>
--<see_also>
--</see_also>
--</function>
  return exec_func(h_mysql_affected_rows, { dbh }, "mysql_affected_rows")
end function

--------------------------------------------------------------------------------

global function mysql_query(atom dbh, sequence sql)
--<function>
--<name>mysql_query</name>
--<digest>Executes an SQL statement and returns a resultset with fields description.</digest>
--<desc>
--</desc>
--<param>
--<type>atom</type>
--<name>dbh</name>
--<desc></desc>
--</param>
--<param>
--<type>sequence</type>
--<name>sql</name>
--<desc></desc>
--</param>
--<return>
-- sequence {dbr, fields} on success or integer zero on failure
--</return>
--<example>
--</example>
--<see_also>
--</see_also>
--</function>
  integer q_result
  atom dbr
  sequence fdata
  object f

  q_result = mysql_execute(dbh, sql)
  if not q_result = 0 then return 0 end if

  dbr = mysql_use_result(dbh)
  fdata = repeat(0, mysql_num_fields(dbr))

  for i = 1 to length(fdata) do
    f = mysql_fetch_field_direct(dbr, i - 1)
    fdata[i] = f
  end for

  return { dbr, fdata }
end function

--------------------------------------------------------------------------------

global function mysql_query_rows(atom dbh, sequence sql)
--<function>
--<name>mysql_query_rows</name>
--<digest>Executes an SQL statement and returns fields description and records.</digest>
--<desc>
--</desc>
--<param>
--<type>atom</type>
--<name>dbh</name>
--<desc></desc>
--</param>
--<param>
--<type>sequence</type>
--<name>sql</name>
--<desc></desc>
--</param>
--<return>
-- object: sequence {fields, records} on success or
-- integer error code on failure
--</return>
--<example>
--</example>
--<see_also>
--</see_also>
--</function>
  sequence fields, records, s
  object o
  atom dbr
  
  s = mysql_query(dbh, sql)
  dbr = s[1]
  if mysql_error_code(dbh) then
    return mysql_error_code(dbh)
  end if

  fields = s[2]
  records = {}

  while 1 do
    o = mysql_next(dbr, 0)
    if atom(o) then exit end if
    records &= { o }
  end while

  mysql_free_result(dbr)

  return {fields, records}
end function
