-- _types_.e

include _common_.e

global constant
  -- basic C types
  int8         = #01000001,  --	 C_CHAR
  int16        = #01000002,  --	 C_SHORT
  int32        = #01000004,  --	 C_INT, C_LONG
  int64        = #01000008,
  uint8        = #02000001,  --	 C_UCHAR
  uint16       = #02000002,  --	 C_USHORT
  uint32       = #02000004,  --	 C_UINT, C_ULONG, C_POINTER
  uint64       = #02000008,
  pointer      = #03000001,
  long_pointer = #03000002,
  float        = #03000004,  --	 C_FLOAT
  double       = #03000008,  --	 C_DOUBLE
  bool         = int32,
  -- extended C types
  Bool = bool, byte = uint8, char = uint8, char16 = uint16, char16_t = uint16,
  char32 = uint32, char32_t = uint32, double_t = double, dword = uint32,
  dwordlong = uint64, float_t = float, int = int32, int8_t = int8,
  int16_t = int16, int32_t = int32, int64_t = int64, intptr = pointer,
  intptr_t = pointer, long = int32, long_double = pointer, long_int = int32,
  long_long = int64, long_long_int = int64, longlong = int64,
  ptrdiff_t = pointer, short = int16, short_int = int16, signed = int32,
  signed_char = int8, signed_int = int32, signed_long = int32,
  signed_long_int = int32, signed_long_long = int64,
  signed_long_long_int = int64, signed_short = int16, signed_short_int = int16,
  size_t = pointer, ssize_t = pointer, uint8_t = uint8, uint16_t = uint16,
  uint32_t = uint32, uint64_t = uint64, uintptr = pointer, uintptr_t = pointer,
  ulonglong = uint64, unsigned = uint32, unsigned_char = uint8,
  unsigned_int = uint32, unsigned_long = uint32, unsigned_long_int = uint32,
  unsigned_long_long = uint64, unsigned_long_long_int = uint64,
  unsigned_short = uint16, unsigned_short_int = uint16,
  wchar = uint16, wchar_t = uint16, word = uint16, time_t = pointer,
  uint = uint32, ulong = uint32, ushort = uint16, ubyte = uint8, uchar = uint8,
  half_ptr = int16, uhalf_ptr = uint16
--<constant>
--<name>int8</name>
--<value>#01000001</value>
--<desc></desc>
--</constant>
--<constant>
--<name>int16</name>
--<value>#01000002</value>
--<desc></desc>
--</constant>
--<constant>
--<name>int32</name>
--<value>#01000004</value>
--<desc></desc>
--</constant>
--<constant>
--<name>int64</name>
--<value>#01000008</value>
--<desc></desc>
--</constant>
--<constant>
--<name>uint8</name>
--<value>#02000001</value>
--<desc></desc>
--</constant>
--<constant>
--<name>uint16</name>
--<value>#02000002</value>
--<desc></desc>
--</constant>
--<constant>
--<name>uint32</name>
--<value>#02000004</value>
--<desc></desc>
--</constant>
--<constant>
--<name>uint64</name>
--<value>#02000008</value>
--<desc></desc>
--</constant>
--<constant>
--<name>pointer</name>
--<value>#03000001</value>
--<desc></desc>
--</constant>
--<constant>
--<name>long_pointer</name>
--<value>#03000002</value>
--<desc></desc>
--</constant>
--<constant>
--<name>float</name>
--<value>#03000004</value>
--<desc></desc>
--</constant>
--<constant>
--<name>double</name>
--<value>#03000008</value>
--<desc></desc>
--</constant>
--<constant>
--<name>bool</name>
--<value>int32</value>
--<desc></desc>
--</constant>
--<constant>
--<name>Bool</name>
--<value>bool</value>
--<desc></desc>
--</constant>
--<constant>
--<name>byte</name>
--<value>uint8</value>
--<desc></desc>
--</constant>
--<constant>
--<name>char</name>
--<value>uint8</value>
--<desc></desc>
--</constant>
--<constant>
--<name>char16</name>
--<value>uint16</value>
--<desc></desc>
--</constant>
--<constant>
--<name>char16_t</name>
--<value>uint16</value>
--<desc></desc>
--</constant>
--<constant>
--<name>char32</name>
--<value>uint32</value>
--<desc></desc>
--</constant>
--<constant>
--<name>char32_t</name>
--<value>uint32</value>
--<desc></desc>
--</constant>
--<constant>
--<name>double_t</name>
--<value>double</value>
--<desc></desc>
--</constant>
--<constant>
--<name>dword</name>
--<value>uint32</value>
--<desc></desc>
--</constant>
--<constant>
--<name>dwordlong</name>
--<value>uint64</value>
--<desc></desc>
--</constant>
--<constant>
--<name>float_t</name>
--<value>float</value>
--<desc></desc>
--</constant>
--<constant>
--<name>int</name>
--<value>int32</value>
--<desc></desc>
--</constant>
--<constant>
--<name>int8_t</name>
--<value>int8</value>
--<desc></desc>
--</constant>
--<constant>
--<name>int16_t</name>
--<value>int16</value>
--<desc></desc>
--</constant>
--<constant>
--<name>int32_t</name>
--<value>int32</value>
--<desc></desc>
--</constant>
--<constant>
--<name>int64_t</name>
--<value>int64</value>
--<desc></desc>
--</constant>
--<constant>
--<name>intptr</name>
--<value>pointer</value>
--<desc></desc>
--</constant>
--<constant>
--<name>intptr_t</name>
--<value>pointer</value>
--<desc></desc>
--</constant>
--<constant>
--<name>long</name>
--<value>int32</value>
--<desc></desc>
--</constant>
--<constant>
--<name>long_double</name>
--<value>pointer</value>
--<desc></desc>
--</constant>
--<constant>
--<name>long_int</name>
--<value>int32</value>
--<desc></desc>
--</constant>
--<constant>
--<name>long_long</name>
--<value>int64</value>
--<desc></desc>
--</constant>
--<constant>
--<name>long_long_int</name>
--<value>int64</value>
--<desc></desc>
--</constant>
--<constant>
--<name>longlong</name>
--<value>int64</value>
--<desc></desc>
--</constant>
--<constant>
--<name>ptrdiff_t</name>
--<value>pointer</value>
--<desc></desc>
--</constant>
--<constant>
--<name>short</name>
--<value>int16</value>
--<desc></desc>
--</constant>
--<constant>
--<name>short_int</name>
--<value>int16</value>
--<desc></desc>
--</constant>
--<constant>
--<name>signed</name>
--<value>int32</value>
--<desc></desc>
--</constant>
--<constant>
--<name>signed_char</name>
--<value>int8</value>
--<desc></desc>
--</constant>
--<constant>
--<name>signed_int</name>
--<value>int32</value>
--<desc></desc>
--</constant>
--<constant>
--<name>signed_long</name>
--<value>int32</value>
--<desc></desc>
--</constant>
--<constant>
--<name>signed_long_int</name>
--<value>int32</value>
--<desc></desc>
--</constant>
--<constant>
--<name>signed_long_long</name>
--<value>int64</value>
--<desc></desc>
--</constant>
--<constant>
--<name>signed_long_long_int</name>
--<value>int64</value>
--<desc></desc>
--</constant>
--<constant>
--<name>signed_short</name>
--<value>int16</value>
--<desc></desc>
--</constant>
--<constant>
--<name>signed_short_int</name>
--<value>int16</value>
--<desc></desc>
--</constant>
--<constant>
--<name>size_t</name>
--<value>pointer</value>
--<desc></desc>
--</constant>
--<constant>
--<name>ssize_t</name>
--<value>pointer</value>
--<desc></desc>
--</constant>
--<constant>
--<name>ubyte</name>
--<value>uint8</value>
--<desc></desc>
--</constant>
--<constant>
--<name>uchar</name>
--<value>uint8</value>
--<desc></desc>
--</constant>
--<constant>
--<name>uint</name>
--<value>uint32</value>
--<desc></desc>
--</constant>
--<constant>
--<name>uint8_t</name>
--<value>uint8</value>
--<desc></desc>
--</constant>
--<constant>
--<name>uint16_t</name>
--<value>uint16</value>
--<desc></desc>
--</constant>
--<constant>
--<name>uint32_t</name>
--<value>uint32</value>
--<desc></desc>
--</constant>
--<constant>
--<name>uint64_t</name>
--<value>uint64</value>
--<desc></desc>
--</constant>
--<constant>
--<name>uintptr</name>
--<value>pointer</value>
--<desc></desc>
--</constant>
--<constant>
--<name>uintptr_t</name>
--<value>pointer</value>
--<desc></desc>
--</constant>
--<constant>
--<name>ulong</name>
--<value>uint32</value>
--<desc></desc>
--</constant>
--<constant>
--<name>ulonglong</name>
--<value>uint64</value>
--<desc></desc>
--</constant>
--<constant>
--<name>ushort</name>
--<value>uint16</value>
--<desc></desc>
--</constant>
--<constant>
--<name>unsigned</name>
--<value>uint32</value>
--<desc></desc>
--</constant>
--<constant>
--<name>unsigned_char</name>
--<value>uint8</value>
--<desc></desc>
--</constant>
--<constant>
--<name>unsigned_int</name>
--<value>uint32</value>
--<desc></desc>
--</constant>
--<constant>
--<name>unsigned_long</name>
--<value>uint32</value>
--<desc></desc>
--</constant>
--<constant>
--<name>unsigned_long_int</name>
--<value>uint32</value>
--<desc></desc>
--</constant>
--<constant>
--<name>unsigned_long_long</name>
--<value>uint64</value>
--<desc></desc>
--</constant>
--<constant>
--<name>unsigned_long_long_int</name>
--<value>uint64</value>
--<desc></desc>
--</constant>
--<constant>
--<name>unsigned_short</name>
--<value>uint16</value>
--<desc></desc>
--</constant>
--<constant>
--<name>unsigned_short_int</name>
--<value>uint16</value>
--<desc></desc>
--</constant>
--<constant>
--<name>wchar</name>
--<value>uint16</value>
--<desc></desc>
--</constant>
--<constant>
--<name>wchar_t</name>
--<value>uint16</value>
--<desc></desc>
--</constant>
--<constant>
--<name>word</name>
--<value>uint16</value>
--<desc></desc>
--</constant>
--<constant>
--<name>time_t</name>
--<value>pointer</value>
--<desc></desc>
--</constant>
--<constant>
--<name>half_ptr</name>
--<value>int16</value>
--<desc></desc>
--</constant>
--<constant>
--<name>uhalf_ptr</name>
--<value>uint16</value>
--<desc></desc>
--</constant>

global constant CTYPE_NAMES = {
--<constant>
--<name>CTYPE_NAMES</name>
--<value>{</value>
--<desc></desc>
--</constant>
  {Bool                  , "_Bool"},
  {bool                  , "bool"},
  {byte                  , "byte"},
  {char                  , "char"},
  {char16                , "char16"},
  {char16_t              , "char16_t"},
  {char32                , "char32"},
  {char32_t              , "char32_t"},
  {double                , "double"},
  {double_t              , "double_t"},
  {dword                 , "dword"},
  {dwordlong             , "dwordlong"},
  {float                 , "float"},
  {float_t               , "float_t"},
  {half_ptr              , "half_ptr"},
  {int                   , "int"},
  {int8                  , "int8"},
  {int8_t                , "int8_t"},
  {int16                 , "int16"},
  {int16_t               , "int16_t"},
  {int32                 , "int32"},
  {int32_t               , "int32_t"},
  {int64                 , "int64"},
  {int64_t               , "int64_t"},
  {intptr                , "intptr"},
  {intptr_t              , "intptr_t"},
  {long                  , "long"},
  {long_double           , "long double"},
  {long_int              , "long int"},
  {long_long             , "long long"},
  {long_long_int         , "long long int"},
  {longlong              , "longlong"},
  {pointer               , "pointer"},
  {ptrdiff_t             , "ptrdiff_t"},
  {short                 , "short"},
  {short_int             , "short int"},
  {signed                , "signed"},
  {signed_char           , "signed char"},
  {signed_int            , "signed int"},
  {signed_long           , "signed long"},
  {signed_long_int       , "signed long int"},
  {signed_long_long      , "signed long long"},
  {signed_long_long_int  , "signed long long int"},
  {signed_short          , "signed short"},
  {signed_short_int      , "signed short int"},
  {size_t                , "size_t"},
  {ssize_t               , "ssize_t"},
  {time_t                , "time_t"},
  {ubyte                 , "ubyte"},
  {uchar                 , "uchar"},
  {uhalf_ptr             , "uhalf_ptr"},
  {uint                  , "uint"},
  {uint8                 , "uint8"},
  {uint8_t               , "uint8_t"},
  {uint16                , "uint16"},
  {uint16_t              , "uint16_t"},
  {uint32                , "uint32"},
  {uint32_t              , "uint32_t"},
  {uint64                , "uint64"},
  {uint64_t              , "uint64_t"},
  {uintptr               , "uintptr"},
  {uintptr_t             , "uintptr_t"},
  {ulong                 , "ulong"},
  {ulonglong             , "ulonglong"},
  {unsigned              , "unsigned"},
  {unsigned_char         , "unsigned char"},
  {unsigned_int          , "unsigned int"},
  {unsigned_long         , "unsigned long"},
  {unsigned_long_int     , "unsigned long int"},
  {unsigned_long_long    , "unsigned long long"},
  {unsigned_long_long_int, "unsigned long long int"},
  {unsigned_short        , "unsigned short"},
  {unsigned_short_int    , "unsigned short int"},
  {ushort                , "ushort"},
  {wchar                 , "wchar"},
  {wchar_t               , "wchar_t"},
  {word                  , "word"}
}

------------------------------------------------------------------------------

global constant
  DIGITS = "0123456789ABCDEF"
--<constant>
--<name>DIGITS</name>
--<value>"0123456789ABCDEF"</value>
--<desc></desc>
--</constant>

------------------------------------------------------------------------------

global type positive(object x)
--<eu_type>
--<name>positive</name>
--<desc>checks if <b>x</b> >=0</desc>
--<param>
--<type>object</type>
--<name>x</name>
--<desc>object to check</desc>
--</param>
--</eu_type>
  if not atom(x) then return 0 end if
  return x>=0
end type

--------------------------------------------------------------------------------

global type is_space(object n)
--<eu_type>
--<name>is_space</name>
--<desc>checks if <b>n</b> is a space, tab, vtab, cr, lf of ff</desc>
--<param>
--<type>object</type>
--<name>n</name>
--<desc>object to check</desc>
--</param>
--</eu_type>
  if not integer(n) then return 0 end if
  return find(n, {32, 10, 9, 11, 12, 13})
end type

--------------------------------------------------------------------------------

global type is_alpha(object n)
--<eu_type>
--<name>is_alpha</name>
--<desc>checks if <b>n</b> is within [a-z] or [A-Z]</desc>
--<param>
--<type>object</type>
--<name>n</name>
--<desc>object to check</desc>
--</param>
--</eu_type>
  if not integer(n) then return 0 end if
  return ((n >= 'A') and (n <= 'Z')) or
         ((n >= 'a') and (n <= 'z'))
end type

--------------------------------------------------------------------------------

global type is_digit(object n)
--<eu_type>
--<name>is_digit</name>
--<desc>test if <b>n</b> is within [0-9]</desc>
--<param>
--<type>object</type>
--<name>n</name>
--<desc>object to check</desc>
--</param>
--</eu_type>
  if not integer(n) then return 0 end if
  return (n >= '0') and (n <= '9')
end type

------------------------------------------------------------------------------

global type is_string(object x)
--<eu_type>
--<name>is_string</name>
--<desc>checks if <b>x</b> is a string</desc>
--<param>
--<type>object</type>
--<name>x</name>
--<desc>object to check</desc>
--</param>
--</eu_type>
  if atom(x) then return 0 end if
  for i = 1 to length(x) do
    if not integer(x[i]) then return 0 end if
    if (x[i] < ' ') and (x[i] != 9) and (x[i] != 13) and (x[i] != 10) then return 0 end if
    if x[i]> 254 then return 0 end if
  end for
  return 1
end type

------------------------------------------------------------------------------

global type is_integer(object s)
--<eu_type>
--<name>is_integer</name>
--<desc>checks if <b>s</b> represents an integer</desc>
--<param>
--<type>object</type>
--<name>s</name>
--<desc>object to check</desc>
--</param>
--</eu_type>
  integer lg, nb_digits

  if atom(s) then return 0 end if
  lg = length(s)
  nb_digits = 0
  if lg = 0 then return 0 end if
  for i = 1 to lg do
    if sequence(s[i]) then
      return 0
    else
      if is_digit(s[i]) then
        nb_digits += 1
      elsif not find(s[i], "-+") then
        return 0
      end if
    end if
  end for
  if nb_digits = 0 then return 0 else return 1 end if
end type

------------------------------------------------------------------------------

global type is_number(object s)
--<eu_type>
--<name>is_number</name>
--<desc>checks if <b>s</b> represents a number</desc>
--<param>
--<type>object</type>
--<name>s</name>
--<desc>object to check</desc>
--</param>
--</eu_type>
  integer lg, nb_digits

  if atom(s) then return 0 end if
  lg = length(s)
  nb_digits = 0
  if lg = 0 then return 0 end if
  for i = 1 to lg do
    if sequence(s[i]) then
      return 0
    else
      if is_digit(s[i]) then
        nb_digits += 1
      elsif not find(s[i], ",.-+") then
        return 0
      end if
    end if
  end for
  if nb_digits = 0 then return 0 else return 1 end if
end type

------------------------------------------------------------------------------

global type is_date(object s)
--<eu_type>
--<name>is_date</name>
--<desc>
-- checks if <b>s</b> represents a date
-- "[.]./[.]./[..].."
--</desc>
--<param>
--<type>object</type>
--<name>s</name>
--<desc>object to check</desc>
--</param>
--</eu_type>
  integer n, n2

  if atom(s) then return 0 end if
  n = length(s) if (n < 6) or (n > 10) then return 0 end if
  for i = 1 to length(s) do
    if sequence(s[i]) then return 0 end if
    if not is_digit(s[i]) and (s[i] != '/') then return 0 end if
    n = find('/', s) if (n != 2) and (n != 3) then return 0 end if
    n2 = find('/', s[n+1..$]) if (n2 != 2) and (n2 != 3) then return 0 end if
  end for
  return 1
end type

------------------------------------------------------------------------------

global type is_hex(object s)
--<eu_type>
--<name>is_hex</name>
--<desc>checks if <b>s</b> represents a hexadecimal number</desc>
--<param>
--<type>object</type>
--<name>s</name>
--<desc>object to check</desc>
--</param>
--</eu_type>
  integer lg

  if atom(s) then return 0 end if
  lg = length(s)
  if lg < 2 then return 0 end if         -- min 2 cars (#n)
  if s[1] != '#' then return 0 end if
  for i = 2 to lg do
    if sequence(s[i]) then
      return 0
    else
      if not find(s[i], DIGITS) then return 0 end if
    end if
  end for
  return 1
end type

--------------------------------------------------------------------------------

global type is_identifier(object s)
--<eu_type>
--<name>is_identifier</name>
--<desc>
-- checks if <b>s</b> represents an identifier
-- begins with '_' or  [a-z] or [A-Z]
-- contains '_' or  [a-z] or [A-Z] or [0-9]
--</desc>
--<param>
--<type>object</type>
--<name>s</name>
--<desc>object to check</desc>
--</param>
--</eu_type>
  integer lg

  if not is_string(s) then return 0 end if
  lg = length(s)
  if lg = 0 then return 0 end if
  if not is_alpha(s[1]) and (s[1] != '_') then
    return 0
  end if
  for i = 2 to lg do
    if sequence(s[i]) then
      return 0
    else
      if not is_alpha(s[i]) and (s[i] != '_') and not is_digit(s[i]) then
        return 0
      end if
    end if
  end for
  return 1
end type

--------------------------------------------------------------------------------

global function size_of( atom ctype )
--<function>
--<name>size_of</name>
--<digest></digest>
--<desc>
--</desc>
--<param>
--<type>atom</type>
--<name>ctype</name>
--<desc></desc>
--</param>
--<return>
--</return>
--<example>
-- ? size_of(pointer)
--</example>
--<see_also>
--</see_also>
--</function>
  if ctype = #03000001 then
    return address_length
  elsif ctype = #03000002 then  -- T_LONGLONG
    return 8
  else
    return and_bits( ctype, #FF )
  end if
end function

-----------------------------------------------------------------------------

global function convert_c_type(atom ctype)
--<function>
--<name>convert_c_type</name>
--<digest>convert extended C types to basic C types</digest>
--<desc>
--</desc>
--<param>
--<type>atom</type>
--<name>ctype</name>
--<desc></desc>
--</param>
--<return>
--</return>
--<example>
-- ? convert_c_type(uchar)
--</example>
--<see_also>
--</see_also>
--</function>
  if find(eu_version, {EU_4_0_LNX, EU_3_1_LNX, EU_4_0_WIN, EU_3_1_WIN}) then
    if ctype = int64 then
--      log_puts("type int64 converted to int32\n")
      return int32
    elsif (ctype = uint64) or (ctype = pointer) then
--      log_puts("type uint64 converted to uint32\n")
      return uint32
    end if
  end if
  if ctype = long_pointer then
    if find(eu_version, {EU_4_0_LNX, EU_4_0_WIN}) then
--      log_puts("type long_pointer converted to double\n")
      return double
    elsif find(eu_version, {EU_3_1_LNX, EU_3_1_WIN}) then
      return uint32
    end if
  end if
  return ctype
end function

