include dll.e
include machine.e
include misc.e
include _search_.e
include _debug_.e
include _sequence_.e
include _dll_.e

constant LIB_NAME = 1, LIB_FILE = 2

constant LIB_HANDLE = 1, FN_HANDLE = 2, FN_LIB = 3, FN_NAME = 4, FN_PARAMS = 5, FN_RETURN = 6

sequence WINDOWS_LIBRARY_DEFINITION
WINDOWS_LIBRARY_DEFINITION = {
  {"advapi32", "advapi32.dll"}, 
  {"avifil32", "avifil32.dll"}, 
  {"aygshell", "aygshell.dll"}, 
  {"comctl32", "comctl32.dll"}, 
  {"comdlg32", "comdlg32.dll"}, 
  {"crypt32" , "crypt32.dll"}, 
  {"d3d9"    , "directx\\d3d9.dll"}, 
  {"dhcpcsvc", "dhcpcsvc.dll"}, 
  {"dnsapi"  , "dnsapi.dll"}, 
  {"dxerr8"  , "directx\\dxerr8.dll"}, 
  {"dxerr9"  , "directx\\dxerr9.dll"}, 
  {"faultrep", "faultrep.dll"}, 
  {"gdi32"   , "gdi32.dll"}, 
  {"hid"     , "ddk\\hid.dll"}, 
  {"imagehlp", "imagehlp.dll"}, 
  {"iphlpapi", "iphlpapi.dll"}, 
  {"kernel32", "kernel32.dll"}, 
  {"largeint", "largeint.dll"}, 
  {"lmchdev" , "lmchdev.dll"}, 
  {"lz32"    , "lz32.dll"}, 
  {"mprapi"  , "mprapi.dll"}, 
  {"mqrt"    , "mqrt.dll"}, 
  {"msacm32" , "msacm32.dll"}, 
  {"mscms"   , "mscms.dll"},
  {"msimg32" , "msimg32.dll"},
  {"msvfw32" , "msvfw32.dll"}, 
  {"nddeapi" , "nddeapi.dll"}, 
  {"netapi32", "netapi32.dll"}, 
  {"ntdll"   , "ntdll.dll"}, 
  {"ole32"   , "ole32.dll"}, 
  {"oleacc"  , "oleacc.dll"}, 
  {"olecli32", "olecli32.dll"}, 
  {"powrprof", "powrprof.dll"}, 
  {"psapi"   , "psapi.dll"}, 
  {"quartz"  , "quartz.dll"}, 
  {"riched32", "Msftedit.dll"}, -- "riched20.dll", "riched32.dll"
  {"rtm"     , "rtm.dll"}, 
  {"rtutils" , "rtutils.dll"}, 
  {"scrnsave", "scrnsave.dll"}, 
  {"secur32" , "secur32.dll"}, 
  {"setupapi", "setupapi.dll"}, 
  {"shell32" , "shell32.dll"}, 
  {"shlwapi" , "shlwapi.dll"}, 
  {"svrapi"  , "svrapi.dll"}, 
  {"url"     , "url.dll"}, 
  {"user32"  , "user32.dll"}, 
  {"userenv" , "userenv.dll"}, 
  {"usp10"   , "usp10.dll"}, 
  {"uxtheme" , "uxtheme.dll"}, 
  {"version" , "version.dll"}, 
  {"winhttp" , "winhttp.dll"}, 
  {"wininet" , "wininet.dll"}, 
  {"winmm"   , "winmm.dll"}, 
  {"winspool", "winspool.drv"}, 
  {"ws2_32"  , "ws2_32.dll"}, 
  {"wsahelp" , "wsahelp.dll"}, 
  {"wsock32" , "wsock32.dll"}, 
  {"wtsapi32", "wtsapi32.dll"}
} 

sequence WINDOWS_ROUTINE_DEFINITION
WINDOWS_ROUTINE_DEFINITION = {
  {0, 0, "advapi32", "AbortSystemShutdownA", {pointer}, bool}, 
  {0, 0, "advapi32", "AbortSystemShutdownW", {pointer}, bool}, 
  {0, 0, "advapi32", "BuildExplicitAccessWithNameA", {pointer, pointer, dword, pointer, dword}}, 
  {0, 0, "advapi32", "BuildExplicitAccessWithNameW", {pointer, pointer, dword, pointer, dword}}, 
  {0, 0, "advapi32", "BuildImpersonateExplicitAccessWithNameA", {pointer, pointer, pointer, dword, pointer, dword}}, 
  {0, 0, "advapi32", "BuildImpersonateExplicitAccessWithNameW", {pointer, pointer, pointer, dword, pointer, dword}}, 
  {0, 0, "advapi32", "BuildImpersonateTrusteeA", {pointer, pointer}}, 
  {0, 0, "advapi32", "BuildImpersonateTrusteeW", {pointer, pointer}}, 
  {0, 0, "advapi32", "BuildSecurityDescriptorA", {pointer, pointer, ulong, pointer, ulong, pointer, pointer, pointer, pointer}, dword}, 
  {0, 0, "advapi32", "BuildSecurityDescriptorW", {pointer, pointer, ulong, pointer, ulong, pointer, pointer, pointer, pointer}, dword}, 
  {0, 0, "advapi32", "BuildTrusteeWithNameA", {pointer, pointer}}, 
  {0, 0, "advapi32", "BuildTrusteeWithNameW", {pointer, pointer}}, 
  {0, 0, "advapi32", "BuildTrusteeWithObjectsAndNameA", {pointer, pointer, pointer, pointer, pointer, pointer}}, 
  {0, 0, "advapi32", "BuildTrusteeWithObjectsAndNameW", {pointer, pointer, pointer, pointer, pointer, pointer}}, 
  {0, 0, "advapi32", "BuildTrusteeWithObjectsAndSidA", {pointer, pointer, pointer, pointer, pointer}}, 
  {0, 0, "advapi32", "BuildTrusteeWithObjectsAndSidW", {pointer, pointer, pointer, pointer, pointer}}, 
  {0, 0, "advapi32", "BuildTrusteeWithSidA", {pointer, pointer}}, 
  {0, 0, "advapi32", "BuildTrusteeWithSidW", {pointer, pointer}}, 
  {0, 0, "advapi32", "ChangeServiceConfig2A", {pointer, dword, long_pointer}, bool}, 
  {0, 0, "advapi32", "ChangeServiceConfig2W", {pointer, dword, long_pointer}, bool}, 
  {0, 0, "advapi32", "ChangeServiceConfigA", {pointer, dword, dword, dword, pointer, pointer, pointer, pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "advapi32", "ChangeServiceConfigW", {pointer, dword, dword, dword, pointer, pointer, pointer, pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "advapi32", "CloseServiceHandle", {pointer}, bool}, 
  {0, 0, "advapi32", "ControlService", {pointer, dword, long_pointer}, bool}, 
  {0, 0, "advapi32", "ConvertSidToStringSidA", {pointer, pointer}, bool}, 
  {0, 0, "advapi32", "ConvertSidToStringSidW", {pointer, pointer}, bool}, 
  {0, 0, "advapi32", "ConvertStringSidToSidA", {pointer, pointer}, bool}, 
  {0, 0, "advapi32", "ConvertStringSidToSidW", {pointer, pointer}, bool}, 
  {0, 0, "advapi32", "CreateProcessWithLogonW", {pointer, pointer, pointer, dword, pointer , pointer, dword, long_pointer, pointer, long_pointer, long_pointer}, bool}, 
  {0, 0, "advapi32", "CreateServiceA", {pointer, pointer, pointer, dword, dword, dword, dword, pointer, pointer, pointer, pointer, pointer, pointer}, pointer}, 
  {0, 0, "advapi32", "CreateServiceW", {pointer, pointer, pointer, dword, dword, dword, dword, pointer, pointer, pointer, pointer, pointer, pointer}, pointer}, 
-- Following crypting functions are now defined in crypt32
--  {0, 0, "advapi32", "CryptAcquireContextA", {pointer, pointer, pointer, long, uint}, long}, 
--  {0, 0, "advapi32", "CryptGenRandom", {pointer, long, pointer}, uint}, 
--  {0, 0, "advapi32", "CryptReleaseContext", {pointer, uint}, long}, 
  {0, 0, "advapi32", "DeleteService", {pointer}, bool}, 
  {0, 0, "advapi32", "DllMain", {pointer, dword, long_pointer}, bool}, 
  {0, 0, "advapi32", "EnumDependentServicesA", {pointer, dword, long_pointer, dword, pointer, pointer}, bool}, 
  {0, 0, "advapi32", "EnumDependentServicesW", {pointer, dword, long_pointer, dword, pointer, pointer}, bool}, 
  {0, 0, "advapi32", "EnumServicesStatusA", {pointer, dword, dword, long_pointer, dword, pointer, pointer, pointer}, bool}, 
  {0, 0, "advapi32", "EnumServicesStatusExA", {pointer, pointer, dword, dword, pointer, dword, pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "advapi32", "EnumServicesStatusExW", {pointer, pointer, dword, dword, pointer, dword, pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "advapi32", "EnumServicesStatusW", {pointer, dword, dword, long_pointer, dword, pointer, pointer, pointer}, bool}, 
  {0, 0, "advapi32", "GetAuditedPermissionsFromAclA", {pointer, pointer, pointer, pointer}, dword}, 
  {0, 0, "advapi32", "GetAuditedPermissionsFromAclW", {pointer, pointer, pointer, pointer}, dword}, 
  {0, 0, "advapi32", "GetEffectiveRightsFromAclA", {pointer, pointer, pointer}, dword}, 
  {0, 0, "advapi32", "GetEffectiveRightsFromAclW", {pointer, pointer, pointer}, dword}, 
  {0, 0, "advapi32", "GetExplicitEntriesFromAclA", {pointer, pointer, pointer}, dword}, 
  {0, 0, "advapi32", "GetExplicitEntriesFromAclW", {pointer, pointer, pointer}, dword}, 
  {0, 0, "advapi32", "GetInheritanceSourceA", {pointer, pointer, pointer, bool, pointer, dword, pointer, pointer, pointer, pointer}, dword}, 
  {0, 0, "advapi32", "GetInheritanceSourceW", {pointer, pointer, pointer, bool, pointer, dword, pointer, pointer, pointer, pointer}, dword}, 
  {0, 0, "advapi32", "GetMultipleTrusteeA", {pointer}, pointer}, 
  {0, 0, "advapi32", "GetMultipleTrusteeOperationA", {pointer}, pointer}, 
  {0, 0, "advapi32", "GetMultipleTrusteeOperationW", {pointer}, pointer}, 
  {0, 0, "advapi32", "GetMultipleTrusteeW", {pointer}, pointer}, 
  {0, 0, "advapi32", "GetNamedSecurityInfoA", {pointer, pointer, pointer, pointer, pointer, pointer, pointer, pointer}, dword}, 
  {0, 0, "advapi32", "GetNamedSecurityInfoW", {pointer, pointer, pointer, pointer, pointer, pointer, pointer, pointer}, dword}, 
  {0, 0, "advapi32", "GetSecurityInfo", {pointer, pointer, pointer, pointer, pointer, pointer, pointer, pointer}, dword}, 
  {0, 0, "advapi32", "GetServiceDisplayNameA", {pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "advapi32", "GetServiceDisplayNameW", {pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "advapi32", "GetServiceKeyNameA", {pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "advapi32", "GetServiceKeyNameW", {pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "advapi32", "GetTrusteeFormA", {pointer}, pointer}, 
  {0, 0, "advapi32", "GetTrusteeFormW", {pointer}, pointer}, 
  {0, 0, "advapi32", "GetTrusteeNameA", {pointer}, pointer}, 
  {0, 0, "advapi32", "GetTrusteeNameW", {pointer}, pointer}, 
  {0, 0, "advapi32", "GetTrusteeTypeA", {pointer}, pointer}, 
  {0, 0, "advapi32", "GetTrusteeTypeW", {pointer}, pointer}, 
  {0, 0, "advapi32", "GetUserNameA", {pointer, pointer}, int}, 
  {0, 0, "advapi32", "InitiateSystemShutdownA", {pointer, pointer, dword, bool, bool}, bool}, 
  {0, 0, "advapi32", "InitiateSystemShutdownW", {pointer, pointer, dword, bool, bool}, bool}, 
  {0, 0, "advapi32", "LockServiceDatabase", {pointer}, pointer}, 
  {0, 0, "advapi32", "LookupSecurityDescriptorPartsA", {pointer, pointer, pointer, pointer, pointer, pointer, pointer}, dword}, 
  {0, 0, "advapi32", "LookupSecurityDescriptorPartsW", {pointer, pointer, pointer, pointer, pointer, pointer, pointer}, dword}, 
  {0, 0, "advapi32", "NotifyBootConfigStatus", {bool}, bool}, 
  {0, 0, "advapi32", "OpenSCManagerA", {pointer, pointer, dword}, pointer}, 
  {0, 0, "advapi32", "OpenSCManagerW", {pointer, pointer, dword}, pointer}, 
  {0, 0, "advapi32", "OpenServiceA", {pointer, pointer, dword}, pointer}, 
  {0, 0, "advapi32", "OpenServiceW", {pointer, pointer, dword}, pointer}, 
  {0, 0, "advapi32", "QueryServiceConfig2A", {pointer, dword, pointer, dword, pointer}, bool}, 
  {0, 0, "advapi32", "QueryServiceConfig2W", {pointer, dword, pointer, dword, pointer}, bool}, 
  {0, 0, "advapi32", "QueryServiceConfigA", {pointer, long_pointer, dword, pointer}, bool}, 
  {0, 0, "advapi32", "QueryServiceConfigW", {pointer, long_pointer, dword, pointer}, bool}, 
  {0, 0, "advapi32", "QueryServiceLockStatusA", {pointer, long_pointer, dword, pointer}, bool}, 
  {0, 0, "advapi32", "QueryServiceLockStatusW", {pointer, long_pointer, dword, pointer}, bool}, 
  {0, 0, "advapi32", "QueryServiceObjectSecurity", {pointer, pointer, pointer, dword, pointer}, bool}, 
  {0, 0, "advapi32", "QueryServiceStatus", {pointer, long_pointer}, bool}, 
  {0, 0, "advapi32", "QueryServiceStatusEx", {pointer, pointer, pointer, dword, pointer}, bool}, 
  {0, 0, "advapi32", "RegCloseKey", {pointer}, long}, 
  {0, 0, "advapi32", "RegConnectRegistryA", {pointer, pointer, pointer}, long}, 
  {0, 0, "advapi32", "RegConnectRegistryW", {pointer, pointer, pointer}, long}, 
  {0, 0, "advapi32", "RegCreateKeyA", {pointer, pointer, pointer}, long}, 
  {0, 0, "advapi32", "RegCreateKeyExA", {pointer, pointer, dword, pointer, dword, pointer, long_pointer, pointer, pointer}, long}, 
  {0, 0, "advapi32", "RegCreateKeyExW", {pointer, pointer, dword, pointer, dword, pointer, long_pointer, pointer, pointer}, long}, 
  {0, 0, "advapi32", "RegCreateKeyW", {pointer, pointer, pointer}, long}, 
  {0, 0, "advapi32", "RegDeleteKeyA", {pointer, pointer}, long}, 
  {0, 0, "advapi32", "RegDeleteKeyExA", {pointer, pointer, pointer, dword}, long}, 
  {0, 0, "advapi32", "RegDeleteKeyExW", {pointer, pointer, pointer, dword}, long}, 
  {0, 0, "advapi32", "RegDeleteKeyW", {pointer, pointer}, long}, 
  {0, 0, "advapi32", "RegDeleteValueA", {pointer, pointer}, long}, 
  {0, 0, "advapi32", "RegDeleteValueW", {pointer, pointer}, long}, 
  {0, 0, "advapi32", "RegEnumKeyA", {pointer, dword, pointer, dword}, long}, 
  {0, 0, "advapi32", "RegEnumKeyExA", {pointer, dword, pointer, pointer, pointer, pointer, pointer, pointer}, long}, 
  {0, 0, "advapi32", "RegEnumKeyExW", {pointer, dword, pointer, pointer, pointer, pointer, pointer, pointer}, long}, 
  {0, 0, "advapi32", "RegEnumKeyW", {pointer, dword, pointer, dword}, long}, 
  {0, 0, "advapi32", "RegEnumValueA", {pointer, dword, pointer, pointer, pointer, pointer, pointer, pointer}, long}, 
  {0, 0, "advapi32", "RegEnumValueW", {pointer, dword, pointer, pointer, pointer, pointer, pointer, pointer}, long}, 
  {0, 0, "advapi32", "RegFlushKey", {pointer}, long}, 
  {0, 0, "advapi32", "RegGetKeySecurity", {pointer, pointer, pointer, pointer}, long}, 
  {0, 0, "advapi32", "RegisterServiceCtrlHandlerA", {pointer, long_pointer}, pointer}, 
  {0, 0, "advapi32", "RegisterServiceCtrlHandlerExA", {pointer, long_pointer, long_pointer}, pointer}, 
  {0, 0, "advapi32", "RegisterServiceCtrlHandlerExW", {pointer, long_pointer, long_pointer}, pointer}, 
  {0, 0, "advapi32", "RegisterServiceCtrlHandlerW", {pointer, long_pointer}, pointer}, 
  {0, 0, "advapi32", "RegLoadKeyA", {pointer, pointer, pointer}, long}, 
  {0, 0, "advapi32", "RegLoadKeyW", {pointer, pointer, pointer}, long}, 
  {0, 0, "advapi32", "RegNotifyChangeKeyValue", {pointer, bool, dword, pointer, bool}, long}, 
  {0, 0, "advapi32", "RegOpenKeyA", {pointer, pointer, pointer}, long}, 
  {0, 0, "advapi32", "RegOpenKeyExA", {pointer, pointer, dword, pointer, pointer}, long}, 
  {0, 0, "advapi32", "RegOpenKeyExW", {pointer, pointer, dword, pointer, pointer}, long}, 
  {0, 0, "advapi32", "RegOpenKeyW", {pointer, pointer, pointer}, long}, 
  {0, 0, "advapi32", "RegQueryInfoKeyA", {pointer, pointer, pointer, pointer, pointer, pointer, pointer, pointer, pointer, pointer, pointer, pointer}, long}, 
  {0, 0, "advapi32", "RegQueryInfoKeyW", {pointer, pointer, pointer, pointer, pointer, pointer, pointer, pointer, pointer, pointer, pointer, pointer}, long}, 
  {0, 0, "advapi32", "RegQueryMultipleValuesA", {pointer, pointer, dword, pointer, pointer}, long}, 
  {0, 0, "advapi32", "RegQueryMultipleValuesW", {pointer, pointer, dword, pointer, pointer}, long}, 
  {0, 0, "advapi32", "RegQueryValueA", {pointer, pointer, pointer, pointer}, long}, 
  {0, 0, "advapi32", "RegQueryValueExA", {pointer, pointer, pointer, pointer, pointer, pointer}, long}, 
  {0, 0, "advapi32", "RegQueryValueExW", {pointer, pointer, pointer, pointer, pointer, pointer}, long}, 
  {0, 0, "advapi32", "RegQueryValueW", {pointer, pointer, pointer, pointer}, long}, 
  {0, 0, "advapi32", "RegReplaceKeyA", {pointer, pointer, pointer, pointer}, long}, 
  {0, 0, "advapi32", "RegReplaceKeyW", {pointer, pointer, pointer, pointer}, long}, 
  {0, 0, "advapi32", "RegRestoreKeyA", {pointer, pointer, dword}, long}, 
  {0, 0, "advapi32", "RegRestoreKeyW", {pointer, pointer, dword}, long}, 
  {0, 0, "advapi32", "RegSaveKeyA", {pointer, pointer, long_pointer}, long}, 
  {0, 0, "advapi32", "RegSaveKeyW", {pointer, pointer, long_pointer}, long}, 
  {0, 0, "advapi32", "RegSetKeySecurity", {pointer, pointer, pointer}, long}, 
  {0, 0, "advapi32", "RegSetValueA", {pointer, pointer, dword, pointer, dword}, long}, 
  {0, 0, "advapi32", "RegSetValueExA", {pointer, pointer, dword, dword, pointer, dword}, long}, 
  {0, 0, "advapi32", "RegSetValueExW", {pointer, pointer, dword, dword, pointer, dword}, long}, 
  {0, 0, "advapi32", "RegSetValueW", {pointer, pointer, dword, pointer, dword}, long}, 
  {0, 0, "advapi32", "RegUnLoadKeyA", {pointer, pointer}, long}, 
  {0, 0, "advapi32", "RegUnLoadKeyW", {pointer, pointer}, long}, 
  {0, 0, "advapi32", "SetEntriesInAclA", {ulong, pointer, pointer, pointer}, dword}, 
  {0, 0, "advapi32", "SetEntriesInAclW", {ulong, pointer, pointer, pointer}, dword}, 
  {0, 0, "advapi32", "SetNamedSecurityInfoA", {pointer, pointer, pointer, pointer, pointer, pointer, pointer}, dword}, 
  {0, 0, "advapi32", "SetNamedSecurityInfoW", {pointer, pointer, pointer, pointer, pointer, pointer, pointer}, dword}, 
  {0, 0, "advapi32", "SetSecurityInfo", {pointer, pointer, pointer, pointer, pointer, pointer, pointer}, dword}, 
  {0, 0, "advapi32", "SetServiceObjectSecurity", {pointer, pointer, pointer}, bool}, 
  {0, 0, "advapi32", "SetServiceStatus", {pointer, long_pointer}, bool}, 
  {0, 0, "advapi32", "StartServiceA", {pointer, dword, pointer}, bool}, 
  {0, 0, "advapi32", "StartServiceCtrlDispatcherA", {long_pointer}, bool}, 
  {0, 0, "advapi32", "StartServiceCtrlDispatcherW", {long_pointer}, bool}, 
  {0, 0, "advapi32", "StartServiceW", {pointer, dword, pointer}, bool}, 
  {0, 0, "advapi32", "UnlockServiceDatabase", {pointer}, bool}, 
  {0, 0, "avifil32", "AVIBuildFilterA", {pointer, long, bool}, long}, 
  {0, 0, "avifil32", "AVIBuildFilterW", {pointer, long, bool}, long}, 
  {0, 0, "avifil32", "AVIClearClipboard", {}, long}, 
  {0, 0, "avifil32", "AVIFileAddRef", {pointer}, ulong}, 
  {0, 0, "avifil32", "AVIFileCreateStreamA", {pointer, pointer, pointer}, long}, 
  {0, 0, "avifil32", "AVIFileCreateStreamW", {pointer, pointer, pointer}, long}, 
  {0, 0, "avifil32", "AVIFileEndRecord", {pointer}, long}, 
  {0, 0, "avifil32", "AVIFileExit", {}}, 
  {0, 0, "avifil32", "AVIFileGetStream", {pointer, pointer, dword, long}, long}, 
  {0, 0, "avifil32", "AVIFileInfoA", {pointer, pointer, long}, long}, 
  {0, 0, "avifil32", "AVIFileInfoW", {pointer, pointer, long}, long}, 
  {0, 0, "avifil32", "AVIFileInit", {}}, 
  {0, 0, "avifil32", "AVIFileOpenA", {pointer, pointer, uint, long_pointer}, long}, 
  {0, 0, "avifil32", "AVIFileOpenW", {pointer, pointer, uint, long_pointer}, long}, 
  {0, 0, "avifil32", "AVIFileReadData", {pointer, dword, long_pointer, pointer}, long}, 
  {0, 0, "avifil32", "AVIFileRelease", {pointer}, ulong}, 
  {0, 0, "avifil32", "AVIFileWriteData", {pointer, dword, long_pointer, long}, long}, 
  {0, 0, "avifil32", "AVIGetFromClipboard", {pointer}, long}, 
  {0, 0, "avifil32", "AVIMakeCompressedStream", {pointer, pointer, pointer, pointer}, long}, 
  {0, 0, "avifil32", "AVIMakeFileFromStreams", {pointer, int, pointer}, long}, 
  {0, 0, "avifil32", "AVIPutFileOnClipboard", {pointer}, long}, 
  {0, 0, "avifil32", "AVISaveOptions", {pointer, uint, int, pointer, pointer}, bool}, 
  {0, 0, "avifil32", "AVISaveOptionsFree", {int, pointer}, long}, 
  {0, 0, "avifil32", "AVISaveVA", {pointer, pointer, pointer, int, pointer, pointer}, long}, 
  {0, 0, "avifil32", "AVISaveVW", {pointer, pointer, pointer, int, pointer, pointer}, long}, 
  {0, 0, "avifil32", "AVIStreamAddRef", {pointer}, ulong}, 
  {0, 0, "avifil32", "AVIStreamCreate", {pointer, long, long, pointer}, long}, 
  {0, 0, "avifil32", "AVIStreamFindSample", {pointer, long, dword}, long}, 
  {0, 0, "avifil32", "AVIStreamGetFrame", {pointer, long}, long_pointer}, 
  {0, 0, "avifil32", "AVIStreamGetFrameClose", {pointer}, long}, 
  {0, 0, "avifil32", "AVIStreamGetFrameOpen", {pointer, long_pointer}, pointer}, 
  {0, 0, "avifil32", "AVIStreamInfoA", {pointer, pointer, long}, long}, 
  {0, 0, "avifil32", "AVIStreamInfoW", {pointer, pointer, long}, long}, 
  {0, 0, "avifil32", "AVIStreamLength", {pointer}, long}, 
  {0, 0, "avifil32", "AVIStreamOpenFromFileA", {pointer, pointer, dword, long, uint, pointer}, long}, 
  {0, 0, "avifil32", "AVIStreamOpenFromFileW", {pointer, pointer, dword, long, uint, pointer}, long}, 
  {0, 0, "avifil32", "AVIStreamRead", {pointer, long, long, long_pointer, long, pointer, pointer}, long}, 
  {0, 0, "avifil32", "AVIStreamReadData", {pointer, dword, long_pointer, pointer}, long}, 
  {0, 0, "avifil32", "AVIStreamReadFormat", {pointer, long, long_pointer, pointer}, long}, 
  {0, 0, "avifil32", "AVIStreamRelease", {pointer}, ulong}, 
  {0, 0, "avifil32", "AVIStreamSampleToTime", {pointer, long}, long}, 
  {0, 0, "avifil32", "AVIStreamSetFormat", {pointer, long, long_pointer, long}, long}, 
  {0, 0, "avifil32", "AVIStreamStart", {pointer}, long}, 
  {0, 0, "avifil32", "AVIStreamTimeToSample", {pointer, long}, long}, 
  {0, 0, "avifil32", "AVIStreamWrite", {pointer, long, long, long_pointer, long, dword, pointer, pointer}, long}, 
  {0, 0, "avifil32", "AVIStreamWriteData", {pointer, dword, long_pointer, long}, long}, 
  {0, 0, "avifil32", "CreateEditableStream", {pointer, pointer}, long}, 
  {0, 0, "avifil32", "EditStreamClone", {pointer, pointer}, long}, 
  {0, 0, "avifil32", "EditStreamCopy", {pointer, pointer, pointer, pointer}, long}, 
  {0, 0, "avifil32", "EditStreamCut", {pointer, pointer, pointer, pointer}, long}, 
  {0, 0, "avifil32", "EditStreamPaste", {pointer, pointer, pointer, pointer, long, long}, long}, 
  {0, 0, "avifil32", "EditStreamSetInfoA", {pointer, long_pointer, long}, long}, 
  {0, 0, "avifil32", "EditStreamSetInfoW", {pointer, long_pointer, long}, long}, 
  {0, 0, "avifil32", "EditStreamSetNameA", {pointer, pointer}, long}, 
  {0, 0, "avifil32", "EditStreamSetNameW", {pointer, pointer}, long}, 
  {0, 0, "aygshell", "SHCreateMenuBar", {pointer}, bool}, 
  {0, 0, "aygshell", "SHCreateNewItem", {pointer, pointer}, long}, 
  {0, 0, "aygshell", "SHFindMenuBar", {pointer}, pointer}, 
  {0, 0, "aygshell", "SHFullScreen", {pointer, dword}, bool}, 
  {0, 0, "aygshell", "SHHandleWMActivate", {pointer, unsigned_int, long, pointer, dword}, bool}, 
  {0, 0, "aygshell", "SHHandleWMSettingChange", {pointer, unsigned_int, long, pointer}, bool}, 
  {0, 0, "aygshell", "SHSipInfo", {uint, uint, pointer, uint}, bool}, 
  {0, 0, "comctl32", "_TrackMouseEvent", {long_pointer}, bool}, 
  {0, 0, "comctl32", "CommandBar_AddAdornments", {pointer, dword, dword}, bool}, 
  {0, 0, "comctl32", "CommandBar_AddBitmap", {pointer, pointer, int, int, int, int}, int}, 
  {0, 0, "comctl32", "CommandBar_Create", {pointer, pointer, int}, pointer}, 
  {0, 0, "comctl32", "CommandBar_DrawMenuBar", {pointer, word}, bool}, 
  {0, 0, "comctl32", "CommandBar_GetMenu", {pointer, word}, pointer}, 
  {0, 0, "comctl32", "CommandBar_Height", {pointer}, int}, 
  {0, 0, "comctl32", "CommandBar_InsertComboBox", {pointer, pointer, int, uint, word, word}, pointer}, 
  {0, 0, "comctl32", "CommandBar_InsertMenubar", {pointer, pointer, word, word}, bool}, 
  {0, 0, "comctl32", "CommandBar_InsertMenubarEx", {pointer, pointer, long_pointer, word}, bool}, 
  {0, 0, "comctl32", "CommandBar_Show", {pointer, bool}, bool}, 
  {0, 0, "comctl32", "CreateMappedBitmap", {pointer, int, uint, long_pointer, int}, pointer}, 
  {0, 0, "comctl32", "CreatePropertySheetPageA", {long_pointer}, pointer}, 
  {0, 0, "comctl32", "CreatePropertySheetPageW", {long_pointer}, pointer}, 
  {0, 0, "comctl32", "CreateStatusWindowA", {long, pointer, pointer, uint}, pointer}, 
  {0, 0, "comctl32", "CreateStatusWindowW", {long, pointer, pointer, uint}, pointer}, 
  {0, 0, "comctl32", "CreateToolbarEx", {pointer, dword, uint, int, pointer, uint, long_pointer, int, int, int, int, int, uint}, pointer}, 
  {0, 0, "comctl32", "CreateUpDownControl", {dword, int, int, int, int, pointer, int, pointer, pointer, int, int, int}, pointer}, 
  {0, 0, "comctl32", "DefSubclassProc", {pointer, uint, unsigned_int, long}, long}, 
  {0, 0, "comctl32", "DestroyPropertySheetPage", {pointer}, bool}, 
  {0, 0, "comctl32", "DPA_Create", {int}, pointer}, 
  {0, 0, "comctl32", "DPA_DeleteAllPtrs", {pointer}, bool}, 
  {0, 0, "comctl32", "DPA_DeletePtr", {pointer, int}, pointer}, 
  {0, 0, "comctl32", "DPA_Destroy", {pointer}, bool}, 
  {0, 0, "comctl32", "DPA_DestroyCallback", {pointer, pointer, pointer}}, 
  {0, 0, "comctl32", "DPA_EnumCallback", {pointer, pointer, pointer}}, 
  {0, 0, "comctl32", "DPA_GetPtr", {pointer, pointer}, pointer}, 
  {0, 0, "comctl32", "DPA_InsertPtr", {pointer, int, pointer}, int}, 
  {0, 0, "comctl32", "DPA_Search", {pointer, pointer, int, pointer, long, uint}, int}, 
  {0, 0, "comctl32", "DPA_SetPtr", {pointer, int, pointer}, bool}, 
  {0, 0, "comctl32", "DPA_Sort", {pointer, pointer, long}, bool}, 
  {0, 0, "comctl32", "DrawInsert", {pointer, pointer, int}}, 
  {0, 0, "comctl32", "DrawShadowText", {pointer, pointer, uint, pointer, dword, dword, dword, int, int}, int}, 
  {0, 0, "comctl32", "DrawStatusTextA", {pointer, long_pointer, pointer, uint}}, 
  {0, 0, "comctl32", "DrawStatusTextW", {pointer, long_pointer, pointer, uint}}, 
  {0, 0, "comctl32", "DSA_Create", {int, int}, pointer}, 
  {0, 0, "comctl32", "DSA_Destroy", {pointer}, bool}, 
  {0, 0, "comctl32", "DSA_DestroyCallback", {pointer, pointer, pointer}}, 
  {0, 0, "comctl32", "DSA_GetItemPtr", {pointer, int}, pointer}, 
  {0, 0, "comctl32", "DSA_InsertItem", {pointer, int, pointer}, int}, 
  {0, 0, "comctl32", "FlatSB_EnableScrollBar", {pointer, int, uint}, bool}, 
  {0, 0, "comctl32", "FlatSB_GetScrollInfo", {pointer, int, long_pointer}, bool}, 
  {0, 0, "comctl32", "FlatSB_GetScrollPos", {pointer, int}, int}, 
  {0, 0, "comctl32", "FlatSB_GetScrollProp", {pointer, int, pointer}, bool}, 
  {0, 0, "comctl32", "FlatSB_GetScrollPropPtr", {pointer, int, pointer}, bool}, 
  {0, 0, "comctl32", "FlatSB_GetScrollRange", {pointer, int, pointer, pointer}, bool}, 
  {0, 0, "comctl32", "FlatSB_SetScrollInfo", {pointer, int, long_pointer, bool}, int}, 
  {0, 0, "comctl32", "FlatSB_SetScrollPos", {pointer, int, int, bool}, int}, 
  {0, 0, "comctl32", "FlatSB_SetScrollProp", {pointer, uint, pointer, bool}, bool}, 
  {0, 0, "comctl32", "FlatSB_SetScrollRange", {pointer, int, int, int, bool}, int}, 
  {0, 0, "comctl32", "FlatSB_ShowScrollBar", {pointer, int, bool}, bool}, 
  {0, 0, "comctl32", "GetEffectiveClientRect", {pointer, long_pointer, pointer}}, 
  {0, 0, "comctl32", "GetMUILanguage", {}, word}, 
  {0, 0, "comctl32", "GetWindowSubclass", {pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "comctl32", "ImageList_Add", {pointer, pointer, pointer}, int}, 
  {0, 0, "comctl32", "ImageList_AddIcon", {long, long}, long}, 
  {0, 0, "comctl32", "ImageList_AddMasked", {pointer, pointer, dword}, int}, 
  {0, 0, "comctl32", "ImageList_BeginDrag", {pointer, int, int, int}, bool}, 
  {0, 0, "comctl32", "ImageList_Copy", {pointer, int, pointer, int, uint}, int}, 
  {0, 0, "comctl32", "ImageList_Create", {int, int, uint, int, int}, pointer}, 
  {0, 0, "comctl32", "ImageList_Destroy", {pointer}, bool}, 
  {0, 0, "comctl32", "ImageList_DragEnter", {pointer, int, int}, bool}, 
  {0, 0, "comctl32", "ImageList_DragLeave", {pointer}, bool}, 
  {0, 0, "comctl32", "ImageList_DragMove", {int, int}, bool}, 
  {0, 0, "comctl32", "ImageList_DragShowNolock", {bool}, bool}, 
  {0, 0, "comctl32", "ImageList_Draw", {pointer, int, pointer, int, int, uint}, bool}, 
  {0, 0, "comctl32", "ImageList_DrawEx", {pointer, int, pointer, int, int, int, int, dword, dword, uint}, bool}, 
  {0, 0, "comctl32", "ImageList_DrawIndirect", {pointer}, int}, 
  {0, 0, "comctl32", "ImageList_Duplicate", {pointer}, pointer}, 
  {0, 0, "comctl32", "ImageList_EndDrag", {}}, 
  {0, 0, "comctl32", "ImageList_GetBkColor", {pointer}, dword}, 
  {0, 0, "comctl32", "ImageList_GetDragImage", {long_pointer, long_pointer}, pointer}, 
  {0, 0, "comctl32", "ImageList_GetIcon", {pointer, int, uint}, pointer}, 
  {0, 0, "comctl32", "ImageList_GetIconSize", {pointer, pointer, pointer}, bool}, 
  {0, 0, "comctl32", "ImageList_GetImageCount", {pointer}, int}, 
  {0, 0, "comctl32", "ImageList_GetImageInfo", {pointer, int, pointer}, bool}, 
  {0, 0, "comctl32", "ImageList_LoadImageA", {pointer, pointer, int, int, dword, uint, uint}, pointer}, 
  {0, 0, "comctl32", "ImageList_LoadImageW", {pointer, pointer, int, int, dword, uint, uint}, pointer}, 
  {0, 0, "comctl32", "ImageList_Merge", {pointer, int, pointer, int, int, int}, pointer}, 
  {0, 0, "comctl32", "ImageList_Read", {long_pointer}, pointer}, 
  {0, 0, "comctl32", "ImageList_Remove", {pointer, int}, bool}, 
  {0, 0, "comctl32", "ImageList_Replace", {pointer, int, pointer, pointer}, bool}, 
  {0, 0, "comctl32", "ImageList_ReplaceIcon", {pointer, int, pointer}, int}, 
  {0, 0, "comctl32", "ImageList_SetBkColor", {pointer, dword}, dword}, 
  {0, 0, "comctl32", "ImageList_SetDragCursorImage", {pointer, int, int, int}, bool}, 
  {0, 0, "comctl32", "ImageList_SetIconSize", {pointer, int, int}, bool}, 
  {0, 0, "comctl32", "ImageList_SetImageCount", {pointer, uint}, int}, 
  {0, 0, "comctl32", "ImageList_SetOverlayImage", {pointer, int, int}, bool}, 
  {0, 0, "comctl32", "ImageList_Write", {pointer, long_pointer}, bool}, 
  {0, 0, "comctl32", "InitCommonControls", {}}, 
  {0, 0, "comctl32", "InitCommonControlsEx", {long_pointer}, bool}, 
  {0, 0, "comctl32", "InitializeFlatSB", {pointer}, bool}, 
  {0, 0, "comctl32", "InitMUILanguage", {word}}, 
  {0, 0, "comctl32", "LBItemFromPt", {pointer, pointer, bool}, int}, 
  {0, 0, "comctl32", "MakeDragList", {pointer}, bool}, 
  {0, 0, "comctl32", "MenuHelp", {uint, unsigned_int, long, pointer, pointer, pointer, pointer}}, 
  {0, 0, "comctl32", "PropertySheetA", {long_pointer}, int}, 
  {0, 0, "comctl32", "PropertySheetW", {long_pointer}, int}, 
  {0, 0, "comctl32", "RemoveWindowSubclass", {pointer, pointer, pointer}, bool}, 
  {0, 0, "comctl32", "SetWindowSubclass", {pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "comctl32", "ShowHideMenuCtl", {pointer, uint, pointer}, bool}, 
  {0, 0, "comctl32", "Str_SetPtrW", {pointer, pointer}, bool}, 
  {0, 0, "comctl32", "UninitializeFlatSB", {pointer}, long}, 
  {0, 0, "comdlg32", "ChooseColorA", {long_pointer}, bool}, 
  {0, 0, "comdlg32", "ChooseColorW", {long_pointer}, bool}, 
  {0, 0, "comdlg32", "ChooseFontA", {long_pointer}, bool}, 
  {0, 0, "comdlg32", "ChooseFontW", {long_pointer}, bool}, 
  {0, 0, "comdlg32", "CommDlgExtendedError", {}, dword}, 
  {0, 0, "comdlg32", "FindTextA", {long_pointer}, pointer}, 
  {0, 0, "comdlg32", "FindTextW", {long_pointer}, pointer}, 
  {0, 0, "comdlg32", "GetFileTitleA", {pointer, pointer, word}, short}, 
  {0, 0, "comdlg32", "GetFileTitleW", {pointer, pointer, word}, short}, 
  {0, 0, "comdlg32", "GetOpenFileNameA", {long_pointer}, bool}, 
  {0, 0, "comdlg32", "GetOpenFileNameW", {long_pointer}, bool}, 
  {0, 0, "comdlg32", "GetSaveFileNameA", {long_pointer}, bool}, 
  {0, 0, "comdlg32", "GetSaveFileNameW", {long_pointer}, bool}, 
  {0, 0, "comdlg32", "PageSetupDlgA", {long_pointer}, bool}, 
  {0, 0, "comdlg32", "PageSetupDlgW", {long_pointer}, bool}, 
  {0, 0, "comdlg32", "PrintDlgA", {long_pointer}, bool}, 
  {0, 0, "comdlg32", "PrintDlgExA", {long_pointer}, long}, 
  {0, 0, "comdlg32", "PrintDlgExW", {long_pointer}, long}, 
  {0, 0, "comdlg32", "PrintDlgW", {long_pointer}, bool}, 
  {0, 0, "comdlg32", "ReplaceTextA", {long_pointer}, pointer}, 
  {0, 0, "comdlg32", "ReplaceTextW", {long_pointer}, pointer}, 
  {0, 0, "crypt32" , "CertAddCertificateContextToStore", {pointer, pointer, dword, pointer}, bool}, 
  {0, 0, "crypt32" , "CertCloseStore", {pointer, dword}, bool}, 
  {0, 0, "crypt32" , "CertCompareCertificate", {dword, pointer, pointer}, bool}, 
  {0, 0, "crypt32" , "CertCompareCertificateName", {dword, pointer, pointer}, bool}, 
  {0, 0, "crypt32" , "CertCreateCertificateContext", {dword, pointer, dword}, pointer}, 
  {0, 0, "crypt32" , "CertDeleteCertificateFromStore", {pointer}, bool}, 
  {0, 0, "crypt32" , "CertDuplicateCertificateContext", {pointer}, pointer}, 
  {0, 0, "crypt32" , "CertDuplicateStore", {pointer}, pointer}, 
  {0, 0, "crypt32" , "CertEnumCertificatesInStore", {pointer, pointer}, pointer}, 
  {0, 0, "crypt32" , "CertEnumCRLsInStore", {pointer, pointer}, pointer}, 
  {0, 0, "crypt32" , "CertFindCertificateInStore", {pointer, dword, dword, dword, pointer, pointer}, pointer}, 
  {0, 0, "crypt32" , "CertFindChainInStore", {pointer, dword, dword, dword, pointer, pointer}, pointer}, 
  {0, 0, "crypt32" , "CertFindExtension", {pointer, dword, pointer}, pointer}, 
  {0, 0, "crypt32" , "CertFreeCertificateChain", {pointer}}, 
  {0, 0, "crypt32" , "CertFreeCertificateContext", {pointer}, bool}, 
  {0, 0, "crypt32" , "CertGetCertificateChain", {pointer, pointer, long_pointer, pointer, pointer, dword, long_pointer, pointer}, bool}, 
  {0, 0, "crypt32" , "CertGetCertificateContextProperty", {pointer, dword, pointer, pointer}, bool}, 
  {0, 0, "crypt32" , "CertGetIssuerCertificateFromStore", {pointer, pointer, pointer, pointer}, pointer}, 
  {0, 0, "crypt32" , "CertGetNameStringA", {pointer, dword, dword, pointer, pointer, dword}, dword}, 
  {0, 0, "crypt32" , "CertGetNameStringW", {pointer, dword, dword, pointer, pointer, dword}, dword}, 
  {0, 0, "crypt32" , "CertNameToStrA", {dword, pointer, dword, pointer, dword}, dword}, 
  {0, 0, "crypt32" , "CertNameToStrW", {dword, pointer, dword, pointer, dword}, dword}, 
  {0, 0, "crypt32" , "CertOIDToAlgId", {pointer}, dword}, 
  {0, 0, "crypt32" , "CertOpenStore", {pointer, dword, pointer, dword, pointer}, pointer}, 
  {0, 0, "crypt32" , "CertOpenSystemStoreA", {pointer, pointer}, pointer}, 
  {0, 0, "crypt32" , "CertOpenSystemStoreW", {pointer, pointer}, pointer}, 
  {0, 0, "crypt32" , "CertSetCertificateContextProperty", {pointer, dword, dword, pointer}, bool}, 
  {0, 0, "crypt32" , "CertVerifyCertificateChainPolicy", {pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "crypt32" , "CryptAcquireCertificatePrivateKey", {pointer, dword, pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "crypt32" , "CryptAcquireContextA", {pointer, pointer, pointer, dword, dword}, bool}, 
  {0, 0, "crypt32" , "CryptAcquireContextW", {pointer, pointer, pointer, dword, dword}, bool}, 
  {0, 0, "crypt32" , "CryptContextAddRef", {pointer, pointer, dword}, bool}, 
  {0, 0, "crypt32" , "CryptCreateHash", {pointer, pointer, pointer, dword, pointer}, bool}, 
  {0, 0, "crypt32" , "CryptDecodeObject", {dword, pointer, pointer, dword, dword, pointer, pointer}, bool}, 
  {0, 0, "crypt32" , "CryptDecodeObjectEx", {dword, pointer, pointer, dword, dword, pointer, pointer, pointer}, bool}, 
  {0, 0, "crypt32" , "CryptDecrypt", {pointer, pointer, bool, dword, pointer, pointer}, bool}, 
  {0, 0, "crypt32" , "CryptDeriveKey", {pointer, pointer, pointer, dword, pointer}, bool}, 
  {0, 0, "crypt32" , "CryptDestroyHash", {pointer}, bool}, 
  {0, 0, "crypt32" , "CryptDestroyKey", {pointer}, bool}, 
  {0, 0, "crypt32" , "CryptDuplicateHash", {pointer, pointer, dword, pointer}, bool}, 
  {0, 0, "crypt32" , "CryptDuplicateKey", {pointer, pointer, dword, pointer}, bool}, 
  {0, 0, "crypt32" , "CryptEncodeObject", {dword, pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "crypt32" , "CryptEncodeObjectEx", {dword, pointer, pointer, dword, pointer, pointer, pointer}, bool}, 
  {0, 0, "crypt32" , "CryptEncrypt", {pointer, pointer, bool, dword, pointer, pointer, dword}, bool}, 
  {0, 0, "crypt32" , "CryptEnumKeyIdentifierProperties", {pointer, dword, dword, pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "crypt32" , "CryptEnumProvidersA", {dword, pointer, dword, pointer, long_pointer, pointer}, bool}, 
  {0, 0, "crypt32" , "CryptEnumProvidersW", {dword, pointer, dword, pointer, long_pointer, pointer}, bool}, 
  {0, 0, "crypt32" , "CryptExportKey", {pointer, pointer, dword, dword, pointer, pointer}, bool}, 
  {0, 0, "crypt32" , "CryptGenKey", {pointer, pointer, dword, pointer}, bool}, 
  {0, 0, "crypt32" , "CryptGenRandom", {pointer, dword, pointer}, bool}, 
  {0, 0, "crypt32" , "CryptGetDefaultProviderA", {dword, dword, dword, pointer, dword}, bool}, 
  {0, 0, "crypt32" , "CryptGetDefaultProviderW", {dword, dword, dword, pointer, dword}, bool}, 
  {0, 0, "crypt32" , "CryptGetHashParam", {pointer, dword, pointer, pointer, dword}, bool}, 
  {0, 0, "crypt32" , "CryptGetHashValue", {pointer, dword, pointer, pointer}, bool}, 
  {0, 0, "crypt32" , "CryptGetKeyIdentifierProperty", {pointer, dword, dword, pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "crypt32" , "CryptGetKeyParam", {pointer, dword, pointer, pointer, dword}, bool}, 
  {0, 0, "crypt32" , "CryptGetProvParam", {pointer, dword, pointer, pointer, dword}, bool}, 
  {0, 0, "crypt32" , "CryptGetUserKey", {pointer, dword, pointer}, bool}, 
  {0, 0, "crypt32" , "CryptHashData", {pointer, pointer, dword, dword}, bool}, 
  {0, 0, "crypt32" , "CryptHashSessionKey", {pointer, pointer, dword}, bool}, 
  {0, 0, "crypt32" , "CryptImportKey", {pointer, pointer, dword, pointer, dword, pointer}, bool}, 
  {0, 0, "crypt32" , "CryptProtectData", {pointer, pointer, pointer, pointer, pointer, dword, pointer}, bool}, 
  {0, 0, "crypt32" , "CryptReleaseContext", {pointer, dword}, bool}, 
  {0, 0, "crypt32" , "CryptSetHashParam", {pointer, dword, pointer, dword}, bool}, 
  {0, 0, "crypt32" , "CryptSetKeyIdentifierProperty", {pointer, dword, dword, pointer, pointer, pointer}, bool}, 
  {0, 0, "crypt32" , "CryptSetKeyParam", {pointer, dword, pointer, dword}, bool}, 
  {0, 0, "crypt32" , "CryptSetProviderA", {pointer, dword}, bool}, 
  {0, 0, "crypt32" , "CryptSetProviderW", {pointer, dword}, bool}, 
  {0, 0, "crypt32" , "CryptSetProvParam", {pointer, dword, pointer, dword}, bool}, 
  {0, 0, "crypt32" , "CryptSignHashA", {pointer, dword, pointer, dword, pointer, pointer}, bool}, 
  {0, 0, "crypt32" , "CryptSignHashW", {pointer, dword, pointer, dword, pointer, pointer}, bool}, 
  {0, 0, "crypt32" , "CryptUnprotectData", {pointer, pointer, pointer, pointer, pointer, dword, pointer}, bool}, 
  {0, 0, "crypt32" , "CryptVerifySignatureA", {pointer, pointer, dword, pointer, pointer, dword}, bool}, 
  {0, 0, "crypt32" , "CryptVerifySignatureW", {pointer, pointer, dword, pointer, pointer, dword}, bool}, 
  {0, 0, "crypt32" , "PFXImportCertStore", {pointer, pointer, dword}, pointer}, 
  {0, 0, "crypt32" , "PFXIsPFXBlob", {pointer}, bool}, 
  {0, 0, "crypt32" , "PFXVerifyPassword", {pointer, pointer, dword}, bool}, 
  {0, 0, "d3d9"    , "Direct3DCreate9", {uint}, pointer}, 
  {0, 0, "dhcpcsvc", "DhcpCApiCleanup", {}}, 
  {0, 0, "dhcpcsvc", "DhcpCApiInitialize", {pointer}, dword}, 
  {0, 0, "dhcpcsvc", "DhcpDeRegisterParamChange", {dword, long_pointer, long_pointer}, dword}, 
  {0, 0, "dhcpcsvc", "DhcpRegisterParamChange", {dword, long_pointer, pointer, long_pointer, pointer, long_pointer}, dword}, 
  {0, 0, "dhcpcsvc", "DhcpRemoveDNSRegistrations", {}, dword}, 
  {0, 0, "dhcpcsvc", "DhcpUndoRequestParams", {dword, long_pointer, pointer, pointer}, dword}, 
  {0, 0, "dnsapi"  , "DnsAcquireContextHandle_A", {dword, pointer, pointer}, pointer}, 
  {0, 0, "dnsapi"  , "DnsAcquireContextHandle_W", {dword, pointer, pointer}, pointer}, 
  {0, 0, "dnsapi"  , "DnsExtractRecordsFromMessage_UTF8", {pointer, word, pointer}, pointer}, 
  {0, 0, "dnsapi"  , "DnsExtractRecordsFromMessage_W", {pointer, word, pointer}, pointer}, 
  {0, 0, "dnsapi"  , "DnsModifyRecordsInSet_A", {pointer, pointer, dword, pointer, pointer, pointer}, pointer}, 
  {0, 0, "dnsapi"  , "DnsModifyRecordsInSet_UTF8", {pointer, pointer, dword, pointer, pointer, pointer}, pointer}, 
  {0, 0, "dnsapi"  , "DnsModifyRecordsInSet_W", {pointer, pointer, dword, pointer, pointer, pointer}, pointer}, 
  {0, 0, "dnsapi"  , "DnsNameCompare_A", {pointer, pointer}, bool}, 
  {0, 0, "dnsapi"  , "DnsNameCompare_W", {pointer, pointer}, bool}, 
  {0, 0, "dnsapi"  , "DnsQuery_A", {pointer, word, dword, pointer, pointer, pointer}, pointer}, 
  {0, 0, "dnsapi"  , "DnsQuery_UTF8", {pointer, word, dword, pointer, pointer, pointer}, pointer}, 
  {0, 0, "dnsapi"  , "DnsQuery_W", {pointer, word, dword, pointer, pointer, pointer}, pointer}, 
  {0, 0, "dnsapi"  , "DnsQueryConfig", {pointer, dword, pointer, pointer, pointer, pointer}, pointer}, 
  {0, 0, "dnsapi"  , "DnsRecordCompare", {pointer, pointer}, bool}, 
  {0, 0, "dnsapi"  , "DnsRecordCopyEx", {pointer, pointer, pointer}, pointer}, 
  {0, 0, "dnsapi"  , "DnsRecordListFree", {pointer, pointer}}, 
  {0, 0, "dnsapi"  , "DnsRecordSetCompare", {pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "dnsapi"  , "DnsRecordSetCopyEx", {pointer, pointer, pointer}, pointer}, 
  {0, 0, "dnsapi"  , "DnsRecordSetDetach", {pointer}, pointer}, 
  {0, 0, "dnsapi"  , "DnsReleaseContextHandle", {pointer}}, 
  {0, 0, "dnsapi"  , "DnsReplaceRecordSetA", {pointer, dword, pointer, pointer, pointer}, pointer}, 
  {0, 0, "dnsapi"  , "DnsReplaceRecordSetUTF8", {pointer, dword, pointer, pointer, pointer}, pointer}, 
  {0, 0, "dnsapi"  , "DnsReplaceRecordSetW", {pointer, dword, pointer, pointer, pointer}, pointer}, 
  {0, 0, "dnsapi"  , "DnsValidateName_A", {pointer, pointer}, pointer}, 
  {0, 0, "dnsapi"  , "DnsValidateName_UTF8", {pointer, pointer}, pointer}, 
  {0, 0, "dnsapi"  , "DnsValidateName_W", {pointer, pointer}, pointer}, 
  {0, 0, "dnsapi"  , "DnsWriteQuestionToBuffer_UTF8", {pointer, pointer, pointer, word, word, bool}, bool}, 
  {0, 0, "dnsapi"  , "DnsWriteQuestionToBuffer_W", {pointer, pointer, pointer, word, word, bool}, bool}, 
  {0, 0, "dxerr8"  , "DXGetErrorDescription8A", {long}, pointer}, 
  {0, 0, "dxerr8"  , "DXGetErrorDescription8W", {long}, pointer}, 
  {0, 0, "dxerr8"  , "DXGetErrorString8A", {long}, pointer}, 
  {0, 0, "dxerr8"  , "DXGetErrorString8W", {long}, pointer}, 
  {0, 0, "dxerr8"  , "DXTraceA", {pointer, dword, long, pointer, bool}, long}, 
  {0, 0, "dxerr8"  , "DXTraceW", {pointer, dword, long, pointer, bool}, long}, 
  {0, 0, "dxerr9"  , "DXGetErrorDescription9A", {long}, pointer}, 
  {0, 0, "dxerr9"  , "DXGetErrorDescription9W", {long}, pointer}, 
  {0, 0, "dxerr9"  , "DXGetErrorString9A", {long}, pointer}, 
  {0, 0, "dxerr9"  , "DXGetErrorString9W", {long}, pointer}, 
  {0, 0, "dxerr9"  , "DXTraceA", {pointer, dword, long, pointer, bool}, long}, 
  {0, 0, "dxerr9"  , "DXTraceW", {pointer, dword, long, pointer, bool}, long}, 
  {0, 0, "faultrep", "AddERExcludedApplicationA", {pointer}, bool}, 
  {0, 0, "faultrep", "AddERExcludedApplicationW", {pointer}, bool}, 
  {0, 0, "faultrep", "ReportFault", {long_pointer, dword}, pointer}, 
  {0, 0, "gdi32"   , "AbortDoc", {pointer}, int}, 
  {0, 0, "gdi32"   , "AbortPath", {pointer}, bool}, 
  {0, 0, "gdi32"   , "AddFontMemResourceEx", {pointer, dword, pointer, pointer}, pointer}, 
  {0, 0, "gdi32"   , "AddFontResourceA", {pointer}, int}, 
  {0, 0, "gdi32"   , "AddFontResourceExA", {pointer, dword, pointer}, int}, 
  {0, 0, "gdi32"   , "AddFontResourceExW", {pointer, dword, pointer}, int}, 
  {0, 0, "gdi32"   , "AddFontResourceW", {pointer}, int}, 
  {0, 0, "gdi32"   , "AlphaBlend", {pointer, int, int, int, int, pointer, int, int, int, int, pointer}, bool}, 
  {0, 0, "gdi32"   , "AngleArc", {pointer, int, int, dword, float, float}, bool}, 
  {0, 0, "gdi32"   , "AnimatePalette", {pointer, uint, uint, pointer}, bool}, 
  {0, 0, "gdi32"   , "Arc", {pointer, int, int, int, int, int, int, int, int}, bool}, 
  {0, 0, "gdi32"   , "ArcTo", {pointer, int, int, int, int, int, int, int, int}, bool}, 
  {0, 0, "gdi32"   , "BeginPath", {pointer}, bool}, 
  {0, 0, "gdi32"   , "BitBlt", {pointer, int, int, int, int, pointer, int, int, dword}, bool}, 
  {0, 0, "gdi32"   , "CancelDC", {pointer}, bool}, 
  {0, 0, "gdi32"   , "CheckColorsInGamut", {pointer, pointer, pointer, dword}, bool}, 
  {0, 0, "gdi32"   , "ChoosePixelFormat", {pointer, pointer}, int}, 
  {0, 0, "gdi32"   , "Chord", {pointer, int, int, int, int, int, int, int, int}, bool}, 
  {0, 0, "gdi32"   , "CloseEnhMetaFile", {pointer}, pointer}, 
  {0, 0, "gdi32"   , "CloseFigure", {pointer}, bool}, 
  {0, 0, "gdi32"   , "CloseMetaFile", {pointer}, pointer}, 
  {0, 0, "gdi32"   , "ColorCorrectPalette", {pointer, pointer, dword, dword}, bool}, 
  {0, 0, "gdi32"   , "ColorMatchToTarget", {pointer, pointer, dword}, bool}, 
  {0, 0, "gdi32"   , "CombineRgn", {pointer, pointer, pointer, int}, int}, 
  {0, 0, "gdi32"   , "CombineTransform", {long_pointer, pointer, pointer}, bool}, 
  {0, 0, "gdi32"   , "CopyEnhMetaFileA", {pointer, pointer}, pointer}, 
  {0, 0, "gdi32"   , "CopyEnhMetaFileW", {pointer, pointer}, pointer}, 
  {0, 0, "gdi32"   , "CopyMetaFileA", {pointer, pointer}, pointer}, 
  {0, 0, "gdi32"   , "CopyMetaFileW", {pointer, pointer}, pointer}, 
  {0, 0, "gdi32"   , "CreateBitmap", {int, int, uint, uint, pointer}, pointer}, 
  {0, 0, "gdi32"   , "CreateBitmapIndirect", {pointer}, pointer}, 
  {0, 0, "gdi32"   , "CreateBrushIndirect", {pointer}, pointer}, 
  {0, 0, "gdi32"   , "CreateColorSpaceA", {long_pointer}, pointer}, 
  {0, 0, "gdi32"   , "CreateColorSpaceW", {long_pointer}, pointer}, 
  {0, 0, "gdi32"   , "CreateCompatibleBitmap", {pointer, int, int}, pointer}, 
  {0, 0, "gdi32"   , "CreateCompatibleDC", {pointer}, pointer}, 
  {0, 0, "gdi32"   , "CreateDCA", {pointer, pointer, pointer, pointer}, pointer}, 
  {0, 0, "gdi32"   , "CreateDCW", {pointer, pointer, pointer, pointer}, pointer}, 
  {0, 0, "gdi32"   , "CreateDIBitmap", {pointer, pointer, dword, pointer, pointer, uint}, pointer}, 
  {0, 0, "gdi32"   , "CreateDIBPatternBrush", {pointer, uint}, pointer}, 
  {0, 0, "gdi32"   , "CreateDIBPatternBrushPt", {pointer, uint}, pointer}, 
  {0, 0, "gdi32"   , "CreateDIBSection", {pointer, pointer, uint, pointer, pointer, dword}, pointer}, 
  {0, 0, "gdi32"   , "CreateDiscardableBitmap", {pointer, int, int}, pointer}, 
  {0, 0, "gdi32"   , "CreateEllipticRgn", {int, int, int, int}, pointer}, 
  {0, 0, "gdi32"   , "CreateEllipticRgnIndirect", {long_pointer}, pointer}, 
  {0, 0, "gdi32"   , "CreateEnhMetaFileA", {pointer, pointer, long_pointer, pointer}, pointer}, 
  {0, 0, "gdi32"   , "CreateEnhMetaFileW", {pointer, pointer, long_pointer, pointer}, pointer}, 
  {0, 0, "gdi32"   , "CreateFontA", {int, int, int, int, int, dword, dword, dword, dword, dword, dword, dword, dword, pointer}, pointer}, 
  {0, 0, "gdi32"   , "CreateFontIndirectA", {pointer}, pointer}, 
  {0, 0, "gdi32"   , "CreateFontIndirectW", {pointer}, pointer}, 
  {0, 0, "gdi32"   , "CreateFontW", {int, int, int, int, int, dword, dword, dword, dword, dword, dword, dword, dword, pointer}, pointer}, 
  {0, 0, "gdi32"   , "CreateHalftonePalette", {pointer}, pointer}, 
  {0, 0, "gdi32"   , "CreateHatchBrush", {int, dword}, pointer}, 
  {0, 0, "gdi32"   , "CreateICA", {pointer, pointer, pointer, pointer}, pointer}, 
  {0, 0, "gdi32"   , "CreateICW", {pointer, pointer, pointer, pointer}, pointer}, 
  {0, 0, "gdi32"   , "CreateMetaFileA", {pointer}, pointer}, 
  {0, 0, "gdi32"   , "CreateMetaFileW", {pointer}, pointer}, 
  {0, 0, "gdi32"   , "CreatePalette", {pointer}, pointer}, 
  {0, 0, "gdi32"   , "CreatePatternBrush", {pointer}, pointer}, 
  {0, 0, "gdi32"   , "CreatePen", {int, int, dword}, pointer}, 
  {0, 0, "gdi32"   , "CreatePenIndirect", {pointer}, pointer}, 
  {0, 0, "gdi32"   , "CreatePolygonRgn", {pointer, int, int}, pointer}, 
  {0, 0, "gdi32"   , "CreatePolyPolygonRgn", {pointer, pointer, int, int}, pointer}, 
  {0, 0, "gdi32"   , "CreateRectRgn", {int, int, int, int}, pointer}, 
  {0, 0, "gdi32"   , "CreateRectRgnIndirect", {long_pointer}, pointer}, 
  {0, 0, "gdi32"   , "CreateRoundRectRgn", {int, int, int, int, int, int}, pointer}, 
  {0, 0, "gdi32"   , "CreateScalableFontResourceA", {dword, pointer, pointer, pointer}, bool}, 
  {0, 0, "gdi32"   , "CreateScalableFontResourceW", {dword, pointer, pointer, pointer}, bool}, 
  {0, 0, "gdi32"   , "CreateSolidBrush", {dword}, pointer}, 
  {0, 0, "gdi32"   , "DeleteColorSpace", {pointer}, bool}, 
  {0, 0, "gdi32"   , "DeleteDC", {pointer}, bool}, 
  {0, 0, "gdi32"   , "DeleteEnhMetaFile", {pointer}, bool}, 
  {0, 0, "gdi32"   , "DeleteMetaFile", {pointer}, bool}, 
  {0, 0, "gdi32"   , "DeleteObject", {pointer}, bool}, 
  {0, 0, "gdi32"   , "DescribePixelFormat", {pointer, int, uint, long_pointer}, int}, 
  {0, 0, "gdi32"   , "DeviceCapabilitiesA", {pointer, pointer, word, pointer, pointer}, dword}, 
  {0, 0, "gdi32"   , "DeviceCapabilitiesW", {pointer, pointer, word, pointer, pointer}, dword}, 
  {0, 0, "gdi32"   , "DPtoLP", {pointer, long_pointer, int}, bool}, 
  {0, 0, "gdi32"   , "DrawEscape", {pointer, int, int, pointer}, int}, 
  {0, 0, "gdi32"   , "Ellipse", {pointer, int, int, int, int}, bool}, 
  {0, 0, "gdi32"   , "EndDoc", {pointer}, int}, 
  {0, 0, "gdi32"   , "EndPage", {pointer}, int}, 
  {0, 0, "gdi32"   , "EndPath", {pointer}, bool}, 
  {0, 0, "gdi32"   , "EnumEnhMetaFile", {pointer, pointer, pointer, pointer, long_pointer}, bool}, 
  {0, 0, "gdi32"   , "EnumFontFamiliesA", {pointer, pointer, pointer, long}, int}, 
  {0, 0, "gdi32"   , "EnumFontFamiliesExA", {pointer, pointer, pointer, long, dword}, int}, 
  {0, 0, "gdi32"   , "EnumFontFamiliesExW", {pointer, pointer, pointer, long, dword}, int}, 
  {0, 0, "gdi32"   , "EnumFontFamiliesW", {pointer, pointer, pointer, long}, int}, 
  {0, 0, "gdi32"   , "EnumFontsA", {pointer, pointer, pointer, long}, int}, 
  {0, 0, "gdi32"   , "EnumFontsW", {pointer, pointer, pointer, long}, int}, 
  {0, 0, "gdi32"   , "EnumICMProfilesA", {pointer, pointer, long}, int}, 
  {0, 0, "gdi32"   , "EnumICMProfilesW", {pointer, pointer, long}, int}, 
  {0, 0, "gdi32"   , "EnumMetaFile", {pointer, pointer, pointer, long}, bool}, 
  {0, 0, "gdi32"   , "EnumObjects", {pointer, int, pointer, long}, int}, 
  {0, 0, "gdi32"   , "EqualRgn", {pointer, pointer}, bool}, 
  {0, 0, "gdi32"   , "Escape", {pointer, int, int, pointer, pointer}, int}, 
  {0, 0, "gdi32"   , "ExcludeClipRect", {pointer, int, int, int, int}, int}, 
  {0, 0, "gdi32"   , "ExcludeUpdateRgn", {pointer, pointer}, int}, 
  {0, 0, "gdi32"   , "ExtCreatePen", {dword, dword, pointer, dword, pointer}, pointer}, 
  {0, 0, "gdi32"   , "ExtCreateRegion", {pointer, dword, pointer}, pointer}, 
  {0, 0, "gdi32"   , "ExtEscape", {pointer, int, int, pointer, int, pointer}, int}, 
  {0, 0, "gdi32"   , "ExtFloodFill", {pointer, int, int, dword, uint}, bool}, 
  {0, 0, "gdi32"   , "ExtSelectClipRgn", {pointer, pointer, int}, int}, 
  {0, 0, "gdi32"   , "ExtTextOutA", {pointer, int, int, uint, long_pointer, pointer, uint, pointer}, bool}, 
  {0, 0, "gdi32"   , "ExtTextOutW", {pointer, int, int, uint, long_pointer, pointer, uint, pointer}, bool}, 
  {0, 0, "gdi32"   , "FillPath", {pointer}, bool}, 
  {0, 0, "gdi32"   , "FillRect", {pointer, long_pointer, pointer}, int}, 
  {0, 0, "gdi32"   , "FillRgn", {pointer, pointer, pointer}, int}, 
  {0, 0, "gdi32"   , "FixBrushOrgEx", {pointer, int, int, long_pointer}, bool}, 
  {0, 0, "gdi32"   , "FlattenPath", {pointer}, bool}, 
  {0, 0, "gdi32"   , "FloodFill", {pointer, int, int, dword}, bool}, 
  {0, 0, "gdi32"   , "GdiComment", {pointer, uint, pointer}, bool}, 
  {0, 0, "gdi32"   , "GdiFlush", {}, bool}, 
  {0, 0, "gdi32"   , "GdiGetBatchLimit", {}, dword}, 
  {0, 0, "gdi32"   , "GdiSetBatchLimit", {dword}, dword}, 
  {0, 0, "gdi32"   , "GetArcDirection", {pointer}, int}, 
  {0, 0, "gdi32"   , "GetAspectRatioFilterEx", {pointer, long_pointer}, bool}, 
  {0, 0, "gdi32"   , "GetBitmapBits", {pointer, long, pointer}, long}, 
  {0, 0, "gdi32"   , "GetBitmapDimensionEx", {pointer, long_pointer}, bool}, 
  {0, 0, "gdi32"   , "GetBkColor", {pointer}, dword}, 
  {0, 0, "gdi32"   , "GetBkMode", {pointer}, int}, 
  {0, 0, "gdi32"   , "GetBoundsRect", {pointer, long_pointer, uint}, uint}, 
  {0, 0, "gdi32"   , "GetBrushOrgEx", {pointer, long_pointer}, bool}, 
  {0, 0, "gdi32"   , "GetCharABCWidthsA", {pointer, uint, uint, long_pointer}, bool}, 
  {0, 0, "gdi32"   , "GetCharABCWidthsFloatA", {pointer, uint, uint, long_pointer}, bool}, 
  {0, 0, "gdi32"   , "GetCharABCWidthsFloatW", {pointer, uint, uint, long_pointer}, bool}, 
  {0, 0, "gdi32"   , "GetCharABCWidthsW", {pointer, uint, uint, long_pointer}, bool}, 
  {0, 0, "gdi32"   , "GetCharacterPlacementA", {pointer, pointer, int, int, long_pointer, dword}, dword}, 
  {0, 0, "gdi32"   , "GetCharacterPlacementW", {pointer, pointer, int, int, long_pointer, dword}, dword}, 
  {0, 0, "gdi32"   , "GetCharWidth32A", {pointer, uint, uint, pointer}, bool}, 
  {0, 0, "gdi32"   , "GetCharWidth32W", {pointer, uint, uint, pointer}, bool}, 
  {0, 0, "gdi32"   , "GetCharWidthA", {pointer, uint, uint, pointer}, bool}, 
  {0, 0, "gdi32"   , "GetCharWidthFloatA", {pointer, uint, uint, pointer}, bool}, 
  {0, 0, "gdi32"   , "GetCharWidthFloatW", {pointer, uint, uint, pointer}, bool}, 
  {0, 0, "gdi32"   , "GetCharWidthW", {pointer, uint, uint, pointer}, bool}, 
  {0, 0, "gdi32"   , "GetClipBox", {pointer, long_pointer}, int}, 
  {0, 0, "gdi32"   , "GetClipRgn", {pointer, pointer}, int}, 
  {0, 0, "gdi32"   , "GetColorAdjustment", {pointer, long_pointer}, bool}, 
  {0, 0, "gdi32"   , "GetColorSpace", {pointer}, pointer}, 
  {0, 0, "gdi32"   , "GetCurrentObject", {pointer, uint}, pointer}, 
  {0, 0, "gdi32"   , "GetCurrentPositionEx", {pointer, long_pointer}, bool}, 
  {0, 0, "gdi32"   , "GetCursor", {}, pointer}, 
  {0, 0, "gdi32"   , "GetDCBrushColor", {pointer}, dword}, 
  {0, 0, "gdi32"   , "GetDCOrgEx", {pointer, long_pointer}, bool}, 
  {0, 0, "gdi32"   , "GetDCPenColor", {pointer}, dword}, 
  {0, 0, "gdi32"   , "GetDeviceCaps", {pointer, int}, int}, 
  {0, 0, "gdi32"   , "GetDeviceGammaRamp", {pointer, pointer}, bool}, 
  {0, 0, "gdi32"   , "GetDIBColorTable", {pointer, uint, uint, pointer}, uint}, 
  {0, 0, "gdi32"   , "GetDIBits", {pointer, pointer, uint, uint, pointer, long_pointer, uint}, int}, 
  {0, 0, "gdi32"   , "GetEnhMetaFileA", {pointer}, pointer}, 
  {0, 0, "gdi32"   , "GetEnhMetaFileBits", {pointer, uint, pointer}, uint}, 
  {0, 0, "gdi32"   , "GetEnhMetaFileDescriptionA", {pointer, uint, pointer}, uint}, 
  {0, 0, "gdi32"   , "GetEnhMetaFileDescriptionW", {pointer, uint, pointer}, uint}, 
  {0, 0, "gdi32"   , "GetEnhMetaFileHeader", {pointer, uint, long_pointer}, uint}, 
  {0, 0, "gdi32"   , "GetEnhMetaFilePaletteEntries", {pointer, uint, long_pointer}, uint}, 
  {0, 0, "gdi32"   , "GetEnhMetaFilePixelFormat", {pointer, dword, pointer}, uint}, 
  {0, 0, "gdi32"   , "GetEnhMetaFileW", {pointer}, pointer}, 
  {0, 0, "gdi32"   , "GetFontData", {pointer, dword, dword, pointer, dword}, dword}, 
  {0, 0, "gdi32"   , "GetFontLanguageInfo", {pointer}, dword}, 
  {0, 0, "gdi32"   , "GetFontUnicodeRanges", {pointer, long_pointer}, dword}, 
  {0, 0, "gdi32"   , "GetGlyphIndicesA", {pointer, pointer, int, pointer, dword}, dword}, 
  {0, 0, "gdi32"   , "GetGlyphIndicesW", {pointer, pointer, int, pointer, dword}, dword}, 
  {0, 0, "gdi32"   , "GetGlyphOutlineA", {pointer, uint, uint, long_pointer, dword, pointer, pointer}, dword}, 
  {0, 0, "gdi32"   , "GetGlyphOutlineW", {pointer, uint, uint, long_pointer, dword, pointer, pointer}, dword}, 
  {0, 0, "gdi32"   , "GetGraphicsMode", {pointer}, int}, 
  {0, 0, "gdi32"   , "GetICMProfileA", {pointer, pointer, pointer}, bool}, 
  {0, 0, "gdi32"   , "GetICMProfileW", {pointer, pointer, pointer}, bool}, 
  {0, 0, "gdi32"   , "GetKerningPairsA", {pointer, dword, long_pointer}, dword}, 
  {0, 0, "gdi32"   , "GetKerningPairsW", {pointer, dword, long_pointer}, dword}, 
  {0, 0, "gdi32"   , "GetLayout", {pointer}, dword}, 
  {0, 0, "gdi32"   , "GetLogColorSpaceA", {pointer, long_pointer, dword}, bool}, 
  {0, 0, "gdi32"   , "GetLogColorSpaceW", {pointer, long_pointer, dword}, bool}, 
  {0, 0, "gdi32"   , "GetMapMode", {pointer}, int}, 
  {0, 0, "gdi32"   , "GetMetaFileA", {pointer}, pointer}, 
  {0, 0, "gdi32"   , "GetMetaFileBitsEx", {pointer, uint, pointer}, uint}, 
  {0, 0, "gdi32"   , "GetMetaFileW", {pointer}, pointer}, 
  {0, 0, "gdi32"   , "GetMetaRgn", {pointer, pointer}, int}, 
  {0, 0, "gdi32"   , "GetMiterLimit", {pointer, pointer}, bool}, 
  {0, 0, "gdi32"   , "GetNearestColor", {pointer, dword}, dword}, 
  {0, 0, "gdi32"   , "GetNearestPaletteIndex", {pointer, dword}, uint}, 
  {0, 0, "gdi32"   , "GetObjectA", {pointer, int, pointer}, int}, 
  {0, 0, "gdi32"   , "GetObjectType", {pointer}, dword}, 
  {0, 0, "gdi32"   , "GetObjectW", {pointer, int, pointer}, int}, 
  {0, 0, "gdi32"   , "GetOutlineTextMetricsA", {pointer, uint, long_pointer}, uint}, 
  {0, 0, "gdi32"   , "GetOutlineTextMetricsW", {pointer, uint, long_pointer}, uint}, 
  {0, 0, "gdi32"   , "GetPaletteEntries", {pointer, uint, uint, long_pointer}, uint}, 
  {0, 0, "gdi32"   , "GetPath", {pointer, long_pointer, pointer, int}, int}, 
  {0, 0, "gdi32"   , "GetPixel", {pointer, int, int}, dword}, 
  {0, 0, "gdi32"   , "GetPixelFormat", {pointer}, int}, 
  {0, 0, "gdi32"   , "GetPolyFillMode", {pointer}, int}, 
  {0, 0, "gdi32"   , "GetRandomRgn", {pointer, pointer, int}, int}, 
  {0, 0, "gdi32"   , "GetRasterizerCaps", {long_pointer, uint}, bool}, 
  {0, 0, "gdi32"   , "GetRegionData", {pointer, dword, long_pointer}, dword}, 
  {0, 0, "gdi32"   , "GetRgnBox", {pointer, long_pointer}, int}, 
  {0, 0, "gdi32"   , "GetROP2", {pointer}, int}, 
  {0, 0, "gdi32"   , "GetStockObject", {int}, pointer}, 
  {0, 0, "gdi32"   , "GetStretchBltMode", {pointer}, int}, 
  {0, 0, "gdi32"   , "GetSystemPaletteEntries", {pointer, uint, uint, long_pointer}, uint}, 
  {0, 0, "gdi32"   , "GetSystemPaletteUse", {pointer}, uint}, 
  {0, 0, "gdi32"   , "GetTextAlign", {pointer}, uint}, 
  {0, 0, "gdi32"   , "GetTextCharacterExtra", {pointer}, int}, 
  {0, 0, "gdi32"   , "GetTextCharset", {pointer}, int}, 
  {0, 0, "gdi32"   , "GetTextCharsetInfo", {pointer, long_pointer, dword}, int}, 
  {0, 0, "gdi32"   , "GetTextColor", {pointer}, dword}, 
  {0, 0, "gdi32"   , "GetTextExtentExPointA", {pointer, pointer, int, int, pointer, pointer, long_pointer}, bool}, 
  {0, 0, "gdi32"   , "GetTextExtentExPointI", {pointer, pointer, int, int, pointer, pointer, long_pointer}, bool}, 
  {0, 0, "gdi32"   , "GetTextExtentExPointW", {pointer, pointer, int, int, pointer, pointer, long_pointer}, bool}, 
  {0, 0, "gdi32"   , "GetTextExtentPoint32A", {pointer, pointer, int, long_pointer}, bool}, 
  {0, 0, "gdi32"   , "GetTextExtentPoint32W", {pointer, pointer, int, long_pointer}, bool}, 
  {0, 0, "gdi32"   , "GetTextExtentPointA", {pointer, pointer, int, long_pointer}, bool}, 
  {0, 0, "gdi32"   , "GetTextExtentPointW", {pointer, pointer, int, long_pointer}, bool}, 
  {0, 0, "gdi32"   , "GetTextFaceA", {pointer, int, pointer}, int}, 
  {0, 0, "gdi32"   , "GetTextFaceW", {pointer, int, pointer}, int}, 
  {0, 0, "gdi32"   , "GetTextMetricsA", {pointer, long_pointer}, bool}, 
  {0, 0, "gdi32"   , "GetTextMetricsW", {pointer, long_pointer}, bool}, 
  {0, 0, "gdi32"   , "GetViewportExtEx", {pointer, long_pointer}, bool}, 
  {0, 0, "gdi32"   , "GetViewportOrgEx", {pointer, long_pointer}, bool}, 
  {0, 0, "gdi32"   , "GetWindowExtEx", {pointer, long_pointer}, bool}, 
  {0, 0, "gdi32"   , "GetWindowOrgEx", {pointer, long_pointer}, bool}, 
  {0, 0, "gdi32"   , "GetWinMetaFileBits", {pointer, uint, pointer, int, pointer}, uint}, 
  {0, 0, "gdi32"   , "GetWorldTransform", {pointer, long_pointer}, bool}, 
  {0, 0, "gdi32"   , "IntersectClipRect", {pointer, int, int, int, int}, int}, 
  {0, 0, "gdi32"   , "InvertRgn", {pointer, pointer}, bool}, 
  {0, 0, "gdi32"   , "LineDDA", {int, int, int, int, pointer, long}, bool}, 
  {0, 0, "gdi32"   , "LineTo", {pointer, int, int}, bool}, 
  {0, 0, "gdi32"   , "LPtoDP", {pointer, long_pointer, int}, bool}, 
  {0, 0, "gdi32"   , "MaskBlt", {pointer, int, int, int, int, pointer, int, int, pointer, int, int, dword}, bool}, 
  {0, 0, "gdi32"   , "ModifyWorldTransform", {pointer, pointer, dword}, bool}, 
  {0, 0, "gdi32"   , "MoveToEx", {pointer, int, int, long_pointer}, bool}, 
  {0, 0, "gdi32"   , "OffsetClipRgn", {pointer, int, int}, int}, 
  {0, 0, "gdi32"   , "OffsetRgn", {pointer, int, int}, int}, 
  {0, 0, "gdi32"   , "OffsetViewportOrgEx", {pointer, int, int, long_pointer}, bool}, 
  {0, 0, "gdi32"   , "OffsetWindowOrgEx", {pointer, int, int, long_pointer}, bool}, 
  {0, 0, "gdi32"   , "PaintRgn", {pointer, pointer}, bool}, 
  {0, 0, "gdi32"   , "PatBlt", {pointer, int, int, int, int, dword}, bool}, 
  {0, 0, "gdi32"   , "PathToRegion", {pointer}, pointer}, 
  {0, 0, "gdi32"   , "Pie", {pointer, int, int, int, int, int, int, int, int}, bool}, 
  {0, 0, "gdi32"   , "PlayEnhMetaFile", {pointer, pointer, long_pointer}, bool}, 
  {0, 0, "gdi32"   , "PlayEnhMetaFileRecord", {pointer, long_pointer, pointer, uint}, bool}, 
  {0, 0, "gdi32"   , "PlayMetaFile", {pointer, pointer}, bool}, 
  {0, 0, "gdi32"   , "PlayMetaFileRecord", {pointer, long_pointer, long_pointer, uint}, bool}, 
  {0, 0, "gdi32"   , "PlgBlt", {pointer, pointer, pointer, int, int, int, int, pointer, int, int}, bool}, 
  {0, 0, "gdi32"   , "PolyBezier", {pointer, pointer, dword}, bool}, 
  {0, 0, "gdi32"   , "PolyBezierTo", {pointer, pointer, dword}, bool}, 
  {0, 0, "gdi32"   , "PolyDraw", {pointer, pointer, pointer, int}, bool}, 
  {0, 0, "gdi32"   , "Polygon", {pointer, pointer, int}, bool}, 
  {0, 0, "gdi32"   , "Polyline", {pointer, pointer, int}, bool}, 
  {0, 0, "gdi32"   , "PolylineTo", {pointer, pointer, dword}, bool}, 
  {0, 0, "gdi32"   , "PolyPolygon", {pointer, pointer, pointer, int}, bool}, 
  {0, 0, "gdi32"   , "PolyPolyline", {pointer, pointer, pointer, dword}, bool}, 
  {0, 0, "gdi32"   , "PolyTextOutA", {pointer, pointer, int}, bool}, 
  {0, 0, "gdi32"   , "PolyTextOutW", {pointer, pointer, int}, bool}, 
  {0, 0, "gdi32"   , "PtInRegion", {pointer, int, int}, bool}, 
  {0, 0, "gdi32"   , "PtVisible", {pointer, int, int}, bool}, 
  {0, 0, "gdi32"   , "RealizePalette", {pointer}, uint}, 
  {0, 0, "gdi32"   , "Rectangle", {pointer, int, int, int, int}, bool}, 
  {0, 0, "gdi32"   , "RectInRegion", {pointer, long_pointer}, bool}, 
  {0, 0, "gdi32"   , "RectVisible", {pointer, long_pointer}, bool}, 
  {0, 0, "gdi32"   , "RemoveFontMemResourceEx", {pointer}, bool}, 
  {0, 0, "gdi32"   , "RemoveFontResourceA", {pointer}, bool}, 
  {0, 0, "gdi32"   , "RemoveFontResourceExA", {pointer, dword, pointer}, bool}, 
  {0, 0, "gdi32"   , "RemoveFontResourceExW", {pointer, dword, pointer}, bool}, 
  {0, 0, "gdi32"   , "RemoveFontResourceW", {pointer}, bool}, 
  {0, 0, "gdi32"   , "ResetDCA", {pointer, pointer}, pointer}, 
  {0, 0, "gdi32"   , "ResetDCW", {pointer, pointer}, pointer}, 
  {0, 0, "gdi32"   , "ResizePalette", {pointer, uint}, bool}, 
  {0, 0, "gdi32"   , "RestoreDC", {pointer, int}, bool}, 
  {0, 0, "gdi32"   , "RoundRect", {pointer, int, int, int, int, int, int}, bool}, 
  {0, 0, "gdi32"   , "SaveDC", {pointer}, int}, 
  {0, 0, "gdi32"   , "ScaleViewportExtEx", {pointer, int, int, int, int, long_pointer}, bool}, 
  {0, 0, "gdi32"   , "ScaleWindowExtEx", {pointer, int, int, int, int, long_pointer}, bool}, 
  {0, 0, "gdi32"   , "SelectClipPath", {pointer, int}, bool}, 
  {0, 0, "gdi32"   , "SelectClipRgn", {pointer, pointer}, int}, 
  {0, 0, "gdi32"   , "SelectObject", {pointer, pointer}, pointer}, 
  {0, 0, "gdi32"   , "SelectPalette", {pointer, pointer, bool}, pointer}, 
  {0, 0, "gdi32"   , "SetAbortProc", {pointer, pointer}, int}, 
  {0, 0, "gdi32"   , "SetArcDirection", {pointer, int}, int}, 
  {0, 0, "gdi32"   , "SetBitmapBits", {pointer, dword, pointer}, long}, 
  {0, 0, "gdi32"   , "SetBitmapDimensionEx", {pointer, int, int, long_pointer}, bool}, 
  {0, 0, "gdi32"   , "SetBkColor", {pointer, dword}, dword}, 
  {0, 0, "gdi32"   , "SetBkMode", {pointer, int}, int}, 
  {0, 0, "gdi32"   , "SetBoundsRect", {pointer, long_pointer, uint}, uint}, 
  {0, 0, "gdi32"   , "SetBrushOrgEx", {pointer, int, int, long_pointer}, bool}, 
  {0, 0, "gdi32"   , "SetColorAdjustment", {pointer, pointer}, bool}, 
  {0, 0, "gdi32"   , "SetColorSpace", {pointer, pointer}, bool}, 
  {0, 0, "gdi32"   , "SetDCBrushColor", {pointer, dword}, dword}, 
  {0, 0, "gdi32"   , "SetDCPenColor", {pointer, dword}, dword}, 
  {0, 0, "gdi32"   , "SetDeviceGammaRamp", {pointer, pointer}, bool}, 
  {0, 0, "gdi32"   , "SetDIBColorTable", {pointer, uint, uint, pointer}, uint}, 
  {0, 0, "gdi32"   , "SetDIBits", {pointer, pointer, uint, uint, pointer, pointer, uint}, int}, 
  {0, 0, "gdi32"   , "SetDIBitsToDevice", {pointer, int, int, dword, dword, int, int, uint, uint, pointer, pointer, uint}, int}, 
  {0, 0, "gdi32"   , "SetEnhMetaFileBits", {uint, pointer}, pointer}, 
  {0, 0, "gdi32"   , "SetGraphicsMode", {pointer, int}, int}, 
  {0, 0, "gdi32"   , "SetICMMode", {pointer, int}, int}, 
  {0, 0, "gdi32"   , "SetICMProfileA", {pointer, pointer}, bool}, 
  {0, 0, "gdi32"   , "SetICMProfileW", {pointer, pointer}, bool}, 
  {0, 0, "gdi32"   , "SetLayout", {pointer, dword}, dword}, 
  {0, 0, "gdi32"   , "SetMapMode", {pointer, int}, int}, 
  {0, 0, "gdi32"   , "SetMapperFlags", {pointer, dword}, dword}, 
  {0, 0, "gdi32"   , "SetMetaFileBitsEx", {uint, pointer}, pointer}, 
  {0, 0, "gdi32"   , "SetMetaRgn", {pointer}, int}, 
  {0, 0, "gdi32"   , "SetMiterLimit", {pointer, float, pointer}, bool}, 
  {0, 0, "gdi32"   , "SetPaletteEntries", {pointer, uint, uint, pointer}, uint}, 
  {0, 0, "gdi32"   , "SetPixel", {pointer, int, int, dword}, dword}, 
  {0, 0, "gdi32"   , "SetPixelFormat", {pointer, int, pointer}, bool}, 
  {0, 0, "gdi32"   , "SetPixelV", {pointer, int, int, dword}, bool}, 
  {0, 0, "gdi32"   , "SetPolyFillMode", {pointer, int}, int}, 
  {0, 0, "gdi32"   , "SetRectRgn", {pointer, int, int, int, int}, bool}, 
  {0, 0, "gdi32"   , "SetROP2", {pointer, int}, int}, 
  {0, 0, "gdi32"   , "SetStretchBltMode", {pointer, int}, int}, 
  {0, 0, "gdi32"   , "SetSystemPaletteUse", {pointer, uint}, uint}, 
  {0, 0, "gdi32"   , "SetTextAlign", {pointer, uint}, uint}, 
  {0, 0, "gdi32"   , "SetTextCharacterExtra", {pointer, int}, int}, 
  {0, 0, "gdi32"   , "SetTextColor", {pointer, dword}, dword}, 
  {0, 0, "gdi32"   , "SetTextJustification", {pointer, int, int}, bool}, 
  {0, 0, "gdi32"   , "SetViewportExtEx", {pointer, int, int, long_pointer}, bool}, 
  {0, 0, "gdi32"   , "SetViewportOrgEx", {pointer, int, int, long_pointer}, bool}, 
  {0, 0, "gdi32"   , "SetWindowExtEx", {pointer, int, int, long_pointer}, bool}, 
  {0, 0, "gdi32"   , "SetWindowOrgEx", {pointer, int, int, long_pointer}, bool}, 
  {0, 0, "gdi32"   , "SetWinMetaFileBits", {uint, pointer, pointer, pointer}, pointer}, 
  {0, 0, "gdi32"   , "SetWorldTransform", {pointer, pointer}, bool}, 
  {0, 0, "gdi32"   , "StartDocA", {pointer, pointer}, int}, 
  {0, 0, "gdi32"   , "StartDocW", {pointer, pointer}, int}, 
  {0, 0, "gdi32"   , "StartPage", {pointer}, int}, 
  {0, 0, "gdi32"   , "StretchBlt", {pointer, int, int, int, int, pointer, int, int, int, int, dword}, bool}, 
  {0, 0, "gdi32"   , "StretchDIBits", {pointer, int, int, int, int, int, int, int, int, pointer, pointer, uint, dword}, int}, 
  {0, 0, "gdi32"   , "StrokeAndFillPath", {pointer}, bool}, 
  {0, 0, "gdi32"   , "StrokePath", {pointer}, bool}, 
  {0, 0, "gdi32"   , "SwapBuffers", {pointer}, bool}, 
  {0, 0, "gdi32"   , "TextOutA", {pointer, int, int, pointer, int}, bool}, 
  {0, 0, "gdi32"   , "TextOutW", {pointer, int, int, pointer, int}, bool}, 
  {0, 0, "gdi32"   , "TranslateCharsetInfo", {pointer, long_pointer, dword}, bool}, 
  {0, 0, "gdi32"   , "TransparentBlt", {pointer, int, int, int, int, pointer, int, int, int, int, uint}, bool}, 
  {0, 0, "gdi32"   , "UnrealizeObject", {pointer}, bool}, 
  {0, 0, "gdi32"   , "UpdateColors", {pointer}, bool}, 
  {0, 0, "gdi32"   , "UpdateICMRegKeyA", {dword, dword, pointer, uint}, bool}, 
  {0, 0, "gdi32"   , "UpdateICMRegKeyW", {dword, dword, pointer, uint}, bool}, 
  {0, 0, "gdi32"   , "wglCopyContext", {pointer, pointer, uint}, bool}, 
  {0, 0, "gdi32"   , "wglCreateContext", {pointer}, pointer}, 
  {0, 0, "gdi32"   , "wglCreateLayerContext", {pointer, int}, pointer}, 
  {0, 0, "gdi32"   , "wglDeleteContext", {pointer}, bool}, 
  {0, 0, "gdi32"   , "wglDescribeLayerPlane", {pointer, int, int, uint, long_pointer}, bool}, 
  {0, 0, "gdi32"   , "wglGetCurrentContext", {}, pointer}, 
  {0, 0, "gdi32"   , "wglGetCurrentDC", {}, pointer}, 
  {0, 0, "gdi32"   , "wglGetLayerPaletteEntries", {pointer, int, int, int, pointer}, int}, 
  {0, 0, "gdi32"   , "wglGetProcAddress", {pointer}, pointer}, 
  {0, 0, "gdi32"   , "wglMakeCurrent", {pointer, pointer}, bool}, 
  {0, 0, "gdi32"   , "wglRealizeLayerPalette", {pointer, int, bool}, bool}, 
  {0, 0, "gdi32"   , "wglSetLayerPaletteEntries", {pointer, int, int, int, pointer}, int}, 
  {0, 0, "gdi32"   , "wglShareLists", {pointer, pointer}, bool}, 
  {0, 0, "gdi32"   , "wglSwapLayerBuffers", {pointer, uint}, bool}, 
  {0, 0, "gdi32"   , "wglUseFontBitmapsA", {pointer, dword, dword, dword}, bool}, 
  {0, 0, "gdi32"   , "wglUseFontBitmapsW", {pointer, dword, dword, dword}, bool}, 
  {0, 0, "gdi32"   , "wglUseFontOutlinesA", {pointer, dword, dword, dword, float, float, int, long_pointer}, bool}, 
  {0, 0, "gdi32"   , "wglUseFontOutlinesW", {pointer, dword, dword, dword, float, float, int, long_pointer}, bool}, 
  {0, 0, "gdi32"   , "WidenPath", {pointer}, bool}, 
  {0, 0, "hid"     , "HidD_FlushQueue", {pointer}, bool}, 
  {0, 0, "hid"     , "HidD_FreePreparsedData", {pointer}, bool}, 
  {0, 0, "hid"     , "HidD_GetAttributes", {pointer, pointer}, bool}, 
  {0, 0, "hid"     , "HidD_GetConfiguration", {pointer, pointer, ulong}, bool}, 
  {0, 0, "hid"     , "HidD_GetFeature", {pointer, pointer, ulong}, bool}, 
  {0, 0, "hid"     , "HidD_GetHidGuid", {long_pointer}}, 
  {0, 0, "hid"     , "HidD_GetIndexedString", {pointer, ulong, pointer, ulong}, bool}, 
  {0, 0, "hid"     , "HidD_GetManufacturerString", {pointer, pointer, ulong}, bool}, 
  {0, 0, "hid"     , "HidD_GetNumInputBuffers", {pointer, pointer}, bool}, 
  {0, 0, "hid"     , "HidD_GetPhysicalDescriptor", {pointer, pointer, ulong}, bool}, 
  {0, 0, "hid"     , "HidD_GetPreparsedData", {pointer, pointer}, bool}, 
  {0, 0, "hid"     , "HidD_GetProductString", {pointer, pointer, ulong}, bool}, 
  {0, 0, "hid"     , "HidD_GetSerialNumberString", {pointer, pointer, ulong}, bool}, 
  {0, 0, "hid"     , "HidD_SetConfiguration", {pointer, pointer, ulong}, bool}, 
  {0, 0, "hid"     , "HidD_SetFeature", {pointer, pointer, ulong}, bool}, 
  {0, 0, "hid"     , "HidD_SetNumInputBuffers", {pointer, ulong}, bool}, 
  {0, 0, "imagehlp", "UnDecorateSymbolName", {pointer, pointer, dword, dword}, dword}, 
  {0, 0, "iphlpapi", "GetAdaptersInfo", {pointer, pointer}, long}, 
  {0, 0, "iphlpapi", "GetIpAddrTable", {pointer, pointer, int}, int}, 
  {0, 0, "kernel32", "_hread", {int, long_pointer, long}, long}, 
  {0, 0, "kernel32", "_hwrite", {int, pointer, long}, long}, 
  {0, 0, "kernel32", "_lclose", {int}, int}, 
  {0, 0, "kernel32", "_lcreat", {pointer, int}, int}, 
  {0, 0, "kernel32", "_llseek", {int, long, int}, long}, 
  {0, 0, "kernel32", "_lopen", {pointer, int}, int}, 
  {0, 0, "kernel32", "_lread", {int, long_pointer, uint}, uint}, 
  {0, 0, "kernel32", "_lwrite", {int, pointer, uint}, uint}, 
  {0, 0, "kernel32", "AccessCheck", {pointer, pointer, dword, pointer, pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "AccessCheckAndAuditAlarmA", {pointer, long_pointer, pointer, pointer, pointer, dword, pointer, bool, pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "AccessCheckAndAuditAlarmW", {pointer, long_pointer, pointer, pointer, pointer, dword, pointer, bool, pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "ActivateActCtx", {pointer, pointer}, bool}, 
  {0, 0, "kernel32", "AddAccessAllowedAce", {pointer, dword, dword, pointer}, bool}, 
  {0, 0, "kernel32", "AddAccessAllowedAceEx", {pointer, dword, dword, dword, pointer}, bool}, 
  {0, 0, "kernel32", "AddAccessDeniedAce", {pointer, dword, dword, pointer}, bool}, 
  {0, 0, "kernel32", "AddAccessDeniedAceEx", {pointer, dword, dword, dword, pointer}, bool}, 
  {0, 0, "kernel32", "AddAce", {pointer, dword, dword, pointer, dword}, bool}, 
  {0, 0, "kernel32", "AddAtomA", {pointer}, word}, 
  {0, 0, "kernel32", "AddAtomW", {pointer}, word}, 
  {0, 0, "kernel32", "AddAuditAccessAce", {pointer, dword, dword, pointer, bool, bool}, bool}, 
  {0, 0, "kernel32", "AddRefActCtx", {pointer}}, 
  {0, 0, "kernel32", "AddVectoredExceptionHandler", {ulong, pointer}, pointer}, 
  {0, 0, "kernel32", "AdjustTokenGroups", {pointer, bool, pointer, dword, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "AdjustTokenPrivileges", {pointer, bool, pointer, dword, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "AllocateAndInitializeSid", {pointer, byte, dword, dword, dword, dword, dword, dword, dword, dword, pointer}, bool}, 
  {0, 0, "kernel32", "AllocateLocallyUniqueId", {pointer}, bool}, 
  {0, 0, "kernel32", "AllocateUserPhysicalPages", {pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "AllocConsole", {}, bool}, 
  {0, 0, "kernel32", "AreAllAccessesGranted", {dword, dword}, bool}, 
  {0, 0, "kernel32", "AreAnyAccessesGranted", {dword, dword}, bool}, 
  {0, 0, "kernel32", "AreFileApisANSI", {}, bool}, 
  {0, 0, "kernel32", "AssignProcessToJobObject", {pointer, pointer}, bool}, 
  {0, 0, "kernel32", "AttachConsole", {dword}, bool}, 
  {0, 0, "kernel32", "BackupEventLogA", {pointer, pointer}, bool}, 
  {0, 0, "kernel32", "BackupEventLogW", {pointer, pointer}, bool}, 
  {0, 0, "kernel32", "BackupRead", {pointer, pointer, dword, pointer, bool, bool, pointer}, bool}, 
  {0, 0, "kernel32", "BackupSeek", {pointer, dword, dword, pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "BackupWrite", {pointer, pointer, dword, pointer, bool, bool, pointer}, bool}, 
  {0, 0, "kernel32", "Beep", {dword, dword}, bool}, 
  {0, 0, "kernel32", "BeginUpdateResourceA", {pointer, bool}, pointer}, 
  {0, 0, "kernel32", "BeginUpdateResourceW", {pointer, bool}, pointer}, 
  {0, 0, "kernel32", "BuildCommDCBA", {pointer, long_pointer}, bool}, 
  {0, 0, "kernel32", "BuildCommDCBAndTimeoutsA", {pointer, long_pointer, long_pointer}, bool}, 
  {0, 0, "kernel32", "BuildCommDCBAndTimeoutsW", {pointer, long_pointer, long_pointer}, bool}, 
  {0, 0, "kernel32", "BuildCommDCBW", {pointer, long_pointer}, bool}, 
  {0, 0, "kernel32", "CallNamedPipeA", {pointer, pointer, dword, pointer, dword, pointer, dword}, bool}, 
  {0, 0, "kernel32", "CallNamedPipeW", {pointer, pointer, dword, pointer, dword, pointer, dword}, bool}, 
  {0, 0, "kernel32", "CancelDeviceWakeupRequest", {pointer}, bool}, 
  {0, 0, "kernel32", "CancelIo", {pointer}, bool}, 
  {0, 0, "kernel32", "CancelWaitableTimer", {pointer}, bool}, 
  {0, 0, "kernel32", "ChangeTimerQueueTimer", {pointer, pointer, ulong, ulong}, bool}, 
  {0, 0, "kernel32", "CheckNameLegalDOS8Dot3A", {pointer, pointer, dword, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "CheckNameLegalDOS8Dot3W", {pointer, pointer, dword, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "CheckRemoteDebuggerPresent", {pointer, pointer}, bool}, 
  {0, 0, "kernel32", "CheckTokenMembership", {pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "ClearCommBreak", {pointer}, bool}, 
  {0, 0, "kernel32", "ClearCommError", {pointer, pointer, long_pointer}, bool}, 
  {0, 0, "kernel32", "ClearEventLogA", {pointer, pointer}, bool}, 
  {0, 0, "kernel32", "ClearEventLogW", {pointer, pointer}, bool}, 
  {0, 0, "kernel32", "CloseEventLog", {pointer}, bool}, 
  {0, 0, "kernel32", "CloseHandle", {pointer}, bool}, 
  {0, 0, "kernel32", "CommConfigDialogA", {pointer, pointer, long_pointer}, bool}, 
  {0, 0, "kernel32", "CommConfigDialogW", {pointer, pointer, long_pointer}, bool}, 
  {0, 0, "kernel32", "CompareFileTime", {pointer, pointer}, long}, 
  {0, 0, "kernel32", "CompareStringA", {dword, dword, pointer, int, pointer, int}, int}, 
  {0, 0, "kernel32", "CompareStringW", {dword, dword, pointer, int, pointer, int}, int}, 
  {0, 0, "kernel32", "ConnectNamedPipe", {pointer, long_pointer}, bool}, 
  {0, 0, "kernel32", "ContinueDebugEvent", {dword, dword, dword}, bool}, 
  {0, 0, "kernel32", "ConvertDefaultLocale", {dword}, dword}, 
  {0, 0, "kernel32", "ConvertFiberToThread", {}, bool}, 
  {0, 0, "kernel32", "ConvertThreadToFiber", {pointer}, pointer}, 
  {0, 0, "kernel32", "CopyFileA", {pointer, pointer, bool}, bool}, 
  {0, 0, "kernel32", "CopyFileExA", {pointer, pointer, long_pointer, long_pointer, pointer, dword}, bool}, 
  {0, 0, "kernel32", "CopyFileExW", {pointer, pointer, long_pointer, long_pointer, pointer, dword}, bool}, 
  {0, 0, "kernel32", "CopyFileW", {pointer, pointer, bool}, bool}, 
  {0, 0, "kernel32", "CopySid", {dword, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "CreateActCtxA", {pointer}, pointer}, 
  {0, 0, "kernel32", "CreateActCtxW", {pointer}, pointer}, 
  {0, 0, "kernel32", "CreateConsoleScreenBuffer", {dword, dword, pointer, dword, long_pointer}, pointer}, 
  {0, 0, "kernel32", "CreateDirectoryA", {pointer, long_pointer}, bool}, 
  {0, 0, "kernel32", "CreateDirectoryExA", {pointer, pointer, long_pointer}, bool}, 
  {0, 0, "kernel32", "CreateDirectoryExW", {pointer, pointer, long_pointer}, bool}, 
  {0, 0, "kernel32", "CreateDirectoryW", {pointer, long_pointer}, bool}, 
  {0, 0, "kernel32", "CreateEventA", {long_pointer, bool, bool, pointer}, pointer}, 
  {0, 0, "kernel32", "CreateEventW", {long_pointer, bool, bool, pointer}, pointer}, 
  {0, 0, "kernel32", "CreateFiber", {size_t, long_pointer, long_pointer}, long_pointer}, 
  {0, 0, "kernel32", "CreateFiberEx", {size_t, size_t, dword, long_pointer, long_pointer}, long_pointer}, 
  {0, 0, "kernel32", "CreateFileA", {pointer, dword, dword, long_pointer, dword, dword, pointer}, pointer}, 
  {0, 0, "kernel32", "CreateFileMappingA", {pointer, long_pointer, dword, dword, dword, pointer}, pointer}, 
  {0, 0, "kernel32", "CreateFileMappingW", {pointer, long_pointer, dword, dword, dword, pointer}, pointer}, 
  {0, 0, "kernel32", "CreateFileW", {pointer, dword, dword, long_pointer, dword, dword, pointer}, pointer}, 
  {0, 0, "kernel32", "CreateHardLinkA", {pointer, pointer, long_pointer}, bool}, 
  {0, 0, "kernel32", "CreateHardLinkW", {pointer, pointer, long_pointer}, bool}, 
  {0, 0, "kernel32", "CreateIoCompletionPort", {pointer, pointer, pointer, dword}, pointer}, 
  {0, 0, "kernel32", "CreateJobObjectA", {long_pointer, pointer}, pointer}, 
  {0, 0, "kernel32", "CreateJobObjectW", {long_pointer, pointer}, pointer}, 
  {0, 0, "kernel32", "CreateMailslotA", {pointer, dword, dword, long_pointer}, pointer}, 
  {0, 0, "kernel32", "CreateMailslotW", {pointer, dword, dword, long_pointer}, pointer}, 
  {0, 0, "kernel32", "CreateMemoryResourceNotification", {pointer}, pointer}, 
  {0, 0, "kernel32", "CreateMutexA", {long_pointer, bool, pointer}, pointer}, 
  {0, 0, "kernel32", "CreateMutexW", {long_pointer, bool, pointer}, pointer}, 
  {0, 0, "kernel32", "CreateNamedPipeA", {pointer, dword, dword, dword, dword, dword, dword, long_pointer}, pointer}, 
  {0, 0, "kernel32", "CreateNamedPipeW", {pointer, dword, dword, dword, dword, dword, dword, long_pointer}, pointer}, 
  {0, 0, "kernel32", "CreatePipe", {pointer, pointer, long_pointer, dword}, bool}, 
  {0, 0, "kernel32", "CreatePrivateObjectSecurity", {pointer, pointer, pointer, bool, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "CreateProcessA", {pointer, pointer, long_pointer, long_pointer, bool, dword, pointer, pointer, long_pointer, long_pointer}, bool}, 
  {0, 0, "kernel32", "CreateProcessAsUserA", {pointer, pointer, pointer, long_pointer, long_pointer, bool, dword, pointer, pointer, long_pointer, long_pointer}, bool}, 
  {0, 0, "kernel32", "CreateProcessAsUserW", {pointer, pointer, pointer, long_pointer, long_pointer, bool, dword, pointer, pointer, long_pointer, long_pointer}, bool}, 
  {0, 0, "kernel32", "CreateProcessW", {pointer, pointer, long_pointer, long_pointer, bool, dword, pointer, pointer, long_pointer, long_pointer}, bool}, 
  {0, 0, "kernel32", "CreateRemoteThread", {pointer, long_pointer, dword, long_pointer, long_pointer, dword, pointer}, pointer}, 
  {0, 0, "kernel32", "CreateRestrictedToken", {pointer, dword, dword, pointer, dword, pointer, dword, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "CreateSemaphoreA", {long_pointer, long, long, pointer}, pointer}, 
  {0, 0, "kernel32", "CreateSemaphoreW", {long_pointer, long, long, pointer}, pointer}, 
  {0, 0, "kernel32", "CreateSymbolicLinkA", {pointer, pointer, dword}, bool}, 
  {0, 0, "kernel32", "CreateSymbolicLinkW", {pointer, pointer, dword}, bool}, 
  {0, 0, "kernel32", "CreateTapePartition", {pointer, dword, dword, dword}, dword}, 
  {0, 0, "kernel32", "CreateThread", {long_pointer, dword, long_pointer, pointer, dword, pointer}, pointer}, 
  {0, 0, "kernel32", "CreateTimerQueue", {}, pointer}, 
  {0, 0, "kernel32", "CreateTimerQueueTimer", {pointer, pointer, pointer, pointer, dword, dword, ulong}, bool}, 
  {0, 0, "kernel32", "CreateToolhelp32Snapshot", {dword, dword}, pointer}, 
  {0, 0, "kernel32", "CreateWaitableTimerA", {long_pointer, bool, pointer}, pointer}, 
  {0, 0, "kernel32", "CreateWaitableTimerW", {long_pointer, bool, pointer}, pointer}, 
  {0, 0, "kernel32", "DeactivateActCtx", {dword, pointer}, bool}, 
  {0, 0, "kernel32", "DebugActiveProcess", {dword}, bool}, 
  {0, 0, "kernel32", "DebugActiveProcessStop", {dword}, bool}, 
  {0, 0, "kernel32", "DebugBreak", {}}, 
  {0, 0, "kernel32", "DebugBreakProcess", {pointer}, bool}, 
  {0, 0, "kernel32", "DebugSetProcessKillOnExit", {bool}, bool}, 
  {0, 0, "kernel32", "DefineDosDeviceA", {dword, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "DefineDosDeviceW", {dword, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "DeleteAce", {pointer, dword}, bool}, 
  {0, 0, "kernel32", "DeleteAtom", {word}, word}, 
  {0, 0, "kernel32", "DeleteCriticalSection", {pointer}}, 
  {0, 0, "kernel32", "DeleteFiber", {pointer}}, 
  {0, 0, "kernel32", "DeleteFileA", {pointer}, bool}, 
  {0, 0, "kernel32", "DeleteFileW", {pointer}, bool}, 
  {0, 0, "kernel32", "DeleteTimerQueue", {pointer}, bool}, 
  {0, 0, "kernel32", "DeleteTimerQueueEx", {pointer, pointer}, bool}, 
  {0, 0, "kernel32", "DeleteTimerQueueTimer", {pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "DeleteVolumeMountPointA", {pointer}, bool}, 
  {0, 0, "kernel32", "DeleteVolumeMountPointW", {pointer}, bool}, 
  {0, 0, "kernel32", "DeregisterEventSource", {pointer}, bool}, 
  {0, 0, "kernel32", "DestroyPrivateObjectSecurity", {pointer}, bool}, 
  {0, 0, "kernel32", "DeviceIoControl", {pointer, dword, pointer, dword, pointer, dword, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "DisableThreadLibraryCalls", {pointer}, bool}, 
  {0, 0, "kernel32", "DisconnectNamedPipe", {pointer}, bool}, 
  {0, 0, "kernel32", "DllMain", {pointer, dword, long_pointer}, bool}, 
  {0, 0, "kernel32", "DnsHostnameToComputerNameA", {pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "DnsHostnameToComputerNameW", {pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "DosDateTimeToFileTime", {word, word, long_pointer}, bool}, 
  {0, 0, "kernel32", "DuplicateHandle", {pointer, pointer, pointer, pointer, dword, bool, dword}, bool}, 
  {0, 0, "kernel32", "DuplicateToken", {pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "DuplicateTokenEx", {pointer, dword, long_pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "EncryptFileA", {pointer}, bool}, 
  {0, 0, "kernel32", "EncryptFileW", {pointer}, bool}, 
  {0, 0, "kernel32", "EndUpdateResourceA", {pointer, bool}, bool}, 
  {0, 0, "kernel32", "EndUpdateResourceW", {pointer, bool}, bool}, 
  {0, 0, "kernel32", "EnterCriticalSection", {long_pointer}}, 
  {0, 0, "kernel32", "EnumCalendarInfoA", {pointer, dword, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "EnumCalendarInfoExA", {pointer, dword, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "EnumCalendarInfoExW", {pointer, dword, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "EnumCalendarInfoW", {pointer, dword, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "EnumDateFormatsA", {pointer, dword, dword}, bool}, 
  {0, 0, "kernel32", "EnumDateFormatsExA", {pointer, dword, dword}, bool}, 
  {0, 0, "kernel32", "EnumDateFormatsExW", {pointer, dword, dword}, bool}, 
  {0, 0, "kernel32", "EnumDateFormatsW", {pointer, dword, dword}, bool}, 
  {0, 0, "kernel32", "EnumLanguageGroupLocalesA", {pointer, dword, dword, pointer}, bool}, 
  {0, 0, "kernel32", "EnumLanguageGroupLocalesW", {pointer, dword, dword, pointer}, bool}, 
  {0, 0, "kernel32", "EnumResourceLanguagesA", {pointer, pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "EnumResourceLanguagesW", {pointer, pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "EnumResourceNamesA", {pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "EnumResourceNamesW", {pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "EnumResourceTypesA", {pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "EnumResourceTypesW", {pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "EnumSystemCodePagesA", {pointer, dword}, bool}, 
  {0, 0, "kernel32", "EnumSystemCodePagesW", {pointer, dword}, bool}, 
  {0, 0, "kernel32", "EnumSystemGeoID", {pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "EnumSystemLanguageGroupsA", {pointer, dword, pointer}, bool}, 
  {0, 0, "kernel32", "EnumSystemLanguageGroupsW", {pointer, dword, pointer}, bool}, 
  {0, 0, "kernel32", "EnumSystemLocalesA", {pointer, dword}, bool}, 
  {0, 0, "kernel32", "EnumSystemLocalesW", {pointer, dword}, bool}, 
  {0, 0, "kernel32", "EnumTimeFormatsA", {pointer, dword, dword}, bool}, 
  {0, 0, "kernel32", "EnumTimeFormatsW", {pointer, dword, dword}, bool}, 
  {0, 0, "kernel32", "EnumUILanguagesA", {pointer, dword, pointer}, bool}, 
  {0, 0, "kernel32", "EnumUILanguagesW", {pointer, dword, pointer}, bool}, 
  {0, 0, "kernel32", "EqualPrefixSid", {pointer, pointer}, bool}, 
  {0, 0, "kernel32", "EqualSid", {pointer, pointer}, bool}, 
  {0, 0, "kernel32", "EraseTape", {pointer, dword, bool}, dword}, 
  {0, 0, "kernel32", "EscapeCommFunction", {pointer, dword}, bool}, 
  {0, 0, "kernel32", "ExitProcess", {uint}}, 
  {0, 0, "kernel32", "ExitThread", {dword}}, 
  {0, 0, "kernel32", "ExpandEnvironmentStringsA", {pointer, pointer, dword}, dword}, 
  {0, 0, "kernel32", "ExpandEnvironmentStringsW", {pointer, pointer, dword}, dword}, 
  {0, 0, "kernel32", "FatalAppExitA", {uint, pointer}}, 
  {0, 0, "kernel32", "FatalAppExitW", {uint, pointer}}, 
  {0, 0, "kernel32", "FatalExit", {int}}, 
  {0, 0, "kernel32", "FileEncryptionStatusA", {pointer, pointer}, bool}, 
  {0, 0, "kernel32", "FileEncryptionStatusW", {pointer, pointer}, bool}, 
  {0, 0, "kernel32", "FileTimeToDosDateTime", {pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "FileTimeToLocalFileTime", {pointer, long_pointer}, bool}, 
  {0, 0, "kernel32", "FileTimeToSystemTime", {pointer, long_pointer}, bool}, 
  {0, 0, "kernel32", "FillConsoleOutputAttribute", {pointer, word, dword, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "FillConsoleOutputCharacterA", {pointer, char, dword, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "FillConsoleOutputCharacterW", {pointer, wchar, dword, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "FindActCtxSectionGuid", {dword, pointer, ulong, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "FindActCtxSectionStringA", {dword, pointer, ulong, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "FindActCtxSectionStringW", {dword, pointer, ulong, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "FindAtomA", {pointer}, word}, 
  {0, 0, "kernel32", "FindAtomW", {pointer}, word}, 
  {0, 0, "kernel32", "FindClose", {pointer}, bool}, 
  {0, 0, "kernel32", "FindCloseChangeNotification", {pointer}, bool}, 
  {0, 0, "kernel32", "FindFirstChangeNotificationA", {pointer, bool, dword}, pointer}, 
  {0, 0, "kernel32", "FindFirstChangeNotificationW", {pointer, bool, dword}, pointer}, 
  {0, 0, "kernel32", "FindFirstFileA", {pointer, long_pointer}, pointer}, 
  {0, 0, "kernel32", "FindFirstFileExA", {pointer, pointer, pointer, pointer, pointer, dword}, pointer}, 
  {0, 0, "kernel32", "FindFirstFileExW", {pointer, pointer, pointer, pointer, pointer, dword}, pointer}, 
  {0, 0, "kernel32", "FindFirstFileW", {pointer, pointer}, pointer}, 
  {0, 0, "kernel32", "FindFirstFreeAce", {pointer, pointer}, bool}, 
  {0, 0, "kernel32", "FindFirstVolumeA", {pointer, dword}, pointer}, 
  {0, 0, "kernel32", "FindFirstVolumeMountPointA", {pointer, pointer, dword}, pointer}, 
  {0, 0, "kernel32", "FindFirstVolumeMountPointW", {pointer, pointer, dword}, pointer}, 
  {0, 0, "kernel32", "FindFirstVolumeW", {pointer, dword}, pointer}, 
  {0, 0, "kernel32", "FindNextChangeNotification", {pointer}, bool}, 
  {0, 0, "kernel32", "FindNextFileA", {pointer, long_pointer}, bool}, 
  {0, 0, "kernel32", "FindNextFileW", {pointer, pointer}, bool}, 
  {0, 0, "kernel32", "FindNextVolumeA", {pointer, pointer, dword}, bool}, 
  {0, 0, "kernel32", "FindNextVolumeMountPointA", {pointer, pointer, dword}, bool}, 
  {0, 0, "kernel32", "FindNextVolumeMountPointW", {pointer, pointer, dword}, bool}, 
  {0, 0, "kernel32", "FindNextVolumeW", {pointer, pointer, dword}, bool}, 
  {0, 0, "kernel32", "FindResourceA", {pointer, pointer, pointer}, pointer}, 
  {0, 0, "kernel32", "FindResourceExA", {pointer, pointer, pointer, word}, pointer}, 
  {0, 0, "kernel32", "FindResourceExW", {pointer, pointer, pointer, word}, pointer}, 
  {0, 0, "kernel32", "FindResourceW", {pointer, pointer, pointer}, pointer}, 
  {0, 0, "kernel32", "FindVolumeClose", {pointer}, bool}, 
  {0, 0, "kernel32", "FindVolumeMountPointClose", {pointer}, bool}, 
  {0, 0, "kernel32", "FlushConsoleInputBuffer", {pointer}, bool}, 
  {0, 0, "kernel32", "FlushFileBuffers", {pointer}, bool}, 
  {0, 0, "kernel32", "FlushInstructionCache", {pointer, pointer, dword}, bool}, 
  {0, 0, "kernel32", "FlushViewOfFile", {pointer, dword}, bool}, 
  {0, 0, "kernel32", "FoldStringA", {dword, pointer, int, pointer, int}, int}, 
  {0, 0, "kernel32", "FoldStringW", {dword, pointer, int, pointer, int}, int}, 
  {0, 0, "kernel32", "FormatMessageA", {dword, pointer, dword, dword, pointer, dword, pointer}, dword}, 
  {0, 0, "kernel32", "FormatMessageW", {dword, pointer, dword, dword, pointer, dword, pointer}, dword}, 
  {0, 0, "kernel32", "FreeConsole", {}, bool}, 
  {0, 0, "kernel32", "FreeEnvironmentStringsA", {pointer}, bool}, 
  {0, 0, "kernel32", "FreeEnvironmentStringsW", {pointer}, bool}, 
  {0, 0, "kernel32", "FreeLibrary", {pointer}, bool}, 
  {0, 0, "kernel32", "FreeLibraryAndExitThread", {pointer, dword}}, 
  {0, 0, "kernel32", "FreeResource", {pointer}, bool}, 
  {0, 0, "kernel32", "FreeSid", {pointer}, pointer}, 
  {0, 0, "kernel32", "FreeUserPhysicalPages", {pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "GenerateConsoleCtrlEvent", {dword, dword}, bool}, 
  {0, 0, "kernel32", "GetAce", {pointer, dword, pointer}, bool}, 
  {0, 0, "kernel32", "GetAclInformation", {pointer, pointer, dword, pointer}, bool}, 
  {0, 0, "kernel32", "GetACP", {}, uint}, 
  {0, 0, "kernel32", "GetAtomNameA", {word, pointer, int}, uint}, 
  {0, 0, "kernel32", "GetAtomNameW", {word, pointer, int}, uint}, 
  {0, 0, "kernel32", "GetBinaryTypeA", {pointer, pointer}, bool}, 
  {0, 0, "kernel32", "GetBinaryTypeW", {pointer, pointer}, bool}, 
  {0, 0, "kernel32", "GetCalendarInfoA", {dword, pointer, pointer, pointer, int, pointer}, int}, 
  {0, 0, "kernel32", "GetCalendarInfoW", {dword, pointer, pointer, pointer, int, pointer}, int}, 
  {0, 0, "kernel32", "GetCommandLineA", {}, pointer}, 
  {0, 0, "kernel32", "GetCommandLineW", {}, pointer}, 
  {0, 0, "kernel32", "GetCommConfig", {pointer, long_pointer, pointer}, bool}, 
  {0, 0, "kernel32", "GetCommMask", {pointer, pointer}, bool}, 
  {0, 0, "kernel32", "GetCommModemStatus", {pointer, pointer}, bool}, 
  {0, 0, "kernel32", "GetCommProperties", {pointer, long_pointer}, bool}, 
  {0, 0, "kernel32", "GetCommState", {pointer, long_pointer}, bool}, 
  {0, 0, "kernel32", "GetCommTimeouts", {pointer, long_pointer}, bool}, 
  {0, 0, "kernel32", "GetCompressedFileSizeA", {pointer, pointer}, dword}, 
  {0, 0, "kernel32", "GetCompressedFileSizeW", {pointer, pointer}, dword}, 
  {0, 0, "kernel32", "GetComputerNameA", {pointer, pointer}, bool}, 
  {0, 0, "kernel32", "GetComputerNameExA", {pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "GetComputerNameExW", {pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "GetComputerNameW", {pointer, pointer}, bool}, 
  {0, 0, "kernel32", "GetConsoleCP", {}, uint}, 
  {0, 0, "kernel32", "GetConsoleCursorInfo", {pointer, pointer}, bool}, 
  {0, 0, "kernel32", "GetConsoleDisplayMode", {pointer}, bool}, 
  {0, 0, "kernel32", "GetConsoleMode", {pointer, pointer}, bool}, 
  {0, 0, "kernel32", "GetConsoleOutputCP", {}, uint}, 
  {0, 0, "kernel32", "GetConsoleProcessList", {pointer, dword}, dword}, 
  {0, 0, "kernel32", "GetConsoleScreenBufferInfo", {pointer, pointer}, bool}, 
  {0, 0, "kernel32", "GetConsoleTitleA", {pointer, dword}, dword}, 
  {0, 0, "kernel32", "GetConsoleTitleW", {pointer, dword}, dword}, 
  {0, 0, "kernel32", "GetConsoleWindow", {}, pointer}, 
  {0, 0, "kernel32", "GetCPInfo", {uint, long_pointer}, bool}, 
  {0, 0, "kernel32", "GetCPInfoExA", {uint, dword, long_pointer}, bool}, 
  {0, 0, "kernel32", "GetCPInfoExW", {uint, dword, long_pointer}, bool}, 
  {0, 0, "kernel32", "GetCurrencyFormatA", {dword, dword, pointer, pointer, pointer, int}, int}, 
  {0, 0, "kernel32", "GetCurrencyFormatW", {dword, dword, pointer, pointer, pointer, int}, int}, 
  {0, 0, "kernel32", "GetCurrentActCtx", {pointer}, bool}, 
  {0, 0, "kernel32", "GetCurrentDirectoryA", {dword, pointer}, dword}, 
  {0, 0, "kernel32", "GetCurrentDirectoryW", {dword, pointer}, dword}, 
  {0, 0, "kernel32", "GetCurrentHwProfileA", {pointer}, bool}, 
  {0, 0, "kernel32", "GetCurrentHwProfileW", {pointer}, bool}, 
  {0, 0, "kernel32", "GetCurrentProcess", {}, pointer}, 
  {0, 0, "kernel32", "GetCurrentProcessId", {}, dword}, 
  {0, 0, "kernel32", "GetCurrentThread", {}, pointer}, 
  {0, 0, "kernel32", "GetCurrentThreadId", {}, dword}, 
  {0, 0, "kernel32", "GetDateFormatA", {dword, dword, pointer, pointer, pointer, int}, int}, 
  {0, 0, "kernel32", "GetDateFormatW", {dword, dword, pointer, pointer, pointer, int}, int}, 
  {0, 0, "kernel32", "GetDefaultCommConfigA", {pointer, long_pointer, pointer}, bool}, 
  {0, 0, "kernel32", "GetDefaultCommConfigW", {pointer, long_pointer, pointer}, bool}, 
  {0, 0, "kernel32", "GetDevicePowerState", {pointer, pointer}, bool}, 
  {0, 0, "kernel32", "GetDiskFreeSpaceA", {pointer, pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "GetDiskFreeSpaceExA", {pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "GetDiskFreeSpaceExW", {pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "GetDiskFreeSpaceW", {pointer, pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "GetDllDirectoryA", {dword, pointer}, dword}, 
  {0, 0, "kernel32", "GetDllDirectoryW", {dword, pointer}, dword}, 
  {0, 0, "kernel32", "GetDriveTypeA", {pointer}, uint}, 
  {0, 0, "kernel32", "GetDriveTypeW", {pointer}, uint}, 
  {0, 0, "kernel32", "GetEnvironmentStrings", {}, long_pointer}, 
  {0, 0, "kernel32", "GetEnvironmentStringsA", {}, long_pointer}, 
  {0, 0, "kernel32", "GetEnvironmentStringsW", {}, long_pointer}, 
  {0, 0, "kernel32", "GetEnvironmentVariableA", {pointer, pointer, dword}, dword}, 
  {0, 0, "kernel32", "GetEnvironmentVariableW", {pointer, pointer, dword}, dword}, 
  {0, 0, "kernel32", "GetExitCodeProcess", {pointer, pointer}, bool}, 
  {0, 0, "kernel32", "GetExitCodeThread", {pointer, pointer}, bool}, 
  {0, 0, "kernel32", "GetFileAttributesA", {pointer}, dword}, 
  {0, 0, "kernel32", "GetFileAttributesExA", {pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "GetFileAttributesExW", {pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "GetFileAttributesW", {pointer}, dword}, 
  {0, 0, "kernel32", "GetFileInformationByHandle", {pointer, long_pointer}, bool}, 
  {0, 0, "kernel32", "GetFileInformationByHandleEx", {pointer, pointer, long_pointer, dword}, bool}, 
  {0, 0, "kernel32", "GetFileSecurityA", {pointer, pointer, pointer, dword, pointer}, bool}, 
  {0, 0, "kernel32", "GetFileSecurityW", {pointer, pointer, pointer, dword, pointer}, bool}, 
  {0, 0, "kernel32", "GetFileSize", {pointer, pointer}, dword}, 
  {0, 0, "kernel32", "GetFileSizeEx", {pointer, pointer}, bool}, 
  {0, 0, "kernel32", "GetFileTime", {pointer, long_pointer, long_pointer, long_pointer}, bool}, 
  {0, 0, "kernel32", "GetFileType", {pointer}, dword}, 
  {0, 0, "kernel32", "GetFinalPathNameByHandleA", {pointer, pointer, dword, dword}, dword}, 
  {0, 0, "kernel32", "GetFinalPathNameByHandleW", {pointer, pointer, dword, dword}, dword}, 
  {0, 0, "kernel32", "GetFirmwareEnvironmentVariableA", {pointer, pointer, pointer, dword}, dword}, 
  {0, 0, "kernel32", "GetFirmwareEnvironmentVariableW", {pointer, pointer, pointer, dword}, dword}, 
  {0, 0, "kernel32", "GetFullPathNameA", {pointer, dword, pointer, pointer}, dword}, 
  {0, 0, "kernel32", "GetFullPathNameW", {pointer, dword, pointer, pointer}, dword}, 
  {0, 0, "kernel32", "GetGeoInfoA", {pointer, pointer, pointer, int, word}, int}, 
  {0, 0, "kernel32", "GetGeoInfoW", {pointer, pointer, pointer, int, word}, int}, 
  {0, 0, "kernel32", "GetHandleInformation", {pointer, pointer}, bool}, 
  {0, 0, "kernel32", "GetKernelObjectSecurity", {pointer, pointer, pointer, dword, pointer}, bool}, 
  {0, 0, "kernel32", "GetLargestConsoleWindowSize", {pointer}, pointer}, 
  {0, 0, "kernel32", "GetLastError", {}, dword}, 
  {0, 0, "kernel32", "GetLengthSid", {pointer}, dword}, 
  {0, 0, "kernel32", "GetLocaleInfoA", {dword, dword, pointer, int}, int}, 
  {0, 0, "kernel32", "GetLocaleInfoW", {dword, dword, pointer, int}, int}, 
  {0, 0, "kernel32", "GetLocalTime", {long_pointer}}, 
  {0, 0, "kernel32", "GetLogicalDrives", {}, dword}, 
  {0, 0, "kernel32", "GetLogicalDriveStringsA", {dword, pointer}, dword}, 
  {0, 0, "kernel32", "GetLogicalDriveStringsW", {dword, pointer}, dword}, 
  {0, 0, "kernel32", "GetLongPathNameA", {pointer, pointer, dword}, dword}, 
  {0, 0, "kernel32", "GetLongPathNameW", {pointer, pointer, dword}, dword}, 
  {0, 0, "kernel32", "GetMailslotInfo", {pointer, pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "GetModuleFileNameA", {pointer, pointer, dword}, dword}, 
  {0, 0, "kernel32", "GetModuleFileNameW", {pointer, pointer, dword}, dword}, 
  {0, 0, "kernel32", "GetModuleHandleA", {pointer}, pointer}, 
  {0, 0, "kernel32", "GetModuleHandleExA", {dword, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "GetModuleHandleExW", {dword, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "GetModuleHandleW", {pointer}, pointer}, 
  {0, 0, "kernel32", "GetNamedPipeHandleStateA", {pointer, pointer, pointer, pointer, pointer, pointer, dword}, bool}, 
  {0, 0, "kernel32", "GetNamedPipeHandleStateW", {pointer, pointer, pointer, pointer, pointer, pointer, dword}, bool}, 
  {0, 0, "kernel32", "GetNamedPipeInfo", {pointer, pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "GetNativeSystemInfo", {long_pointer}}, 
  {0, 0, "kernel32", "GetNLSVersion", {pointer, dword, long_pointer}, bool}, 
  {0, 0, "kernel32", "GetNumberFormatA", {dword, dword, pointer, pointer, pointer, int}, int}, 
  {0, 0, "kernel32", "GetNumberFormatW", {dword, dword, pointer, pointer, pointer, int}, int}, 
  {0, 0, "kernel32", "GetNumberOfConsoleInputEvents", {pointer, pointer}, bool}, 
  {0, 0, "kernel32", "GetNumberOfConsoleMouseButtons", {pointer}, bool}, 
  {0, 0, "kernel32", "GetNumberOfEventLogRecords", {pointer, pointer}, bool}, 
  {0, 0, "kernel32", "GetOEMCP", {}, uint}, 
  {0, 0, "kernel32", "GetOldestEventLogRecord", {pointer, pointer}, bool}, 
  {0, 0, "kernel32", "GetOverlappedResult", {pointer, long_pointer, pointer, bool}, bool}, 
  {0, 0, "kernel32", "GetPriorityClass", {pointer}, dword}, 
  {0, 0, "kernel32", "GetPrivateObjectSecurity", {pointer, pointer, pointer, dword, pointer}, bool}, 
  {0, 0, "kernel32", "GetPrivateProfileIntA", {pointer, pointer, int, pointer}, uint}, 
  {0, 0, "kernel32", "GetPrivateProfileIntW", {pointer, pointer, int, pointer}, uint}, 
  {0, 0, "kernel32", "GetPrivateProfileSectionA", {pointer, pointer, dword, pointer}, dword}, 
  {0, 0, "kernel32", "GetPrivateProfileSectionNamesA", {pointer, dword, pointer}, dword}, 
  {0, 0, "kernel32", "GetPrivateProfileSectionNamesW", {pointer, dword, pointer}, dword}, 
  {0, 0, "kernel32", "GetPrivateProfileSectionW", {pointer, pointer, dword, pointer}, dword}, 
  {0, 0, "kernel32", "GetPrivateProfileStringA", {pointer, pointer, pointer, pointer, dword, pointer}, dword}, 
  {0, 0, "kernel32", "GetPrivateProfileStringW", {pointer, pointer, pointer, pointer, dword, pointer}, dword}, 
  {0, 0, "kernel32", "GetPrivateProfileStructA", {pointer, pointer, long_pointer, uint, pointer}, bool}, 
  {0, 0, "kernel32", "GetPrivateProfileStructW", {pointer, pointer, long_pointer, uint, pointer}, bool}, 
  {0, 0, "kernel32", "GetProcAddress", {pointer, pointer}, pointer}, 
  {0, 0, "kernel32", "GetProcessAffinityMask", {pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "GetProcessDEPPolicy", {pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "GetProcessHandleCount", {pointer, pointer}, bool}, 
  {0, 0, "kernel32", "GetProcessHeap", {}, pointer}, 
  {0, 0, "kernel32", "GetProcessHeaps", {dword, pointer}, dword}, 
  {0, 0, "kernel32", "GetProcessId", {pointer}, dword}, 
  {0, 0, "kernel32", "GetProcessIoCounters", {pointer, pointer}, bool}, 
  {0, 0, "kernel32", "GetProcessPriorityBoost", {pointer, pointer}, bool}, 
  {0, 0, "kernel32", "GetProcessShutdownParameters", {pointer, pointer}, bool}, 
  {0, 0, "kernel32", "GetProcessTimes", {pointer, long_pointer, long_pointer, long_pointer, long_pointer}, bool}, 
  {0, 0, "kernel32", "GetProcessVersion", {dword}, dword}, 
  {0, 0, "kernel32", "GetProcessWindowStation", {}, pointer}, 
  {0, 0, "kernel32", "GetProcessWorkingSetSize", {pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "GetProfileIntA", {pointer, pointer, int}, uint}, 
  {0, 0, "kernel32", "GetProfileIntW", {pointer, pointer, int}, uint}, 
  {0, 0, "kernel32", "GetProfileSectionA", {pointer, pointer, dword}, dword}, 
  {0, 0, "kernel32", "GetProfileSectionW", {pointer, pointer, dword}, dword}, 
  {0, 0, "kernel32", "GetProfileStringA", {pointer, pointer, pointer, pointer, dword}, dword}, 
  {0, 0, "kernel32", "GetProfileStringW", {pointer, pointer, pointer, pointer, dword}, dword}, 
  {0, 0, "kernel32", "GetProcAddress", {pointer, pointer}, pointer}, 
  {0, 0, "kernel32", "GetProcessAffinityMask", {pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "GetProcessDEPPolicy", {pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "GetProcessHandleCount", {pointer, pointer}, bool}, 
  {0, 0, "kernel32", "GetProcessHeap", {}, pointer}, 
  {0, 0, "kernel32", "GetProcessHeaps", {dword, pointer}, dword}, 
  {0, 0, "kernel32", "GetProcessId", {pointer}, dword}, 
  {0, 0, "kernel32", "GetProcessIoCounters", {pointer, pointer}, bool}, 
  {0, 0, "kernel32", "GetProcessPriorityBoost", {pointer, pointer}, bool}, 
  {0, 0, "kernel32", "GetProcessShutdownParameters", {pointer, pointer}, bool}, 
  {0, 0, "kernel32", "GetProcessTimes", {pointer, long_pointer, long_pointer, long_pointer, long_pointer}, bool}, 
  {0, 0, "kernel32", "GetProcessVersion", {dword}, dword}, 
  {0, 0, "kernel32", "GetProcessWindowStation", {}, pointer}, 
  {0, 0, "kernel32", "GetProcessWorkingSetSize", {pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "GetProfileIntA", {pointer, pointer, int}, uint}, 
  {0, 0, "kernel32", "GetProfileIntW", {pointer, pointer, int}, uint}, 
  {0, 0, "kernel32", "GetProfileSectionA", {pointer, pointer, dword}, dword}, 
  {0, 0, "kernel32", "GetProfileSectionW", {pointer, pointer, dword}, dword}, 
  {0, 0, "kernel32", "GetProfileStringA", {pointer, pointer, pointer, pointer, dword}, dword}, 
  {0, 0, "kernel32", "GetProfileStringW", {pointer, pointer, pointer, pointer, dword}, dword}, 
  {0, 0, "kernel32", "GetQueuedCompletionStatus", {pointer, pointer, pointer, pointer, dword}, bool}, 
  {0, 0, "kernel32", "GetSecurityDescriptorControl", {pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "GetSecurityDescriptorDacl", {pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "GetSecurityDescriptorGroup", {pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "GetSecurityDescriptorLength", {pointer}, dword}, 
  {0, 0, "kernel32", "GetSecurityDescriptorOwner", {pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "GetSecurityDescriptorSacl", {pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "GetShortPathNameA", {pointer, pointer, dword}, dword}, 
  {0, 0, "kernel32", "GetShortPathNameW", {pointer, pointer, dword}, dword}, 
  {0, 0, "kernel32", "GetSidIdentifierAuthority", {pointer}, pointer}, 
  {0, 0, "kernel32", "GetSidLengthRequired", {uchar}, dword}, 
  {0, 0, "kernel32", "GetSidSubAuthority", {pointer, dword}, pointer}, 
  {0, 0, "kernel32", "GetSidSubAuthorityCount", {pointer}, pointer}, 
  {0, 0, "kernel32", "GetStartupInfoA", {long_pointer}}, 
  {0, 0, "kernel32", "GetStartupInfoW", {long_pointer}}, 
  {0, 0, "kernel32", "GetStdHandle", {dword}, pointer}, 
  {0, 0, "kernel32", "GetStringTypeA", {dword, dword, pointer, int, pointer}, bool}, 
  {0, 0, "kernel32", "GetStringTypeExA", {dword, dword, pointer, int, pointer}, bool}, 
  {0, 0, "kernel32", "GetStringTypeExW", {dword, dword, pointer, int, pointer}, bool}, 
  {0, 0, "kernel32", "GetStringTypeW", {dword, pointer, int, pointer}, bool}, 
  {0, 0, "kernel32", "GetSystemDefaultLangID", {}, word}, 
  {0, 0, "kernel32", "GetSystemDefaultLCID", {}, dword}, 
  {0, 0, "kernel32", "GetSystemDefaultUILanguage", {}, word}, 
  {0, 0, "kernel32", "GetSystemDEPPolicy", {}, pointer}, 
  {0, 0, "kernel32", "GetSystemDirectoryA", {pointer, uint}, uint}, 
  {0, 0, "kernel32", "GetSystemDirectoryW", {pointer, uint}, uint}, 
  {0, 0, "kernel32", "GetSystemInfo", {long_pointer}}, 
  {0, 0, "kernel32", "GetSystemPowerStatus", {long_pointer}, bool}, 
  {0, 0, "kernel32", "GetSystemRegistryQuota", {pointer, pointer}, bool}, 
  {0, 0, "kernel32", "GetSystemTime", {long_pointer}}, 
  {0, 0, "kernel32", "GetSystemTimeAdjustment", {pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "GetSystemTimeAsFileTime", {long_pointer}}, 
  {0, 0, "kernel32", "GetSystemTimes", {long_pointer, long_pointer, long_pointer}, bool}, 
  {0, 0, "kernel32", "GetSystemWindowsDirectoryA", {pointer, uint}, uint}, 
  {0, 0, "kernel32", "GetSystemWindowsDirectoryW", {pointer, uint}, uint}, 
  {0, 0, "kernel32", "GetSystemWow64DirectoryA", {pointer, uint}, uint}, 
  {0, 0, "kernel32", "GetSystemWow64DirectoryW", {pointer, uint}, uint}, 
  {0, 0, "kernel32", "GetTapeParameters", {pointer, dword, pointer, pointer}, dword}, 
  {0, 0, "kernel32", "GetTapePosition", {pointer, dword, pointer, pointer, pointer}, dword}, 
  {0, 0, "kernel32", "GetTapeStatus", {pointer}, dword}, 
  {0, 0, "kernel32", "GetTempFileNameA", {pointer, pointer, uint, pointer}, uint}, 
  {0, 0, "kernel32", "GetTempFileNameW", {pointer, pointer, uint, pointer}, uint}, 
  {0, 0, "kernel32", "GetTempPathA", {dword, pointer}, dword}, 
  {0, 0, "kernel32", "GetTempPathW", {dword, pointer}, dword}, 
  {0, 0, "kernel32", "GetThreadContext", {pointer, long_pointer}, bool}, 
  {0, 0, "kernel32", "GetThreadIOPendingFlag", {pointer, pointer}, bool}, 
  {0, 0, "kernel32", "GetThreadLocale", {}, dword}, 
  {0, 0, "kernel32", "GetThreadPriority", {pointer}, int}, 
  {0, 0, "kernel32", "GetThreadPriorityBoost", {pointer, pointer}, bool}, 
  {0, 0, "kernel32", "GetThreadSelectorEntry", {pointer, dword, long_pointer}, bool}, 
  {0, 0, "kernel32", "GetThreadTimes", {pointer, long_pointer, long_pointer, long_pointer, long_pointer}, bool}, 
  {0, 0, "kernel32", "GetTickCount", {}, dword}, 
  {0, 0, "kernel32", "GetTimeFormatA", {dword, dword, pointer, pointer, pointer, int}, int}, 
  {0, 0, "kernel32", "GetTimeFormatW", {dword, dword, pointer, pointer, pointer, int}, int}, 
  {0, 0, "kernel32", "GetTimeZoneInformation", {long_pointer}, dword}, 
  {0, 0, "kernel32", "GetTokenInformation", {pointer, pointer, pointer, dword, pointer}, bool}, 
  {0, 0, "kernel32", "GetUserDefaultLangID", {}, word}, 
  {0, 0, "kernel32", "GetUserDefaultLCID", {}, dword}, 
  {0, 0, "kernel32", "GetUserDefaultUILanguage", {}, word}, 
  {0, 0, "kernel32", "GetUserGeoID", {pointer}, pointer}, 
  {0, 0, "kernel32", "GetUserNameA", {pointer, pointer}, bool}, 
  {0, 0, "kernel32", "GetUserNameW", {pointer, pointer}, bool}, 
  {0, 0, "kernel32", "GetVersion", {}, dword}, 
  {0, 0, "kernel32", "GetVersionExA", {long_pointer}, bool}, 
  {0, 0, "kernel32", "GetVersionExW", {long_pointer}, bool}, 
  {0, 0, "kernel32", "GetVolumeInformationA", {pointer, pointer, dword, pointer, pointer, pointer, pointer, dword}, bool}, 
  {0, 0, "kernel32", "GetVolumeInformationW", {pointer, pointer, dword, pointer, pointer, pointer, pointer, dword}, bool}, 
  {0, 0, "kernel32", "GetVolumeNameForVolumeMountPointA", {pointer, pointer, dword}, bool}, 
  {0, 0, "kernel32", "GetVolumeNameForVolumeMountPointW", {pointer, pointer, dword}, bool}, 
  {0, 0, "kernel32", "GetVolumePathNameA", {pointer, pointer, dword}, bool}, 
  {0, 0, "kernel32", "GetVolumePathNamesForVolumeNameA", {pointer, pointer, dword, pointer}, bool}, 
  {0, 0, "kernel32", "GetVolumePathNamesForVolumeNameW", {pointer, pointer, dword, pointer}, bool}, 
  {0, 0, "kernel32", "GetVolumePathNameW", {pointer, pointer, dword}, bool}, 
  {0, 0, "kernel32", "GetWindowsDirectoryA", {pointer, uint}, uint}, 
  {0, 0, "kernel32", "GetWindowsDirectoryW", {pointer, uint}, uint}, 
  {0, 0, "kernel32", "GetWindowThreadProcessId", {pointer, pointer}, dword}, 
  {0, 0, "kernel32", "GetWriteWatch", {dword, pointer, size_t, pointer, pointer, pointer}, uint}, 
  {0, 0, "kernel32", "GlobalAddAtomA", {pointer}, word}, 
  {0, 0, "kernel32", "GlobalAddAtomW", {pointer}, word}, 
  {0, 0, "kernel32", "GlobalAlloc", {uint, dword}, pointer}, 
  {0, 0, "kernel32", "GlobalCompact", {dword}, size_t}, 
  {0, 0, "kernel32", "GlobalDeleteAtom", {word}, word}, 
  {0, 0, "kernel32", "GlobalFindAtomA", {pointer}, word}, 
  {0, 0, "kernel32", "GlobalFindAtomW", {pointer}, word}, 
  {0, 0, "kernel32", "GlobalFix", {pointer}}, 
  {0, 0, "kernel32", "GlobalFlags", {pointer}, uint}, 
  {0, 0, "kernel32", "GlobalFree", {pointer}, pointer}, 
  {0, 0, "kernel32", "GlobalGetAtomNameA", {word, pointer, int}, uint}, 
  {0, 0, "kernel32", "GlobalGetAtomNameW", {word, pointer, int}, uint}, 
  {0, 0, "kernel32", "GlobalHandle", {pointer}, pointer}, 
  {0, 0, "kernel32", "GlobalLock", {pointer}, long_pointer}, 
  {0, 0, "kernel32", "GlobalMemoryStatus", {long_pointer}}, 
  {0, 0, "kernel32", "GlobalMemoryStatusEx", {long_pointer}, bool}, 
  {0, 0, "kernel32", "GlobalReAlloc", {pointer, dword, uint}, pointer}, 
  {0, 0, "kernel32", "GlobalSize", {pointer}, dword}, 
  {0, 0, "kernel32", "GlobalUnfix", {pointer}}, 
  {0, 0, "kernel32", "GlobalUnlock", {pointer}, bool}, 
  {0, 0, "kernel32", "GlobalUnWire", {pointer}, bool}, 
  {0, 0, "kernel32", "GlobalWire", {pointer}, pointer}, 
  {0, 0, "kernel32", "Heap32First", {long_pointer, dword, dword}, bool}, 
  {0, 0, "kernel32", "Heap32ListFirst", {pointer, long_pointer}, bool}, 
  {0, 0, "kernel32", "Heap32ListNext", {pointer, long_pointer}, bool}, 
  {0, 0, "kernel32", "Heap32Next", {long_pointer}, bool}, 
  {0, 0, "kernel32", "HeapAlloc", {pointer, dword, dword}, pointer}, 
  {0, 0, "kernel32", "HeapCompact", {pointer, dword}, size_t}, 
  {0, 0, "kernel32", "HeapCreate", {dword, dword, dword}, pointer}, 
  {0, 0, "kernel32", "HeapDestroy", {pointer}, bool}, 
  {0, 0, "kernel32", "HeapFree", {pointer, dword, pointer}, bool}, 
  {0, 0, "kernel32", "HeapLock", {pointer}, bool}, 
  {0, 0, "kernel32", "HeapQueryInformation", {pointer, pointer, pointer, size_t, pointer}, bool}, 
  {0, 0, "kernel32", "HeapReAlloc", {pointer, dword, pointer, dword}, pointer}, 
  {0, 0, "kernel32", "HeapSetInformation", {pointer, pointer, pointer, size_t}, bool}, 
  {0, 0, "kernel32", "HeapSize", {pointer, dword, pointer}, dword}, 
  {0, 0, "kernel32", "HeapUnlock", {pointer}, bool}, 
  {0, 0, "kernel32", "HeapValidate", {pointer, dword, pointer}, bool}, 
  {0, 0, "kernel32", "HeapWalk", {pointer, long_pointer}, bool}, 
  {0, 0, "kernel32", "ImpersonateLoggedOnUser", {pointer}, bool}, 
  {0, 0, "kernel32", "ImpersonateNamedPipeClient", {pointer}, bool}, 
  {0, 0, "kernel32", "ImpersonateSelf", {pointer}, bool}, 
  {0, 0, "kernel32", "InitAtomTable", {dword}, bool}, 
  {0, 0, "kernel32", "InitializeAcl", {pointer, dword, dword}, bool}, 
  {0, 0, "kernel32", "InitializeCriticalSection", {long_pointer}}, 
  {0, 0, "kernel32", "InitializeCriticalSectionAndSpinCount", {long_pointer, dword}, bool}, 
  {0, 0, "kernel32", "InitializeSecurityDescriptor", {pointer, dword}, bool}, 
  {0, 0, "kernel32", "InitializeSid", {pointer, pointer, byte}, bool}, 
  {0, 0, "kernel32", "InitializeSListHead", {pointer}}, 
  {0, 0, "kernel32", "InterlockedCompareExchange", {pointer, long, long}, long}, 
  {0, 0, "kernel32", "InterlockedCompareExchangePointer", {pointer, pointer, pointer}, pointer}, 
  {0, 0, "kernel32", "InterlockedDecrement", {pointer}, long}, 
  {0, 0, "kernel32", "InterlockedExchange", {pointer, long}, long}, 
  {0, 0, "kernel32", "InterlockedExchangeAdd", {pointer, long}, long}, 
  {0, 0, "kernel32", "InterlockedExchangePointer", {pointer, pointer}, pointer}, 
  {0, 0, "kernel32", "InterlockedFlushSList", {pointer}, pointer}, 
  {0, 0, "kernel32", "InterlockedIncrement", {pointer}, long}, 
  {0, 0, "kernel32", "InterlockedPopEntrySList", {pointer}, pointer}, 
  {0, 0, "kernel32", "InterlockedPushEntrySList", {pointer, pointer}, pointer}, 
  {0, 0, "kernel32", "IsBadCodePtr", {pointer}, bool}, 
  {0, 0, "kernel32", "IsBadHugeReadPtr", {pointer, uint}, bool}, 
  {0, 0, "kernel32", "IsBadHugeWritePtr", {pointer, uint}, bool}, 
  {0, 0, "kernel32", "IsBadReadPtr", {pointer, uint}, bool}, 
  {0, 0, "kernel32", "IsBadStringPtrA", {pointer, uint}, bool}, 
  {0, 0, "kernel32", "IsBadStringPtrW", {pointer, uint}, bool}, 
  {0, 0, "kernel32", "IsBadWritePtr", {pointer, uint}, bool}, 
  {0, 0, "kernel32", "IsDBCSLeadByte", {byte}, bool}, 
  {0, 0, "kernel32", "IsDBCSLeadByteEx", {uint, byte}, bool}, 
  {0, 0, "kernel32", "IsDebuggerPresent", {}, bool}, 
  {0, 0, "kernel32", "IsNLSDefinedString", {pointer, dword, long_pointer, pointer, int}, bool}, 
  {0, 0, "kernel32", "IsProcessorFeaturePresent", {dword}, bool}, 
  {0, 0, "kernel32", "IsSystemResumeAutomatic", {}, bool}, 
  {0, 0, "kernel32", "IsTextUnicode", {pointer, int, pointer}, bool}, 
  {0, 0, "kernel32", "IsTokenRestricted", {pointer}, bool}, 
  {0, 0, "kernel32", "IsValidAcl", {pointer}, bool}, 
  {0, 0, "kernel32", "IsValidCodePage", {uint}, bool}, 
  {0, 0, "kernel32", "IsValidLanguageGroup", {dword, dword}, word}, 
  {0, 0, "kernel32", "IsValidLocale", {dword, dword}, bool}, 
  {0, 0, "kernel32", "IsValidSecurityDescriptor", {pointer}, bool}, 
  {0, 0, "kernel32", "IsValidSid", {pointer}, bool}, 
  {0, 0, "kernel32", "IsWow64Process", {pointer, pointer}, bool}, 
  {0, 0, "kernel32", "LCMapStringA", {dword, dword, pointer, int, pointer, int}, int}, 
  {0, 0, "kernel32", "LCMapStringW", {dword, dword, pointer, int, pointer, int}, int}, 
  {0, 0, "kernel32", "LeaveCriticalSection", {long_pointer}}, 
  {0, 0, "kernel32", "LoadLibraryA", {pointer}, pointer}, 
  {0, 0, "kernel32", "LoadLibraryExA", {pointer, pointer, dword}, pointer}, 
  {0, 0, "kernel32", "LoadLibraryExW", {pointer, pointer, dword}, pointer}, 
  {0, 0, "kernel32", "LoadLibraryW", {pointer}, pointer}, 
  {0, 0, "kernel32", "LoadModule", {pointer, pointer}, dword}, 
  {0, 0, "kernel32", "LoadResource", {pointer, pointer}, pointer}, 
  {0, 0, "kernel32", "LocalAlloc", {uint, size_t}, pointer}, 
  {0, 0, "kernel32", "LocalCompact", {uint}, size_t}, 
  {0, 0, "kernel32", "LocalFileTimeToFileTime", {pointer, long_pointer}, bool}, 
  {0, 0, "kernel32", "LocalFlags", {pointer}, uint}, 
  {0, 0, "kernel32", "LocalFree", {pointer}, pointer}, 
  {0, 0, "kernel32", "LocalHandle", {pointer}, pointer}, 
  {0, 0, "kernel32", "LocalLock", {pointer}, pointer}, 
  {0, 0, "kernel32", "LocalReAlloc", {pointer, size_t, uint}, pointer}, 
  {0, 0, "kernel32", "LocalShrink", {pointer, uint}, size_t}, 
  {0, 0, "kernel32", "LocalSize", {pointer}, uint}, 
  {0, 0, "kernel32", "LocalUnlock", {pointer}, bool}, 
  {0, 0, "kernel32", "LockFile", {pointer, dword, dword, dword, dword}, bool}, 
  {0, 0, "kernel32", "LockFileEx", {pointer, dword, dword, dword, dword, long_pointer}, bool}, 
  {0, 0, "kernel32", "LockResource", {pointer}, pointer}, 
  {0, 0, "kernel32", "LogonUserA", {pointer, pointer, pointer, dword, dword, pointer}, bool}, 
  {0, 0, "kernel32", "LogonUserW", {pointer, pointer, pointer, dword, dword, pointer}, bool}, 
  {0, 0, "kernel32", "LookupAccountNameA", {pointer, pointer, pointer, pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "LookupAccountNameW", {pointer, pointer, pointer, pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "LookupAccountSidA", {pointer, pointer, pointer, pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "LookupAccountSidW", {pointer, pointer, pointer, pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "LookupPrivilegeDisplayNameA", {pointer, pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "LookupPrivilegeDisplayNameW", {pointer, pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "LookupPrivilegeNameA", {pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "LookupPrivilegeNameW", {pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "LookupPrivilegeValueA", {pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "LookupPrivilegeValueW", {pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "lstrcat", {pointer, pointer}, pointer}, 
  {0, 0, "kernel32", "lstrcatA", {pointer, pointer}, pointer}, 
  {0, 0, "kernel32", "lstrcatW", {pointer, pointer}, pointer}, 
  {0, 0, "kernel32", "lstrcmp", {pointer, pointer}, int}, 
  {0, 0, "kernel32", "lstrcmpA", {pointer, pointer}, int}, 
  {0, 0, "kernel32", "lstrcmpi", {pointer, pointer}, int}, 
  {0, 0, "kernel32", "lstrcmpiA", {pointer, pointer}, int}, 
  {0, 0, "kernel32", "lstrcmpiW", {pointer, pointer}, int}, 
  {0, 0, "kernel32", "lstrcmpW", {pointer, pointer}, int}, 
  {0, 0, "kernel32", "lstrcpy", {pointer, pointer}, pointer}, 
  {0, 0, "kernel32", "lstrcpyA", {pointer, pointer}, pointer}, 
  {0, 0, "kernel32", "lstrcpyn", {pointer, pointer, int}, pointer}, 
  {0, 0, "kernel32", "lstrcpynA", {pointer, pointer, int}, pointer}, 
  {0, 0, "kernel32", "lstrcpynW", {pointer, pointer, int}, pointer}, 
  {0, 0, "kernel32", "lstrcpyW", {pointer, pointer}, pointer}, 
  {0, 0, "kernel32", "lstrlen", {pointer}, int}, 
  {0, 0, "kernel32", "lstrlenA", {pointer}, int}, 
  {0, 0, "kernel32", "lstrlenW", {pointer}, int}, 
  {0, 0, "kernel32", "MakeAbsoluteSD", {pointer, pointer, pointer, pointer, pointer, pointer, pointer, pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "MakeSelfRelativeSD", {pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "MapGenericMask", {pointer, pointer}}, 
  {0, 0, "kernel32", "MapUserPhysicalPages", {pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "MapUserPhysicalPagesScatter", {pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "MapViewOfFile", {pointer, dword, dword, dword, dword}, pointer}, 
  {0, 0, "kernel32", "MapViewOfFileEx", {pointer, dword, dword, dword, dword, pointer}, pointer}, 
  {0, 0, "kernel32", "Module32First", {pointer, long_pointer}, bool}, 
  {0, 0, "kernel32", "Module32FirstW", {pointer, long_pointer}, bool}, 
  {0, 0, "kernel32", "Module32Next", {pointer, long_pointer}, bool}, 
  {0, 0, "kernel32", "Module32NextW", {pointer, long_pointer}, bool}, 
  {0, 0, "kernel32", "MoveFileA", {pointer, pointer}, bool}, 
  {0, 0, "kernel32", "MoveFileExA", {pointer, pointer, dword}, bool}, 
  {0, 0, "kernel32", "MoveFileExW", {pointer, pointer, dword}, bool}, 
  {0, 0, "kernel32", "MoveFileW", {pointer, pointer}, bool}, 
  {0, 0, "kernel32", "MoveFileWithProgressA", {pointer, pointer, long_pointer, long_pointer, dword}, bool}, 
  {0, 0, "kernel32", "MoveFileWithProgressW", {pointer, pointer, long_pointer, long_pointer, dword}, bool}, 
  {0, 0, "kernel32", "MulDiv", {int, int, int}, int}, 
  {0, 0, "kernel32", "MultiByteToWideChar", {uint, dword, pointer, int, pointer, int}, int}, 
  {0, 0, "kernel32", "NotifyChangeEventLog", {pointer, pointer}, bool}, 
  {0, 0, "kernel32", "ObjectCloseAuditAlarmA", {pointer, pointer, bool}, bool}, 
  {0, 0, "kernel32", "ObjectCloseAuditAlarmW", {pointer, pointer, bool}, bool}, 
  {0, 0, "kernel32", "ObjectDeleteAuditAlarmA", {pointer, pointer, bool}, bool}, 
  {0, 0, "kernel32", "ObjectDeleteAuditAlarmW", {pointer, pointer, bool}, bool}, 
  {0, 0, "kernel32", "ObjectOpenAuditAlarmA", {pointer, pointer, pointer, pointer, pointer, pointer, dword, dword, pointer, bool, bool, pointer}, bool}, 
  {0, 0, "kernel32", "ObjectOpenAuditAlarmW", {pointer, pointer, pointer, pointer, pointer, pointer, dword, dword, pointer, bool, bool, pointer}, bool}, 
  {0, 0, "kernel32", "ObjectPrivilegeAuditAlarmA", {pointer, pointer, pointer, dword, pointer, bool}, bool}, 
  {0, 0, "kernel32", "ObjectPrivilegeAuditAlarmW", {pointer, pointer, pointer, dword, pointer, bool}, bool}, 
  {0, 0, "kernel32", "OpenBackupEventLogA", {pointer, pointer}, pointer}, 
  {0, 0, "kernel32", "OpenBackupEventLogW", {pointer, pointer}, pointer}, 
  {0, 0, "kernel32", "OpenEventA", {dword, bool, pointer}, pointer}, 
  {0, 0, "kernel32", "OpenEventLogA", {pointer, pointer}, pointer}, 
  {0, 0, "kernel32", "OpenEventLogW", {pointer, pointer}, pointer}, 
  {0, 0, "kernel32", "OpenEventW", {dword, bool, pointer}, pointer}, 
  {0, 0, "kernel32", "OpenFile", {pointer, long_pointer, uint}, int}, 
  {0, 0, "kernel32", "OpenFileMappingA", {dword, bool, pointer}, pointer}, 
  {0, 0, "kernel32", "OpenFileMappingW", {dword, bool, pointer}, pointer}, 
  {0, 0, "kernel32", "OpenMutexA", {dword, bool, pointer}, pointer}, 
  {0, 0, "kernel32", "OpenMutexW", {dword, bool, pointer}, pointer}, 
  {0, 0, "kernel32", "OpenProcess", {dword, bool, dword}, pointer}, 
  {0, 0, "kernel32", "OpenProcessToken", {pointer, dword, pointer}, bool}, 
  {0, 0, "kernel32", "OpenSemaphoreA", {dword, bool, pointer}, pointer}, 
  {0, 0, "kernel32", "OpenSemaphoreW", {dword, bool, pointer}, pointer}, 
  {0, 0, "kernel32", "OpenThread", {dword, bool, dword}, pointer}, 
  {0, 0, "kernel32", "OpenThreadToken", {pointer, dword, bool, pointer}, bool}, 
  {0, 0, "kernel32", "OpenWaitableTimerA", {dword, bool, pointer}, pointer}, 
  {0, 0, "kernel32", "OpenWaitableTimerW", {dword, bool, pointer}, pointer}, 
  {0, 0, "kernel32", "OutputDebugStringA", {pointer}}, 
  {0, 0, "kernel32", "OutputDebugStringW", {pointer}}, 
  {0, 0, "kernel32", "PeekConsoleInputA", {pointer, pointer, dword, pointer}, bool}, 
  {0, 0, "kernel32", "PeekConsoleInputW", {pointer, pointer, dword, pointer}, bool}, 
  {0, 0, "kernel32", "PeekNamedPipe", {pointer, pointer, dword, pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "PostQueuedCompletionStatus", {pointer, dword, pointer, long_pointer}, bool}, 
  {0, 0, "kernel32", "PrepareTape", {pointer, dword, bool}, dword}, 
  {0, 0, "kernel32", "PrivilegeCheck", {pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "PrivilegedServiceAuditAlarmA", {pointer, pointer, pointer, pointer, bool}, bool}, 
  {0, 0, "kernel32", "PrivilegedServiceAuditAlarmW", {pointer, pointer, pointer, pointer, bool}, bool}, 
  {0, 0, "kernel32", "Process32First", {pointer, long_pointer}, bool}, 
  {0, 0, "kernel32", "Process32FirstW", {pointer, long_pointer}, bool}, 
  {0, 0, "kernel32", "Process32Next", {pointer, long_pointer}, bool}, 
  {0, 0, "kernel32", "Process32NextW", {pointer, long_pointer}, bool}, 
  {0, 0, "kernel32", "ProcessIdToSessionId", {dword, pointer}, bool}, 
  {0, 0, "kernel32", "PulseEvent", {pointer}, bool}, 
  {0, 0, "kernel32", "PurgeComm", {pointer, dword}, bool}, 
  {0, 0, "kernel32", "QueryActCtxW", {dword, pointer, pointer, ulong, pointer, size_t, pointer}, bool}, 
  {0, 0, "kernel32", "QueryDosDeviceA", {pointer, pointer, dword}, dword}, 
  {0, 0, "kernel32", "QueryDosDeviceW", {pointer, pointer, dword}, dword}, 
  {0, 0, "kernel32", "QueryInformationJobObject", {pointer, pointer, long_pointer, dword, pointer}, bool}, 
  {0, 0, "kernel32", "QueryMemoryResourceNotification", {pointer, pointer}, bool}, 
  {0, 0, "kernel32", "QueryPerformanceCounter", {pointer}, bool}, 
  {0, 0, "kernel32", "QueryPerformanceFrequency", {pointer}, bool}, 
  {0, 0, "kernel32", "QueueUserAPC", {pointer, pointer, pointer}, dword}, 
  {0, 0, "kernel32", "QueueUserWorkItem", {long_pointer, pointer, ulong}, bool}, 
  {0, 0, "kernel32", "RaiseException", {dword, dword, dword, pointer}}, 
  {0, 0, "kernel32", "ReadConsoleA", {pointer, pointer, dword, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "ReadConsoleInputA", {pointer, pointer, dword, pointer}, bool}, 
  {0, 0, "kernel32", "ReadConsoleInputW", {pointer, pointer, dword, pointer}, bool}, 
  {0, 0, "kernel32", "ReadConsoleOutputA", {pointer, pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "ReadConsoleOutputAttribute", {pointer, pointer, dword, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "ReadConsoleOutputCharacterA", {pointer, pointer, dword, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "ReadConsoleOutputCharacterW", {pointer, pointer, dword, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "ReadConsoleOutputW", {pointer, pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "ReadConsoleW", {pointer, pointer, dword, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "ReadDirectoryChangesW", {pointer, pointer, dword, bool, dword, pointer, long_pointer, long_pointer}, bool}, 
  {0, 0, "kernel32", "ReadEventLogA", {pointer, dword, dword, pointer, dword, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "ReadEventLogW", {pointer, dword, dword, pointer, dword, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "ReadFile", {pointer, pointer, dword, pointer, long_pointer}, bool}, 
  {0, 0, "kernel32", "ReadFileEx", {pointer, pointer, dword, long_pointer, long_pointer}, bool}, 
  {0, 0, "kernel32", "ReadFileScatter", {pointer, pointer, dword, pointer, long_pointer}, bool}, 
  {0, 0, "kernel32", "ReadProcessMemory", {pointer, pointer, pointer, dword, pointer}, bool}, 
  {0, 0, "kernel32", "RegisterEventSourceA", {pointer, pointer}, pointer}, 
  {0, 0, "kernel32", "RegisterEventSourceW", {pointer, pointer}, pointer}, 
  {0, 0, "kernel32", "RegisterWaitForSingleObject", {pointer, pointer, pointer, pointer, ulong, ulong}, bool}, 
  {0, 0, "kernel32", "RegisterWaitForSingleObjectEx", {pointer, pointer, pointer, ulong, ulong}, pointer}, 
  {0, 0, "kernel32", "ReleaseActCtx", {pointer}}, 
  {0, 0, "kernel32", "ReleaseMutex", {pointer}, bool}, 
  {0, 0, "kernel32", "ReleaseSemaphore", {pointer, long, pointer}, bool}, 
  {0, 0, "kernel32", "RemoveDirectoryA", {pointer}, bool}, 
  {0, 0, "kernel32", "RemoveDirectoryW", {pointer}, bool}, 
  {0, 0, "kernel32", "RemoveVectoredExceptionHandler", {pointer}, ulong}, 
  {0, 0, "kernel32", "ReOpenFile", {pointer, dword, dword, dword}, pointer}, 
  {0, 0, "kernel32", "ReplaceFileA", {pointer, pointer, pointer, dword, long_pointer, long_pointer}, bool}, 
  {0, 0, "kernel32", "ReplaceFileW", {pointer, pointer, pointer, dword, long_pointer, long_pointer}, bool}, 
  {0, 0, "kernel32", "ReportEventA", {pointer, word, word, dword, pointer, word, dword, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "ReportEventW", {pointer, word, word, dword, pointer, word, dword, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "ResetEvent", {pointer}, bool}, 
  {0, 0, "kernel32", "ResetWriteWatch", {long_pointer, size_t}, uint}, 
  {0, 0, "kernel32", "RestoreLastError", {dword}}, 
  {0, 0, "kernel32", "ResumeThread", {pointer}, dword}, 
  {0, 0, "kernel32", "RevertToSelf", {}, bool}, 
  {0, 0, "kernel32", "ScrollConsoleScreenBufferA", {pointer, pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "ScrollConsoleScreenBufferW", {pointer, pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "SearchPathA", {pointer, pointer, pointer, dword, pointer, pointer}, dword}, 
  {0, 0, "kernel32", "SearchPathW", {pointer, pointer, pointer, dword, pointer, pointer}, dword}, 
  {0, 0, "kernel32", "SetAclInformation", {pointer, pointer, dword, pointer}, bool}, 
  {0, 0, "kernel32", "SetCalendarInfoA", {dword, pointer, pointer, pointer}, int}, 
  {0, 0, "kernel32", "SetCalendarInfoW", {dword, pointer, pointer, pointer}, int}, 
  {0, 0, "kernel32", "SetCommBreak", {pointer}, bool}, 
  {0, 0, "kernel32", "SetCommConfig", {pointer, long_pointer, dword}, bool}, 
  {0, 0, "kernel32", "SetCommMask", {pointer, dword}, bool}, 
  {0, 0, "kernel32", "SetCommState", {pointer, long_pointer}, bool}, 
  {0, 0, "kernel32", "SetCommTimeouts", {pointer, long_pointer}, bool}, 
  {0, 0, "kernel32", "SetComputerNameA", {pointer}, bool}, 
  {0, 0, "kernel32", "SetComputerNameExA", {pointer, pointer}, bool}, 
  {0, 0, "kernel32", "SetComputerNameExW", {pointer, pointer}, bool}, 
  {0, 0, "kernel32", "SetComputerNameW", {pointer}, bool}, 
  {0, 0, "kernel32", "SetConsoleActiveScreenBuffer", {pointer}, bool}, 
  {0, 0, "kernel32", "SetConsoleCP", {uint}, bool}, 
  {0, 0, "kernel32", "SetConsoleCtrlHandler", {pointer, bool}, bool}, 
  {0, 0, "kernel32", "SetConsoleCursorInfo", {pointer, pointer}, bool}, 
  {0, 0, "kernel32", "SetConsoleCursorPosition", {pointer, pointer}, bool}, 
  {0, 0, "kernel32", "SetConsoleDisplayMode", {pointer, dword, pointer}, bool}, 
  {0, 0, "kernel32", "SetConsoleMode", {pointer, dword}, bool}, 
  {0, 0, "kernel32", "SetConsoleOutputCP", {uint}, bool}, 
  {0, 0, "kernel32", "SetConsoleScreenBufferSize", {pointer, pointer}, bool}, 
  {0, 0, "kernel32", "SetConsoleTextAttribute", {pointer, word}, bool}, 
  {0, 0, "kernel32", "SetConsoleTitleA", {pointer}, bool}, 
  {0, 0, "kernel32", "SetConsoleTitleW", {pointer}, bool}, 
  {0, 0, "kernel32", "SetConsoleWindowInfo", {pointer, bool, pointer}, bool}, 
  {0, 0, "kernel32", "SetCriticalSectionSpinCount", {long_pointer, dword}, dword}, 
  {0, 0, "kernel32", "SetCurrentDirectoryA", {pointer}, bool}, 
  {0, 0, "kernel32", "SetCurrentDirectoryW", {pointer}, bool}, 
  {0, 0, "kernel32", "SetDefaultCommConfigA", {pointer, long_pointer, dword}, bool}, 
  {0, 0, "kernel32", "SetDefaultCommConfigW", {pointer, long_pointer, dword}, bool}, 
  {0, 0, "kernel32", "SetDllDirectoryA", {pointer}, bool}, 
  {0, 0, "kernel32", "SetDllDirectoryW", {pointer}, bool}, 
  {0, 0, "kernel32", "SetEndOfFile", {pointer}, bool}, 
  {0, 0, "kernel32", "SetEnvironmentVariableA", {pointer, pointer}, bool}, 
  {0, 0, "kernel32", "SetEnvironmentVariableW", {pointer, pointer}, bool}, 
  {0, 0, "kernel32", "SetErrorMode", {uint}, uint}, 
  {0, 0, "kernel32", "SetEvent", {pointer}, bool}, 
  {0, 0, "kernel32", "SetFileApisToANSI", {}}, 
  {0, 0, "kernel32", "SetFileApisToOEM", {}}, 
  {0, 0, "kernel32", "SetFileAttributesA", {pointer, dword}, bool}, 
  {0, 0, "kernel32", "SetFileAttributesW", {pointer, dword}, bool}, 
  {0, 0, "kernel32", "SetFilePointer", {pointer, long, pointer, dword}, dword}, 
  {0, 0, "kernel32", "SetFilePointerEx", {pointer, dwordlong, pointer, dword}, bool}, 
  {0, 0, "kernel32", "SetFileSecurityA", {pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "SetFileSecurityW", {pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "SetFileShortNameA", {pointer, pointer}, bool}, 
  {0, 0, "kernel32", "SetFileShortNameW", {pointer, pointer}, bool}, 
  {0, 0, "kernel32", "SetFileTime", {pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "SetFileValidData", {pointer, int64}, bool}, 
  {0, 0, "kernel32", "SetFirmwareEnvironmentVariableA", {pointer, pointer, pointer, dword}, bool}, 
  {0, 0, "kernel32", "SetFirmwareEnvironmentVariableW", {pointer, pointer, pointer, dword}, bool}, 
  {0, 0, "kernel32", "SetHandleCount", {uint}, uint}, 
  {0, 0, "kernel32", "SetHandleInformation", {pointer, dword, dword}, bool}, 
  {0, 0, "kernel32", "SetInformationJobObject", {pointer, pointer, long_pointer, dword}, bool}, 
  {0, 0, "kernel32", "SetKernelObjectSecurity", {pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "SetLastError", {dword}}, 
  {0, 0, "kernel32", "SetLastErrorEx", {dword, dword}}, 
  {0, 0, "kernel32", "SetLocaleInfoA", {dword, dword, pointer}, bool}, 
  {0, 0, "kernel32", "SetLocaleInfoW", {dword, dword, pointer}, bool}, 
  {0, 0, "kernel32", "SetLocalTime", {pointer}, bool}, 
  {0, 0, "kernel32", "SetMailslotInfo", {pointer, dword}, bool}, 
  {0, 0, "kernel32", "SetNamedPipeHandleState", {pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "SetPriorityClass", {pointer, dword}, bool}, 
  {0, 0, "kernel32", "SetPrivateObjectSecurity", {pointer, pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "SetProcessAffinityMask", {pointer, dword}, bool}, 
  {0, 0, "kernel32", "SetProcessDEPPolicy", {dword}, bool}, 
  {0, 0, "kernel32", "SetProcessPriorityBoost", {pointer, bool}, bool}, 
  {0, 0, "kernel32", "SetProcessShutdownParameters", {dword, dword}, bool}, 
  {0, 0, "kernel32", "SetProcessWorkingSetSize", {pointer, size_t, size_t}, bool}, 
  {0, 0, "kernel32", "SetSecurityDescriptorControl", {pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "SetSecurityDescriptorDacl", {pointer, bool, pointer, bool}, bool}, 
  {0, 0, "kernel32", "SetSecurityDescriptorGroup", {pointer, pointer, bool}, bool}, 
  {0, 0, "kernel32", "SetSecurityDescriptorOwner", {pointer, pointer, bool}, bool}, 
  {0, 0, "kernel32", "SetSecurityDescriptorSacl", {pointer, bool, pointer, bool}, bool}, 
  {0, 0, "kernel32", "SetStdHandle", {dword, pointer}, bool}, 
  {0, 0, "kernel32", "SetSystemPowerState", {bool, bool}, bool}, 
  {0, 0, "kernel32", "SetSystemTime", {pointer}, bool}, 
  {0, 0, "kernel32", "SetSystemTimeAdjustment", {dword, bool}, bool}, 
  {0, 0, "kernel32", "SetTapeParameters", {pointer, dword, pointer}, dword}, 
  {0, 0, "kernel32", "SetTapePosition", {pointer, dword, dword, dword, dword, bool}, dword}, 
  {0, 0, "kernel32", "SetThreadAffinityMask", {pointer, dword}, dword}, 
  {0, 0, "kernel32", "SetThreadContext", {pointer, pointer}, bool}, 
  {0, 0, "kernel32", "SetThreadExecutionState", {pointer}, pointer}, 
  {0, 0, "kernel32", "SetThreadIdealProcessor", {pointer, dword}, dword}, 
  {0, 0, "kernel32", "SetThreadLocale", {dword}, bool}, 
  {0, 0, "kernel32", "SetThreadPriority", {pointer, int}, bool}, 
  {0, 0, "kernel32", "SetThreadPriorityBoost", {pointer, bool}, bool}, 
  {0, 0, "kernel32", "SetThreadToken", {pointer, pointer}, bool}, 
  {0, 0, "kernel32", "SetTimeZoneInformation", {pointer}, bool}, 
  {0, 0, "kernel32", "SetTokenInformation", {pointer, pointer, pointer, dword}, bool}, 
  {0, 0, "kernel32", "SetUnhandledExceptionFilter", {pointer}, pointer}, 
  {0, 0, "kernel32", "SetupComm", {pointer, dword, dword}, bool}, 
  {0, 0, "kernel32", "SetUserGeoID", {pointer}, bool}, 
  {0, 0, "kernel32", "SetVolumeLabelA", {pointer, pointer}, bool}, 
  {0, 0, "kernel32", "SetVolumeLabelW", {pointer, pointer}, bool}, 
  {0, 0, "kernel32", "SetVolumeMountPointA", {pointer, pointer}, bool}, 
  {0, 0, "kernel32", "SetVolumeMountPointW", {pointer, pointer}, bool}, 
  {0, 0, "kernel32", "SetWaitableTimer", {pointer, pointer, long, pointer, pointer, bool}, bool}, 
  {0, 0, "kernel32", "SignalObjectAndWait", {pointer, pointer, dword, bool}, dword}, 
  {0, 0, "kernel32", "SizeofResource", {pointer, pointer}, dword}, 
  {0, 0, "kernel32", "Sleep", {dword}}, 
  {0, 0, "kernel32", "SleepEx", {dword, bool}, dword}, 
  {0, 0, "kernel32", "SuspendThread", {pointer}, dword}, 
  {0, 0, "kernel32", "SwitchToFiber", {pointer}}, 
  {0, 0, "kernel32", "SwitchToThread", {}, bool}, 
  {0, 0, "kernel32", "SystemTimeToFileTime", {pointer, long_pointer}, bool}, 
  {0, 0, "kernel32", "SystemTimeToTzSpecificLocalTime", {long_pointer, long_pointer, long_pointer}, bool}, 
  {0, 0, "kernel32", "TerminateJobObject", {pointer, uint}, bool}, 
  {0, 0, "kernel32", "TerminateProcess", {pointer, uint}, bool}, 
  {0, 0, "kernel32", "TerminateThread", {pointer, dword}, bool}, 
  {0, 0, "kernel32", "Thread32First", {pointer, long_pointer}, bool}, 
  {0, 0, "kernel32", "Thread32Next", {pointer, long_pointer}, bool}, 
  {0, 0, "kernel32", "TlsAlloc", {}, dword}, 
  {0, 0, "kernel32", "TlsFree", {dword}, bool}, 
  {0, 0, "kernel32", "TlsGetValue", {dword}, pointer}, 
  {0, 0, "kernel32", "TlsSetValue", {dword, pointer}, bool}, 
  {0, 0, "kernel32", "Toolhelp32ReadProcessMemory", {dword, pointer, long_pointer, dword, pointer}, bool}, 
  {0, 0, "kernel32", "TransactNamedPipe", {pointer, pointer, dword, pointer, dword, pointer, long_pointer}, bool}, 
  {0, 0, "kernel32", "TransmitCommChar", {pointer, char}, bool}, 
  {0, 0, "kernel32", "TryEnterCriticalSection", {long_pointer}, bool}, 
  {0, 0, "kernel32", "TzSpecificLocalTimeToSystemTime", {long_pointer, long_pointer, long_pointer}, bool}, 
  {0, 0, "kernel32", "UnhandledExceptionFilter", {long_pointer}, long}, 
  {0, 0, "kernel32", "UnlockFile", {pointer, dword, dword, dword, dword}, bool}, 
  {0, 0, "kernel32", "UnlockFileEx", {pointer, dword, dword, dword, long_pointer}, bool}, 
  {0, 0, "kernel32", "UnmapViewOfFile", {pointer}, bool}, 
  {0, 0, "kernel32", "UnregisterWait", {pointer}, bool}, 
  {0, 0, "kernel32", "UnregisterWaitEx", {pointer, pointer}, bool}, 
  {0, 0, "kernel32", "UpdateResourceA", {pointer, pointer, pointer, word, pointer, dword}, bool}, 
  {0, 0, "kernel32", "UpdateResourceW", {pointer, pointer, pointer, word, pointer, dword}, bool}, 
  {0, 0, "kernel32", "VerifyVersionInfoA", {long_pointer, dword, dwordlong}, bool}, 
  {0, 0, "kernel32", "VerifyVersionInfoW", {long_pointer, dword, dwordlong}, bool}, 
  {0, 0, "kernel32", "VerSetConditionMask", {ulonglong, dword, byte}, ulonglong}, 
  {0, 0, "kernel32", "VirtualAlloc", {pointer, dword, dword, dword}, pointer}, 
  {0, 0, "kernel32", "VirtualAllocEx", {pointer, pointer, dword, dword, dword}, pointer}, 
  {0, 0, "kernel32", "VirtualFree", {pointer, dword, dword}, bool}, 
  {0, 0, "kernel32", "VirtualFreeEx", {pointer, pointer, dword, dword}, bool}, 
  {0, 0, "kernel32", "VirtualLock", {pointer, dword}, bool}, 
  {0, 0, "kernel32", "VirtualProtect", {pointer, dword, dword, pointer}, bool}, 
  {0, 0, "kernel32", "VirtualProtectEx", {pointer, pointer, dword, dword, pointer}, bool}, 
  {0, 0, "kernel32", "VirtualQuery", {pointer, pointer, dword}, dword}, 
  {0, 0, "kernel32", "VirtualQueryEx", {pointer, pointer, pointer, dword}, dword}, 
  {0, 0, "kernel32", "VirtualUnlock", {pointer, dword}, bool}, 
  {0, 0, "kernel32", "WaitCommEvent", {pointer, pointer, long_pointer}, bool}, 
  {0, 0, "kernel32", "WaitForDebugEvent", {long_pointer, dword}, bool}, 
  {0, 0, "kernel32", "WaitForMultipleObjects", {dword, pointer, bool, dword}, dword}, 
  {0, 0, "kernel32", "WaitForMultipleObjectsEx", {dword, pointer, bool, dword, bool}, dword}, 
  {0, 0, "kernel32", "WaitForSingleObject", {pointer, dword}, dword}, 
  {0, 0, "kernel32", "WaitForSingleObjectEx", {pointer, dword, bool}, dword}, 
  {0, 0, "kernel32", "WaitNamedPipeA", {pointer, dword}, bool}, 
  {0, 0, "kernel32", "WaitNamedPipeW", {pointer, dword}, bool}, 
  {0, 0, "kernel32", "WideCharToMultiByte", {uint, dword, pointer, int, pointer, int, pointer, pointer}, int}, 
  {0, 0, "kernel32", "WinLoadTrustProvider", {pointer}, bool}, 
  {0, 0, "kernel32", "WriteConsoleA", {pointer, pointer, dword, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "WriteConsoleInputA", {pointer, pointer, dword, pointer}, bool}, 
  {0, 0, "kernel32", "WriteConsoleInputW", {pointer, pointer, dword, pointer}, bool}, 
  {0, 0, "kernel32", "WriteConsoleOutputA", {pointer, pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "WriteConsoleOutputAttribute", {pointer, pointer, dword, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "WriteConsoleOutputCharacterA", {pointer, pointer, dword, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "WriteConsoleOutputCharacterW", {pointer, pointer, dword, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "WriteConsoleOutputW", {pointer, pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "WriteConsoleW", {pointer, pointer, dword, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "WriteFile", {pointer, pointer, dword, pointer, long_pointer}, bool}, 
  {0, 0, "kernel32", "WriteFileEx", {pointer, pointer, dword, long_pointer, long_pointer}, bool}, 
  {0, 0, "kernel32", "WriteFileGather", {pointer, pointer, dword, pointer, long_pointer}, bool}, 
  {0, 0, "kernel32", "WritePrivateProfileSectionA", {pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "WritePrivateProfileSectionW", {pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "WritePrivateProfileStringA", {pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "WritePrivateProfileStringW", {pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "WritePrivateProfileStructA", {pointer, pointer, long_pointer, uint, pointer}, bool}, 
  {0, 0, "kernel32", "WritePrivateProfileStructW", {pointer, pointer, long_pointer, uint, pointer}, bool}, 
  {0, 0, "kernel32", "WriteProcessMemory", {pointer, long_pointer, pointer, size_t, pointer}, bool}, 
  {0, 0, "kernel32", "WriteProfileSectionA", {pointer, pointer}, bool}, 
  {0, 0, "kernel32", "WriteProfileSectionW", {pointer, pointer}, bool}, 
  {0, 0, "kernel32", "WriteProfileStringA", {pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "WriteProfileStringW", {pointer, pointer, pointer}, bool}, 
  {0, 0, "kernel32", "WriteTapemark", {pointer, dword, dword, bool}, dword}, 
  {0, 0, "kernel32", "ZombifyActCtx", {pointer}, bool}, 
  {0, 0, "largeint", "ConvertLongToLargeInteger", {long}, dwordlong}, 
  {0, 0, "largeint", "ConvertUlongToLargeInteger", {ulong}, dwordlong}, 
  {0, 0, "largeint", "EnlargedIntegerMultiply", {long, long}, dwordlong}, 
  {0, 0, "largeint", "EnlargedUnsignedDivide", {uint64, ulong, pointer}, ulong}, 
  {0, 0, "largeint", "EnlargedUnsignedMultiply", {ulong, ulong}, dwordlong}, 
  {0, 0, "largeint", "ExtendedIntegerMultiply", {dwordlong, long}, dwordlong}, 
  {0, 0, "largeint", "ExtendedLargeIntegerDivide", {dwordlong, ulong, pointer}, dwordlong}, 
  {0, 0, "largeint", "ExtendedMagicDivide", {dwordlong, dwordlong, int}, dwordlong}, 
  {0, 0, "largeint", "LargeIntegerAdd", {dwordlong, dwordlong}, dwordlong}, 
  {0, 0, "largeint", "LargeIntegerArithmeticShift", {dwordlong, int}, dwordlong}, 
  {0, 0, "largeint", "LargeIntegerDivide", {dwordlong, dwordlong, pointer}, dwordlong}, 
  {0, 0, "largeint", "LargeIntegerMultiply", {dwordlong, dwordlong}, dwordlong}, 
  {0, 0, "largeint", "LargeIntegerNegate", {dwordlong}, dwordlong}, 
  {0, 0, "largeint", "LargeIntegerShiftLeft", {dwordlong, int}, dwordlong}, 
  {0, 0, "largeint", "LargeIntegerShiftRight", {dwordlong, int}, dwordlong}, 
  {0, 0, "largeint", "LargeIntegerSubtract", {dwordlong, dwordlong}, dwordlong}, 
  {0, 0, "lmchdev" , "NetCharDevControl", {pointer, pointer, dword}, pointer}, 
  {0, 0, "lmchdev" , "NetCharDevEnum", {pointer, dword, pointer, dword, pointer, pointer, pointer}, pointer}, 
  {0, 0, "lmchdev" , "NetCharDevGetInfo", {pointer, pointer, dword, pointer}, pointer}, 
  {0, 0, "lmchdev" , "NetCharDevQEnum", {pointer, pointer, dword, pointer, dword, pointer, pointer, pointer}, pointer}, 
  {0, 0, "lmchdev" , "NetCharDevQGetInfo", {pointer, pointer, pointer, dword, pointer}, pointer}, 
  {0, 0, "lmchdev" , "NetCharDevQPurge", {pointer, pointer}, pointer}, 
  {0, 0, "lmchdev" , "NetCharDevQPurgeSelf", {pointer, pointer, pointer}, pointer}, 
  {0, 0, "lmchdev" , "NetCharDevQSetInfo", {pointer, pointer, dword, pointer, pointer}, pointer}, 
  {0, 0, "lmchdev" , "NetHandleGetInfo", {pointer, dword, pointer}, pointer}, 
  {0, 0, "lmchdev" , "NetHandleSetInfo", {pointer, dword, pointer, dword, pointer}, pointer}, 
  {0, 0, "lz32"    , "CopyLZFile", {int, int}, long}, 
  {0, 0, "lz32"    , "GetExpandedNameA", {pointer, pointer}, int}, 
  {0, 0, "lz32"    , "GetExpandedNameW", {pointer, pointer}, int}, 
  {0, 0, "lz32"    , "LZDone", {}}, 
  {0, 0, "lz32"    , "LZInit", {int}, int}, 
  {0, 0, "lz32"    , "LZOpenFileA", {pointer, long_pointer, word}, int}, 
  {0, 0, "lz32"    , "LZOpenFileW", {pointer, long_pointer, word}, int}, 
  {0, 0, "lz32"    , "LZRead", {int, pointer, int}, int}, 
  {0, 0, "lz32"    , "LZSeek", {int, long, int}, long}, 
  {0, 0, "lz32"    , "LZStart", {}, int}, 
  {0, 0, "mprapi"  , "MprAdminAcceptNewConnection", {pointer, pointer}, bool}, 
  {0, 0, "mprapi"  , "MprAdminAcceptNewConnection2", {pointer, pointer, pointer}, bool}, 
  {0, 0, "mprapi"  , "MprAdminAcceptNewLink", {pointer, pointer}, bool}, 
  {0, 0, "mprapi"  , "MprAdminAcceptReauthentication", {pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "mprapi"  , "MprAdminBufferFree", {long_pointer}, dword}, 
  {0, 0, "mprapi"  , "MprAdminConnectionClearStats", {pointer, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprAdminConnectionEnum", {pointer, dword, pointer, dword, pointer, pointer, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprAdminConnectionGetInfo", {pointer, dword, pointer, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprAdminConnectionHangupNotification", {pointer, pointer}}, 
  {0, 0, "mprapi"  , "MprAdminConnectionHangupNotification2", {pointer, pointer, pointer}}, 
  {0, 0, "mprapi"  , "MprAdminConnectionRemoveQuarantine", {pointer, pointer, bool}, dword}, 
  {0, 0, "mprapi"  , "MprAdminDeregisterConnectionNotification", {pointer, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprAdminEstablishDomainRasServer", {pointer, pointer, bool}, dword}, 
  {0, 0, "mprapi"  , "MprAdminGetErrorString", {dword, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprAdminGetIpAddressForUser", {pointer, pointer, pointer, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprAdminGetPDCServer", {pointer, pointer, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprAdminInitializeDll", {}, dword}, 
  {0, 0, "mprapi"  , "MprAdminInterfaceConnect", {pointer, pointer, pointer, bool}, dword}, 
  {0, 0, "mprapi"  , "MprAdminInterfaceCreate", {pointer, dword, pointer, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprAdminInterfaceDelete", {pointer, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprAdminInterfaceDeviceGetInfo", {pointer, pointer, dword, dword, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprAdminInterfaceDeviceSetInfo", {pointer, pointer, dword, dword, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprAdminInterfaceDisconnect", {pointer, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprAdminInterfaceEnum", {pointer, dword, pointer, dword, pointer, pointer, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprAdminInterfaceGetCredentials", {pointer, pointer, pointer, pointer, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprAdminInterfaceGetCredentialsEx", {pointer, pointer, dword, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprAdminInterfaceGetHandle", {pointer, pointer, pointer, bool}, dword}, 
  {0, 0, "mprapi"  , "MprAdminInterfaceGetInfo", {pointer, pointer, dword, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprAdminInterfaceQueryUpdateResult", {pointer, pointer, dword, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprAdminInterfaceSetCredentials", {pointer, pointer, pointer, pointer, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprAdminInterfaceSetCredentialsEx", {pointer, pointer, dword, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprAdminInterfaceSetInfo", {pointer, pointer, dword, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprAdminInterfaceTransportAdd", {pointer, pointer, dword, pointer, dword}, dword}, 
  {0, 0, "mprapi"  , "MprAdminInterfaceTransportGetInfo", {pointer, pointer, dword, pointer, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprAdminInterfaceTransportRemove", {pointer, pointer, dword}, dword}, 
  {0, 0, "mprapi"  , "MprAdminInterfaceTransportSetInfo", {pointer, pointer, dword, pointer, dword}, dword}, 
  {0, 0, "mprapi"  , "MprAdminInterfaceUpdatePhonebookInfo", {pointer, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprAdminInterfaceUpdateRoutes", {pointer, pointer, dword, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprAdminIsDomainRasServer", {pointer, pointer, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprAdminIsServiceRunning", {pointer}, bool}, 
  {0, 0, "mprapi"  , "MprAdminLinkHangupNotification", {pointer, pointer}}, 
  {0, 0, "mprapi"  , "MprAdminMIBBufferFree", {long_pointer}, dword}, 
  {0, 0, "mprapi"  , "MprAdminMIBEntryCreate", {pointer, dword, dword, long_pointer, dword}, dword}, 
  {0, 0, "mprapi"  , "MprAdminMIBEntryDelete", {pointer, dword, dword, long_pointer, dword}, dword}, 
  {0, 0, "mprapi"  , "MprAdminMIBEntryGet", {pointer, dword, dword, long_pointer, dword, pointer, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprAdminMIBEntryGetFirst", {pointer, dword, dword, long_pointer, dword, pointer, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprAdminMIBEntryGetNext", {pointer, dword, dword, long_pointer, dword, pointer, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprAdminMIBEntrySet", {pointer, dword, dword, long_pointer, dword}, dword}, 
  {0, 0, "mprapi"  , "MprAdminMIBGetTrapInfo", {pointer, dword, dword, long_pointer, dword, pointer, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprAdminMIBServerConnect", {pointer, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprAdminMIBServerDisconnect", {pointer}}, 
  {0, 0, "mprapi"  , "MprAdminMIBSetTrapInfo", {dword, dword, pointer, long_pointer, dword, pointer, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprAdminPortClearStats", {pointer, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprAdminPortDisconnect", {pointer, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprAdminPortEnum", {pointer, dword, pointer, pointer, dword, pointer, pointer, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprAdminPortGetInfo", {pointer, dword, pointer, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprAdminPortReset", {pointer, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprAdminRegisterConnectionNotification", {pointer, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprAdminReleaseIpAddress", {pointer, pointer, pointer}}, 
  {0, 0, "mprapi"  , "MprAdminSendUserMessage", {pointer, pointer, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprAdminServerConnect", {pointer, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprAdminServerDisconnect", {pointer}}, 
  {0, 0, "mprapi"  , "MprAdminServerGetCredentials", {pointer, dword, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprAdminServerGetInfo", {pointer, dword, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprAdminServerSetCredentials", {pointer, dword, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprAdminServerSetInfo", {pointer, dword, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprAdminTerminateDll", {}, dword}, 
  {0, 0, "mprapi"  , "MprAdminTransportCreate", {pointer, dword, pointer, pointer, dword, pointer, dword, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprAdminTransportGetInfo", {pointer, dword, pointer, pointer, pointer, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprAdminTransportSetInfo", {pointer, dword, pointer, dword, pointer, dword}, dword}, 
  {0, 0, "mprapi"  , "MprAdminUserGetInfo", {pointer, pointer, dword, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprAdminUserSetInfo", {pointer, pointer, dword, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprConfigBufferFree", {long_pointer}, dword}, 
  {0, 0, "mprapi"  , "MprConfigGetFriendlyName", {pointer, pointer, pointer, dword}, dword}, 
  {0, 0, "mprapi"  , "MprConfigGetGuidName", {pointer, pointer, pointer, dword}, dword}, 
  {0, 0, "mprapi"  , "MprConfigInterfaceCreate", {pointer, dword, pointer, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprConfigInterfaceDelete", {pointer, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprConfigInterfaceEnum", {pointer, dword, pointer, dword, pointer, pointer, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprConfigInterfaceGetHandle", {pointer, pointer, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprConfigInterfaceGetInfo", {pointer, pointer, dword, pointer, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprConfigInterfaceSetInfo", {pointer, pointer, dword, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprConfigInterfaceTransportAdd", {pointer, pointer, dword, pointer, pointer, dword, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprConfigInterfaceTransportEnum", {pointer, pointer, dword, pointer, dword, pointer, pointer, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprConfigInterfaceTransportGetHandle", {pointer, pointer, dword, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprConfigInterfaceTransportGetInfo", {pointer, pointer, pointer, pointer, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprConfigInterfaceTransportRemove", {pointer, pointer, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprConfigInterfaceTransportSetInfo", {pointer, pointer, pointer, pointer, dword}, dword}, 
  {0, 0, "mprapi"  , "MprConfigServerBackup", {pointer, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprConfigServerConnect", {pointer, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprConfigServerDisconnect", {pointer}}, 
  {0, 0, "mprapi"  , "MprConfigServerGetInfo", {pointer, dword, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprConfigServerInstall", {dword, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprConfigServerRestore", {pointer, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprConfigServerSetInfo", {pointer, dword, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprConfigTransportCreate", {pointer, dword, pointer, pointer, dword, pointer, dword, pointer, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprConfigTransportDelete", {pointer, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprConfigTransportEnum", {pointer, dword, pointer, dword, pointer, pointer, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprConfigTransportGetHandle", {pointer, dword, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprConfigTransportGetInfo", {pointer, pointer, pointer, pointer, pointer, pointer, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprConfigTransportSetInfo", {pointer, pointer, pointer, dword, pointer, dword, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprInfoBlockAdd", {long_pointer, dword, dword, dword, pointer, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprInfoBlockFind", {long_pointer, dword, pointer, pointer, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprInfoBlockQuerySize", {long_pointer}, dword}, 
  {0, 0, "mprapi"  , "MprInfoBlockRemove", {long_pointer, dword, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprInfoBlockSet", {long_pointer, dword, dword, dword, pointer, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprInfoCreate", {dword, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprInfoDelete", {long_pointer}, dword}, 
  {0, 0, "mprapi"  , "MprInfoDuplicate", {long_pointer, pointer}, dword}, 
  {0, 0, "mprapi"  , "MprInfoRemoveAll", {long_pointer, pointer}, dword}, 
  {0, 0, "mqrt"    , "MQADsPathToFormatName", {pointer, pointer, pointer}, long}, 
  {0, 0, "mqrt"    , "MQBeginTransaction", {pointer}, long}, 
  {0, 0, "mqrt"    , "MQCloseCursor", {pointer}, long}, 
  {0, 0, "mqrt"    , "MQCloseQueue", {pointer}, long}, 
  {0, 0, "mqrt"    , "MQCreateCursor", {pointer, pointer}, long}, 
  {0, 0, "mqrt"    , "MQCreateQueue", {pointer, pointer, pointer, pointer}, long}, 
  {0, 0, "mqrt"    , "MQDeleteQueue", {pointer}, long}, 
  {0, 0, "mqrt"    , "MQFreeMemory", {pointer}}, 
  {0, 0, "mqrt"    , "MQFreeSecurityContext", {pointer}}, 
  {0, 0, "mqrt"    , "MQGetMachineProperties", {pointer, pointer, pointer}, long}, 
  {0, 0, "mqrt"    , "MQGetOverlappedResult", {long_pointer}, long}, 
  {0, 0, "mqrt"    , "MQGetPrivateComputerInformation", {pointer, pointer}, long}, 
  {0, 0, "mqrt"    , "MQGetQueueProperties", {pointer, pointer}, long}, 
  {0, 0, "mqrt"    , "MQGetQueueSecurity", {pointer, pointer, pointer, dword, pointer}, long}, 
  {0, 0, "mqrt"    , "MQGetSecurityContext", {long_pointer, dword, pointer}, long}, 
  {0, 0, "mqrt"    , "MQGetSecurityContextEx", {long_pointer, dword, pointer}, long}, 
  {0, 0, "mqrt"    , "MQHandleToFormatName", {pointer, pointer, pointer}, long}, 
  {0, 0, "mqrt"    , "MQInstanceToFormatName", {pointer, pointer, pointer}, long}, 
  {0, 0, "mqrt"    , "MQLocateBegin", {pointer, pointer, pointer, pointer, pointer}, long}, 
  {0, 0, "mqrt"    , "MQLocateEnd", {pointer}, long}, 
  {0, 0, "mqrt"    , "MQLocateNext", {pointer, pointer, pointer}, long}, 
  {0, 0, "mqrt"    , "MQMarkMessageRejected", {pointer, ulonglong}, long}, 
  {0, 0, "mqrt"    , "MQMgmtAction", {pointer, pointer, pointer}, long}, 
  {0, 0, "mqrt"    , "MQMgmtGetInfo", {pointer, pointer, pointer}, long}, 
  {0, 0, "mqrt"    , "MQMoveMessage", {pointer, pointer, ulonglong, pointer}, long}, 
  {0, 0, "mqrt"    , "MQOpenQueue", {pointer, dword, dword, pointer}, long}, 
  {0, 0, "mqrt"    , "MQPathNameToFormatName", {pointer, pointer, pointer}, long}, 
  {0, 0, "mqrt"    , "MQPurgeQueue", {pointer}, long}, 
  {0, 0, "mqrt"    , "MQReceiveMessage", {pointer, dword, dword, pointer, long_pointer, pointer, pointer, pointer}, long}, 
  {0, 0, "mqrt"    , "MQReceiveMessageByLookupId", {pointer, ulonglong, dword, pointer, long_pointer, pointer, pointer}, long}, 
  {0, 0, "mqrt"    , "MQRegisterCertificate", {dword, pointer, dword}, long}, 
  {0, 0, "mqrt"    , "MQSendMessage", {pointer, pointer, pointer}, long}, 
  {0, 0, "mqrt"    , "MQSetQueueProperties", {pointer, pointer}, long}, 
  {0, 0, "mqrt"    , "MQSetQueueSecurity", {pointer, pointer, pointer}, long}, 
  {0, 0, "msacm32" , "acmDriverAddA", {long_pointer, pointer, long, dword, dword}, uint}, 
  {0, 0, "msacm32" , "acmDriverAddW", {long_pointer, pointer, long, dword, dword}, uint}, 
  {0, 0, "msacm32" , "acmDriverClose", {pointer, dword}, uint}, 
  {0, 0, "msacm32" , "acmDriverDetailsA", {pointer, long_pointer, dword}, uint}, 
  {0, 0, "msacm32" , "acmDriverDetailsW", {pointer, long_pointer, dword}, uint}, 
  {0, 0, "msacm32" , "acmDriverEnum", {pointer, pointer, dword}, uint}, 
  {0, 0, "msacm32" , "acmDriverOpen", {long_pointer, pointer, dword}, uint}, 
  {0, 0, "msacm32" , "acmDriverRemove", {pointer, dword}, uint}, 
  {0, 0, "msacm32" , "acmFormatEnumA", {pointer, long_pointer, pointer, pointer, dword}, uint}, 
  {0, 0, "msacm32" , "acmFormatEnumW", {pointer, long_pointer, pointer, pointer, dword}, uint}, 
  {0, 0, "msacm32" , "acmFormatTagEnumA", {pointer, long_pointer, pointer, pointer, dword}, uint}, 
  {0, 0, "msacm32" , "acmFormatTagEnumW", {pointer, long_pointer, pointer, pointer, dword}, uint}, 
  {0, 0, "msacm32" , "acmMetrics", {pointer, uint, long_pointer}, uint}, 
  {0, 0, "msacm32" , "acmStreamClose", {pointer, dword}, uint}, 
  {0, 0, "msacm32" , "acmStreamConvert", {pointer, long_pointer, dword}, uint}, 
  {0, 0, "msacm32" , "acmStreamOpen", {long_pointer, pointer, long_pointer, long_pointer, long_pointer, pointer, pointer, dword}, uint}, 
  {0, 0, "msacm32" , "acmStreamPrepareHeader", {pointer, long_pointer, dword}, uint}, 
  {0, 0, "msacm32" , "acmStreamReset", {pointer, dword}, uint}, 
  {0, 0, "msacm32" , "acmStreamSize", {pointer, dword, pointer, dword}, uint}, 
  {0, 0, "msacm32" , "acmStreamUnprepareHeader", {pointer, long_pointer, dword}, uint}, 
  {0, 0, "mscms"   , "AssociateColorProfileWithDeviceA", {pointer, pointer, pointer}, bool}, 
  {0, 0, "mscms"   , "AssociateColorProfileWithDeviceW", {pointer, pointer, pointer}, bool}, 
  {0, 0, "mscms"   , "CheckBitmapBits", {pointer, pointer, pointer, dword, dword, dword, pointer, pointer, long}, bool}, 
  {0, 0, "mscms"   , "CheckColors", {pointer, pointer, dword, pointer, pointer}, bool}, 
  {0, 0, "mscms"   , "CloseColorProfile", {pointer}, bool}, 
  {0, 0, "mscms"   , "ConvertColorNameToIndex", {pointer, pointer, pointer, dword}, bool}, 
  {0, 0, "mscms"   , "ConvertIndexToColorName", {pointer, pointer, pointer, dword}, bool}, 
  {0, 0, "mscms"   , "CreateColorTransformA", {long_pointer, pointer, pointer, dword}, pointer}, 
  {0, 0, "mscms"   , "CreateColorTransformW", {long_pointer, pointer, pointer, dword}, pointer}, 
  {0, 0, "mscms"   , "CreateDeviceLinkProfile", {pointer, dword, pointer, dword, dword, pointer, dword}, bool}, 
  {0, 0, "mscms"   , "CreateMultiProfileTransform", {pointer, dword, pointer, dword, dword, dword}, pointer}, 
  {0, 0, "mscms"   , "CreateProfileFromLogColorSpaceA", {long_pointer, pointer}, bool}, 
  {0, 0, "mscms"   , "CreateProfileFromLogColorSpaceW", {long_pointer, pointer}, bool}, 
  {0, 0, "mscms"   , "DeleteColorTransform", {pointer}, bool}, 
  {0, 0, "mscms"   , "DisassociateColorProfileFromDeviceA", {pointer, pointer, pointer}, bool}, 
  {0, 0, "mscms"   , "DisassociateColorProfileFromDeviceW", {pointer, pointer, pointer}, bool}, 
  {0, 0, "mscms"   , "EnumColorProfilesA", {pointer, pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "mscms"   , "EnumColorProfilesW", {pointer, pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "mscms"   , "GetCMMInfo", {pointer, dword}, dword}, 
  {0, 0, "mscms"   , "GetColorDirectoryA", {pointer, pointer, pointer}, bool}, 
  {0, 0, "mscms"   , "GetColorDirectoryW", {pointer, pointer, pointer}, bool}, 
  {0, 0, "mscms"   , "GetColorProfileElement", {pointer, dword, dword, pointer, pointer, pointer}, bool}, 
  {0, 0, "mscms"   , "GetColorProfileElementTag", {pointer, dword, pointer}, bool}, 
  {0, 0, "mscms"   , "GetColorProfileFromHandle", {pointer, pointer, pointer}, bool}, 
  {0, 0, "mscms"   , "GetColorProfileHeader", {pointer, pointer}, bool}, 
  {0, 0, "mscms"   , "GetCountColorProfileElements", {pointer, pointer}, bool}, 
  {0, 0, "mscms"   , "GetNamedProfileInfo", {pointer, pointer}, bool}, 
  {0, 0, "mscms"   , "GetPS2ColorRenderingDictionary", {pointer, dword, pointer, pointer, pointer}, bool}, 
  {0, 0, "mscms"   , "GetPS2ColorRenderingIntent", {pointer, dword, pointer, pointer}, bool}, 
  {0, 0, "mscms"   , "GetPS2ColorSpaceArray", {pointer, dword, dword, pointer, pointer, pointer}, bool}, 
  {0, 0, "mscms"   , "GetStandardColorSpaceProfileA", {pointer, dword, pointer, pointer}, bool}, 
  {0, 0, "mscms"   , "GetStandardColorSpaceProfileW", {pointer, dword, pointer, pointer}, bool}, 
  {0, 0, "mscms"   , "InstallColorProfileA", {pointer, pointer}, bool}, 
  {0, 0, "mscms"   , "InstallColorProfileW", {pointer, pointer}, bool}, 
  {0, 0, "mscms"   , "IsColorProfileTagPresent", {pointer, dword, pointer}, bool}, 
  {0, 0, "mscms"   , "IsColorProfileValid", {pointer, pointer}, bool}, 
  {0, 0, "mscms"   , "OpenColorProfileA", {pointer, dword, dword, dword}, pointer}, 
  {0, 0, "mscms"   , "OpenColorProfileW", {pointer, dword, dword, dword}, pointer}, 
  {0, 0, "mscms"   , "RegisterCMMA", {pointer, dword, pointer}, bool}, 
  {0, 0, "mscms"   , "RegisterCMMW", {pointer, dword, pointer}, bool}, 
  {0, 0, "mscms"   , "SelectCMM", {dword}, bool}, 
  {0, 0, "mscms"   , "SetColorProfileElement", {pointer, dword, dword, pointer, pointer}, bool}, 
  {0, 0, "mscms"   , "SetColorProfileElementReference", {pointer, dword, dword}, bool}, 
  {0, 0, "mscms"   , "SetColorProfileElementSize", {pointer, dword, dword}, bool}, 
  {0, 0, "mscms"   , "SetColorProfileHeader", {pointer, pointer}, bool}, 
  {0, 0, "mscms"   , "SetStandardColorSpaceProfileA", {pointer, dword, pointer}, bool}, 
  {0, 0, "mscms"   , "SetStandardColorSpaceProfileW", {pointer, dword, pointer}, bool}, 
  {0, 0, "mscms"   , "SetupColorMatchingA", {pointer}, bool}, 
  {0, 0, "mscms"   , "SetupColorMatchingW", {pointer}, bool}, 
  {0, 0, "mscms"   , "TranslateBitmapBits", {pointer, pointer, pointer, dword, dword, dword, pointer, pointer, dword, pointer, ulong}, bool}, 
  {0, 0, "mscms"   , "TranslateColors", {pointer, pointer, dword, pointer, pointer, pointer}, bool}, 
  {0, 0, "mscms"   , "UninstallColorProfileA", {pointer, pointer, bool}, bool}, 
  {0, 0, "mscms"   , "UninstallColorProfileW", {pointer, pointer, bool}, bool}, 
  {0, 0, "mscms"   , "UnregisterCMMA", {pointer, dword}, bool}, 
  {0, 0, "mscms"   , "UnregisterCMMW", {pointer, dword}, bool}, 
  {0, 0, "msimg32" , "GradientFill", {pointer, pointer, ulong, pointer, ulong, ulong}, bool}, 
  {0, 0, "msvfw32" , "GetOpenFileNamePreviewA", {long_pointer}, bool}, 
  {0, 0, "msvfw32" , "GetOpenFileNamePreviewW", {long_pointer}, bool}, 
  {0, 0, "msvfw32" , "GetSaveFileNamePreviewA", {long_pointer}, bool}, 
  {0, 0, "msvfw32" , "GetSaveFileNamePreviewW", {long_pointer}, bool}, 
  {0, 0, "nddeapi" , "NDdeGetErrorStringA", {uint, pointer, dword}, uint}, 
  {0, 0, "nddeapi" , "NDdeGetErrorStringW", {uint, pointer, dword}, uint}, 
  {0, 0, "nddeapi" , "NDdeGetShareSecurityA", {pointer, pointer, pointer, pointer, dword, pointer}, uint}, 
  {0, 0, "nddeapi" , "NDdeGetShareSecurityW", {pointer, pointer, pointer, pointer, dword, pointer}, uint}, 
  {0, 0, "nddeapi" , "NDdeGetTrustedShareA", {pointer, pointer, pointer, pointer, pointer}, uint}, 
  {0, 0, "nddeapi" , "NDdeGetTrustedShareW", {pointer, pointer, pointer, pointer, pointer}, uint}, 
  {0, 0, "nddeapi" , "NDdeIsValidAppTopicListA", {pointer}, bool}, 
  {0, 0, "nddeapi" , "NDdeIsValidAppTopicListW", {pointer}, bool}, 
  {0, 0, "nddeapi" , "NDdeIsValidShareNameA", {pointer}, bool}, 
  {0, 0, "nddeapi" , "NDdeIsValidShareNameW", {pointer}, bool}, 
  {0, 0, "nddeapi" , "NDdeSetShareSecurityA", {pointer, pointer, pointer, pointer}, uint}, 
  {0, 0, "nddeapi" , "NDdeSetShareSecurityW", {pointer, pointer, pointer, pointer}, uint}, 
  {0, 0, "nddeapi" , "NDdeSetTrustedShareA", {pointer, pointer, dword}, uint}, 
  {0, 0, "nddeapi" , "NDdeSetTrustedShareW", {pointer, pointer, dword}, uint}, 
  {0, 0, "nddeapi" , "NDdeShareAddA", {pointer, uint, pointer, pointer, dword}, uint}, 
  {0, 0, "nddeapi" , "NDdeShareAddW", {pointer, uint, pointer, pointer, dword}, uint}, 
  {0, 0, "nddeapi" , "NDdeShareDelA", {pointer, pointer, uint}, uint}, 
  {0, 0, "nddeapi" , "NDdeShareDelW", {pointer, pointer, uint}, uint}, 
  {0, 0, "nddeapi" , "NDdeShareEnumA", {pointer, uint, pointer, dword, pointer, pointer}, uint}, 
  {0, 0, "nddeapi" , "NDdeShareEnumW", {pointer, uint, pointer, dword, pointer, pointer}, uint}, 
  {0, 0, "nddeapi" , "NDdeShareGetInfoA", {pointer, pointer, uint, pointer, dword, pointer, pointer}, uint}, 
  {0, 0, "nddeapi" , "NDdeShareGetInfoW", {pointer, pointer, uint, pointer, dword, pointer, pointer}, uint}, 
  {0, 0, "nddeapi" , "NDdeShareSetInfoA", {pointer, pointer, uint, pointer, dword, word}, uint}, 
  {0, 0, "nddeapi" , "NDdeShareSetInfoW", {pointer, pointer, uint, pointer, dword, word}, uint}, 
  {0, 0, "nddeapi" , "NDdeTrustedShareEnumA", {pointer, uint, pointer, dword, pointer, pointer}, uint}, 
  {0, 0, "nddeapi" , "NDdeTrustedShareEnumW", {pointer, uint, pointer, dword, pointer, pointer}, uint}, 
  {0, 0, "netapi32", "DsGetDcNameA", {pointer, pointer, pointer, pointer, ulong, pointer}, dword}, 
  {0, 0, "netapi32", "DsGetDcNameW", {pointer, pointer, pointer, pointer, ulong, pointer}, dword}, 
  {0, 0, "netapi32", "I_BrowserServerEnum", {pointer, pointer, pointer, dword, pointer, dword, pointer, pointer, dword, pointer, pointer}, pointer}, 
  {0, 0, "netapi32", "I_BrowserServerEnumEx", {pointer, pointer, pointer, dword, pointer, dword, pointer, pointer, dword, pointer, pointer}, pointer}, 
  {0, 0, "netapi32", "NetAlertRaise", {pointer, pointer, dword}, pointer}, 
  {0, 0, "netapi32", "NetAlertRaiseEx", {pointer, pointer, dword, pointer}, pointer}, 
  {0, 0, "netapi32", "NetApiBufferAllocate", {dword, pointer}, pointer}, 
  {0, 0, "netapi32", "NetApiBufferFree", {pointer}, pointer}, 
  {0, 0, "netapi32", "NetApiBufferReallocate", {pointer, dword, pointer}, pointer}, 
  {0, 0, "netapi32", "NetApiBufferSize", {pointer, pointer}, pointer}, 
  {0, 0, "netapi32", "NetapipBufferAllocate", {dword, pointer}, pointer}, 
  {0, 0, "netapi32", "NetAuditClear", {pointer, pointer, pointer}, pointer}, 
  {0, 0, "netapi32", "NetAuditRead", {long_pointer, long_pointer, long_pointer, dword, pointer, dword, dword, pointer, dword, pointer, pointer}, pointer}, 
  {0, 0, "netapi32", "NetAuditWrite", {dword, pointer, dword, long_pointer, pointer}, pointer}, 
  {0, 0, "netapi32", "Netbios", {pointer}, uchar}, 
  {0, 0, "netapi32", "NetConfigGet", {pointer, pointer, pointer, pointer}, pointer}, 
  {0, 0, "netapi32", "NetConfigGetAll", {pointer, pointer, pointer}, pointer}, 
  {0, 0, "netapi32", "NetConfigSet", {pointer, pointer, pointer, dword, dword, pointer, dword}, pointer}, 
  {0, 0, "netapi32", "NetConnectionEnum", {pointer, pointer, dword, pointer, dword, pointer, pointer, pointer}, pointer}, 
  {0, 0, "netapi32", "NetErrorLogClear", {pointer, pointer, pointer}, pointer}, 
  {0, 0, "netapi32", "NetErrorLogRead", {pointer, pointer, long_pointer, dword, pointer, dword, dword, pointer, dword, pointer, pointer}, pointer}, 
  {0, 0, "netapi32", "NetErrorLogWrite", {pointer, dword, pointer, pointer, dword, pointer, dword, pointer}, pointer}, 
  {0, 0, "netapi32", "NetFileClose", {pointer, dword}, pointer}, 
  {0, 0, "netapi32", "NetFileEnum", {pointer, pointer, pointer, dword, pointer, dword, pointer, pointer, pointer}, pointer}, 
  {0, 0, "netapi32", "NetFileGetInfo", {pointer, dword, dword, pointer}, pointer}, 
  {0, 0, "netapi32", "NetLocalGroupGetMembers", {pointer, pointer, dword, pointer, dword, pointer, pointer, pointer}, pointer}, 
  {0, 0, "netapi32", "NetMessageBufferSend", {pointer, pointer, pointer, pointer, dword}, pointer}, 
  {0, 0, "netapi32", "NetMessageNameAdd", {pointer, pointer}, pointer}, 
  {0, 0, "netapi32", "NetMessageNameDel", {pointer, pointer}, pointer}, 
  {0, 0, "netapi32", "NetMessageNameEnum", {pointer, dword, pointer, dword, pointer, pointer, pointer}, pointer}, 
  {0, 0, "netapi32", "NetMessageNameGetInfo", {pointer, pointer, dword, pointer}, pointer}, 
  {0, 0, "netapi32", "NetRemoteComputerSupports", {pointer, dword, pointer}, pointer}, 
  {0, 0, "netapi32", "NetRemoteTOD", {pointer, pointer}, pointer}, 
  {0, 0, "netapi32", "NetReplExportDirAdd", {pointer, dword, pointer, pointer}, pointer}, 
  {0, 0, "netapi32", "NetReplExportDirDel", {pointer, pointer}, pointer}, 
  {0, 0, "netapi32", "NetReplExportDirEnum", {pointer, dword, pointer, dword, pointer, pointer, pointer}, pointer}, 
  {0, 0, "netapi32", "NetReplExportDirGetInfo", {pointer, pointer, dword, pointer}, pointer}, 
  {0, 0, "netapi32", "NetReplExportDirLock", {pointer, pointer}, pointer}, 
  {0, 0, "netapi32", "NetReplExportDirSetInfo", {pointer, pointer, dword, pointer, pointer}, pointer}, 
  {0, 0, "netapi32", "NetReplExportDirUnlock", {pointer, pointer, dword}, pointer}, 
  {0, 0, "netapi32", "NetReplGetInfo", {pointer, dword, pointer}, pointer}, 
  {0, 0, "netapi32", "NetReplImportDirAdd", {pointer, dword, pointer, pointer}, pointer}, 
  {0, 0, "netapi32", "NetReplImportDirDel", {pointer, pointer}, pointer}, 
  {0, 0, "netapi32", "NetReplImportDirEnum", {pointer, dword, pointer, dword, pointer, pointer, pointer}, pointer}, 
  {0, 0, "netapi32", "NetReplImportDirGetInfo", {pointer, pointer, dword, pointer}, pointer}, 
  {0, 0, "netapi32", "NetReplImportDirLock", {pointer, pointer}, pointer}, 
  {0, 0, "netapi32", "NetReplImportDirUnlock", {pointer, pointer, dword}, pointer}, 
  {0, 0, "netapi32", "NetReplSetInfo", {pointer, dword, pointer, pointer}, pointer}, 
  {0, 0, "netapi32", "NetScheduleJobAdd", {pointer, pointer, pointer}, pointer}, 
  {0, 0, "netapi32", "NetScheduleJobDel", {pointer, dword, dword}, pointer}, 
  {0, 0, "netapi32", "NetScheduleJobEnum", {pointer, pointer, dword, pointer, pointer, pointer}, pointer}, 
  {0, 0, "netapi32", "NetScheduleJobGetInfo", {pointer, dword, pointer}, pointer}, 
  {0, 0, "netapi32", "NetServerComputerNameAdd", {pointer, pointer, pointer}, pointer}, 
  {0, 0, "netapi32", "NetServerComputerNameDel", {pointer, pointer}, pointer}, 
  {0, 0, "netapi32", "NetServerDiskEnum", {pointer, dword, pointer, dword, pointer, pointer, pointer}, pointer}, 
  {0, 0, "netapi32", "NetServerEnum", {pointer, dword, pointer, dword, pointer, pointer, dword, pointer, pointer}, pointer}, 
  {0, 0, "netapi32", "NetServerEnumEx", {pointer, dword, pointer, dword, pointer, pointer, dword, pointer, pointer}, pointer}, 
  {0, 0, "netapi32", "NetServerGetInfo", {pointer, dword, pointer}, pointer}, 
  {0, 0, "netapi32", "NetServerSetInfo", {pointer, dword, pointer, pointer}, pointer}, 
  {0, 0, "netapi32", "NetServerTransportAdd", {pointer, dword, pointer}, pointer}, 
  {0, 0, "netapi32", "NetServerTransportAddEx", {pointer, dword, pointer}, pointer}, 
  {0, 0, "netapi32", "NetServerTransportDel", {pointer, dword, pointer}, pointer}, 
  {0, 0, "netapi32", "NetServerTransportEnum", {pointer, dword, pointer, dword, pointer, pointer, pointer}, pointer}, 
  {0, 0, "netapi32", "NetServiceControl", {pointer, pointer, dword, dword, pointer}, pointer}, 
  {0, 0, "netapi32", "NetServiceEnum", {pointer, dword, pointer, dword, pointer, pointer, pointer}, pointer}, 
  {0, 0, "netapi32", "NetServiceGetInfo", {pointer, pointer, dword, pointer}, pointer}, 
  {0, 0, "netapi32", "NetServiceInstall", {pointer, pointer, dword, pointer, pointer}, pointer}, 
  {0, 0, "netapi32", "NetSessionDel", {pointer, pointer, pointer}, pointer}, 
  {0, 0, "netapi32", "NetSessionEnum", {pointer, pointer, pointer, dword, pointer, dword, pointer, pointer, pointer}, pointer}, 
  {0, 0, "netapi32", "NetSessionGetInfo", {pointer, pointer, pointer, dword, pointer}, pointer}, 
  {0, 0, "netapi32", "NetShareAdd", {pointer, dword, pointer, pointer}, pointer}, 
  {0, 0, "netapi32", "NetShareCheck", {pointer, pointer, pointer}, pointer}, 
  {0, 0, "netapi32", "NetShareDel", {pointer, pointer, dword}, pointer}, 
  {0, 0, "netapi32", "NetShareDelSticky", {pointer, pointer, dword}, pointer}, 
  {0, 0, "netapi32", "NetShareEnum", {pointer, dword, pointer, dword, pointer, pointer, pointer}, pointer}, 
  {0, 0, "netapi32", "NetShareEnumSticky", {pointer, dword, pointer, dword, pointer, pointer, pointer}, pointer}, 
  {0, 0, "netapi32", "NetShareGetInfo", {pointer, pointer, dword, pointer}, pointer}, 
  {0, 0, "netapi32", "NetShareSetInfo", {pointer, pointer, dword, pointer, pointer}, pointer}, 
  {0, 0, "netapi32", "NetStatisticsGet", {pointer, pointer, dword, dword, pointer}, pointer}, 
  {0, 0, "netapi32", "NetUseAdd", {pointer, dword, pointer, pointer}, pointer}, 
  {0, 0, "netapi32", "NetUseDel", {pointer, pointer, dword}, pointer}, 
  {0, 0, "netapi32", "NetUseEnum", {pointer, dword, pointer, dword, pointer, pointer, pointer}, pointer}, 
  {0, 0, "netapi32", "NetUseGetInfo", {pointer, pointer, dword, pointer}, pointer}, 
  {0, 0, "netapi32", "NetWkstaGetInfo", {pointer, dword, pointer}, pointer}, 
  {0, 0, "netapi32", "NetWkstaSetInfo", {pointer, dword, pointer, pointer}, pointer}, 
  {0, 0, "netapi32", "NetWkstaTransportAdd", {pointer, dword, pointer, pointer}, pointer}, 
  {0, 0, "netapi32", "NetWkstaTransportDel", {pointer, pointer, dword}, pointer}, 
  {0, 0, "netapi32", "NetWkstaTransportEnum", {pointer, dword, pointer, dword, pointer, pointer, pointer}, pointer}, 
  {0, 0, "netapi32", "NetWkstaUserEnum", {pointer, dword, pointer, dword, pointer, pointer, pointer}, pointer}, 
  {0, 0, "netapi32", "NetWkstaUserGetInfo", {pointer, dword, pointer}, pointer}, 
  {0, 0, "netapi32", "NetWkstaUserSetInfo", {pointer, dword, pointer, pointer}, pointer}, 
  {0, 0, "ntdll"   , "NtShutdownSystem", {pointer}, dword}, 
  {0, 0, "ole32"   , "OleInitialize", {int}, int}, 
  {0, 0, "ole32"   , "OleUninitialize", {}}, 
  {0, 0, "oleacc"  , "GetOleaccVersionInfo", {pointer, pointer}}, 
  {0, 0, "oleacc"  , "GetRoleTextA", {dword, pointer, uint}, uint}, 
  {0, 0, "oleacc"  , "GetRoleTextW", {dword, pointer, uint}, uint}, 
  {0, 0, "oleacc"  , "GetStateTextA", {dword, pointer, uint}, uint}, 
  {0, 0, "oleacc"  , "GetStateTextW", {dword, pointer, uint}, uint}, 
  {0, 0, "oleacc"  , "LresultFromObject", {pointer, unsigned_int, long_pointer}, long}, 
  {0, 0, "olecli32", "OleActivate", {long_pointer, uint, bool, bool, pointer, long_pointer}, pointer}, 
  {0, 0, "olecli32", "OleBlockServer", {long}, pointer}, 
  {0, 0, "olecli32", "OleClone", {long_pointer, long_pointer, pointer, pointer, pointer}, pointer}, 
  {0, 0, "olecli32", "OleClose", {long_pointer}, pointer}, 
  {0, 0, "olecli32", "OleCopyFromLink", {long_pointer, pointer, long_pointer, pointer, pointer, pointer}, pointer}, 
  {0, 0, "olecli32", "OleCopyToClipboard", {long_pointer}, pointer}, 
  {0, 0, "olecli32", "OleCreate", {pointer, long_pointer, pointer, pointer, pointer, pointer, pointer, word}, pointer}, 
  {0, 0, "olecli32", "OleCreateFromClip", {pointer, long_pointer, pointer, pointer, pointer, pointer, word}, pointer}, 
  {0, 0, "olecli32", "OleCreateFromFile", {pointer, long_pointer, pointer, pointer, pointer, pointer, pointer, pointer, word}, pointer}, 
  {0, 0, "olecli32", "OleCreateFromTemplate", {pointer, long_pointer, pointer, pointer, pointer, pointer, pointer, word}, pointer}, 
  {0, 0, "olecli32", "OleCreateInvisible", {pointer, long_pointer, pointer, pointer, pointer, pointer, pointer, word, bool}, pointer}, 
  {0, 0, "olecli32", "OleCreateLinkFromClip", {pointer, long_pointer, pointer, pointer, pointer, pointer, word}, pointer}, 
  {0, 0, "olecli32", "OleCreateLinkFromFile", {pointer, long_pointer, pointer, pointer, pointer, pointer, pointer, pointer, pointer, word}, pointer}, 
  {0, 0, "olecli32", "OleDelete", {long_pointer}, pointer}, 
  {0, 0, "olecli32", "OleDraw", {long_pointer, pointer, long_pointer, long_pointer, pointer}, pointer}, 
  {0, 0, "olecli32", "OleEnumFormats", {long_pointer, word}, word}, 
  {0, 0, "olecli32", "OleEnumObjects", {pointer, pointer}, pointer}, 
  {0, 0, "olecli32", "OleEqual", {long_pointer, long_pointer}, pointer}, 
  {0, 0, "olecli32", "OleExecute", {long_pointer, pointer, uint}, pointer}, 
  {0, 0, "olecli32", "OleGetData", {long_pointer, word, pointer}, pointer}, 
  {0, 0, "olecli32", "OleGetLinkUpdateOptions", {long_pointer, pointer}, pointer}, 
  {0, 0, "olecli32", "OleIsDcMeta", {pointer}, bool}, 
  {0, 0, "olecli32", "OleLoadFromStream", {long_pointer, pointer, long_pointer, pointer, pointer, pointer}, pointer}, 
  {0, 0, "olecli32", "OleLockServer", {long_pointer, pointer}, pointer}, 
  {0, 0, "olecli32", "OleObjectConvert", {long_pointer, pointer, long_pointer, pointer, pointer, pointer}, pointer}, 
  {0, 0, "olecli32", "OleQueryBounds", {long_pointer, pointer}, pointer}, 
  {0, 0, "olecli32", "OleQueryClientVersion", {}, dword}, 
  {0, 0, "olecli32", "OleQueryCreateFromClip", {pointer, pointer, word}, pointer}, 
  {0, 0, "olecli32", "OleQueryLinkFromClip", {pointer, pointer, word}, pointer}, 
  {0, 0, "olecli32", "OleQueryName", {long_pointer, pointer, pointer}, pointer}, 
  {0, 0, "olecli32", "OleQueryOpen", {long_pointer}, pointer}, 
  {0, 0, "olecli32", "OleQueryOutOfDate", {long_pointer}, pointer}, 
  {0, 0, "olecli32", "OleQueryProtocol", {long_pointer, pointer}, pointer}, 
  {0, 0, "olecli32", "OleQueryReleaseError", {long_pointer}, pointer}, 
  {0, 0, "olecli32", "OleQueryReleaseMethod", {long_pointer}, pointer}, 
  {0, 0, "olecli32", "OleQueryReleaseStatus", {long_pointer}, pointer}, 
  {0, 0, "olecli32", "OleQueryServerVersion", {}, dword}, 
  {0, 0, "olecli32", "OleQuerySize", {long_pointer, pointer}, pointer}, 
  {0, 0, "olecli32", "OleQueryType", {long_pointer, pointer}, pointer}, 
  {0, 0, "olecli32", "OleReconnect", {long_pointer}, pointer}, 
  {0, 0, "olecli32", "OleRegisterClientDoc", {pointer, pointer, long, pointer}, pointer}, 
  {0, 0, "olecli32", "OleRegisterServer", {pointer, long_pointer, pointer, pointer, pointer}, pointer}, 
  {0, 0, "olecli32", "OleRegisterServerDoc", {long, pointer, long_pointer, pointer}, pointer}, 
  {0, 0, "olecli32", "OleRelease", {long_pointer}, pointer}, 
  {0, 0, "olecli32", "OleRename", {long_pointer, pointer}, pointer}, 
  {0, 0, "olecli32", "OleRenameClientDoc", {pointer, pointer}, pointer}, 
  {0, 0, "olecli32", "OleRenameServerDoc", {long, pointer}, pointer}, 
  {0, 0, "olecli32", "OleRequestData", {long_pointer, word}, pointer}, 
  {0, 0, "olecli32", "OleRevertClientDoc", {pointer}, pointer}, 
  {0, 0, "olecli32", "OleRevertServerDoc", {long}, pointer}, 
  {0, 0, "olecli32", "OleRevokeClientDoc", {pointer}, pointer}, 
  {0, 0, "olecli32", "OleRevokeObject", {long_pointer}, pointer}, 
  {0, 0, "olecli32", "OleRevokeServer", {long}, pointer}, 
  {0, 0, "olecli32", "OleRevokeServerDoc", {long}, pointer}, 
  {0, 0, "olecli32", "OleSavedClientDoc", {pointer}, pointer}, 
  {0, 0, "olecli32", "OleSavedServerDoc", {long}, pointer}, 
  {0, 0, "olecli32", "OleSaveToStream", {long_pointer, long_pointer}, pointer}, 
  {0, 0, "olecli32", "OleSetBounds", {long_pointer, long_pointer}, pointer}, 
  {0, 0, "olecli32", "OleSetColorScheme", {long_pointer, pointer}, pointer}, 
  {0, 0, "olecli32", "OleSetData", {long_pointer, word, pointer}, pointer}, 
  {0, 0, "olecli32", "OleSetHostNames", {long_pointer, pointer, pointer}, pointer}, 
  {0, 0, "olecli32", "OleSetLinkUpdateOptions", {long_pointer, pointer}, pointer}, 
  {0, 0, "olecli32", "OleSetTargetDevice", {long_pointer, pointer}, pointer}, 
  {0, 0, "olecli32", "OleUnblockServer", {long, pointer}, pointer}, 
  {0, 0, "olecli32", "OleUnlockServer", {long}, pointer}, 
  {0, 0, "olecli32", "OleUpdate", {long_pointer}, pointer}, 
  {0, 0, "powrprof", "CallNtPowerInformation", {pointer, pointer, ulong, pointer, ulong}, long}, 
  {0, 0, "powrprof", "CanUserWritePwrScheme", {}, bool}, 
  {0, 0, "powrprof", "DeletePwrScheme", {uint}, bool}, 
  {0, 0, "powrprof", "EnumPwrSchemes", {pointer, long}, bool}, 
  {0, 0, "powrprof", "GetActivePwrScheme", {pointer}, bool}, 
  {0, 0, "powrprof", "GetCurrentPowerPolicies", {pointer, pointer}, bool}, 
  {0, 0, "powrprof", "GetPwrCapabilities", {pointer}, bool}, 
  {0, 0, "powrprof", "GetPwrDiskSpindownRange", {pointer, pointer}, bool}, 
  {0, 0, "powrprof", "IsAdminOverrideActive", {pointer}, bool}, 
  {0, 0, "powrprof", "IsPwrHibernateAllowed", {}, bool}, 
  {0, 0, "powrprof", "IsPwrShutdownAllowed", {}, bool}, 
  {0, 0, "powrprof", "IsPwrSuspendAllowed", {}, bool}, 
  {0, 0, "powrprof", "ReadGlobalPwrPolicy", {pointer}, bool}, 
  {0, 0, "powrprof", "ReadProcessorPwrScheme", {uint, pointer}, bool}, 
  {0, 0, "powrprof", "ReadPwrScheme", {uint, pointer}, bool}, 
  {0, 0, "powrprof", "SetActivePwrScheme", {uint, pointer, pointer}, bool}, 
  {0, 0, "powrprof", "SetSuspendState", {bool, bool, bool}, bool}, 
  {0, 0, "powrprof", "ValidatePowerPolicies", {pointer, pointer}, bool}, 
  {0, 0, "powrprof", "WriteGlobalPwrPolicy", {pointer}, bool}, 
  {0, 0, "powrprof", "WriteProcessorPwrScheme", {uint, pointer}, bool}, 
  {0, 0, "powrprof", "WritePwrScheme", {pointer, long_pointer, long_pointer, pointer}, bool}, 
  {0, 0, "psapi"   , "EmptyWorkingSet", {pointer}, bool}, 
  {0, 0, "psapi"   , "EnumDeviceDrivers", {pointer, dword, pointer}, bool}, 
  {0, 0, "psapi"   , "EnumProcesses", {pointer, dword, pointer}, bool}, 
  {0, 0, "psapi"   , "EnumProcessModules", {pointer, pointer, dword, pointer}, bool}, 
  {0, 0, "psapi"   , "GetDeviceDriverBaseNameA", {long_pointer, pointer, dword}, dword}, 
  {0, 0, "psapi"   , "GetDeviceDriverBaseNameW", {long_pointer, pointer, dword}, dword}, 
  {0, 0, "psapi"   , "GetDeviceDriverFileNameA", {long_pointer, pointer, dword}, dword}, 
  {0, 0, "psapi"   , "GetDeviceDriverFileNameW", {long_pointer, pointer, dword}, dword}, 
  {0, 0, "psapi"   , "GetMappedFileNameA", {pointer, long_pointer, pointer, dword}, dword}, 
  {0, 0, "psapi"   , "GetMappedFileNameW", {pointer, long_pointer, pointer, dword}, dword}, 
  {0, 0, "psapi"   , "GetModuleBaseNameA", {pointer, pointer, pointer, dword}, dword}, 
  {0, 0, "psapi"   , "GetModuleBaseNameW", {pointer, pointer, pointer, dword}, dword}, 
  {0, 0, "psapi"   , "GetModuleFileNameExA", {pointer, pointer, pointer, dword}, dword}, 
  {0, 0, "psapi"   , "GetModuleFileNameExW", {pointer, pointer, pointer, dword}, dword}, 
  {0, 0, "psapi"   , "GetModuleInformation", {pointer, pointer, long_pointer, dword}, bool}, 
  {0, 0, "psapi"   , "GetPerformanceInfo", {pointer, dword}, bool}, 
  {0, 0, "psapi"   , "GetProcessImageFileNameA", {pointer, pointer, dword}, dword}, 
  {0, 0, "psapi"   , "GetProcessImageFileNameW", {pointer, pointer, dword}, dword}, 
  {0, 0, "psapi"   , "GetProcessMemoryInfo", {pointer, pointer, dword}, bool}, 
  {0, 0, "psapi"   , "GetWsChanges", {pointer, pointer, dword}, bool}, 
  {0, 0, "psapi"   , "InitializeProcessForWsWatch", {pointer}, bool}, 
  {0, 0, "psapi"   , "QueryWorkingSet", {pointer, pointer, dword}, bool}, 
  {0, 0, "quartz"  , "AMGetErrorTextA", {long, pointer, dword}, dword}, 
  {0, 0, "quartz"  , "AMGetErrorTextW", {long, pointer, dword}, dword}, 
  {0, 0, "rtm"     , "MgmAddGroupMembershipEntry", {pointer, dword, dword, dword, dword, dword, dword, dword}, dword}, 
  {0, 0, "rtm"     , "MgmDeleteGroupMembershipEntry", {pointer, dword, dword, dword, dword, dword, dword, dword}, dword}, 
  {0, 0, "rtm"     , "MgmDeRegisterMProtocol", {pointer}, dword}, 
  {0, 0, "rtm"     , "MgmGetFirstMfe", {pointer, pointer, pointer}, dword}, 
  {0, 0, "rtm"     , "MgmGetFirstMfeStats", {pointer, pointer, pointer, dword}, dword}, 
  {0, 0, "rtm"     , "MgmGetMfe", {pointer, pointer, pointer}, dword}, 
  {0, 0, "rtm"     , "MgmGetMfeStats", {pointer, pointer, pointer, dword}, dword}, 
  {0, 0, "rtm"     , "MgmGetNextMfe", {pointer, pointer, pointer, pointer}, dword}, 
  {0, 0, "rtm"     , "MgmGetNextMfeStats", {pointer, pointer, pointer, pointer, dword}, dword}, 
  {0, 0, "rtm"     , "MgmGetProtocolOnInterface", {dword, dword, pointer, pointer}, dword}, 
  {0, 0, "rtm"     , "MgmGroupEnumerationEnd", {pointer}, dword}, 
  {0, 0, "rtm"     , "MgmGroupEnumerationGetNext", {pointer, pointer, pointer, pointer}, dword}, 
  {0, 0, "rtm"     , "MgmGroupEnumerationStart", {pointer, pointer, pointer}, dword}, 
  {0, 0, "rtm"     , "MgmRegisterMProtocol", {pointer, dword, dword, pointer}, dword}, 
  {0, 0, "rtm"     , "MgmReleaseInterfaceOwnership", {pointer, dword, dword}, dword}, 
  {0, 0, "rtm"     , "MgmSetMfe", {pointer, pointer}, dword}, 
  {0, 0, "rtm"     , "MgmTakeInterfaceOwnership", {pointer, dword, dword}, dword}, 
  {0, 0, "rtutils" , "TraceDeregisterA", {dword}, dword}, 
  {0, 0, "rtutils" , "TraceDeregisterExA", {dword, dword}, dword}, 
  {0, 0, "rtutils" , "TraceDeregisterExW", {dword, dword}, dword}, 
  {0, 0, "rtutils" , "TraceDeregisterW", {dword}, dword}, 
  {0, 0, "rtutils" , "TraceDumpExA", {dword, dword, pointer, dword, dword, bool, pointer}, dword}, 
  {0, 0, "rtutils" , "TraceDumpExW", {dword, dword, pointer, dword, dword, bool, pointer}, dword}, 
  -- {0, 0, "rtutils" , "TracePrintfA", {dword, pointer, ...}, dword}, 
  -- {0, 0, "rtutils" , "TracePrintfExA", {dword, dword, pointer, ...}, dword}, 
  -- {0, 0, "rtutils" , "TracePrintfExW", {dword, dword, pointer, ...}, dword}, 
  -- {0, 0, "rtutils" , "TracePrintfW", {dword, pointer, ...}, dword}, 
  {0, 0, "rtutils" , "TracePutsExA", {dword, dword, pointer}, dword}, 
  {0, 0, "rtutils" , "TracePutsExW", {dword, dword, pointer}, dword}, 
  {0, 0, "rtutils" , "TraceRegisterExA", {pointer, dword}, dword}, 
  {0, 0, "rtutils" , "TraceRegisterExW", {pointer, dword}, dword}, 
  {0, 0, "rtutils" , "TraceVprintfExA", {dword, dword, pointer, pointer}, dword}, 
  {0, 0, "rtutils" , "TraceVprintfExW", {dword, dword, pointer, pointer}, dword}, 
  {0, 0, "scrnsave", "DefScreenSaverProc", {pointer, uint, unsigned_int, long}, long}, 
  {0, 0, "scrnsave", "RegisterDialogClasses", {pointer}, bool}, 
  {0, 0, "scrnsave", "ScreenSaverChangePassword", {pointer}}, 
  {0, 0, "scrnsave", "ScreenSaverConfigureDialog", {pointer, uint, unsigned_int, long}, bool}, 
  {0, 0, "scrnsave", "ScreenSaverProc", {pointer, uint, unsigned_int, long}, long}, 
  {0, 0, "secur32" , "AcceptSecurityContext", {pointer, pointer, pointer, ulong, ulong, pointer, pointer, pointer, pointer}, long}, 
  {0, 0, "secur32" , "AcquireCredentialsHandleA", {pointer, pointer, ulong, pointer, pointer, pointer, pointer, pointer, pointer}, long}, 
  {0, 0, "secur32" , "AcquireCredentialsHandleW", {pointer, pointer, ulong, pointer, pointer, pointer, pointer, pointer, pointer}, long}, 
  {0, 0, "secur32" , "ApplyControlTokenA", {pointer, pointer}, long}, 
  {0, 0, "secur32" , "ApplyControlTokenW", {pointer, pointer}, long}, 
  {0, 0, "secur32" , "CompleteAuthToken", {pointer, pointer}, long}, 
  {0, 0, "secur32" , "DecryptMessage", {pointer, pointer, ulong, pointer}, long}, 
  {0, 0, "secur32" , "DeleteSecurityContext", {pointer}, long}, 
  {0, 0, "secur32" , "EncryptMessage", {pointer, ulong, pointer, ulong}, long}, 
  {0, 0, "secur32" , "EnumerateSecurityPackagesA", {pointer, pointer}, long}, 
  {0, 0, "secur32" , "EnumerateSecurityPackagesW", {pointer, pointer}, long}, 
  {0, 0, "secur32" , "FreeContextBuffer", {pointer}, long}, 
  {0, 0, "secur32" , "FreeCredentialsHandle", {pointer}, long}, 
  {0, 0, "secur32" , "GetComputerObjectNameA", {pointer, pointer, pointer}, bool}, 
  {0, 0, "secur32" , "GetComputerObjectNameW", {pointer, pointer, pointer}, bool}, 
  {0, 0, "secur32" , "GetUserNameExA", {pointer, pointer, pointer}, bool}, 
  {0, 0, "secur32" , "GetUserNameExW", {pointer, pointer, pointer}, bool}, 
  {0, 0, "secur32" , "ImpersonateSecurityContext", {pointer}, long}, 
  {0, 0, "secur32" , "InitializeSecurityContextA", {pointer, pointer, pointer, ulong, ulong, ulong, pointer, ulong, pointer, pointer, pointer, pointer}, long}, 
  {0, 0, "secur32" , "InitializeSecurityContextW", {pointer, pointer, pointer, ulong, ulong, ulong, pointer, ulong, pointer, pointer, pointer, pointer}, long}, 
  {0, 0, "secur32" , "InitSecurityInterfaceA", {}, pointer}, 
  {0, 0, "secur32" , "InitSecurityInterfaceW", {}, pointer}, 
  {0, 0, "secur32" , "MakeSignature", {pointer, ulong, pointer, ulong}, long}, 
  {0, 0, "secur32" , "QueryContextAttributesA", {pointer, ulong, pointer}, long}, 
  {0, 0, "secur32" , "QueryContextAttributesW", {pointer, ulong, pointer}, long}, 
  {0, 0, "secur32" , "QueryCredentialsAttributesA", {pointer, ulong, pointer}, long}, 
  {0, 0, "secur32" , "QueryCredentialsAttributesW", {pointer, ulong, pointer}, long}, 
  {0, 0, "secur32" , "QuerySecurityContextToken", {pointer, pointer}, long}, 
  {0, 0, "secur32" , "QuerySecurityPackageInfoA", {pointer, pointer}, long}, 
  {0, 0, "secur32" , "QuerySecurityPackageInfoW", {pointer, pointer}, long}, 
  {0, 0, "secur32" , "RevertSecurityContext", {pointer}, long}, 
  {0, 0, "secur32" , "TranslateNameA", {pointer, pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "secur32" , "TranslateNameW", {pointer, pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "secur32" , "VerifySignature", {pointer, pointer, ulong, pointer}, long}, 
  {0, 0, "setupapi", "SetupAddInstallSectionToDiskSpaceListA", {pointer, pointer, pointer, pointer, pointer, uint}, bool}, 
  {0, 0, "setupapi", "SetupAddInstallSectionToDiskSpaceListW", {pointer, pointer, pointer, pointer, pointer, uint}, bool}, 
  {0, 0, "setupapi", "SetupAddSectionToDiskSpaceListA", {pointer, pointer, pointer, pointer, uint, pointer, uint}, bool}, 
  {0, 0, "setupapi", "SetupAddSectionToDiskSpaceListW", {pointer, pointer, pointer, pointer, uint, pointer, uint}, bool}, 
  {0, 0, "setupapi", "SetupAddToDiskSpaceListA", {pointer, pointer, int64, uint, pointer, uint}, bool}, 
  {0, 0, "setupapi", "SetupAddToDiskSpaceListW", {pointer, pointer, int64, uint, pointer, uint}, bool}, 
  {0, 0, "setupapi", "SetupAddToSourceListA", {dword, pointer}, bool}, 
  {0, 0, "setupapi", "SetupAddToSourceListW", {dword, pointer}, bool}, 
  {0, 0, "setupapi", "SetupAdjustDiskSpaceListA", {pointer, pointer, int64, pointer, uint}, bool}, 
  {0, 0, "setupapi", "SetupAdjustDiskSpaceListW", {pointer, pointer, int64, pointer, uint}, bool}, 
  {0, 0, "setupapi", "SetupBackupErrorA", {pointer, pointer, pointer, pointer, uint, dword}, uint}, 
  {0, 0, "setupapi", "SetupBackupErrorW", {pointer, pointer, pointer, pointer, uint, dword}, uint}, 
  {0, 0, "setupapi", "SetupCancelTemporarySourceList", {}, bool}, 
  {0, 0, "setupapi", "SetupCloseFileQueue", {pointer}, bool}, 
  {0, 0, "setupapi", "SetupCloseInfFile", {pointer}}, 
  {0, 0, "setupapi", "SetupCloseLog", {}}, 
  {0, 0, "setupapi", "SetupCommitFileQueueA", {pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupCommitFileQueueW", {pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupConfigureWmiFromInfSectionA", {pointer, pointer, dword}, bool}, 
  {0, 0, "setupapi", "SetupConfigureWmiFromInfSectionW", {pointer, pointer, dword}, bool}, 
  {0, 0, "setupapi", "SetupCopyErrorA", {pointer, pointer, pointer, pointer, pointer, pointer, uint, dword, pointer, dword, pointer}, uint}, 
  {0, 0, "setupapi", "SetupCopyErrorW", {pointer, pointer, pointer, pointer, pointer, pointer, uint, dword, pointer, dword, pointer}, uint}, 
  {0, 0, "setupapi", "SetupCopyOEMInfA", {pointer, pointer, dword, dword, pointer, dword, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupCopyOEMInfW", {pointer, pointer, dword, dword, pointer, dword, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupCreateDiskSpaceListA", {pointer, dword, uint}, pointer}, 
  {0, 0, "setupapi", "SetupCreateDiskSpaceListW", {pointer, dword, uint}, pointer}, 
  {0, 0, "setupapi", "SetupDecompressOrCopyFileA", {pointer, pointer, pointer}, dword}, 
  {0, 0, "setupapi", "SetupDecompressOrCopyFileW", {pointer, pointer, pointer}, dword}, 
  {0, 0, "setupapi", "SetupDefaultQueueCallbackA", {pointer, uint, pointer, pointer}, uint}, 
  {0, 0, "setupapi", "SetupDefaultQueueCallbackW", {pointer, uint, pointer, pointer}, uint}, 
  {0, 0, "setupapi", "SetupDeleteErrorA", {pointer, pointer, pointer, uint, dword}, uint}, 
  {0, 0, "setupapi", "SetupDeleteErrorW", {pointer, pointer, pointer, uint, dword}, uint}, 
  {0, 0, "setupapi", "SetupDestroyDiskSpaceList", {pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiAskForOEMDisk", {pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiBuildClassInfoList", {dword, long_pointer, dword, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiBuildClassInfoListExA", {dword, long_pointer, dword, pointer, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiBuildClassInfoListExW", {dword, long_pointer, dword, pointer, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiBuildDriverInfoList", {pointer, pointer, dword}, bool}, 
  {0, 0, "setupapi", "SetupDiCallClassInstaller", {uint, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiCancelDriverInfoSearch", {pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiChangeState", {pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiClassGuidsFromNameA", {pointer, long_pointer, dword, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiClassGuidsFromNameExA", {pointer, long_pointer, dword, pointer, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiClassGuidsFromNameExW", {pointer, long_pointer, dword, pointer, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiClassGuidsFromNameW", {pointer, long_pointer, dword, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiClassNameFromGuidA", {pointer, pointer, dword, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiClassNameFromGuidExA", {pointer, pointer, dword, pointer, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiClassNameFromGuidExW", {pointer, pointer, dword, pointer, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiClassNameFromGuidW", {pointer, pointer, dword, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiCreateDeviceInfoA", {pointer, pointer, pointer, pointer, pointer, dword, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiCreateDeviceInfoList", {pointer, pointer}, pointer}, 
  {0, 0, "setupapi", "SetupDiCreateDeviceInfoListExA", {pointer, pointer, pointer, pointer}, pointer}, 
  {0, 0, "setupapi", "SetupDiCreateDeviceInfoListExW", {pointer, pointer, pointer, pointer}, pointer}, 
  {0, 0, "setupapi", "SetupDiCreateDeviceInfoW", {pointer, pointer, pointer, pointer, pointer, dword, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiCreateDeviceInterfaceA", {pointer, pointer, pointer, pointer, dword, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiCreateDeviceInterfaceRegKeyA", {pointer, pointer, dword, pointer, pointer, pointer}, pointer}, 
  {0, 0, "setupapi", "SetupDiCreateDeviceInterfaceRegKeyW", {pointer, pointer, dword, pointer, pointer, pointer}, pointer}, 
  {0, 0, "setupapi", "SetupDiCreateDeviceInterfaceW", {pointer, pointer, pointer, pointer, dword, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiCreateDevRegKeyA", {pointer, pointer, dword, dword, dword, pointer, pointer}, pointer}, 
  {0, 0, "setupapi", "SetupDiCreateDevRegKeyW", {pointer, pointer, dword, dword, dword, pointer, pointer}, pointer}, 
  {0, 0, "setupapi", "SetupDiDeleteDeviceInfo", {pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiDeleteDeviceInterfaceData", {pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiDeleteDeviceInterfaceRegKey", {pointer, pointer, dword}, bool}, 
  {0, 0, "setupapi", "SetupDiDeleteDevRegKey", {pointer, pointer, dword, dword, dword}, bool}, 
  {0, 0, "setupapi", "SetupDiDestroyClassImageList", {pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiDestroyDeviceInfoList", {pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiDestroyDriverInfoList", {pointer, pointer, dword}, bool}, 
  {0, 0, "setupapi", "SetupDiDrawMiniIcon", {pointer, pointer, int, dword}, int}, 
  {0, 0, "setupapi", "SetupDiEnumDeviceInfo", {pointer, dword, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiEnumDeviceInterfaces", {pointer, pointer, pointer, dword, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiEnumDriverInfoA", {pointer, pointer, dword, dword, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiEnumDriverInfoW", {pointer, pointer, dword, dword, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiGetActualSectionToInstallA", {pointer, pointer, pointer, dword, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiGetActualSectionToInstallW", {pointer, pointer, pointer, dword, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiGetClassBitmapIndex", {pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiGetClassDescriptionA", {pointer, pointer, dword, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiGetClassDescriptionExA", {pointer, pointer, dword, pointer, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiGetClassDescriptionExW", {pointer, pointer, dword, pointer, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiGetClassDescriptionW", {pointer, pointer, dword, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiGetClassDevPropertySheetsA", {pointer, pointer, long_pointer, dword, pointer, dword}, bool}, 
  {0, 0, "setupapi", "SetupDiGetClassDevPropertySheetsW", {pointer, pointer, long_pointer, dword, pointer, dword}, bool}, 
  {0, 0, "setupapi", "SetupDiGetClassDevsA", {pointer, pointer, pointer, dword}, pointer}, 
  {0, 0, "setupapi", "SetupDiGetClassDevsExA", {pointer, pointer, pointer, dword, pointer, pointer, pointer}, pointer}, 
  {0, 0, "setupapi", "SetupDiGetClassDevsExW", {pointer, pointer, pointer, dword, pointer, pointer, pointer}, pointer}, 
  {0, 0, "setupapi", "SetupDiGetClassDevsW", {pointer, pointer, pointer, dword}, pointer}, 
  {0, 0, "setupapi", "SetupDiGetClassImageIndex", {pointer, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiGetClassImageList", {pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiGetClassImageListExA", {pointer, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiGetClassImageListExW", {pointer, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiGetClassInstallParamsA", {pointer, pointer, pointer, dword, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiGetClassInstallParamsW", {pointer, pointer, pointer, dword, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiGetClassRegistryPropertyA", {long_pointer, dword, pointer, pointer, dword, pointer, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiGetClassRegistryPropertyW", {long_pointer, dword, pointer, pointer, dword, pointer, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiGetDeviceInfoListClass", {pointer, long_pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiGetDeviceInfoListDetailA", {pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiGetDeviceInfoListDetailW", {pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiGetDeviceInstallParamsA", {pointer, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiGetDeviceInstallParamsW", {pointer, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiGetDeviceInstanceIdA", {pointer, pointer, pointer, dword, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiGetDeviceInstanceIdW", {pointer, pointer, pointer, dword, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiGetDeviceInterfaceAlias", {pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiGetDeviceInterfaceDetailA", {pointer, pointer, pointer, dword, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiGetDeviceInterfaceDetailW", {pointer, pointer, pointer, dword, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiGetDeviceRegistryPropertyA", {pointer, pointer, dword, pointer, pointer, dword, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiGetDeviceRegistryPropertyW", {pointer, pointer, dword, pointer, pointer, dword, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiGetDriverInfoDetailA", {pointer, pointer, pointer, pointer, dword, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiGetDriverInfoDetailW", {pointer, pointer, pointer, pointer, dword, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiGetDriverInstallParamsA", {pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiGetDriverInstallParamsW", {pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiGetHwProfileFriendlyNameA", {dword, pointer, dword, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiGetHwProfileFriendlyNameExA", {dword, pointer, dword, pointer, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiGetHwProfileFriendlyNameExW", {dword, pointer, dword, pointer, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiGetHwProfileFriendlyNameW", {dword, pointer, dword, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiGetHwProfileList", {pointer, dword, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiGetHwProfileListExA", {pointer, dword, pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiGetHwProfileListExW", {pointer, dword, pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiGetINFClassA", {pointer, long_pointer, pointer, dword, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiGetINFClassW", {pointer, long_pointer, pointer, dword, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiGetSelectedDevice", {pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiGetSelectedDriverA", {pointer, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiGetSelectedDriverW", {pointer, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiGetWizardPage", {pointer, pointer, pointer, dword, dword}, pointer}, 
  {0, 0, "setupapi", "SetupDiInstallClassA", {pointer, pointer, dword, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiInstallClassExA", {pointer, pointer, dword, pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiInstallClassExW", {pointer, pointer, dword, pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiInstallClassW", {pointer, pointer, dword, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiInstallDevice", {pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiInstallDeviceInterfaces", {pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiInstallDriverFiles", {pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiLoadClassIcon", {pointer, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiMoveDuplicateDevice", {pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiOpenClassRegKey", {pointer, pointer}, pointer}, 
  {0, 0, "setupapi", "SetupDiOpenClassRegKeyExA", {pointer, pointer, dword, pointer, pointer}, pointer}, 
  {0, 0, "setupapi", "SetupDiOpenClassRegKeyExW", {pointer, pointer, dword, pointer, pointer}, pointer}, 
  {0, 0, "setupapi", "SetupDiOpenDeviceInfoA", {pointer, pointer, pointer, dword, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiOpenDeviceInfoW", {pointer, pointer, pointer, dword, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiOpenDeviceInterfaceA", {pointer, pointer, dword, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiOpenDeviceInterfaceRegKey", {pointer, pointer, dword, pointer}, pointer}, 
  {0, 0, "setupapi", "SetupDiOpenDeviceInterfaceW", {pointer, pointer, dword, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiOpenDevRegKey", {pointer, pointer, dword, dword, dword, pointer}, pointer}, 
  {0, 0, "setupapi", "SetupDiRegisterCoDeviceInstallers", {pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiRegisterDeviceInfo", {pointer, pointer, dword, pointer, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiRemoveDevice", {pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiRemoveDeviceInterface", {pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiSelectBestCompatDrv", {pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiSelectDevice", {pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiSelectOEMDrv", {pointer, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiSetClassInstallParamsA", {pointer, pointer, pointer, dword}, bool}, 
  {0, 0, "setupapi", "SetupDiSetClassInstallParamsW", {pointer, pointer, pointer, dword}, bool}, 
  {0, 0, "setupapi", "SetupDiSetClassRegistryPropertyA", {long_pointer, dword, pointer, dword, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiSetClassRegistryPropertyW", {long_pointer, dword, pointer, dword, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiSetDeviceInstallParamsA", {pointer, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiSetDeviceInstallParamsW", {pointer, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiSetDeviceRegistryPropertyA", {pointer, pointer, dword, pointer, dword}, bool}, 
  {0, 0, "setupapi", "SetupDiSetDeviceRegistryPropertyW", {pointer, pointer, dword, pointer, dword}, bool}, 
  {0, 0, "setupapi", "SetupDiSetDriverInstallParamsA", {pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiSetDriverInstallParamsW", {pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiSetSelectedDevice", {pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiSetSelectedDriverA", {pointer, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiSetSelectedDriverW", {pointer, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDiUnremoveDevice", {pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupDuplicateDiskSpaceListA", {pointer, pointer, dword, uint}, pointer}, 
  {0, 0, "setupapi", "SetupDuplicateDiskSpaceListW", {pointer, pointer, dword, uint}, pointer}, 
  {0, 0, "setupapi", "SetupFindFirstLineA", {pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupFindFirstLineW", {pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupFindNextLine", {pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupFindNextMatchLineA", {pointer, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupFindNextMatchLineW", {pointer, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupFreeSourceListA", {pointer, uint}, bool}, 
  {0, 0, "setupapi", "SetupFreeSourceListW", {pointer, uint}, bool}, 
  {0, 0, "setupapi", "SetupGetBackupInformationA", {pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupGetBackupInformationW", {pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupGetBinaryField", {pointer, dword, pointer, dword, pointer}, bool}, 
  {0, 0, "setupapi", "SetupGetFieldCount", {pointer}, dword}, 
  {0, 0, "setupapi", "SetupGetFileCompressionInfoA", {pointer, pointer, pointer, pointer, pointer}, dword}, 
  {0, 0, "setupapi", "SetupGetFileCompressionInfoW", {pointer, pointer, pointer, pointer, pointer}, dword}, 
  {0, 0, "setupapi", "SetupGetInfFileListA", {pointer, dword, pointer, dword, pointer}, bool}, 
  {0, 0, "setupapi", "SetupGetInfFileListW", {pointer, dword, pointer, dword, pointer}, bool}, 
  {0, 0, "setupapi", "SetupGetInfInformationA", {pointer, dword, pointer, dword, pointer}, bool}, 
  {0, 0, "setupapi", "SetupGetInfInformationW", {pointer, dword, pointer, dword, pointer}, bool}, 
  {0, 0, "setupapi", "SetupGetIntField", {pointer, dword, pointer}, bool}, 
  {0, 0, "setupapi", "SetupGetLineByIndexA", {pointer, pointer, dword, pointer}, bool}, 
  {0, 0, "setupapi", "SetupGetLineByIndexW", {pointer, pointer, dword, pointer}, bool}, 
  {0, 0, "setupapi", "SetupGetLineCountA", {pointer, pointer}, long}, 
  {0, 0, "setupapi", "SetupGetLineCountW", {pointer, pointer}, long}, 
  {0, 0, "setupapi", "SetupGetLineTextA", {pointer, pointer, pointer, pointer, pointer, dword, pointer}, bool}, 
  {0, 0, "setupapi", "SetupGetLineTextW", {pointer, pointer, pointer, pointer, pointer, dword, pointer}, bool}, 
  {0, 0, "setupapi", "SetupGetMultiSzFieldA", {pointer, dword, pointer, dword, pointer}, bool}, 
  {0, 0, "setupapi", "SetupGetMultiSzFieldW", {pointer, dword, pointer, dword, pointer}, bool}, 
  {0, 0, "setupapi", "SetupGetSourceFileLocationA", {pointer, pointer, pointer, pointer, pointer, dword, pointer}, bool}, 
  {0, 0, "setupapi", "SetupGetSourceFileLocationW", {pointer, pointer, pointer, pointer, pointer, dword, pointer}, bool}, 
  {0, 0, "setupapi", "SetupGetSourceFileSizeA", {pointer, pointer, pointer, pointer, pointer, uint}, bool}, 
  {0, 0, "setupapi", "SetupGetSourceFileSizeW", {pointer, pointer, pointer, pointer, pointer, uint}, bool}, 
  {0, 0, "setupapi", "SetupGetSourceInfoA", {pointer, uint, uint, pointer, dword, pointer}, bool}, 
  {0, 0, "setupapi", "SetupGetSourceInfoW", {pointer, uint, uint, pointer, dword, pointer}, bool}, 
  {0, 0, "setupapi", "SetupGetStringFieldA", {pointer, dword, pointer, dword, pointer}, bool}, 
  {0, 0, "setupapi", "SetupGetStringFieldW", {pointer, dword, pointer, dword, pointer}, bool}, 
  {0, 0, "setupapi", "SetupGetTargetPathA", {pointer, pointer, pointer, pointer, dword, pointer}, bool}, 
  {0, 0, "setupapi", "SetupGetTargetPathW", {pointer, pointer, pointer, pointer, dword, pointer}, bool}, 
  {0, 0, "setupapi", "SetupInitDefaultQueueCallback", {pointer}, pointer}, 
  {0, 0, "setupapi", "SetupInitDefaultQueueCallbackEx", {pointer, pointer, uint, dword, pointer}, pointer}, 
  {0, 0, "setupapi", "SetupInitializeFileLogA", {pointer, dword}, pointer}, 
  {0, 0, "setupapi", "SetupInitializeFileLogW", {pointer, dword}, pointer}, 
  {0, 0, "setupapi", "SetupInstallFileA", {pointer, pointer, pointer, pointer, pointer, dword, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupInstallFileExA", {pointer, pointer, pointer, pointer, pointer, dword, pointer, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupInstallFileExW", {pointer, pointer, pointer, pointer, pointer, dword, pointer, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupInstallFilesFromInfSectionA", {pointer, pointer, pointer, pointer, pointer, uint}, bool}, 
  {0, 0, "setupapi", "SetupInstallFilesFromInfSectionW", {pointer, pointer, pointer, pointer, pointer, uint}, bool}, 
  {0, 0, "setupapi", "SetupInstallFileW", {pointer, pointer, pointer, pointer, pointer, dword, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupInstallFromInfSectionA", {pointer, pointer, pointer, uint, pointer, pointer, uint, pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupInstallFromInfSectionW", {pointer, pointer, pointer, uint, pointer, pointer, uint, pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupInstallServicesFromInfSectionA", {pointer, pointer, dword}, bool}, 
  {0, 0, "setupapi", "SetupInstallServicesFromInfSectionExA", {pointer, pointer, dword, pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupInstallServicesFromInfSectionExW", {pointer, pointer, dword, pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupInstallServicesFromInfSectionW", {pointer, pointer, dword}, bool}, 
  {0, 0, "setupapi", "SetupIterateCabinetA", {pointer, dword, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupIterateCabinetW", {pointer, dword, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupLogErrorA", {pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupLogErrorW", {pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupLogFileA", {pointer, pointer, pointer, pointer, dword, pointer, pointer, pointer, dword}, bool}, 
  {0, 0, "setupapi", "SetupLogFileW", {pointer, pointer, pointer, pointer, dword, pointer, pointer, pointer, dword}, bool}, 
  {0, 0, "setupapi", "SetupOpenAppendInfFileA", {pointer, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupOpenAppendInfFileW", {pointer, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupOpenFileQueue", {}, pointer}, 
  {0, 0, "setupapi", "SetupOpenInfFileA", {pointer, pointer, dword, pointer}, pointer}, 
  {0, 0, "setupapi", "SetupOpenInfFileW", {pointer, pointer, dword, pointer}, pointer}, 
  {0, 0, "setupapi", "SetupOpenLog", {bool}, bool}, 
  {0, 0, "setupapi", "SetupOpenMasterInf", {}, pointer}, 
  {0, 0, "setupapi", "SetupPromptForDiskA", {pointer, pointer, pointer, pointer, pointer, pointer, dword, pointer, dword, pointer}, uint}, 
  {0, 0, "setupapi", "SetupPromptForDiskW", {pointer, pointer, pointer, pointer, pointer, pointer, dword, pointer, dword, pointer}, uint}, 
  {0, 0, "setupapi", "SetupPromptReboot", {pointer, pointer, bool}, int}, 
  {0, 0, "setupapi", "SetupQueryDrivesInDiskSpaceListA", {pointer, pointer, dword, pointer}, bool}, 
  {0, 0, "setupapi", "SetupQueryDrivesInDiskSpaceListW", {pointer, pointer, dword, pointer}, bool}, 
  {0, 0, "setupapi", "SetupQueryFileLogA", {pointer, pointer, pointer, pointer, pointer, dword, pointer}, bool}, 
  {0, 0, "setupapi", "SetupQueryFileLogW", {pointer, pointer, pointer, pointer, pointer, dword, pointer}, bool}, 
  {0, 0, "setupapi", "SetupQueryInfFileInformationA", {pointer, uint, pointer, dword, pointer}, bool}, 
  {0, 0, "setupapi", "SetupQueryInfFileInformationW", {pointer, uint, pointer, dword, pointer}, bool}, 
  {0, 0, "setupapi", "SetupQueryInfOriginalFileInformationA", {pointer, uint, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupQueryInfOriginalFileInformationW", {pointer, uint, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupQueryInfVersionInformationA", {pointer, uint, pointer, pointer, dword, pointer}, bool}, 
  {0, 0, "setupapi", "SetupQueryInfVersionInformationW", {pointer, uint, pointer, pointer, dword, pointer}, bool}, 
  {0, 0, "setupapi", "SetupQuerySourceListA", {dword, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupQuerySourceListW", {dword, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupQuerySpaceRequiredOnDriveA", {pointer, pointer, pointer, pointer, uint}, bool}, 
  {0, 0, "setupapi", "SetupQuerySpaceRequiredOnDriveW", {pointer, pointer, pointer, pointer, uint}, bool}, 
  {0, 0, "setupapi", "SetupQueueCopyA", {pointer, pointer, pointer, pointer, pointer, pointer, pointer, pointer, dword}, bool}, 
  {0, 0, "setupapi", "SetupQueueCopyIndirectA", {pointer}, bool}, 
  {0, 0, "setupapi", "SetupQueueCopyIndirectW", {pointer}, bool}, 
  {0, 0, "setupapi", "SetupQueueCopySectionA", {pointer, pointer, pointer, pointer, pointer, dword}, bool}, 
  {0, 0, "setupapi", "SetupQueueCopySectionW", {pointer, pointer, pointer, pointer, pointer, dword}, bool}, 
  {0, 0, "setupapi", "SetupQueueCopyW", {pointer, pointer, pointer, pointer, pointer, pointer, pointer, pointer, dword}, bool}, 
  {0, 0, "setupapi", "SetupQueueDefaultCopyA", {pointer, pointer, pointer, pointer, pointer, dword}, bool}, 
  {0, 0, "setupapi", "SetupQueueDefaultCopyW", {pointer, pointer, pointer, pointer, pointer, dword}, bool}, 
  {0, 0, "setupapi", "SetupQueueDeleteA", {pointer, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupQueueDeleteSectionA", {pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupQueueDeleteSectionW", {pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupQueueDeleteW", {pointer, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupQueueRenameA", {pointer, pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupQueueRenameSectionA", {pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupQueueRenameSectionW", {pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupQueueRenameW", {pointer, pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupRemoveFileLogEntryA", {pointer, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupRemoveFileLogEntryW", {pointer, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupRemoveFromDiskSpaceListA", {pointer, pointer, uint, pointer, uint}, bool}, 
  {0, 0, "setupapi", "SetupRemoveFromDiskSpaceListW", {pointer, pointer, uint, pointer, uint}, bool}, 
  {0, 0, "setupapi", "SetupRemoveFromSourceListA", {dword, pointer}, bool}, 
  {0, 0, "setupapi", "SetupRemoveFromSourceListW", {dword, pointer}, bool}, 
  {0, 0, "setupapi", "SetupRemoveInstallSectionFromDiskSpaceListA", {pointer, pointer, pointer, pointer, pointer, uint}, bool}, 
  {0, 0, "setupapi", "SetupRemoveInstallSectionFromDiskSpaceListW", {pointer, pointer, pointer, pointer, pointer, uint}, bool}, 
  {0, 0, "setupapi", "SetupRemoveSectionFromDiskSpaceListA", {pointer, pointer, pointer, pointer, uint, pointer, uint}, bool}, 
  {0, 0, "setupapi", "SetupRemoveSectionFromDiskSpaceListW", {pointer, pointer, pointer, pointer, uint, pointer, uint}, bool}, 
  {0, 0, "setupapi", "SetupRenameErrorA", {pointer, pointer, pointer, pointer, uint, dword}, uint}, 
  {0, 0, "setupapi", "SetupRenameErrorW", {pointer, pointer, pointer, pointer, uint, dword}, uint}, 
  {0, 0, "setupapi", "SetupScanFileQueueA", {pointer, dword, pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupScanFileQueueW", {pointer, dword, pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupSetDirectoryIdA", {pointer, dword, pointer}, bool}, 
  {0, 0, "setupapi", "SetupSetDirectoryIdExA", {pointer, dword, pointer, dword, dword, pointer}, bool}, 
  {0, 0, "setupapi", "SetupSetDirectoryIdExW", {pointer, dword, pointer, dword, dword, pointer}, bool}, 
  {0, 0, "setupapi", "SetupSetDirectoryIdW", {pointer, dword, pointer}, bool}, 
  {0, 0, "setupapi", "SetupSetFileQueueAlternatePlatformA", {pointer, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupSetFileQueueAlternatePlatformW", {pointer, pointer, pointer}, bool}, 
  {0, 0, "setupapi", "SetupSetPlatformPathOverrideA", {pointer}, bool}, 
  {0, 0, "setupapi", "SetupSetPlatformPathOverrideW", {pointer}, bool}, 
  {0, 0, "setupapi", "SetupSetSourceListA", {dword, pointer, uint}, bool}, 
  {0, 0, "setupapi", "SetupSetSourceListW", {dword, pointer, uint}, bool}, 
  {0, 0, "setupapi", "SetupTermDefaultQueueCallback", {pointer}}, 
  {0, 0, "setupapi", "SetupTerminateFileLog", {pointer}, bool}, 
  {0, 0, "shell32" , "CommandLineToArgvW", {pointer, pointer}, pointer}, 
  {0, 0, "shell32" , "DragAcceptFiles", {pointer, bool}}, 
  {0, 0, "shell32" , "DragFinish", {pointer}}, 
  {0, 0, "shell32" , "DragQueryFileA", {pointer, uint, pointer, uint}, uint}, 
  {0, 0, "shell32" , "DragQueryFileW", {pointer, uint, pointer, uint}, uint}, 
  {0, 0, "shell32" , "DragQueryPoint", {pointer, long_pointer}, bool}, 
  {0, 0, "shell32" , "DuplicateIcon", {pointer, pointer}, pointer}, 
  {0, 0, "shell32" , "ExtractAssociatedIconA", {pointer, pointer, pointer}, pointer}, 
  {0, 0, "shell32" , "ExtractAssociatedIconW", {pointer, pointer, pointer}, pointer}, 
  {0, 0, "shell32" , "ExtractIconA", {pointer, pointer, uint}, pointer}, 
  {0, 0, "shell32" , "ExtractIconExA", {pointer, int, pointer, pointer, uint}, uint}, 
  {0, 0, "shell32" , "ExtractIconExW", {pointer, int, pointer, pointer, uint}, uint}, 
  {0, 0, "shell32" , "ExtractIconW", {pointer, pointer, uint}, pointer}, 
  {0, 0, "shell32" , "FindExecutableA", {pointer, pointer, pointer}, pointer}, 
  {0, 0, "shell32" , "FindExecutableW", {pointer, pointer, pointer}, pointer}, 
  {0, 0, "shell32" , "ILAppendID", {long_pointer, long_pointer, bool}, long_pointer}, 
  {0, 0, "shell32" , "ILClone", {long_pointer}, long_pointer}, 
  {0, 0, "shell32" , "ILCloneFirst", {long_pointer}, long_pointer}, 
  {0, 0, "shell32" , "ILCombine", {long_pointer, long_pointer}, long_pointer}, 
  {0, 0, "shell32" , "ILFindChild", {long_pointer, long_pointer}, long_pointer}, 
  {0, 0, "shell32" , "ILFindLastID", {long_pointer}, long_pointer}, 
  {0, 0, "shell32" , "ILFree", {long_pointer}}, 
  {0, 0, "shell32" , "ILGetNext", {long_pointer}, long_pointer}, 
  {0, 0, "shell32" , "ILGetSize", {long_pointer}, uint}, 
  {0, 0, "shell32" , "ILIsEqual", {long_pointer, long_pointer}, bool}, 
  {0, 0, "shell32" , "ILIsParent", {long_pointer, long_pointer, bool}, bool}, 
  {0, 0, "shell32" , "ILLoadFromStream", {pointer, pointer}, long}, 
  {0, 0, "shell32" , "ILRemoveLastID", {long_pointer}, bool}, 
  {0, 0, "shell32" , "ILSaveToStream", {pointer, long_pointer}, long}, 
  {0, 0, "shell32" , "PathResolve", {pointer, pointer, uint}, bool}, 
  {0, 0, "shell32" , "SHAddToRecentDocs", {uint, pointer}}, 
  {0, 0, "shell32" , "SHAppBarMessage", {dword, pointer}, uint}, 
  {0, 0, "shell32" , "SHBindToParent", {long_pointer, pointer, pointer, pointer}, long}, 
  {0, 0, "shell32" , "SHBrowseForFolder", {pointer}, pointer}, 
  {0, 0, "shell32" , "SHBrowseForFolderA", {pointer}, long_pointer}, 
  {0, 0, "shell32" , "SHBrowseForFolderW", {pointer}, long_pointer}, 
  {0, 0, "shell32" , "SHChangeNotify", {long, uint, pointer, pointer}}, 
  {0, 0, "shell32" , "SHCoCreateInstance", {pointer, pointer, pointer, pointer, pointer}, long}, 
  {0, 0, "shell32" , "SHCreateDirectoryExA", {pointer, pointer, long_pointer}, int}, 
  {0, 0, "shell32" , "SHCreateDirectoryExW", {pointer, pointer, long_pointer}, int}, 
  {0, 0, "shell32" , "Shell_NotifyIconA", {dword, pointer}, bool}, 
  {0, 0, "shell32" , "Shell_NotifyIconW", {dword, pointer}, bool}, 
  {0, 0, "shell32" , "ShellAboutA", {pointer, pointer, pointer, pointer}, int}, 
  {0, 0, "shell32" , "ShellAboutW", {pointer, pointer, pointer, pointer}, int}, 
  {0, 0, "shell32" , "ShellExecuteA", {pointer, pointer, pointer, pointer, pointer, int}, pointer}, 
  {0, 0, "shell32" , "ShellExecuteExA", {long_pointer}, bool}, 
  {0, 0, "shell32" , "ShellExecuteExW", {long_pointer}, bool}, 
  {0, 0, "shell32" , "ShellExecuteW", {pointer, pointer, pointer, pointer, pointer, int}, pointer}, 
  {0, 0, "shell32" , "SHEmptyRecycleBinA", {pointer, pointer, dword}, long}, 
  {0, 0, "shell32" , "SHEmptyRecycleBinW", {pointer, pointer, dword}, long}, 
  {0, 0, "shell32" , "SHFileOperationA", {long_pointer}, int}, 
  {0, 0, "shell32" , "SHFileOperationW", {long_pointer}, int}, 
  {0, 0, "shell32" , "SHFormatDrive", {pointer, uint, uint, uint}, dword}, 
  {0, 0, "shell32" , "SHFreeNameMappings", {pointer}}, 
  {0, 0, "shell32" , "SHGetDataFromIDListA", {long_pointer, long_pointer, int, pointer, int}, long}, 
  {0, 0, "shell32" , "SHGetDataFromIDListW", {long_pointer, long_pointer, int, pointer, int}, long}, 
  {0, 0, "shell32" , "SHGetDesktopFolder", {pointer}, long}, 
  {0, 0, "shell32" , "SHGetFileInfoA", {pointer, dword, pointer, uint, uint}, dword}, 
  {0, 0, "shell32" , "SHGetFileInfoW", {pointer, dword, pointer, uint, uint}, dword}, 
  {0, 0, "shell32" , "SHGetFolderLocation", {pointer, int, pointer, dword, pointer}, long}, 
  {0, 0, "shell32" , "SHGetFolderPathA", {pointer, int, pointer, dword, pointer}, long}, 
  {0, 0, "shell32" , "SHGetFolderPathAndSubDirA", {pointer, int, pointer, dword, pointer, pointer}, long}, 
  {0, 0, "shell32" , "SHGetFolderPathAndSubDirW", {pointer, int, pointer, dword, pointer, pointer}, long}, 
  {0, 0, "shell32" , "SHGetFolderPathW", {pointer, int, pointer, dword, pointer}, long}, 
  {0, 0, "shell32" , "SHGetIconOverlayIndexA", {pointer, int}, int}, 
  {0, 0, "shell32" , "SHGetIconOverlayIndexW", {pointer, int}, int}, 
  {0, 0, "shell32" , "SHGetImageList", {int, pointer, pointer}, long}, 
  {0, 0, "shell32" , "SHGetInstanceExplorer", {pointer}, long}, 
  {0, 0, "shell32" , "SHGetMalloc", {pointer}, long}, 
  {0, 0, "shell32" , "SHGetPathFromIDList", {ulong, pointer}, ulong}, 
  {0, 0, "shell32" , "SHGetPathFromIDListA", {long_pointer, pointer}, bool}, 
  {0, 0, "shell32" , "SHGetPathFromIDListW", {long_pointer, pointer}, bool}, 
  {0, 0, "shell32" , "SHGetSetSettings", {long_pointer, dword, bool}}, 
  {0, 0, "shell32" , "SHGetSettings", {long_pointer, dword}}, 
  {0, 0, "shell32" , "SHGetSpecialFolderLocation", {pointer, int, pointer}, long}, 
  {0, 0, "shell32" , "SHGetSpecialFolderPathA", {pointer, pointer, int, bool}, bool}, 
  {0, 0, "shell32" , "SHGetSpecialFolderPathW", {pointer, pointer, int, bool}, bool}, 
  {0, 0, "shell32" , "SHLoadInProc", {pointer}, long}, 
  {0, 0, "shell32" , "SHParseDisplayName", {pointer, pointer, long_pointer, ulong, pointer}, long}, 
  {0, 0, "shell32" , "SHQueryRecycleBinA", {pointer, long_pointer}, long}, 
  {0, 0, "shell32" , "SHQueryRecycleBinW", {pointer, long_pointer}, long}, 
  {0, 0, "shlwapi" , "AssocCreate", {pointer, pointer, pointer}, long}, 
  {0, 0, "shlwapi" , "AssocQueryKeyA", {pointer, pointer, pointer, pointer, pointer}, long}, 
  {0, 0, "shlwapi" , "AssocQueryKeyW", {pointer, pointer, pointer, pointer, pointer}, long}, 
  {0, 0, "shlwapi" , "AssocQueryStringA", {pointer, pointer, pointer, pointer, pointer, pointer}, long}, 
  {0, 0, "shlwapi" , "AssocQueryStringByKeyA", {pointer, pointer, pointer, pointer, pointer, pointer}, long}, 
  {0, 0, "shlwapi" , "AssocQueryStringByKeyW", {pointer, pointer, pointer, pointer, pointer, pointer}, long}, 
  {0, 0, "shlwapi" , "AssocQueryStringW", {pointer, pointer, pointer, pointer, pointer, pointer}, long}, 
  {0, 0, "shlwapi" , "ChrCmpIA", {word, word}, bool}, 
  {0, 0, "shlwapi" , "ChrCmpIW", {wchar, wchar}, bool}, 
  {0, 0, "shlwapi" , "ColorAdjustLuma", {dword, int, bool}, dword}, 
  {0, 0, "shlwapi" , "ColorHLSToRGB", {word, word, word}, dword}, 
  {0, 0, "shlwapi" , "ColorRGBToHLS", {dword, pointer, pointer, pointer}}, 
  {0, 0, "shlwapi" , "DllInstall", {bool, pointer}, long}, 
  {0, 0, "shlwapi" , "HashData", {pointer, dword, pointer, dword}, long}, 
  {0, 0, "shlwapi" , "IntlStrEqWorkerA", {bool, pointer, pointer, int}, bool}, 
  {0, 0, "shlwapi" , "IntlStrEqWorkerW", {bool, pointer, pointer, int}, bool}, 
  {0, 0, "shlwapi" , "MLLoadLibraryA", {pointer, pointer, dword, pointer, bool}, pointer}, 
  {0, 0, "shlwapi" , "MLLoadLibraryW", {pointer, pointer, dword, pointer, bool}, pointer}, 
  {0, 0, "shlwapi" , "PathAddBackslashA", {pointer}, pointer}, 
  {0, 0, "shlwapi" , "PathAddBackslashW", {pointer}, pointer}, 
  {0, 0, "shlwapi" , "PathAddExtensionA", {pointer, pointer}, bool}, 
  {0, 0, "shlwapi" , "PathAddExtensionW", {pointer, pointer}, bool}, 
  {0, 0, "shlwapi" , "PathAppendA", {pointer, pointer}, bool}, 
  {0, 0, "shlwapi" , "PathAppendW", {pointer, pointer}, bool}, 
  {0, 0, "shlwapi" , "PathBuildRootA", {pointer, int}, pointer}, 
  {0, 0, "shlwapi" , "PathBuildRootW", {pointer, int}, pointer}, 
  {0, 0, "shlwapi" , "PathCanonicalizeA", {pointer, pointer}, bool}, 
  {0, 0, "shlwapi" , "PathCanonicalizeW", {pointer, pointer}, bool}, 
  {0, 0, "shlwapi" , "PathCombineA", {pointer, pointer, pointer}, pointer}, 
  {0, 0, "shlwapi" , "PathCombineW", {pointer, pointer, pointer}, pointer}, 
  {0, 0, "shlwapi" , "PathCommonPrefixA", {pointer, pointer, pointer}, int}, 
  {0, 0, "shlwapi" , "PathCommonPrefixW", {pointer, pointer, pointer}, int}, 
  {0, 0, "shlwapi" , "PathCompactPathA", {pointer, pointer, uint}, bool}, 
  {0, 0, "shlwapi" , "PathCompactPathExA", {pointer, pointer, uint, dword}, bool}, 
  {0, 0, "shlwapi" , "PathCompactPathExW", {pointer, pointer, uint, dword}, bool}, 
  {0, 0, "shlwapi" , "PathCompactPathW", {pointer, pointer, uint}, bool}, 
  {0, 0, "shlwapi" , "PathCreateFromUrlA", {pointer, pointer, pointer, dword}, long}, 
  {0, 0, "shlwapi" , "PathCreateFromUrlW", {pointer, pointer, pointer, dword}, long}, 
  {0, 0, "shlwapi" , "PathFileExistsA", {pointer}, bool}, 
  {0, 0, "shlwapi" , "PathFileExistsW", {pointer}, bool}, 
  {0, 0, "shlwapi" , "PathFindExtensionA", {pointer}, pointer}, 
  {0, 0, "shlwapi" , "PathFindExtensionW", {pointer}, pointer}, 
  {0, 0, "shlwapi" , "PathFindFileNameA", {pointer}, pointer}, 
  {0, 0, "shlwapi" , "PathFindFileNameW", {pointer}, pointer}, 
  {0, 0, "shlwapi" , "PathFindNextComponentA", {pointer}, pointer}, 
  {0, 0, "shlwapi" , "PathFindNextComponentW", {pointer}, pointer}, 
  {0, 0, "shlwapi" , "PathFindOnPathA", {pointer, pointer}, bool}, 
  {0, 0, "shlwapi" , "PathFindOnPathW", {pointer, pointer}, bool}, 
  {0, 0, "shlwapi" , "PathFindSuffixArrayA", {pointer, pointer, int}, pointer}, 
  {0, 0, "shlwapi" , "PathFindSuffixArrayW", {pointer, pointer, int}, pointer}, 
  {0, 0, "shlwapi" , "PathGetArgsA", {pointer}, pointer}, 
  {0, 0, "shlwapi" , "PathGetArgsW", {pointer}, pointer}, 
  {0, 0, "shlwapi" , "PathGetCharTypeA", {uchar}, uint}, 
  {0, 0, "shlwapi" , "PathGetCharTypeW", {wchar}, uint}, 
  {0, 0, "shlwapi" , "PathGetDriveNumberA", {pointer}, int}, 
  {0, 0, "shlwapi" , "PathGetDriveNumberW", {pointer}, int}, 
  {0, 0, "shlwapi" , "PathIsContentTypeA", {pointer, pointer}, bool}, 
  {0, 0, "shlwapi" , "PathIsContentTypeW", {pointer, pointer}, bool}, 
  {0, 0, "shlwapi" , "PathIsDirectoryA", {pointer}, bool}, 
  {0, 0, "shlwapi" , "PathIsDirectoryEmptyA", {pointer}, bool}, 
  {0, 0, "shlwapi" , "PathIsDirectoryEmptyW", {pointer}, bool}, 
  {0, 0, "shlwapi" , "PathIsDirectoryW", {pointer}, bool}, 
  {0, 0, "shlwapi" , "PathIsFileSpecA", {pointer}, bool}, 
  {0, 0, "shlwapi" , "PathIsFileSpecW", {pointer}, bool}, 
  {0, 0, "shlwapi" , "PathIsLFNFileSpecA", {pointer}, bool}, 
  {0, 0, "shlwapi" , "PathIsLFNFileSpecW", {pointer}, bool}, 
  {0, 0, "shlwapi" , "PathIsNetworkPathA", {pointer}, bool}, 
  {0, 0, "shlwapi" , "PathIsNetworkPathW", {pointer}, bool}, 
  {0, 0, "shlwapi" , "PathIsPrefixA", {pointer, pointer}, bool}, 
  {0, 0, "shlwapi" , "PathIsPrefixW", {pointer, pointer}, bool}, 
  {0, 0, "shlwapi" , "PathIsRelativeA", {pointer}, bool}, 
  {0, 0, "shlwapi" , "PathIsRelativeW", {pointer}, bool}, 
  {0, 0, "shlwapi" , "PathIsRootA", {pointer}, bool}, 
  {0, 0, "shlwapi" , "PathIsRootW", {pointer}, bool}, 
  {0, 0, "shlwapi" , "PathIsSameRootA", {pointer, pointer}, bool}, 
  {0, 0, "shlwapi" , "PathIsSameRootW", {pointer, pointer}, bool}, 
  {0, 0, "shlwapi" , "PathIsSystemFolderA", {pointer, dword}, bool}, 
  {0, 0, "shlwapi" , "PathIsSystemFolderW", {pointer, dword}, bool}, 
  {0, 0, "shlwapi" , "PathIsUNCA", {pointer}, bool}, 
  {0, 0, "shlwapi" , "PathIsUNCServerA", {pointer}, bool}, 
  {0, 0, "shlwapi" , "PathIsUNCServerShareA", {pointer}, bool}, 
  {0, 0, "shlwapi" , "PathIsUNCServerShareW", {pointer}, bool}, 
  {0, 0, "shlwapi" , "PathIsUNCServerW", {pointer}, bool}, 
  {0, 0, "shlwapi" , "PathIsUNCW", {pointer}, bool}, 
  {0, 0, "shlwapi" , "PathIsURLA", {pointer}, bool}, 
  {0, 0, "shlwapi" , "PathIsURLW", {pointer}, bool}, 
  {0, 0, "shlwapi" , "PathMakePrettyA", {pointer}, bool}, 
  {0, 0, "shlwapi" , "PathMakePrettyW", {pointer}, bool}, 
  {0, 0, "shlwapi" , "PathMakeSystemFolderA", {pointer}, bool}, 
  {0, 0, "shlwapi" , "PathMakeSystemFolderW", {pointer}, bool}, 
  {0, 0, "shlwapi" , "PathMatchSpecA", {pointer, pointer}, bool}, 
  {0, 0, "shlwapi" , "PathMatchSpecW", {pointer, pointer}, bool}, 
  {0, 0, "shlwapi" , "PathParseIconLocationA", {pointer}, int}, 
  {0, 0, "shlwapi" , "PathParseIconLocationW", {pointer}, int}, 
  {0, 0, "shlwapi" , "PathQuoteSpacesA", {pointer}}, 
  {0, 0, "shlwapi" , "PathQuoteSpacesW", {pointer}}, 
  {0, 0, "shlwapi" , "PathRelativePathToA", {pointer, pointer, dword, pointer, dword}, bool}, 
  {0, 0, "shlwapi" , "PathRelativePathToW", {pointer, pointer, dword, pointer, dword}, bool}, 
  {0, 0, "shlwapi" , "PathRemoveArgsA", {pointer}}, 
  {0, 0, "shlwapi" , "PathRemoveArgsW", {pointer}}, 
  {0, 0, "shlwapi" , "PathRemoveBackslashA", {pointer}, pointer}, 
  {0, 0, "shlwapi" , "PathRemoveBackslashW", {pointer}, pointer}, 
  {0, 0, "shlwapi" , "PathRemoveBlanksA", {pointer}}, 
  {0, 0, "shlwapi" , "PathRemoveBlanksW", {pointer}}, 
  {0, 0, "shlwapi" , "PathRemoveExtensionA", {pointer}}, 
  {0, 0, "shlwapi" , "PathRemoveExtensionW", {pointer}}, 
  {0, 0, "shlwapi" , "PathRemoveFileSpecA", {pointer}, bool}, 
  {0, 0, "shlwapi" , "PathRemoveFileSpecW", {pointer}, bool}, 
  {0, 0, "shlwapi" , "PathRenameExtensionA", {pointer, pointer}, bool}, 
  {0, 0, "shlwapi" , "PathRenameExtensionW", {pointer, pointer}, bool}, 
  {0, 0, "shlwapi" , "PathSearchAndQualifyA", {pointer, pointer, uint}, bool}, 
  {0, 0, "shlwapi" , "PathSearchAndQualifyW", {pointer, pointer, uint}, bool}, 
  {0, 0, "shlwapi" , "PathSetDlgItemPathA", {pointer, int, pointer}}, 
  {0, 0, "shlwapi" , "PathSetDlgItemPathW", {pointer, int, pointer}}, 
  {0, 0, "shlwapi" , "PathSkipRootA", {pointer}, pointer}, 
  {0, 0, "shlwapi" , "PathSkipRootW", {pointer}, pointer}, 
  {0, 0, "shlwapi" , "PathStripPathA", {pointer}}, 
  {0, 0, "shlwapi" , "PathStripPathW", {pointer}}, 
  {0, 0, "shlwapi" , "PathStripToRootA", {pointer}, bool}, 
  {0, 0, "shlwapi" , "PathStripToRootW", {pointer}, bool}, 
  {0, 0, "shlwapi" , "PathUndecorateA", {pointer}}, 
  {0, 0, "shlwapi" , "PathUndecorateW", {pointer}}, 
  {0, 0, "shlwapi" , "PathUnExpandEnvStringsA", {pointer, pointer, uint}, bool}, 
  {0, 0, "shlwapi" , "PathUnExpandEnvStringsW", {pointer, pointer, uint}, bool}, 
  {0, 0, "shlwapi" , "PathUnmakeSystemFolderA", {pointer}, bool}, 
  {0, 0, "shlwapi" , "PathUnmakeSystemFolderW", {pointer}, bool}, 
  {0, 0, "shlwapi" , "PathUnquoteSpacesA", {pointer}}, 
  {0, 0, "shlwapi" , "PathUnquoteSpacesW", {pointer}}, 
  {0, 0, "shlwapi" , "SHAutoComplete", {pointer, dword}, long}, 
  {0, 0, "shlwapi" , "SHCopyKeyA", {pointer, pointer, pointer, dword}, dword}, 
  {0, 0, "shlwapi" , "SHCopyKeyW", {pointer, pointer, pointer, dword}, dword}, 
  {0, 0, "shlwapi" , "SHCreateShellPalette", {pointer}, pointer}, 
  {0, 0, "shlwapi" , "SHCreateStreamOnFileA", {pointer, dword, pointer}, long}, 
  {0, 0, "shlwapi" , "SHCreateStreamOnFileW", {pointer, dword, pointer}, long}, 
  {0, 0, "shlwapi" , "SHCreateThread", {long_pointer, pointer, dword, long_pointer}, bool}, 
  {0, 0, "shlwapi" , "SHDeleteEmptyKeyA", {pointer, pointer}, dword}, 
  {0, 0, "shlwapi" , "SHDeleteEmptyKeyW", {pointer, pointer}, dword}, 
  {0, 0, "shlwapi" , "SHDeleteKeyA", {pointer, pointer}, dword}, 
  {0, 0, "shlwapi" , "SHDeleteKeyW", {pointer, pointer}, dword}, 
  {0, 0, "shlwapi" , "SHDeleteValueA", {pointer, pointer, pointer}, dword}, 
  {0, 0, "shlwapi" , "SHDeleteValueW", {pointer, pointer, pointer}, dword}, 
  {0, 0, "shlwapi" , "SHEnumKeyExA", {pointer, dword, pointer, pointer}, dword}, 
  {0, 0, "shlwapi" , "SHEnumKeyExW", {pointer, dword, pointer, pointer}, dword}, 
  {0, 0, "shlwapi" , "SHEnumValueA", {pointer, dword, pointer, pointer, pointer, long_pointer, pointer}, dword}, 
  {0, 0, "shlwapi" , "SHEnumValueW", {pointer, dword, pointer, pointer, pointer, long_pointer, pointer}, dword}, 
  {0, 0, "shlwapi" , "SHGetThreadRef", {pointer}, long}, 
  {0, 0, "shlwapi" , "SHGetValueA", {pointer, pointer, pointer, pointer, long_pointer, pointer}, dword}, 
  {0, 0, "shlwapi" , "SHGetValueW", {pointer, pointer, pointer, pointer, long_pointer, pointer}, dword}, 
  {0, 0, "shlwapi" , "SHOpenRegStream2A", {pointer, pointer, pointer, dword}, pointer}, 
  {0, 0, "shlwapi" , "SHOpenRegStream2W", {pointer, pointer, pointer, dword}, pointer}, 
  {0, 0, "shlwapi" , "SHOpenRegStreamA", {pointer, pointer, pointer, dword}, pointer}, 
  {0, 0, "shlwapi" , "SHOpenRegStreamW", {pointer, pointer, pointer, dword}, pointer}, 
  {0, 0, "shlwapi" , "SHQueryInfoKeyA", {pointer, pointer, pointer, pointer, pointer}, dword}, 
  {0, 0, "shlwapi" , "SHQueryInfoKeyW", {pointer, pointer, pointer, pointer, pointer}, dword}, 
  {0, 0, "shlwapi" , "SHQueryValueExA", {pointer, pointer, pointer, pointer, long_pointer, pointer}, dword}, 
  {0, 0, "shlwapi" , "SHQueryValueExW", {pointer, pointer, pointer, pointer, long_pointer, pointer}, dword}, 
  {0, 0, "shlwapi" , "SHRegCloseUSKey", {pointer}, dword}, 
  {0, 0, "shlwapi" , "SHRegCreateUSKeyA", {pointer, pointer, pointer, pointer, dword}, long}, 
  {0, 0, "shlwapi" , "SHRegCreateUSKeyW", {pointer, pointer, pointer, pointer, dword}, long}, 
  {0, 0, "shlwapi" , "SHRegDeleteEmptyUSKeyA", {pointer, pointer, pointer}, long}, 
  {0, 0, "shlwapi" , "SHRegDeleteEmptyUSKeyW", {pointer, pointer, pointer}, long}, 
  {0, 0, "shlwapi" , "SHRegDeleteUSValueA", {pointer, pointer, pointer}, long}, 
  {0, 0, "shlwapi" , "SHRegDeleteUSValueW", {pointer, pointer, pointer}, long}, 
  {0, 0, "shlwapi" , "SHRegDuplicateHKey", {pointer}, pointer}, 
  {0, 0, "shlwapi" , "SHRegEnumUSKeyA", {pointer, dword, pointer, pointer, pointer}, dword}, 
  {0, 0, "shlwapi" , "SHRegEnumUSKeyW", {pointer, dword, pointer, pointer, pointer}, dword}, 
  {0, 0, "shlwapi" , "SHRegEnumUSValueA", {pointer, dword, pointer, pointer, pointer, long_pointer, pointer, pointer}, dword}, 
  {0, 0, "shlwapi" , "SHRegEnumUSValueW", {pointer, dword, pointer, pointer, pointer, long_pointer, pointer, pointer}, dword}, 
  {0, 0, "shlwapi" , "SHRegGetBoolUSValueA", {pointer, pointer, bool, bool}, bool}, 
  {0, 0, "shlwapi" , "SHRegGetBoolUSValueW", {pointer, pointer, bool, bool}, bool}, 
  {0, 0, "shlwapi" , "SHRegGetPathA", {pointer, pointer, pointer, pointer, dword}, dword}, 
  {0, 0, "shlwapi" , "SHRegGetPathW", {pointer, pointer, pointer, pointer, dword}, dword}, 
  {0, 0, "shlwapi" , "SHRegGetUSValueA", {pointer, pointer, pointer, long_pointer, pointer, bool, long_pointer, dword}, long}, 
  {0, 0, "shlwapi" , "SHRegGetUSValueW", {pointer, pointer, pointer, long_pointer, pointer, bool, long_pointer, dword}, long}, 
  {0, 0, "shlwapi" , "SHRegOpenUSKeyA", {pointer, pointer, pointer, pointer, bool}, long}, 
  {0, 0, "shlwapi" , "SHRegOpenUSKeyW", {pointer, pointer, pointer, pointer, bool}, long}, 
  {0, 0, "shlwapi" , "SHRegQueryInfoUSKeyA", {pointer, pointer, pointer, pointer, pointer, pointer}, dword}, 
  {0, 0, "shlwapi" , "SHRegQueryInfoUSKeyW", {pointer, pointer, pointer, pointer, pointer, pointer}, dword}, 
  {0, 0, "shlwapi" , "SHRegQueryUSValueA", {pointer, pointer, pointer, long_pointer, pointer, bool, long_pointer, dword}, long}, 
  {0, 0, "shlwapi" , "SHRegQueryUSValueW", {pointer, pointer, pointer, long_pointer, pointer, bool, long_pointer, dword}, long}, 
  {0, 0, "shlwapi" , "SHRegSetPathA", {pointer, pointer, pointer, pointer, dword}, dword}, 
  {0, 0, "shlwapi" , "SHRegSetPathW", {pointer, pointer, pointer, pointer, dword}, dword}, 
  {0, 0, "shlwapi" , "SHRegSetUSValueA", {pointer, pointer, dword, long_pointer, dword, dword}, long}, 
  {0, 0, "shlwapi" , "SHRegSetUSValueW", {pointer, pointer, dword, long_pointer, dword, dword}, long}, 
  {0, 0, "shlwapi" , "SHRegWriteUSValueA", {pointer, pointer, dword, long_pointer, dword, dword}, long}, 
  {0, 0, "shlwapi" , "SHRegWriteUSValueW", {pointer, pointer, dword, long_pointer, dword, dword}, long}, 
  {0, 0, "shlwapi" , "SHSetThreadRef", {pointer}, long}, 
  {0, 0, "shlwapi" , "SHSetValueA", {pointer, pointer, pointer, dword, pointer, dword}, dword}, 
  {0, 0, "shlwapi" , "SHSetValueW", {pointer, pointer, pointer, dword, pointer, dword}, dword}, 
  {0, 0, "shlwapi" , "SHSkipJunction", {pointer, pointer}, bool}, 
  {0, 0, "shlwapi" , "SHStrDupA", {pointer, pointer}, long}, 
  {0, 0, "shlwapi" , "SHStrDupW", {pointer, pointer}, long}, 
  {0, 0, "shlwapi" , "StrCatA", {pointer, pointer}, pointer}, 
  {0, 0, "shlwapi" , "StrCatBuffA", {pointer, pointer, int}, pointer}, 
  {0, 0, "shlwapi" , "StrCatBuffW", {pointer, pointer, int}, pointer}, 
  {0, 0, "shlwapi" , "StrCatChainW", {pointer, dword, dword, pointer}, dword}, 
  {0, 0, "shlwapi" , "StrCatW", {pointer, pointer}, pointer}, 
  {0, 0, "shlwapi" , "StrChrA", {pointer, word}, pointer}, 
  {0, 0, "shlwapi" , "StrChrIA", {pointer, word}, pointer}, 
  {0, 0, "shlwapi" , "StrChrIW", {pointer, wchar}, pointer}, 
  {0, 0, "shlwapi" , "StrChrW", {pointer, wchar}, pointer}, 
  {0, 0, "shlwapi" , "StrCmpIW", {pointer, pointer}, int}, 
  {0, 0, "shlwapi" , "StrCmpNA", {pointer, pointer, int}, int}, 
  {0, 0, "shlwapi" , "StrCmpNIA", {pointer, pointer, int}, int}, 
  {0, 0, "shlwapi" , "StrCmpNIW", {pointer, pointer, int}, int}, 
  {0, 0, "shlwapi" , "StrCmpNW", {pointer, pointer, int}, int}, 
  {0, 0, "shlwapi" , "StrCmpW", {pointer, pointer}, int}, 
  {0, 0, "shlwapi" , "StrCpyNW", {pointer, pointer, int}, pointer}, 
  {0, 0, "shlwapi" , "StrCpyW", {pointer, pointer}, pointer}, 
  {0, 0, "shlwapi" , "StrCSpnA", {pointer, pointer}, int}, 
  {0, 0, "shlwapi" , "StrCSpnIA", {pointer, pointer}, int}, 
  {0, 0, "shlwapi" , "StrCSpnIW", {pointer, pointer}, int}, 
  {0, 0, "shlwapi" , "StrCSpnW", {pointer, pointer}, int}, 
  {0, 0, "shlwapi" , "StrDupA", {pointer}, pointer}, 
  {0, 0, "shlwapi" , "StrDupW", {pointer}, pointer}, 
  {0, 0, "shlwapi" , "StrFormatByteSize64A", {int64, pointer, uint}, pointer}, 
  {0, 0, "shlwapi" , "StrFormatByteSizeA", {dword, pointer, uint}, pointer}, 
  {0, 0, "shlwapi" , "StrFormatByteSizeW", {int64, pointer, uint}, pointer}, 
  {0, 0, "shlwapi" , "StrFormatKBSizeA", {int64, pointer, uint}, pointer}, 
  {0, 0, "shlwapi" , "StrFormatKBSizeW", {int64, pointer, uint}, pointer}, 
  {0, 0, "shlwapi" , "StrFromTimeIntervalA", {pointer, uint, dword, int}, int}, 
  {0, 0, "shlwapi" , "StrFromTimeIntervalW", {pointer, uint, dword, int}, int}, 
  {0, 0, "shlwapi" , "StrIsIntlEqualA", {bool, pointer, pointer, int}, bool}, 
  {0, 0, "shlwapi" , "StrIsIntlEqualW", {bool, pointer, pointer, int}, bool}, 
  {0, 0, "shlwapi" , "StrNCatA", {pointer, pointer, int}, pointer}, 
  {0, 0, "shlwapi" , "StrNCatW", {pointer, pointer, int}, pointer}, 
  {0, 0, "shlwapi" , "StrPBrkA", {pointer, pointer}, pointer}, 
  {0, 0, "shlwapi" , "StrPBrkW", {pointer, pointer}, pointer}, 
  {0, 0, "shlwapi" , "StrRChrA", {pointer, pointer, word}, pointer}, 
  {0, 0, "shlwapi" , "StrRChrIA", {pointer, pointer, word}, pointer}, 
  {0, 0, "shlwapi" , "StrRChrIW", {pointer, pointer, wchar}, pointer}, 
  {0, 0, "shlwapi" , "StrRChrW", {pointer, pointer, wchar}, pointer}, 
  {0, 0, "shlwapi" , "StrRetToBufA", {long_pointer, long_pointer, pointer, uint}, long}, 
  {0, 0, "shlwapi" , "StrRetToBufW", {long_pointer, long_pointer, pointer, uint}, long}, 
  {0, 0, "shlwapi" , "StrRetToStrA", {long_pointer, long_pointer, pointer}, long}, 
  {0, 0, "shlwapi" , "StrRetToStrW", {long_pointer, long_pointer, pointer}, long}, 
  {0, 0, "shlwapi" , "StrRStrIA", {pointer, pointer, pointer}, pointer}, 
  {0, 0, "shlwapi" , "StrRStrIW", {pointer, pointer, pointer}, pointer}, 
  {0, 0, "shlwapi" , "StrSpnA", {pointer, pointer}, int}, 
  {0, 0, "shlwapi" , "StrSpnW", {pointer, pointer}, int}, 
  {0, 0, "shlwapi" , "StrStrA", {pointer, pointer}, pointer}, 
  {0, 0, "shlwapi" , "StrStrIA", {pointer, pointer}, pointer}, 
  {0, 0, "shlwapi" , "StrStrIW", {pointer, pointer}, pointer}, 
  {0, 0, "shlwapi" , "StrStrW", {pointer, pointer}, pointer}, 
  {0, 0, "shlwapi" , "StrToIntA", {pointer}, int}, 
  {0, 0, "shlwapi" , "StrToIntExA", {pointer, dword, pointer}, bool}, 
  {0, 0, "shlwapi" , "StrToIntExW", {pointer, dword, pointer}, bool}, 
  {0, 0, "shlwapi" , "StrToIntW", {pointer}, int}, 
  {0, 0, "shlwapi" , "StrTrimA", {pointer, pointer}, bool}, 
  {0, 0, "shlwapi" , "StrTrimW", {pointer, pointer}, bool}, 
  {0, 0, "shlwapi" , "UrlApplySchemeA", {pointer, pointer, pointer, dword}, long}, 
  {0, 0, "shlwapi" , "UrlApplySchemeW", {pointer, pointer, pointer, dword}, long}, 
  {0, 0, "shlwapi" , "UrlCanonicalizeA", {pointer, pointer, pointer, dword}, long}, 
  {0, 0, "shlwapi" , "UrlCanonicalizeW", {pointer, pointer, pointer, dword}, long}, 
  {0, 0, "shlwapi" , "UrlCombineA", {pointer, pointer, pointer, pointer, dword}, long}, 
  {0, 0, "shlwapi" , "UrlCombineW", {pointer, pointer, pointer, pointer, dword}, long}, 
  {0, 0, "shlwapi" , "UrlCompareA", {pointer, pointer, bool}, int}, 
  {0, 0, "shlwapi" , "UrlCompareW", {pointer, pointer, bool}, int}, 
  {0, 0, "shlwapi" , "UrlCreateFromPathA", {pointer, pointer, pointer, dword}, long}, 
  {0, 0, "shlwapi" , "UrlCreateFromPathW", {pointer, pointer, pointer, dword}, long}, 
  {0, 0, "shlwapi" , "UrlEscapeA", {pointer, pointer, pointer, dword}, long}, 
  {0, 0, "shlwapi" , "UrlEscapeW", {pointer, pointer, pointer, dword}, long}, 
  {0, 0, "shlwapi" , "UrlGetLocationA", {pointer}, pointer}, 
  {0, 0, "shlwapi" , "UrlGetLocationW", {pointer}, pointer}, 
  {0, 0, "shlwapi" , "UrlGetPartA", {pointer, pointer, pointer, dword, dword}, long}, 
  {0, 0, "shlwapi" , "UrlGetPartW", {pointer, pointer, pointer, dword, dword}, long}, 
  {0, 0, "shlwapi" , "UrlHashA", {pointer, pointer, dword}, long}, 
  {0, 0, "shlwapi" , "UrlHashW", {pointer, pointer, dword}, long}, 
  {0, 0, "shlwapi" , "UrlIsA", {pointer, pointer}, bool}, 
  {0, 0, "shlwapi" , "UrlIsNoHistoryA", {pointer}, bool}, 
  {0, 0, "shlwapi" , "UrlIsNoHistoryW", {pointer}, bool}, 
  {0, 0, "shlwapi" , "UrlIsOpaqueA", {pointer}, bool}, 
  {0, 0, "shlwapi" , "UrlIsOpaqueW", {pointer}, bool}, 
  {0, 0, "shlwapi" , "UrlIsW", {pointer, pointer}, bool}, 
  {0, 0, "shlwapi" , "UrlUnescapeA", {pointer, pointer, pointer, dword}, long}, 
  {0, 0, "shlwapi" , "UrlUnescapeW", {pointer, pointer, pointer, dword}, long}, 
  {0, 0, "shlwapi" , "wvnsprintfA", {pointer, int, pointer, pointer}, int}, 
  {0, 0, "shlwapi" , "wvnsprintfW", {pointer, int, pointer, pointer}, int}, 
  {0, 0, "svrapi"  , "I_NetLogonControl", {pointer, dword, dword, pointer}, pointer}, 
  {0, 0, "svrapi"  , "I_NetLogonControl2", {pointer, dword, dword, pointer, pointer}, pointer}, 
  {0, 0, "svrapi"  , "NetAccessAdd", {pointer, dword, pointer, pointer}, pointer}, 
  {0, 0, "svrapi"  , "NetAccessDel", {pointer, pointer}, pointer}, 
  {0, 0, "svrapi"  , "NetAccessEnum", {pointer, pointer, dword, dword, pointer, dword, pointer, pointer, pointer}, pointer}, 
  {0, 0, "svrapi"  , "NetAccessGetInfo", {pointer, pointer, dword, pointer}, pointer}, 
  {0, 0, "svrapi"  , "NetAccessGetUserPerms", {pointer, pointer, pointer, pointer}, pointer}, 
  {0, 0, "svrapi"  , "NetAccessSetInfo", {pointer, pointer, dword, pointer, pointer}, pointer}, 
  {0, 0, "svrapi"  , "NetGetAnyDCName", {pointer, pointer, pointer}, pointer}, 
  {0, 0, "svrapi"  , "NetGetDCName", {pointer, pointer, pointer}, pointer}, 
  {0, 0, "svrapi"  , "NetGetDisplayInformationIndex", {pointer, dword, pointer, pointer}, pointer}, 
  {0, 0, "svrapi"  , "NetGroupAdd", {pointer, dword, pointer, pointer}, pointer}, 
  {0, 0, "svrapi"  , "NetGroupAddUser", {pointer, pointer, pointer}, pointer}, 
  {0, 0, "svrapi"  , "NetGroupDel", {pointer, pointer}, pointer}, 
  {0, 0, "svrapi"  , "NetGroupDelUser", {pointer, pointer, pointer}, pointer}, 
  {0, 0, "svrapi"  , "NetGroupEnum", {pointer, dword, pointer, dword, pointer, pointer, pointer}, pointer}, 
  {0, 0, "svrapi"  , "NetGroupGetInfo", {pointer, pointer, dword, pointer}, pointer}, 
  {0, 0, "svrapi"  , "NetGroupGetUsers", {pointer, pointer, dword, pointer, dword, pointer, pointer, pointer}, pointer}, 
  {0, 0, "svrapi"  , "NetGroupSetInfo", {pointer, pointer, dword, pointer, pointer}, pointer}, 
  {0, 0, "svrapi"  , "NetGroupSetUsers", {pointer, pointer, dword, pointer, dword}, pointer}, 
  {0, 0, "svrapi"  , "NetLocalGroupAdd", {pointer, dword, pointer, pointer}, pointer}, 
  {0, 0, "svrapi"  , "NetLocalGroupAddMember", {pointer, pointer, pointer}, pointer}, 
  {0, 0, "svrapi"  , "NetLocalGroupAddMembers", {pointer, pointer, dword, pointer, dword}, pointer}, 
  {0, 0, "svrapi"  , "NetLocalGroupDel", {pointer, pointer}, pointer}, 
  {0, 0, "svrapi"  , "NetLocalGroupDelMember", {pointer, pointer, pointer}, pointer}, 
  {0, 0, "svrapi"  , "NetLocalGroupDelMembers", {pointer, pointer, dword, pointer, dword}, pointer}, 
  {0, 0, "svrapi"  , "NetLocalGroupEnum", {pointer, dword, pointer, dword, pointer, pointer, pointer}, pointer}, 
  {0, 0, "svrapi"  , "NetLocalGroupGetInfo", {pointer, pointer, dword, pointer}, pointer}, 
  {0, 0, "svrapi"  , "NetLocalGroupSetInfo", {pointer, pointer, dword, pointer, pointer}, pointer}, 
  {0, 0, "svrapi"  , "NetLocalGroupSetMembers", {pointer, pointer, dword, pointer, dword}, pointer}, 
  {0, 0, "svrapi"  , "NetQueryDisplayInformation", {pointer, dword, dword, dword, dword, pointer, pointer}, pointer}, 
  {0, 0, "svrapi"  , "NetUserAdd", {pointer, dword, pointer, pointer}, pointer}, 
  {0, 0, "svrapi"  , "NetUserChangePassword", {pointer, pointer, pointer, pointer}, pointer}, 
  {0, 0, "svrapi"  , "NetUserDel", {pointer, pointer}, pointer}, 
  {0, 0, "svrapi"  , "NetUserEnum", {pointer, dword, dword, pointer, dword, pointer, pointer, pointer}, pointer}, 
  {0, 0, "svrapi"  , "NetUserGetGroups", {pointer, pointer, dword, pointer, dword, pointer, pointer}, pointer}, 
  {0, 0, "svrapi"  , "NetUserGetInfo", {pointer, pointer, dword, pointer}, pointer}, 
  {0, 0, "svrapi"  , "NetUserGetLocalGroups", {pointer, pointer, dword, dword, pointer, dword, pointer, pointer}, pointer}, 
  {0, 0, "svrapi"  , "NetUserModalsGet", {pointer, dword, pointer}, pointer}, 
  {0, 0, "svrapi"  , "NetUserModalsSet", {pointer, dword, pointer, pointer}, pointer}, 
  {0, 0, "svrapi"  , "NetUserSetGroups", {pointer, pointer, dword, pointer, dword}, pointer}, 
  {0, 0, "svrapi"  , "NetUserSetInfo", {pointer, pointer, dword, pointer, pointer}, pointer}, 
  {0, 0, "url"     , "InetIsOffline", {dword}, bool}, 
  {0, 0, "url"     , "MIMEAssociationDialogA", {pointer, dword, pointer, pointer, pointer, uint}, long}, 
  {0, 0, "url"     , "MIMEAssociationDialogW", {pointer, dword, pointer, pointer, pointer, uint}, long}, 
  {0, 0, "url"     , "TranslateURLA", {pointer, dword, pointer}, long}, 
  {0, 0, "url"     , "TranslateURLW", {pointer, dword, pointer}, long}, 
  {0, 0, "url"     , "URLAssociationDialogA", {pointer, dword, pointer, pointer, pointer, uint}, long}, 
  {0, 0, "url"     , "URLAssociationDialogW", {pointer, dword, pointer, pointer, pointer, uint}, long}, 
  {0, 0, "user32"  , "ActivateKeyboardLayout", {pointer, uint}, pointer}, 
  {0, 0, "user32"  , "AdjustWindowRect", {long_pointer, dword, bool}, bool}, 
  {0, 0, "user32"  , "AdjustWindowRectEx", {long_pointer, dword, bool, dword}, bool}, 
  {0, 0, "user32"  , "AllowSetForegroundWindow", {dword}, bool}, 
  {0, 0, "user32"  , "AnimateWindow", {pointer, dword, dword}, bool}, 
  {0, 0, "user32"  , "AnyPopup", {}, bool}, 
  {0, 0, "user32"  , "AppendMenuA", {pointer, uint, pointer, pointer}, bool}, 
  {0, 0, "user32"  , "AppendMenuW", {pointer, uint, pointer, pointer}, bool}, 
  {0, 0, "user32"  , "ArrangeIconicWindows", {pointer}, uint}, 
  {0, 0, "user32"  , "AttachThreadInput", {dword, dword, bool}, bool}, 
  {0, 0, "user32"  , "BeginDeferWindowPos", {int}, pointer}, 
  {0, 0, "user32"  , "BeginPaint", {pointer, long_pointer}, pointer}, 
  {0, 0, "user32"  , "BringWindowToTop", {pointer}, bool}, 
  {0, 0, "user32"  , "BroadcastSystemMessage", {dword, pointer, uint, unsigned_int, long}, long}, 
  {0, 0, "user32"  , "BroadcastSystemMessageA", {dword, pointer, uint, unsigned_int, long}, long}, 
  {0, 0, "user32"  , "BroadcastSystemMessageExA", {dword, pointer, uint, unsigned_int, long, pointer}, long}, 
  {0, 0, "user32"  , "BroadcastSystemMessageExW", {dword, pointer, uint, unsigned_int, long, pointer}, long}, 
  {0, 0, "user32"  , "BroadcastSystemMessageW", {dword, pointer, uint, unsigned_int, long}, long}, 
  {0, 0, "user32"  , "CallMsgFilterA", {long_pointer, int}, bool}, 
  {0, 0, "user32"  , "CallMsgFilterW", {long_pointer, int}, bool}, 
  {0, 0, "user32"  , "CallNextHookEx", {pointer, int, unsigned_int, long}, long}, 
  {0, 0, "user32"  , "CallWindowProcA", {pointer, pointer, uint, unsigned_int, long}, long}, 
  {0, 0, "user32"  , "CallWindowProcW", {pointer, pointer, uint, unsigned_int, long}, long}, 
  {0, 0, "user32"  , "CascadeWindows", {pointer, uint, long_pointer, uint, pointer}, word}, 
  {0, 0, "user32"  , "ChangeClipboardChain", {pointer, pointer}, bool}, 
  {0, 0, "user32"  , "ChangeDisplaySettingsA", {pointer, dword}, long}, 
  {0, 0, "user32"  , "ChangeDisplaySettingsExA", {pointer, long_pointer, pointer, dword, long_pointer}, long}, 
  {0, 0, "user32"  , "ChangeDisplaySettingsExW", {pointer, long_pointer, pointer, dword, long_pointer}, long}, 
  {0, 0, "user32"  , "ChangeDisplaySettingsW", {pointer, dword}, long}, 
  {0, 0, "user32"  , "ChangeMenuA", {pointer, uint, pointer, uint, uint}, bool}, 
  {0, 0, "user32"  , "ChangeMenuW", {pointer, uint, pointer, uint, uint}, bool}, 
  {0, 0, "user32"  , "CharLowerA", {pointer}, pointer}, 
  {0, 0, "user32"  , "CharLowerBuffA", {pointer, dword}, dword}, 
  {0, 0, "user32"  , "CharLowerBuffW", {pointer, dword}, dword}, 
  {0, 0, "user32"  , "CharLowerW", {pointer}, pointer}, 
  {0, 0, "user32"  , "CharNextA", {pointer}, pointer}, 
  {0, 0, "user32"  , "CharNextExA", {word, pointer, dword}, pointer}, 
  {0, 0, "user32"  , "CharNextW", {pointer}, pointer}, 
  {0, 0, "user32"  , "CharPrevA", {pointer, pointer}, pointer}, 
  {0, 0, "user32"  , "CharPrevExA", {word, pointer, pointer, dword}, pointer}, 
  {0, 0, "user32"  , "CharPrevW", {pointer, pointer}, pointer}, 
  {0, 0, "user32"  , "CharToOemA", {pointer, pointer}, bool}, 
  {0, 0, "user32"  , "CharToOemBuffA", {pointer, pointer, dword}, bool}, 
  {0, 0, "user32"  , "CharToOemBuffW", {pointer, pointer, dword}, bool}, 
  {0, 0, "user32"  , "CharToOemW", {pointer, pointer}, bool}, 
  {0, 0, "user32"  , "CharUpperA", {pointer}, pointer}, 
  {0, 0, "user32"  , "CharUpperBuffA", {pointer, dword}, dword}, 
  {0, 0, "user32"  , "CharUpperBuffW", {pointer, dword}, dword}, 
  {0, 0, "user32"  , "CharUpperW", {pointer}, pointer}, 
  {0, 0, "user32"  , "CheckDlgButton", {pointer, int, uint}, bool}, 
  {0, 0, "user32"  , "CheckMenuItem", {pointer, uint, uint}, dword}, 
  {0, 0, "user32"  , "CheckMenuRadioItem", {pointer, uint, uint, uint, uint}, bool}, 
  {0, 0, "user32"  , "CheckRadioButton", {pointer, int, int, int}, bool}, 
  {0, 0, "user32"  , "ChildWindowFromPoint", {pointer, pointer}, pointer}, 
  {0, 0, "user32"  , "ChildWindowFromPointEx", {pointer, pointer, uint}, pointer}, 
  {0, 0, "user32"  , "ClientToScreen", {pointer, long_pointer}, bool}, 
  {0, 0, "user32"  , "ClipCursor", {long_pointer}, bool}, 
  {0, 0, "user32"  , "CloseClipboard", {}, bool}, 
  {0, 0, "user32"  , "CloseDesktop", {pointer}, bool}, 
  {0, 0, "user32"  , "CloseTouchInputHandle", {pointer}, bool}, 
  {0, 0, "user32"  , "CloseWindow", {pointer}, bool}, 
  {0, 0, "user32"  , "CloseWindowStation", {pointer}, bool}, 
  {0, 0, "user32"  , "CopyAcceleratorTableA", {pointer, long_pointer, int}, int}, 
  {0, 0, "user32"  , "CopyAcceleratorTableW", {pointer, long_pointer, int}, int}, 
  {0, 0, "user32"  , "CopyIcon", {pointer}, pointer}, 
  {0, 0, "user32"  , "CopyImage", {pointer, uint, int, int, uint}, pointer}, 
  {0, 0, "user32"  , "CopyRect", {long_pointer, long_pointer}, bool}, 
  {0, 0, "user32"  , "CountClipboardFormats", {}, int}, 
  {0, 0, "user32"  , "CreateAcceleratorTableA", {long_pointer, int}, pointer}, 
  {0, 0, "user32"  , "CreateAcceleratorTableW", {long_pointer, int}, pointer}, 
  {0, 0, "user32"  , "CreateCaret", {pointer, pointer, int, int}, bool}, 
  {0, 0, "user32"  , "CreateCursor", {pointer, int, int, int, int, pointer, pointer}, pointer}, 
  {0, 0, "user32"  , "CreateDesktopA", {pointer, pointer, long_pointer, dword, pointer, long_pointer}, pointer}, 
  {0, 0, "user32"  , "CreateDesktopW", {pointer, pointer, long_pointer, dword, pointer, long_pointer}, pointer}, 
  {0, 0, "user32"  , "CreateDialogIndirectParamA", {pointer, long_pointer, pointer, pointer, long}, pointer}, 
  {0, 0, "user32"  , "CreateDialogIndirectParamW", {pointer, long_pointer, pointer, pointer, long}, pointer}, 
  {0, 0, "user32"  , "CreateDialogParamA", {pointer, pointer, pointer, pointer, long}, pointer}, 
  {0, 0, "user32"  , "CreateDialogParamW", {pointer, pointer, pointer, pointer, long}, pointer}, 
  {0, 0, "user32"  , "CreateIcon", {pointer, int, int, byte, byte, pointer, pointer}, pointer}, 
  {0, 0, "user32"  , "CreateIconFromResource", {pointer, dword, bool, dword}, pointer}, 
  {0, 0, "user32"  , "CreateIconFromResourceEx", {pointer, dword, bool, dword, int, int, uint}, pointer}, 
  {0, 0, "user32"  , "CreateIconIndirect", {pointer}, pointer}, 
  {0, 0, "user32"  , "CreateMDIWindowA", {pointer, pointer, dword, int, int, int, int, pointer, pointer, long}, pointer}, 
  {0, 0, "user32"  , "CreateMDIWindowW", {pointer, pointer, dword, int, int, int, int, pointer, pointer, long}, pointer}, 
  {0, 0, "user32"  , "CreateMenu", {}, pointer}, 
  {0, 0, "user32"  , "CreatePopupMenu", {}, pointer}, 
  {0, 0, "user32"  , "CreateWindowExA", {dword, pointer, pointer, dword, int, int, int, int, pointer, pointer, pointer, long_pointer}, pointer}, 
  {0, 0, "user32"  , "CreateWindowExW", {dword, pointer, pointer, dword, int, int, int, int, pointer, pointer, pointer, long_pointer}, pointer}, 
  {0, 0, "user32"  , "CreateWindowStationA", {pointer, dword, dword, long_pointer}, pointer}, 
  {0, 0, "user32"  , "CreateWindowStationW", {pointer, dword, dword, long_pointer}, pointer}, 
  {0, 0, "user32"  , "DdeAbandonTransaction", {dword, pointer, dword}, bool}, 
  {0, 0, "user32"  , "DdeAccessData", {pointer, pointer}, pointer}, 
  {0, 0, "user32"  , "DdeAddData", {pointer, pointer, dword, dword}, pointer}, 
  {0, 0, "user32"  , "DdeClientTransaction", {pointer, dword, pointer, pointer, uint, uint, dword, pointer}, pointer}, 
  {0, 0, "user32"  , "DdeCmpStringHandles", {pointer, pointer}, int}, 
  {0, 0, "user32"  , "DdeConnect", {dword, pointer, pointer, pointer}, pointer}, 
  {0, 0, "user32"  , "DdeConnectList", {dword, pointer, pointer, pointer, pointer}, pointer}, 
  {0, 0, "user32"  , "DdeCreateDataHandle", {dword, pointer, dword, dword, pointer, uint, uint}, pointer}, 
  {0, 0, "user32"  , "DdeCreateStringHandleA", {dword, pointer, int}, pointer}, 
  {0, 0, "user32"  , "DdeCreateStringHandleW", {dword, pointer, int}, pointer}, 
  {0, 0, "user32"  , "DdeDisconnect", {pointer}, bool}, 
  {0, 0, "user32"  , "DdeDisconnectList", {pointer}, bool}, 
  {0, 0, "user32"  , "DdeEnableCallback", {dword, pointer, uint}, bool}, 
  {0, 0, "user32"  , "DdeFreeDataHandle", {pointer}, bool}, 
  {0, 0, "user32"  , "DdeFreeStringHandle", {dword, pointer}, bool}, 
  {0, 0, "user32"  , "DdeGetData", {pointer, pointer, dword, dword}, dword}, 
  {0, 0, "user32"  , "DdeGetLastError", {dword}, uint}, 
  {0, 0, "user32"  , "DdeImpersonateClient", {pointer}, bool}, 
  {0, 0, "user32"  , "DdeInitializeA", {pointer, pointer, dword, dword}, uint}, 
  {0, 0, "user32"  , "DdeInitializeW", {pointer, pointer, dword, dword}, uint}, 
  {0, 0, "user32"  , "DdeKeepStringHandle", {dword, pointer}, bool}, 
  {0, 0, "user32"  , "DdeNameService", {dword, pointer, pointer, uint}, pointer}, 
  {0, 0, "user32"  , "DdePostAdvise", {dword, pointer, pointer}, bool}, 
  {0, 0, "user32"  , "DdeQueryConvInfo", {pointer, dword, pointer}, uint}, 
  {0, 0, "user32"  , "DdeQueryNextServer", {pointer, pointer}, pointer}, 
  {0, 0, "user32"  , "DdeQueryStringA", {dword, pointer, pointer, dword, int}, dword}, 
  {0, 0, "user32"  , "DdeQueryStringW", {dword, pointer, pointer, dword, int}, dword}, 
  {0, 0, "user32"  , "DdeReconnect", {pointer}, pointer}, 
  {0, 0, "user32"  , "DdeSetQualityOfService", {pointer, pointer, pointer}, bool}, 
  {0, 0, "user32"  , "DdeSetUserHandle", {pointer, dword, dword}, bool}, 
  {0, 0, "user32"  , "DdeUnaccessData", {pointer}, bool}, 
  {0, 0, "user32"  , "DdeUninitialize", {dword}, bool}, 
  {0, 0, "user32"  , "DefDlgProcA", {pointer, uint, unsigned_int, long}, long}, 
  {0, 0, "user32"  , "DefDlgProcW", {pointer, uint, unsigned_int, long}, long}, 
  {0, 0, "user32"  , "DeferWindowPos", {pointer, pointer, pointer, int, int, int, int, uint}, pointer}, 
  {0, 0, "user32"  , "DefFrameProcA", {pointer, pointer, uint, unsigned_int, long}, long}, 
  {0, 0, "user32"  , "DefFrameProcW", {pointer, pointer, uint, unsigned_int, long}, long}, 
  {0, 0, "user32"  , "DefMDIChildProcA", {pointer, uint, unsigned_int, long}, long}, 
  {0, 0, "user32"  , "DefMDIChildProcW", {pointer, uint, unsigned_int, long}, long}, 
  {0, 0, "user32"  , "DefRawInputProc", {pointer, int, uint}, long}, 
  {0, 0, "user32"  , "DefWindowProcA", {pointer, uint, unsigned_int, long}, long}, 
  {0, 0, "user32"  , "DefWindowProcW", {pointer, uint, unsigned_int, long}, long}, 
  {0, 0, "user32"  , "DeleteMenu", {pointer, uint, uint}, bool}, 
  {0, 0, "user32"  , "DeregisterShellHookWindow", {pointer}, bool}, 
  {0, 0, "user32"  , "DestroyAcceleratorTable", {pointer}, bool}, 
  {0, 0, "user32"  , "DestroyCaret", {}, bool}, 
  {0, 0, "user32"  , "DestroyCursor", {pointer}, bool}, 
  {0, 0, "user32"  , "DestroyIcon", {pointer}, bool}, 
  {0, 0, "user32"  , "DestroyMenu", {pointer}, bool}, 
  {0, 0, "user32"  , "DestroyWindow", {pointer}, bool}, 
  {0, 0, "user32"  , "DialogBoxIndirectParamA", {pointer, long_pointer, pointer, pointer, long}, int}, 
  {0, 0, "user32"  , "DialogBoxIndirectParamW", {pointer, long_pointer, pointer, pointer, long}, int}, 
  {0, 0, "user32"  , "DialogBoxParamA", {pointer, pointer, pointer, pointer, long}, int}, 
  {0, 0, "user32"  , "DialogBoxParamW", {pointer, pointer, pointer, pointer, long}, int}, 
  {0, 0, "user32"  , "DispatchMessageA", {pointer}, long}, 
  {0, 0, "user32"  , "DispatchMessageW", {pointer}, long}, 
  {0, 0, "user32"  , "DlgDirListA", {pointer, pointer, int, int, uint}, int}, 
  {0, 0, "user32"  , "DlgDirListComboBoxA", {pointer, pointer, int, int, uint}, int}, 
  {0, 0, "user32"  , "DlgDirListComboBoxW", {pointer, pointer, int, int, uint}, int}, 
  {0, 0, "user32"  , "DlgDirListW", {pointer, pointer, int, int, uint}, int}, 
  {0, 0, "user32"  , "DlgDirSelectComboBoxExA", {pointer, pointer, int, int}, bool}, 
  {0, 0, "user32"  , "DlgDirSelectComboBoxExW", {pointer, pointer, int, int}, bool}, 
  {0, 0, "user32"  , "DlgDirSelectExA", {pointer, pointer, int, int}, bool}, 
  {0, 0, "user32"  , "DlgDirSelectExW", {pointer, pointer, int, int}, bool}, 
  {0, 0, "user32"  , "DragDetect", {pointer, pointer}, bool}, 
  {0, 0, "user32"  , "DragObject", {pointer, pointer, uint, dword, pointer}, dword}, 
  {0, 0, "user32"  , "DrawAnimatedRects", {pointer, int, long_pointer, long_pointer}, bool}, 
  {0, 0, "user32"  , "DrawCaption", {pointer, pointer, long_pointer, uint}, bool}, 
  {0, 0, "user32"  , "DrawEdge", {pointer, long_pointer, uint, uint}, bool}, 
  {0, 0, "user32"  , "DrawFocusRect", {pointer, long_pointer}, bool}, 
  {0, 0, "user32"  , "DrawFrameControl", {pointer, long_pointer, uint, uint}, bool}, 
  {0, 0, "user32"  , "DrawIcon", {pointer, int, int, pointer}, bool}, 
  {0, 0, "user32"  , "DrawIconEx", {pointer, int, int, pointer, int, int, uint, pointer, uint}, bool}, 
  {0, 0, "user32"  , "DrawMenuBar", {pointer}, bool}, 
  {0, 0, "user32"  , "DrawStateA", {pointer, pointer, pointer, long, unsigned_int, int, int, int, int, uint}, bool}, 
  {0, 0, "user32"  , "DrawStateW", {pointer, pointer, pointer, long, unsigned_int, int, int, int, int, uint}, bool}, 
  {0, 0, "user32"  , "DrawTextA", {pointer, pointer, int, long_pointer, uint}, int}, 
  {0, 0, "user32"  , "DrawTextExA", {pointer, pointer, int, long_pointer, uint, long_pointer}, int}, 
  {0, 0, "user32"  , "DrawTextExW", {pointer, pointer, int, long_pointer, uint, long_pointer}, int}, 
  {0, 0, "user32"  , "DrawTextW", {pointer, pointer, int, long_pointer, uint}, int}, 
  {0, 0, "user32"  , "EmptyClipboard", {}, bool}, 
  {0, 0, "user32"  , "EnableMenuItem", {pointer, uint, uint}, bool}, 
  {0, 0, "user32"  , "EnableScrollBar", {pointer, uint, uint}, bool}, 
  {0, 0, "user32"  , "EnableWindow", {pointer, bool}, bool}, 
  {0, 0, "user32"  , "EndDeferWindowPos", {pointer}, bool}, 
  {0, 0, "user32"  , "EndDialog", {pointer, int}, bool}, 
  {0, 0, "user32"  , "EndMenu", {}, bool}, 
  {0, 0, "user32"  , "EndPaint", {pointer, pointer}, bool}, 
  {0, 0, "user32"  , "EndTask", {pointer, bool, bool}, bool}, 
  {0, 0, "user32"  , "EnumChildWindows", {pointer, pointer, long}, bool}, 
  {0, 0, "user32"  , "EnumClipboardFormats", {uint}, uint}, 
  {0, 0, "user32"  , "EnumDesktopsA", {pointer, pointer, long}, bool}, 
  {0, 0, "user32"  , "EnumDesktopsW", {pointer, pointer, long}, bool}, 
  {0, 0, "user32"  , "EnumDesktopWindows", {pointer, pointer, long}, bool}, 
  {0, 0, "user32"  , "EnumDisplayDevicesA", {pointer, dword, pointer, dword}, bool}, 
  {0, 0, "user32"  , "EnumDisplayDevicesW", {pointer, dword, pointer, dword}, bool}, 
  {0, 0, "user32"  , "EnumDisplayMonitors", {pointer, long_pointer, pointer, long}, bool}, 
  {0, 0, "user32"  , "EnumDisplaySettingsA", {pointer, dword, pointer}, bool}, 
  {0, 0, "user32"  , "EnumDisplaySettingsExA", {pointer, dword, long_pointer, dword}, bool}, 
  {0, 0, "user32"  , "EnumDisplaySettingsExW", {pointer, dword, long_pointer, dword}, bool}, 
  {0, 0, "user32"  , "EnumDisplaySettingsW", {pointer, dword, pointer}, bool}, 
  {0, 0, "user32"  , "EnumPropsA", {pointer, pointer}, int}, 
  {0, 0, "user32"  , "EnumPropsExA", {pointer, pointer, long}, int}, 
  {0, 0, "user32"  , "EnumPropsExW", {pointer, pointer, long}, int}, 
  {0, 0, "user32"  , "EnumPropsW", {pointer, pointer}, int}, 
  {0, 0, "user32"  , "EnumThreadWindows", {dword, pointer, long}, bool}, 
  {0, 0, "user32"  , "EnumWindows", {pointer, long}, bool}, 
  {0, 0, "user32"  , "EnumWindowStationsA", {pointer, long}, bool}, 
  {0, 0, "user32"  , "EnumWindowStationsW", {pointer, long}, bool}, 
  {0, 0, "user32"  , "EqualRect", {long_pointer, long_pointer}, bool}, 
-- ExcludeUpdateRgn is defined in gdi32
--  {0, 0, "user32"  , "ExcludeUpdateRgn", {pointer, pointer}, long}, 
  {0, 0, "user32"  , "ExitWindowsEx", {uint, dword}, bool}, 
-- FillRect is defined in gdi32
--  {0, 0, "user32"  , "FillRect", {pointer, pointer, pointer}, int}, 
  {0, 0, "user32"  , "FindWindowA", {pointer, pointer}, pointer}, 
  {0, 0, "user32"  , "FindWindowExA", {pointer, pointer, pointer, pointer}, pointer}, 
  {0, 0, "user32"  , "FindWindowExW", {pointer, pointer, pointer, pointer}, pointer}, 
  {0, 0, "user32"  , "FindWindowW", {pointer, pointer}, pointer}, 
  {0, 0, "user32"  , "FlashWindow", {pointer, bool}, bool}, 
  {0, 0, "user32"  , "FlashWindowEx", {pointer}, bool}, 
  {0, 0, "user32"  , "FrameRect", {pointer, long_pointer, pointer}, int}, 
  {0, 0, "user32"  , "FrameRgn", {pointer, pointer, pointer, int, int}, bool}, 
  {0, 0, "user32"  , "FreeDDElParam", {uint, long}, bool}, 
  {0, 0, "user32"  , "GetActiveWindow", {}, pointer}, 
  {0, 0, "user32"  , "GetAltTabInfoA", {pointer, int, pointer, pointer, uint}, bool}, 
  {0, 0, "user32"  , "GetAltTabInfoW", {pointer, int, pointer, pointer, uint}, bool}, 
  {0, 0, "user32"  , "GetAncestor", {pointer, uint}, pointer}, 
  {0, 0, "user32"  , "GetAsyncKeyState", {int}, short}, 
  {0, 0, "user32"  , "GetCapture", {}, pointer}, 
  {0, 0, "user32"  , "GetCaretBlinkTime", {}, uint}, 
  {0, 0, "user32"  , "GetCaretPos", {long_pointer}, bool}, 
  {0, 0, "user32"  , "GetClassInfoA", {pointer, pointer, long_pointer}, bool}, 
  {0, 0, "user32"  , "GetClassInfoExA", {pointer, pointer, long_pointer}, bool}, 
  {0, 0, "user32"  , "GetClassInfoExW", {pointer, pointer, long_pointer}, bool}, 
  {0, 0, "user32"  , "GetClassInfoW", {pointer, pointer, long_pointer}, bool}, 
  {0, 0, "user32"  , "GetClassLongA", {pointer, int}, dword}, 
  {0, 0, "user32"  , "GetClassLongPtrA", {pointer, int}, pointer}, 
  {0, 0, "user32"  , "GetClassLongPtrW", {pointer, int}, pointer}, 
  {0, 0, "user32"  , "GetClassLongW", {pointer, int}, dword}, 
  {0, 0, "user32"  , "GetClassNameA", {pointer, pointer, int}, int}, 
  {0, 0, "user32"  , "GetClassNameW", {pointer, pointer, int}, int}, 
  {0, 0, "user32"  , "GetClassWord", {pointer, int}, word}, 
  {0, 0, "user32"  , "GetClientRect", {pointer, long_pointer}, bool}, 
  {0, 0, "user32"  , "GetClipboardData", {uint}, pointer}, 
  {0, 0, "user32"  , "GetClipboardFormatNameA", {uint, pointer, int}, int}, 
  {0, 0, "user32"  , "GetClipboardFormatNameW", {uint, pointer, int}, int}, 
  {0, 0, "user32"  , "GetClipboardOwner", {}, pointer}, 
  {0, 0, "user32"  , "GetClipboardSequenceNumber", {}, dword}, 
  {0, 0, "user32"  , "GetClipboardViewer", {}, pointer}, 
  {0, 0, "user32"  , "GetClipCursor", {long_pointer}, bool}, 
  {0, 0, "user32"  , "GetComboBoxInfo", {pointer, pointer}, bool}, 
  {0, 0, "user32"  , "GetCursorInfo", {pointer}, bool}, 
  {0, 0, "user32"  , "GetCursorPos", {long_pointer}, bool}, 
  {0, 0, "user32"  , "GetDC", {pointer}, pointer}, 
  {0, 0, "user32"  , "GetDCEx", {pointer, pointer, dword}, pointer}, 
  {0, 0, "user32"  , "GetDesktopWindow", {}, pointer}, 
  {0, 0, "user32"  , "GetDialogBaseUnits", {}, long}, 
  {0, 0, "user32"  , "GetDlgCtrlID", {pointer}, int}, 
  {0, 0, "user32"  , "GetDlgItem", {pointer, int}, pointer}, 
  {0, 0, "user32"  , "GetDlgItemInt", {pointer, int, pointer, bool}, uint}, 
  {0, 0, "user32"  , "GetDlgItemTextA", {pointer, int, pointer, int}, uint}, 
  {0, 0, "user32"  , "GetDlgItemTextW", {pointer, int, pointer, int}, uint}, 
  {0, 0, "user32"  , "GetDoubleClickTime", {}, uint}, 
  {0, 0, "user32"  , "GetFocus", {}, pointer}, 
  {0, 0, "user32"  , "GetForegroundWindow", {}, pointer}, 
  {0, 0, "user32"  , "GetGuiResources", {pointer, dword}, dword}, 
  {0, 0, "user32"  , "GetGUIThreadInfo", {dword, long_pointer}, bool}, 
  {0, 0, "user32"  , "GetIconInfo", {pointer, pointer}, bool}, 
  {0, 0, "user32"  , "GetInputState", {}, bool}, 
  {0, 0, "user32"  , "GetKBCodePage", {}, uint}, 
  {0, 0, "user32"  , "GetKeyboardLayout", {dword}, pointer}, 
  {0, 0, "user32"  , "GetKeyboardLayoutList", {int, pointer}, uint}, 
  {0, 0, "user32"  , "GetKeyboardLayoutNameA", {pointer}, bool}, 
  {0, 0, "user32"  , "GetKeyboardLayoutNameW", {pointer}, bool}, 
  {0, 0, "user32"  , "GetKeyboardState", {pointer}, bool}, 
  {0, 0, "user32"  , "GetKeyboardType", {int}, int}, 
  {0, 0, "user32"  , "GetKeyNameTextA", {long, pointer, int}, int}, 
  {0, 0, "user32"  , "GetKeyNameTextW", {long, pointer, int}, int}, 
  {0, 0, "user32"  , "GetKeyState", {int}, short}, 
  {0, 0, "user32"  , "GetLastActivePopup", {pointer}, pointer}, 
  {0, 0, "user32"  , "GetLastInputInfo", {pointer}, bool}, 
  {0, 0, "user32"  , "GetLayeredWindowAttributes", {pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "user32"  , "GetListBoxInfo", {pointer}, dword}, 
  {0, 0, "user32"  , "GetMenu", {pointer}, pointer}, 
  {0, 0, "user32"  , "GetMenuBarInfo", {pointer, long, long, pointer}, bool}, 
  {0, 0, "user32"  , "GetMenuCheckMarkDimensions", {}, long}, 
  {0, 0, "user32"  , "GetMenuContextHelpId", {pointer}, dword}, 
  {0, 0, "user32"  , "GetMenuDefaultItem", {pointer, uint, uint}, uint}, 
  {0, 0, "user32"  , "GetMenuInfo", {pointer, long_pointer}, bool}, 
  {0, 0, "user32"  , "GetMenuItemCount", {pointer}, int}, 
  {0, 0, "user32"  , "GetMenuItemID", {pointer, int}, uint}, 
  {0, 0, "user32"  , "GetMenuItemInfoA", {pointer, uint, bool, long_pointer}, bool}, 
  {0, 0, "user32"  , "GetMenuItemInfoW", {pointer, uint, bool, long_pointer}, bool}, 
  {0, 0, "user32"  , "GetMenuItemRect", {pointer, pointer, uint, long_pointer}, bool}, 
  {0, 0, "user32"  , "GetMenuState", {pointer, uint, uint}, uint}, 
  {0, 0, "user32"  , "GetMenuStringA", {pointer, uint, pointer, int, uint}, int}, 
  {0, 0, "user32"  , "GetMenuStringW", {pointer, uint, pointer, int, uint}, int}, 
  {0, 0, "user32"  , "GetMessageA", {long_pointer, pointer, uint, uint}, bool}, 
  {0, 0, "user32"  , "GetMessageExtraInfo", {}, long}, 
  {0, 0, "user32"  , "GetMessagePos", {}, dword}, 
  {0, 0, "user32"  , "GetMessageTime", {}, long}, 
  {0, 0, "user32"  , "GetMessageW", {long_pointer, pointer, uint, uint}, bool}, 
  {0, 0, "user32"  , "GetMonitorInfoA", {pointer, long_pointer}, bool}, 
  {0, 0, "user32"  , "GetMonitorInfoW", {pointer, long_pointer}, bool}, 
  {0, 0, "user32"  , "GetMouseMovePointsEx", {uint, long_pointer, long_pointer, int, dword}, int}, 
  {0, 0, "user32"  , "GetNextDlgGroupItem", {pointer, pointer, bool}, pointer}, 
  {0, 0, "user32"  , "GetNextDlgTabItem", {pointer, pointer, bool}, pointer}, 
  {0, 0, "user32"  , "GetOpenClipboardWindow", {}, pointer}, 
  {0, 0, "user32"  , "GetParent", {pointer}, pointer}, 
  {0, 0, "user32"  , "GetPriorityClipboardFormat", {pointer, int}, int}, 
  {0, 0, "user32"  , "GetProcessDefaultLayout", {pointer}, bool}, 
  {0, 0, "user32"  , "GetPropA", {pointer, pointer}, pointer}, 
  {0, 0, "user32"  , "GetPropW", {pointer, pointer}, pointer}, 
  {0, 0, "user32"  , "GetQueueStatus", {uint}, dword}, 
  {0, 0, "user32"  , "GetRawInputBuffer", {pointer, pointer, uint}, uint}, 
  {0, 0, "user32"  , "GetRawInputData", {pointer, uint, long_pointer, pointer, uint}, uint}, 
  {0, 0, "user32"  , "GetRawInputDeviceInfoA", {pointer, uint, long_pointer, pointer}, uint}, 
  {0, 0, "user32"  , "GetRawInputDeviceInfoW", {pointer, uint, long_pointer, pointer}, uint}, 
  {0, 0, "user32"  , "GetRawInputDeviceList", {pointer, pointer, uint}, uint}, 
  {0, 0, "user32"  , "GetRegisteredRawInputDevices", {pointer, pointer, uint}, uint}, 
  {0, 0, "user32"  , "GetScrollBarInfo", {pointer, long, pointer}, bool}, 
  {0, 0, "user32"  , "GetScrollInfo", {pointer, int, long_pointer}, bool}, 
  {0, 0, "user32"  , "GetScrollPos", {pointer, int}, int}, 
  {0, 0, "user32"  , "GetScrollRange", {pointer, int, pointer, pointer}, bool}, 
  {0, 0, "user32"  , "GetShellWindow", {}, pointer}, 
  {0, 0, "user32"  , "GetSubMenu", {pointer, int}, pointer}, 
  {0, 0, "user32"  , "GetSysColor", {int}, dword}, 
  {0, 0, "user32"  , "GetSysColorBrush", {int}, pointer}, 
  {0, 0, "user32"  , "GetSystemMenu", {pointer, bool}, pointer}, 
  {0, 0, "user32"  , "GetSystemMetrics", {int}, int}, 
  {0, 0, "user32"  , "GetTabbedTextExtentA", {pointer, pointer, int, int, pointer}, dword}, 
  {0, 0, "user32"  , "GetTabbedTextExtentW", {pointer, pointer, int, int, pointer}, dword}, 
  {0, 0, "user32"  , "GetThreadDesktop", {dword}, pointer}, 
  {0, 0, "user32"  , "GetTitleBarInfo", {pointer, pointer}, bool}, 
  {0, 0, "user32"  , "GetTopWindow", {pointer}, pointer}, 
  {0, 0, "user32"  , "GetTouchInputInfo", {pointer, uint, pointer, int}, bool}, 
  {0, 0, "user32"  , "GetUpdateRect", {pointer, long_pointer, bool}, bool}, 
  {0, 0, "user32"  , "GetUpdateRgn", {pointer, pointer, bool}, int}, 
  {0, 0, "user32"  , "GetUserObjectInformationA", {pointer, int, pointer, dword, pointer}, bool}, 
  {0, 0, "user32"  , "GetUserObjectInformationW", {pointer, int, pointer, dword, pointer}, bool}, 
  {0, 0, "user32"  , "GetUserObjectSecurity", {pointer, pointer, pointer, dword, pointer}, bool}, 
  {0, 0, "user32"  , "GetWindow", {pointer, uint}, pointer}, 
  {0, 0, "user32"  , "GetWindowContextHelpId", {pointer}, dword}, 
  {0, 0, "user32"  , "GetWindowDC", {pointer}, pointer}, 
  {0, 0, "user32"  , "GetWindowInfo", {pointer, pointer}, bool}, 
  {0, 0, "user32"  , "GetWindowLongA", {pointer, int}, long}, 
  {0, 0, "user32"  , "GetWindowLongPtrA", {pointer, int}, pointer}, 
  {0, 0, "user32"  , "GetWindowLongPtrW", {pointer, int}, pointer}, 
  {0, 0, "user32"  , "GetWindowLongW", {pointer, int}, long}, 
  {0, 0, "user32"  , "GetWindowModuleFileNameA", {pointer, pointer, uint}, uint}, 
  {0, 0, "user32"  , "GetWindowModuleFileNameW", {pointer, pointer, uint}, uint}, 
  {0, 0, "user32"  , "GetWindowPlacement", {pointer, pointer}, bool}, 
  {0, 0, "user32"  , "GetWindowRect", {pointer, long_pointer}, bool}, 
  {0, 0, "user32"  , "GetWindowRgn", {pointer, pointer}, int}, 
  {0, 0, "user32"  , "GetWindowTextA", {pointer, pointer, int}, int}, 
  {0, 0, "user32"  , "GetWindowTextLengthA", {pointer}, int}, 
  {0, 0, "user32"  , "GetWindowTextLengthW", {pointer}, int}, 
  {0, 0, "user32"  , "GetWindowTextW", {pointer, pointer, int}, int}, 
  {0, 0, "user32"  , "GetWindowWord", {pointer, int}, word}, 
  {0, 0, "user32"  , "GrayStringA", {pointer, pointer, pointer, long, int, int, int, int, int}, bool}, 
  {0, 0, "user32"  , "GrayStringW", {pointer, pointer, pointer, long, int, int, int, int, int}, bool}, 
  {0, 0, "user32"  , "HideCaret", {pointer}, bool}, 
  {0, 0, "user32"  , "HiliteMenuItem", {pointer, pointer, uint, uint}, bool}, 
  {0, 0, "user32"  , "ImpersonateDdeClientWindow", {pointer, pointer}, bool}, 
  {0, 0, "user32"  , "InflateRect", {long_pointer, int, int}, bool}, 
  {0, 0, "user32"  , "InSendMessage", {}, bool}, 
  {0, 0, "user32"  , "InSendMessageEx", {long_pointer}, dword}, 
  {0, 0, "user32"  , "InsertMenuA", {pointer, uint, uint, uint, pointer}, bool}, 
  {0, 0, "user32"  , "InsertMenuItemA", {pointer, uint, bool, long_pointer}, bool}, 
  {0, 0, "user32"  , "InsertMenuItemW", {pointer, uint, bool, long_pointer}, bool}, 
  {0, 0, "user32"  , "InsertMenuW", {pointer, uint, uint, uint, pointer}, bool}, 
  {0, 0, "user32"  , "InternalGetWindowText", {pointer, pointer, int}, int}, 
  {0, 0, "user32"  , "IntersectRect", {long_pointer, long_pointer, long_pointer}, bool}, 
  {0, 0, "user32"  , "InvalidateRect", {pointer, long_pointer, bool}, bool}, 
  {0, 0, "user32"  , "InvalidateRgn", {pointer, pointer, bool}, bool}, 
  {0, 0, "user32"  , "InvertRect", {pointer, long_pointer}, bool}, 
  {0, 0, "user32"  , "IsCharAlphaA", {char}, bool}, 
  {0, 0, "user32"  , "IsCharAlphaNumericA", {char}, bool}, 
  {0, 0, "user32"  , "IsCharAlphaNumericW", {wchar}, bool}, 
  {0, 0, "user32"  , "IsCharAlphaW", {wchar}, bool}, 
  {0, 0, "user32"  , "IsCharLowerA", {char}, bool}, 
  {0, 0, "user32"  , "IsCharLowerW", {wchar}, bool}, 
  {0, 0, "user32"  , "IsCharUpperA", {char}, bool}, 
  {0, 0, "user32"  , "IsCharUpperW", {wchar}, bool}, 
  {0, 0, "user32"  , "IsChild", {pointer, pointer}, bool}, 
  {0, 0, "user32"  , "IsClipboardFormatAvailable", {uint}, bool}, 
  {0, 0, "user32"  , "IsDialogMessageA", {pointer, long_pointer}, bool}, 
  {0, 0, "user32"  , "IsDialogMessageW", {pointer, long_pointer}, bool}, 
  {0, 0, "user32"  , "IsDlgButtonChecked", {pointer, int}, uint}, 
  {0, 0, "user32"  , "IsGUIThread", {bool}, bool}, 
  {0, 0, "user32"  , "IsHungAppWindow", {pointer}, bool}, 
  {0, 0, "user32"  , "IsIconic", {pointer}, bool}, 
  {0, 0, "user32"  , "IsMenu", {pointer}, bool}, 
  {0, 0, "user32"  , "IsRectEmpty", {long_pointer}, bool}, 
  {0, 0, "user32"  , "IsTouchWindow", {pointer, pointer}, bool}, 
  {0, 0, "user32"  , "IsWindow", {pointer}, bool}, 
  {0, 0, "user32"  , "IsWindowEnabled", {pointer}, bool}, 
  {0, 0, "user32"  , "IsWindowUnicode", {pointer}, bool}, 
  {0, 0, "user32"  , "IsWindowVisible", {pointer}, bool}, 
  {0, 0, "user32"  , "IsWinEventHookInstalled", {dword}, bool}, 
  {0, 0, "user32"  , "IsZoomed", {pointer}, bool}, 
  {0, 0, "user32"  , "keybd_event", {byte, byte, dword, dword}}, 
  {0, 0, "user32"  , "KillTimer", {pointer, uint}, bool}, 
  {0, 0, "user32"  , "LoadAcceleratorsA", {pointer, pointer}, pointer}, 
  {0, 0, "user32"  , "LoadAcceleratorsW", {pointer, pointer}, pointer}, 
  {0, 0, "user32"  , "LoadBitmapA", {pointer, pointer}, pointer}, 
  {0, 0, "user32"  , "LoadBitmapW", {pointer, pointer}, pointer}, 
  {0, 0, "user32"  , "LoadCursorA", {pointer, pointer}, pointer}, 
  {0, 0, "user32"  , "LoadCursorFromFileA", {pointer}, pointer}, 
  {0, 0, "user32"  , "LoadCursorFromFileW", {pointer}, pointer}, 
  {0, 0, "user32"  , "LoadCursorW", {pointer, pointer}, pointer}, 
  {0, 0, "user32"  , "LoadIconA", {pointer, pointer}, pointer}, 
  {0, 0, "user32"  , "LoadIconW", {pointer, pointer}, pointer}, 
  {0, 0, "user32"  , "LoadImageA", {pointer, pointer, uint, int, int, uint}, pointer}, 
  {0, 0, "user32"  , "LoadImageW", {pointer, pointer, uint, int, int, uint}, pointer}, 
  {0, 0, "user32"  , "LoadKeyboardLayoutA", {pointer, uint}, pointer}, 
  {0, 0, "user32"  , "LoadKeyboardLayoutW", {pointer, uint}, pointer}, 
  {0, 0, "user32"  , "LoadMenuA", {pointer, pointer}, pointer}, 
  {0, 0, "user32"  , "LoadMenuIndirectA", {pointer}, pointer}, 
  {0, 0, "user32"  , "LoadMenuIndirectW", {pointer}, pointer}, 
  {0, 0, "user32"  , "LoadMenuW", {pointer, pointer}, pointer}, 
  {0, 0, "user32"  , "LoadStringA", {pointer, uint, pointer, int}, int}, 
  {0, 0, "user32"  , "LoadStringW", {pointer, uint, pointer, int}, int}, 
  {0, 0, "user32"  , "LockSetForegroundWindow", {uint}, bool}, 
  {0, 0, "user32"  , "LockWindowUpdate", {pointer}, bool}, 
  {0, 0, "user32"  , "LockWorkStation", {}, bool}, 
  {0, 0, "user32"  , "LookupIconIdFromDirectory", {pointer, bool}, int}, 
  {0, 0, "user32"  , "LookupIconIdFromDirectoryEx", {pointer, bool, int, int, uint}, int}, 
  {0, 0, "user32"  , "MapDialogRect", {pointer, long_pointer}, bool}, 
  {0, 0, "user32"  , "MapVirtualKeyA", {uint, uint}, uint}, 
  {0, 0, "user32"  , "MapVirtualKeyExA", {uint, uint, pointer}, uint}, 
  {0, 0, "user32"  , "MapVirtualKeyExW", {uint, uint, pointer}, uint}, 
  {0, 0, "user32"  , "MapVirtualKeyW", {uint, uint}, uint}, 
  {0, 0, "user32"  , "MapWindowPoints", {pointer, pointer, long_pointer, uint}, int}, 
  {0, 0, "user32"  , "MenuItemFromPoint", {pointer, pointer, pointer}, int}, 
  {0, 0, "user32"  , "MessageBeep", {uint}, bool}, 
  {0, 0, "user32"  , "MessageBoxA", {pointer, pointer, pointer, uint}, int}, 
  {0, 0, "user32"  , "MessageBoxExA", {pointer, pointer, pointer, uint, word}, int}, 
  {0, 0, "user32"  , "MessageBoxExW", {pointer, pointer, pointer, uint, word}, int}, 
  {0, 0, "user32"  , "MessageBoxIndirectA", {pointer}, int}, 
  {0, 0, "user32"  , "MessageBoxIndirectW", {pointer}, int}, 
  {0, 0, "user32"  , "MessageBoxW", {pointer, pointer, pointer, uint}, int}, 
  {0, 0, "user32"  , "ModifyMenuA", {pointer, uint, uint, uint, pointer}, bool}, 
  {0, 0, "user32"  , "ModifyMenuW", {pointer, uint, uint, uint, pointer}, bool}, 
  {0, 0, "user32"  , "MonitorFromPoint", {pointer, dword}, pointer}, 
  {0, 0, "user32"  , "MonitorFromRect", {long_pointer, dword}, pointer}, 
  {0, 0, "user32"  , "MonitorFromWindow", {pointer, dword}, pointer}, 
  {0, 0, "user32"  , "mouse_event", {dword, dword, dword, dword, pointer}}, 
  {0, 0, "user32"  , "MoveWindow", {pointer, int, int, int, int, bool}, bool}, 
  {0, 0, "user32"  , "MsgWaitForMultipleObjects", {dword, pointer, bool, dword, dword}, dword}, 
  {0, 0, "user32"  , "MsgWaitForMultipleObjectsEx", {dword, pointer, dword, dword, dword}, dword}, 
  {0, 0, "user32"  , "NotifyWinEvent", {dword, pointer, long, long}}, 
  {0, 0, "user32"  , "OemKeyScan", {word}, dword}, 
  {0, 0, "user32"  , "OemToCharA", {pointer, pointer}, bool}, 
  {0, 0, "user32"  , "OemToCharBuffA", {pointer, pointer, dword}, bool}, 
  {0, 0, "user32"  , "OemToCharBuffW", {pointer, pointer, dword}, bool}, 
  {0, 0, "user32"  , "OemToCharW", {pointer, pointer}, bool}, 
  {0, 0, "user32"  , "OffsetRect", {long_pointer, int, int}, bool}, 
  {0, 0, "user32"  , "OpenClipboard", {pointer}, bool}, 
  {0, 0, "user32"  , "OpenDesktopA", {pointer, dword, bool, dword}, pointer}, 
  {0, 0, "user32"  , "OpenDesktopW", {pointer, dword, bool, dword}, pointer}, 
  {0, 0, "user32"  , "OpenIcon", {pointer}, bool}, 
  {0, 0, "user32"  , "OpenInputDesktop", {dword, bool, dword}, pointer}, 
  {0, 0, "user32"  , "OpenWindowStationA", {pointer, bool, dword}, pointer}, 
  {0, 0, "user32"  , "OpenWindowStationW", {pointer, bool, dword}, pointer}, 
  {0, 0, "user32"  , "PackDDElParam", {uint, pointer, pointer}, long}, 
  {0, 0, "user32"  , "PaintDesktop", {pointer}, bool}, 
  {0, 0, "user32"  , "PeekMessageA", {long_pointer, pointer, uint, uint, uint}, bool}, 
  {0, 0, "user32"  , "PeekMessageW", {long_pointer, pointer, uint, uint, uint}, bool}, 
  {0, 0, "user32"  , "PostMessageA", {pointer, uint, unsigned_int, long}, bool}, 
  {0, 0, "user32"  , "PostMessageW", {pointer, uint, unsigned_int, long}, bool}, 
  {0, 0, "user32"  , "PostQuitMessage", {int}}, 
  {0, 0, "user32"  , "PostThreadMessageA", {dword, uint, unsigned_int, long}, bool}, 
  {0, 0, "user32"  , "PostThreadMessageW", {dword, uint, unsigned_int, long}, bool}, 
  {0, 0, "user32"  , "PrintWindow", {pointer, pointer, uint}, bool}, 
  {0, 0, "user32"  , "PtInRect", {long_pointer, pointer}, bool}, 
  {0, 0, "user32"  , "RealChildWindowFromPoint", {pointer, pointer}, pointer}, 
  {0, 0, "user32"  , "RealGetWindowClassA", {pointer, pointer, uint}, uint}, 
  {0, 0, "user32"  , "RealGetWindowClassW", {pointer, pointer, uint}, uint}, 
  {0, 0, "user32"  , "RedrawWindow", {pointer, long_pointer, pointer, uint}, bool}, 
  {0, 0, "user32"  , "RegisterClassA", {pointer}, word}, 
  {0, 0, "user32"  , "RegisterClassExA", {pointer}, word}, 
  {0, 0, "user32"  , "RegisterClassExW", {pointer}, word}, 
  {0, 0, "user32"  , "RegisterClassW", {pointer}, word}, 
  {0, 0, "user32"  , "RegisterClipboardFormatA", {pointer}, uint}, 
  {0, 0, "user32"  , "RegisterClipboardFormatW", {pointer}, uint}, 
  {0, 0, "user32"  , "RegisterDeviceNotificationA", {pointer, long_pointer, dword}, pointer}, 
  {0, 0, "user32"  , "RegisterDeviceNotificationW", {pointer, long_pointer, dword}, pointer}, 
  {0, 0, "user32"  , "RegisterHotKey", {pointer, int, uint, uint}, bool}, 
  {0, 0, "user32"  , "RegisterPowerSettingNotification", {pointer, long_pointer, dword}, pointer}, 
  {0, 0, "user32"  , "RegisterRawInputDevices", {pointer, uint, uint}, bool}, 
  {0, 0, "user32"  , "RegisterTouchWindow", {pointer, ulong}, bool}, 
  {0, 0, "user32"  , "RegisterWindowMessageA", {pointer}, uint}, 
  {0, 0, "user32"  , "RegisterWindowMessageW", {pointer}, uint}, 
  {0, 0, "user32"  , "ReleaseCapture", {}, bool}, 
  {0, 0, "user32"  , "ReleaseDC", {pointer, pointer}, int}, 
  {0, 0, "user32"  , "RemoveMenu", {pointer, uint, uint}, bool}, 
  {0, 0, "user32"  , "RemovePropA", {pointer, pointer}, pointer}, 
  {0, 0, "user32"  , "RemovePropW", {pointer, pointer}, pointer}, 
  {0, 0, "user32"  , "ReplyMessage", {long}, bool}, 
  {0, 0, "user32"  , "ReuseDDElParam", {long, uint, uint, pointer, pointer}, long}, 
  {0, 0, "user32"  , "ScreenToClient", {pointer, long_pointer}, bool}, 
  {0, 0, "user32"  , "ScrollDC", {pointer, int, int, long_pointer, long_pointer, pointer, long_pointer}, bool}, 
  {0, 0, "user32"  , "ScrollWindow", {pointer, int, int, long_pointer, long_pointer}, bool}, 
  {0, 0, "user32"  , "ScrollWindowEx", {pointer, int, int, long_pointer, long_pointer, pointer, long_pointer, uint}, int}, 
  {0, 0, "user32"  , "SendDlgItemMessageA", {pointer, int, uint, unsigned_int, long}, long}, 
  {0, 0, "user32"  , "SendDlgItemMessageW", {pointer, int, uint, unsigned_int, long}, long}, 
  {0, 0, "user32"  , "SendInput", {uint, long_pointer, int}, uint}, 
  {0, 0, "user32"  , "SendMessageA", {pointer, uint, unsigned_int, long}, long}, 
  {0, 0, "user32"  , "SendMessageCallbackA", {pointer, uint, unsigned_int, long, pointer, dword}, bool}, 
  {0, 0, "user32"  , "SendMessageCallbackW", {pointer, uint, unsigned_int, long, pointer, dword}, bool}, 
  {0, 0, "user32"  , "SendMessageTimeoutA", {pointer, uint, unsigned_int, long, uint, uint, pointer}, long}, 
  {0, 0, "user32"  , "SendMessageTimeoutW", {pointer, uint, unsigned_int, long, uint, uint, pointer}, long}, 
  {0, 0, "user32"  , "SendMessageW", {pointer, uint, unsigned_int, long}, long}, 
  {0, 0, "user32"  , "SendNotifyMessageA", {pointer, uint, unsigned_int, long}, bool}, 
  {0, 0, "user32"  , "SendNotifyMessageW", {pointer, uint, unsigned_int, long}, bool}, 
  {0, 0, "user32"  , "SetActiveWindow", {pointer}, pointer}, 
  {0, 0, "user32"  , "SetCapture", {pointer}, pointer}, 
  {0, 0, "user32"  , "SetCaretBlinkTime", {uint}, bool}, 
  {0, 0, "user32"  , "SetCaretPos", {int, int}, bool}, 
  {0, 0, "user32"  , "SetClassLongA", {pointer, int, long}, dword}, 
  {0, 0, "user32"  , "SetClassLongPtrA", {pointer, int, pointer}, pointer}, 
  {0, 0, "user32"  , "SetClassLongPtrW", {pointer, int, pointer}, pointer}, 
  {0, 0, "user32"  , "SetClassLongW", {pointer, int, long}, dword}, 
  {0, 0, "user32"  , "SetClassWord", {pointer, int, word}, word}, 
  {0, 0, "user32"  , "SetClipboardData", {uint, pointer}, pointer}, 
  {0, 0, "user32"  , "SetClipboardViewer", {pointer}, pointer}, 
  {0, 0, "user32"  , "SetCursor", {pointer}, pointer}, 
  {0, 0, "user32"  , "SetCursorPos", {int, int}, bool}, 
  {0, 0, "user32"  , "SetDebugErrorLevel", {dword}}, 
  {0, 0, "user32"  , "SetDlgItemInt", {pointer, int, uint, bool}, bool}, 
  {0, 0, "user32"  , "SetDlgItemTextA", {pointer, int, pointer}, bool}, 
  {0, 0, "user32"  , "SetDlgItemTextW", {pointer, int, pointer}, bool}, 
  {0, 0, "user32"  , "SetDoubleClickTime", {uint}, bool}, 
  {0, 0, "user32"  , "SetFocus", {pointer}, pointer}, 
  {0, 0, "user32"  , "SetForegroundWindow", {pointer}, bool}, 
  {0, 0, "user32"  , "SetKeyboardState", {pointer}, bool}, 
  {0, 0, "user32"  , "SetLayeredWindowAttributes", {pointer, dword, byte, dword}, bool}, 
  {0, 0, "user32"  , "SetMenu", {pointer, pointer}, bool}, 
  {0, 0, "user32"  , "SetMenuContextHelpId", {pointer, dword}, bool}, 
  {0, 0, "user32"  , "SetMenuDefaultItem", {pointer, uint, uint}, bool}, 
  {0, 0, "user32"  , "SetMenuInfo", {pointer, long_pointer}, bool}, 
  {0, 0, "user32"  , "SetMenuItemBitmaps", {pointer, uint, uint, pointer, pointer}, bool}, 
  {0, 0, "user32"  , "SetMenuItemInfoA", {pointer, uint, bool, long_pointer}, bool}, 
  {0, 0, "user32"  , "SetMenuItemInfoW", {pointer, uint, bool, long_pointer}, bool}, 
  {0, 0, "user32"  , "SetMessageExtraInfo", {long}, long}, 
  {0, 0, "user32"  , "SetMessageQueue", {int}, bool}, 
  {0, 0, "user32"  , "SetParent", {pointer, pointer}, pointer}, 
  {0, 0, "user32"  , "SetProcessDefaultLayout", {dword}, bool}, 
  {0, 0, "user32"  , "SetProcessWindowStation", {pointer}, bool}, 
  {0, 0, "user32"  , "SetPropA", {pointer, pointer, pointer}, bool}, 
  {0, 0, "user32"  , "SetPropW", {pointer, pointer, pointer}, bool}, 
  {0, 0, "user32"  , "SetRect", {long_pointer, int, int, int, int}, bool}, 
  {0, 0, "user32"  , "SetRectEmpty", {long_pointer}, bool}, 
  {0, 0, "user32"  , "SetScrollInfo", {pointer, int, long_pointer, bool}, int}, 
  {0, 0, "user32"  , "SetScrollPos", {pointer, int, int, bool}, int}, 
  {0, 0, "user32"  , "SetScrollRange", {pointer, int, int, int, bool}, bool}, 
  {0, 0, "user32"  , "SetSysColors", {int, pointer, pointer}, bool}, 
  {0, 0, "user32"  , "SetSystemCursor", {pointer, dword}, bool}, 
  {0, 0, "user32"  , "SetThreadDesktop", {pointer}, bool}, 
  {0, 0, "user32"  , "SetTimer", {pointer, uint, uint, pointer}, uint}, 
  {0, 0, "user32"  , "SetUserObjectInformationA", {pointer, int, pointer, dword}, bool}, 
  {0, 0, "user32"  , "SetUserObjectInformationW", {pointer, int, pointer, dword}, bool}, 
  {0, 0, "user32"  , "SetUserObjectSecurity", {pointer, pointer, pointer}, bool}, 
  {0, 0, "user32"  , "SetWindowContextHelpId", {pointer, dword}, bool}, 
  {0, 0, "user32"  , "SetWindowLongA", {pointer, int, long}, long}, 
  {0, 0, "user32"  , "SetWindowLongPtrA", {pointer, int, pointer}, pointer}, 
  {0, 0, "user32"  , "SetWindowLongPtrW", {pointer, int, pointer}, pointer}, 
  {0, 0, "user32"  , "SetWindowLongW", {pointer, int, long}, long}, 
  {0, 0, "user32"  , "SetWindowPlacement", {pointer, pointer}, bool}, 
  {0, 0, "user32"  , "SetWindowPos", {pointer, pointer, int, int, int, int, uint}, bool}, 
  {0, 0, "user32"  , "SetWindowRgn", {pointer, pointer, bool}, int}, 
  {0, 0, "user32"  , "SetWindowsHookA", {int, pointer}, pointer}, 
  {0, 0, "user32"  , "SetWindowsHookExA", {int, pointer, pointer, dword}, pointer}, 
  {0, 0, "user32"  , "SetWindowsHookExW", {int, pointer, pointer, dword}, pointer}, 
  {0, 0, "user32"  , "SetWindowsHookW", {int, pointer}, pointer}, 
  {0, 0, "user32"  , "SetWindowTextA", {pointer, pointer}, bool}, 
  {0, 0, "user32"  , "SetWindowTextW", {pointer, pointer}, bool}, 
  {0, 0, "user32"  , "SetWindowWord", {pointer, int, word}, word}, 
  {0, 0, "user32"  , "SetWinEventHook", {uint, uint, pointer, pointer, dword, dword, uint}, pointer}, 
  {0, 0, "user32"  , "ShowCaret", {pointer}, bool}, 
  {0, 0, "user32"  , "ShowCursor", {bool}, int}, 
  {0, 0, "user32"  , "ShowOwnedPopups", {pointer, bool}, bool}, 
  {0, 0, "user32"  , "ShowScrollBar", {pointer, int, bool}, bool}, 
  {0, 0, "user32"  , "ShowWindow", {pointer, int}, bool}, 
  {0, 0, "user32"  , "ShowWindowAsync", {pointer, int}, bool}, 
  {0, 0, "user32"  , "SubtractRect", {long_pointer, long_pointer, long_pointer}, bool}, 
  {0, 0, "user32"  , "SwapMouseButton", {bool}, bool}, 
  {0, 0, "user32"  , "SwitchDesktop", {pointer}, bool}, 
  {0, 0, "user32"  , "SwitchToThisWindow", {pointer, bool}}, 
  {0, 0, "user32"  , "SystemParametersInfoA", {uint, uint, pointer, uint}, bool}, 
  {0, 0, "user32"  , "SystemParametersInfoW", {uint, uint, pointer, uint}, bool}, 
  {0, 0, "user32"  , "TabbedTextOutA", {pointer, int, int, pointer, int, int, pointer, int}, long}, 
  {0, 0, "user32"  , "TabbedTextOutW", {pointer, int, int, pointer, int, int, pointer, int}, long}, 
  {0, 0, "user32"  , "TileWindows", {pointer, uint, long_pointer, uint, pointer}, word}, 
  {0, 0, "user32"  , "ToAscii", {uint, uint, pointer, pointer, uint}, int}, 
  {0, 0, "user32"  , "ToAsciiEx", {uint, uint, pointer, pointer, uint, pointer}, int}, 
  {0, 0, "user32"  , "ToUnicode", {uint, uint, pointer, pointer, int, uint}, int}, 
  {0, 0, "user32"  , "ToUnicodeEx", {uint, uint, pointer, pointer, int, uint, pointer}, int}, 
  {0, 0, "user32"  , "TrackMouseEvent", {long_pointer}, bool}, 
  {0, 0, "user32"  , "TrackPopupMenu", {pointer, uint, int, int, int, pointer, long_pointer}, bool}, 
  {0, 0, "user32"  , "TrackPopupMenuEx", {pointer, uint, int, int, pointer, long_pointer}, bool}, 
  {0, 0, "user32"  , "TranslateAcceleratorA", {pointer, pointer, long_pointer}, int}, 
  {0, 0, "user32"  , "TranslateAcceleratorW", {pointer, pointer, long_pointer}, int}, 
  {0, 0, "user32"  , "TranslateMDISysAccel", {pointer, long_pointer}, bool}, 
  {0, 0, "user32"  , "TranslateMessage", {pointer}, bool}, 
  {0, 0, "user32"  , "UnhookWindowsHook", {int, pointer}, bool}, 
  {0, 0, "user32"  , "UnhookWindowsHookEx", {pointer}, bool}, 
  {0, 0, "user32"  , "UnhookWinEvent", {pointer}, bool}, 
  {0, 0, "user32"  , "UnionRect", {long_pointer, long_pointer, long_pointer}, bool}, 
  {0, 0, "user32"  , "UnloadKeyboardLayout", {pointer}, bool}, 
  {0, 0, "user32"  , "UnpackDDElParam", {uint, long, pointer, pointer}, bool}, 
  {0, 0, "user32"  , "UnregisterClassA", {pointer, pointer}, bool}, 
  {0, 0, "user32"  , "UnregisterClassW", {pointer, pointer}, bool}, 
  {0, 0, "user32"  , "UnregisterDeviceNotification", {pointer}, bool}, 
  {0, 0, "user32"  , "UnregisterHotKey", {pointer, int}, bool}, 
  {0, 0, "user32"  , "UnregisterPowerSettingNotification", {pointer}, bool}, 
  {0, 0, "user32"  , "UnregisterTouchWindow", {pointer}, bool}, 
  {0, 0, "user32"  , "UpdateLayeredWindow", {pointer, pointer, pointer, pointer, pointer, pointer, dword, pointer, dword}, bool}, 
  {0, 0, "user32"  , "UpdateWindow", {pointer}, bool}, 
  {0, 0, "user32"  , "UserHandleGrantAccess", {pointer, pointer, bool}, bool}, 
  {0, 0, "user32"  , "ValidateRect", {pointer, long_pointer}, bool}, 
  {0, 0, "user32"  , "ValidateRgn", {pointer, pointer}, bool}, 
  {0, 0, "user32"  , "VkKeyScanA", {char}, short}, 
  {0, 0, "user32"  , "VkKeyScanExA", {char, pointer}, short}, 
  {0, 0, "user32"  , "VkKeyScanExW", {wchar, pointer}, short}, 
  {0, 0, "user32"  , "VkKeyScanW", {wchar}, short}, 
  {0, 0, "user32"  , "WaitForInputIdle", {pointer, dword}, dword}, 
  {0, 0, "user32"  , "WaitMessage", {}, bool}, 
  {0, 0, "user32"  , "WindowFromDC", {pointer}, pointer}, 
  {0, 0, "user32"  , "WindowFromPoint", {pointer}, pointer}, 
  {0, 0, "user32"  , "WinExec", {pointer, uint}, uint}, 
  {0, 0, "user32"  , "WinHelpA", {pointer, pointer, uint, dword}, bool}, 
  {0, 0, "user32"  , "WinHelpW", {pointer, pointer, uint, dword}, bool}, 
  {0, 0, "user32"  , "wvsprintfA", {pointer, pointer, pointer}, int}, 
  {0, 0, "user32"  , "wvsprintfW", {pointer, pointer, pointer}, int}, 
  {0, 0, "userenv" , "CreateEnvironmentBlock", {pointer, pointer, bool}, bool}, 
  {0, 0, "userenv" , "CreateProfile", {pointer, pointer, pointer, dword}, long}, 
  {0, 0, "userenv" , "DeleteProfileA", {pointer, pointer, pointer}, bool}, 
  {0, 0, "userenv" , "DeleteProfileW", {pointer, pointer, pointer}, bool}, 
  {0, 0, "userenv" , "DestroyEnvironmentBlock", {long_pointer}, bool}, 
  {0, 0, "userenv" , "ExpandEnvironmentStringsForUserA", {pointer, pointer, pointer, dword}, bool}, 
  {0, 0, "userenv" , "ExpandEnvironmentStringsForUserW", {pointer, pointer, pointer, dword}, bool}, 
  {0, 0, "userenv" , "GetAllUsersProfileDirectoryA", {pointer, pointer}, bool}, 
  {0, 0, "userenv" , "GetAllUsersProfileDirectoryW", {pointer, pointer}, bool}, 
  {0, 0, "userenv" , "GetDefaultUserProfileDirectoryA", {pointer, pointer}, bool}, 
  {0, 0, "userenv" , "GetDefaultUserProfileDirectoryW", {pointer, pointer}, bool}, 
  {0, 0, "userenv" , "GetProfilesDirectoryA", {pointer, pointer}, bool}, 
  {0, 0, "userenv" , "GetProfilesDirectoryW", {pointer, pointer}, bool}, 
  {0, 0, "userenv" , "GetProfileType", {pointer}, bool}, 
  {0, 0, "userenv" , "GetUserProfileDirectoryA", {pointer, pointer, pointer}, bool}, 
  {0, 0, "userenv" , "GetUserProfileDirectoryW", {pointer, pointer, pointer}, bool}, 
  {0, 0, "userenv" , "LoadUserProfileA", {pointer, long_pointer}, bool}, 
  {0, 0, "userenv" , "LoadUserProfileW", {pointer, long_pointer}, bool}, 
  {0, 0, "userenv" , "UnloadUserProfile", {pointer, pointer}, bool}, 
  {0, 0, "usp10"   , "ScriptApplyDigitSubstitution", {pointer, pointer, pointer}, long}, 
  {0, 0, "usp10"   , "ScriptApplyLogicalWidth", {pointer, int, int, pointer, pointer, pointer, pointer, pointer, pointer}, long}, 
  {0, 0, "usp10"   , "ScriptBreak", {pointer, int, pointer, pointer}, long}, 
  {0, 0, "usp10"   , "ScriptCacheGetHeight", {pointer, pointer, pointer}, long}, 
  {0, 0, "usp10"   , "ScriptCPtoX", {int, bool, int, int, pointer, pointer, pointer, pointer, pointer}, long}, 
  {0, 0, "usp10"   , "ScriptFreeCache", {pointer}, long}, 
  {0, 0, "usp10"   , "ScriptGetCMap", {pointer, pointer, pointer, int, dword, pointer}, long}, 
  {0, 0, "usp10"   , "ScriptGetFontAlternateGlyphs", {pointer, pointer, pointer, pointer, pointer, pointer, word, int, pointer, pointer}, long}, 
  {0, 0, "usp10"   , "ScriptGetFontFeatureTags", {pointer, pointer, pointer, pointer, pointer, int, pointer, pointer}, long}, 
  {0, 0, "usp10"   , "ScriptGetFontLanguageTags", {pointer, pointer, pointer, pointer, int, pointer, pointer}, long}, 
  {0, 0, "usp10"   , "ScriptGetFontProperties", {pointer, pointer, pointer}, long}, 
  {0, 0, "usp10"   , "ScriptGetFontScriptTags", {pointer, pointer, pointer, int, pointer, pointer}, long}, 
  {0, 0, "usp10"   , "ScriptGetGlyphABCWidth", {pointer, pointer, word, pointer}, long}, 
  {0, 0, "usp10"   , "ScriptGetLogicalWidths", {pointer, int, int, pointer, pointer, pointer, pointer}, long}, 
  {0, 0, "usp10"   , "ScriptGetProperties", {pointer, pointer}, long}, 
  {0, 0, "usp10"   , "ScriptIsComplex", {pointer, int, dword}, long}, 
  {0, 0, "usp10"   , "ScriptItemize", {pointer, int, int, pointer, pointer, pointer, pointer}, long}, 
  {0, 0, "usp10"   , "ScriptItemizeOpenType", {pointer, int, int, pointer, pointer, pointer, pointer, pointer}, long}, 
  {0, 0, "usp10"   , "ScriptJustify", {pointer, pointer, int, int, int, pointer}, long}, 
  {0, 0, "usp10"   , "ScriptLayout", {int, pointer, pointer, pointer}, long}, 
  {0, 0, "usp10"   , "ScriptPlace", {pointer, pointer, pointer, int, pointer, pointer, pointer, pointer, pointer}, long}, 
  {0, 0, "usp10"   , "ScriptPlaceOpenType", {pointer, pointer, pointer, pointer, pointer, pointer, pointer, int, pointer, pointer, pointer, int, pointer, pointer, int, pointer, pointer, pointer}, long}, 
  {0, 0, "usp10"   , "ScriptPositionSingleGlyph", {pointer, pointer, pointer, pointer, pointer, pointer, long, word, int, pointer, pointer, pointer}, long}, 
  {0, 0, "usp10"   , "ScriptRecordDigitSubstitution", {dword, pointer}, long}, 
  {0, 0, "usp10"   , "ScriptShape", {pointer, pointer, pointer, int, int, pointer, pointer, pointer, pointer, pointer}, long}, 
  {0, 0, "usp10"   , "ScriptShapeOpenType", {pointer, pointer, pointer, pointer, pointer, pointer, pointer, int, pointer, int, int, pointer, pointer, pointer, pointer, pointer}, long}, 
  {0, 0, "usp10"   , "ScriptString_pcOutChars", {pointer}, pointer}, 
  {0, 0, "usp10"   , "ScriptString_pLogAttr", {pointer}, pointer}, 
  {0, 0, "usp10"   , "ScriptString_pSize", {pointer}, pointer}, 
  {0, 0, "usp10"   , "ScriptStringAnalyse", {pointer, pointer, int, int, int, dword, int, pointer, pointer, pointer, pointer, pointer, pointer}, long}, 
  {0, 0, "usp10"   , "ScriptStringCPtoX", {pointer, int, bool, pointer}, long}, 
  {0, 0, "usp10"   , "ScriptStringFree", {pointer}, long}, 
  {0, 0, "usp10"   , "ScriptStringGetLogicalWidths", {pointer, pointer}, long}, 
  {0, 0, "usp10"   , "ScriptStringGetOrder", {pointer, pointer}, long}, 
  {0, 0, "usp10"   , "ScriptStringOut", {pointer, int, int, uint, pointer, int, int, bool}, long}, 
  {0, 0, "usp10"   , "ScriptStringValidate", {pointer}, long}, 
  {0, 0, "usp10"   , "ScriptStringXtoCP", {pointer, int, pointer, pointer}, long}, 
  {0, 0, "usp10"   , "ScriptSubstituteSingleGlyph", {pointer, pointer, pointer, pointer, pointer, pointer, long, word, pointer}, long}, 
  {0, 0, "usp10"   , "ScriptTextOut", {pointer, pointer, int, int, uint, pointer, pointer, pointer, int, pointer, int, pointer, pointer, pointer}, long}, 
  {0, 0, "usp10"   , "ScriptXtoCP", {int, int, int, pointer, pointer, pointer, pointer, pointer, pointer}, long}, 
  {0, 0, "uxtheme" , "CloseThemeData", {pointer}, long}, 
  {0, 0, "uxtheme" , "DrawThemeBackground", {pointer, pointer, int, int, pointer, pointer}, long}, 
  {0, 0, "uxtheme" , "DrawThemeBackgroundEx", {pointer, pointer, int, int, pointer, pointer}, long}, 
  {0, 0, "uxtheme" , "DrawThemeEdge", {pointer, pointer, int, int, pointer, uint, uint, pointer}, long}, 
  {0, 0, "uxtheme" , "DrawThemeIcon", {pointer, pointer, int, int, pointer, pointer, int}, long}, 
  {0, 0, "uxtheme" , "DrawThemeParentBackground", {pointer, pointer, pointer}, long}, 
  {0, 0, "uxtheme" , "DrawThemeText", {pointer, pointer, int, int, pointer, int, dword, dword, pointer}, long}, 
  {0, 0, "uxtheme" , "EnableThemeDialogTexture", {pointer, dword}, long}, 
  {0, 0, "uxtheme" , "EnableTheming", {bool}, long}, 
  {0, 0, "uxtheme" , "GetCurrentThemeName", {pointer, int, pointer, int, pointer, int}, long}, 
  {0, 0, "uxtheme" , "GetThemeAppProperties", {}, dword}, 
  {0, 0, "uxtheme" , "GetThemeBackgroundContentRect", {pointer, pointer, int, int, pointer, pointer}, long}, 
  {0, 0, "uxtheme" , "GetThemeBackgroundExtent", {pointer, pointer, int, int, pointer, pointer}, long}, 
  {0, 0, "uxtheme" , "GetThemeBackgroundRegion", {pointer, pointer, int, int, pointer, pointer}, long}, 
  {0, 0, "uxtheme" , "GetThemeBool", {pointer, int, int, int, pointer}, long}, 
  {0, 0, "uxtheme" , "GetThemeColor", {pointer, int, int, int, pointer}, long}, 
  {0, 0, "uxtheme" , "GetThemeDocumentationProperty", {pointer, pointer, pointer, int}, long}, 
  {0, 0, "uxtheme" , "GetThemeEnumValue", {pointer, int, int, int, pointer}, long}, 
  {0, 0, "uxtheme" , "GetThemeFilename", {pointer, int, int, int, pointer, int}, long}, 
  {0, 0, "uxtheme" , "GetThemeFont", {pointer, pointer, int, int, int, pointer}, long}, 
  {0, 0, "uxtheme" , "GetThemeInt", {pointer, int, int, int, pointer}, long}, 
  {0, 0, "uxtheme" , "GetThemeIntList", {pointer, int, int, int, pointer}, long}, 
  {0, 0, "uxtheme" , "GetThemeMargins", {pointer, pointer, int, int, int, pointer, pointer}, long}, 
  {0, 0, "uxtheme" , "GetThemeMetric", {pointer, pointer, int, int, int, pointer}, long}, 
  {0, 0, "uxtheme" , "GetThemePartSize", {pointer, pointer, int, int, pointer, pointer, pointer}, long}, 
  {0, 0, "uxtheme" , "GetThemePosition", {pointer, int, int, int, pointer}, long}, 
  {0, 0, "uxtheme" , "GetThemePropertyOrigin", {pointer, int, int, int, pointer}, long}, 
  {0, 0, "uxtheme" , "GetThemeRect", {pointer, int, int, int, pointer}, long}, 
  {0, 0, "uxtheme" , "GetThemeString", {pointer, int, int, int, pointer, int}, long}, 
  {0, 0, "uxtheme" , "GetThemeSysBool", {pointer, int}, bool}, 
  {0, 0, "uxtheme" , "GetThemeSysColor", {pointer, int}, dword}, 
  {0, 0, "uxtheme" , "GetThemeSysColorBrush", {pointer, int}, pointer}, 
  {0, 0, "uxtheme" , "GetThemeSysFont", {pointer, int, pointer}, long}, 
  {0, 0, "uxtheme" , "GetThemeSysInt", {pointer, int, pointer}, long}, 
  {0, 0, "uxtheme" , "GetThemeSysSize", {pointer, int}, int}, 
  {0, 0, "uxtheme" , "GetThemeSysString", {pointer, int, pointer, int}, long}, 
  {0, 0, "uxtheme" , "GetThemeTextExtent", {pointer, pointer, int, int, pointer, int, dword, pointer, pointer}, long}, 
  {0, 0, "uxtheme" , "GetThemeTextMetrics", {pointer, pointer, int, int, pointer}, long}, 
  {0, 0, "uxtheme" , "GetWindowTheme", {pointer}, pointer}, 
  {0, 0, "uxtheme" , "HitTestThemeBackground", {pointer, pointer, int, int, dword, pointer, pointer, pointer, pointer}, long}, 
  {0, 0, "uxtheme" , "IsAppThemed", {}, bool}, 
  {0, 0, "uxtheme" , "IsThemeActive", {}, bool}, 
  {0, 0, "uxtheme" , "IsThemeBackgroundPartiallyTransparent", {pointer, int, int}, bool}, 
  {0, 0, "uxtheme" , "IsThemeDialogTextureEnabled", {pointer}, bool}, 
  {0, 0, "uxtheme" , "IsThemePartDefined", {pointer, int, int}, bool}, 
  {0, 0, "uxtheme" , "OpenThemeData", {pointer, pointer}, pointer}, 
  {0, 0, "uxtheme" , "SetThemeAppProperties", {dword}}, 
  {0, 0, "uxtheme" , "SetWindowTheme", {pointer, pointer, pointer}, long}, 
  {0, 0, "version" , "GetFileVersionInfoA", {pointer, dword, dword, pointer}, bool}, 
  {0, 0, "version" , "GetFileVersionInfoSizeA", {pointer, pointer}, dword}, 
  {0, 0, "version" , "GetFileVersionInfoSizeW", {pointer, pointer}, dword}, 
  {0, 0, "version" , "GetFileVersionInfoW", {pointer, dword, dword, pointer}, bool}, 
  {0, 0, "version" , "VerFindFileA", {dword, pointer, pointer, pointer, pointer, pointer, pointer, pointer}, dword}, 
  {0, 0, "version" , "VerFindFileW", {dword, pointer, pointer, pointer, pointer, pointer, pointer, pointer}, dword}, 
  {0, 0, "version" , "VerInstallFileA", {dword, pointer, pointer, pointer, pointer, pointer, pointer, pointer}, dword}, 
  {0, 0, "version" , "VerInstallFileW", {dword, pointer, pointer, pointer, pointer, pointer, pointer, pointer}, dword}, 
  {0, 0, "version" , "VerLanguageNameA", {dword, pointer, dword}, dword}, 
  {0, 0, "version" , "VerLanguageNameW", {dword, pointer, dword}, dword}, 
  {0, 0, "version" , "VerQueryValueA", {pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "version" , "VerQueryValueW", {pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "winhttp" , "WinHttpAddRequestHeaders", {pointer, pointer, dword, dword}, bool}, 
  {0, 0, "winhttp" , "WinHttpCheckPlatform", {}, bool}, 
  {0, 0, "winhttp" , "WinHttpCloseHandle", {pointer}, bool}, 
  {0, 0, "winhttp" , "WinHttpConnect", {pointer, pointer, word, dword}, pointer}, 
  {0, 0, "winhttp" , "WinHttpCrackUrl", {pointer, dword, dword, pointer}, bool}, 
  {0, 0, "winhttp" , "WinHttpCreateUrl", {pointer, dword, pointer, pointer}, bool}, 
  {0, 0, "winhttp" , "WinHttpDetectAutoProxyConfigUrl", {dword, pointer}, bool}, 
  {0, 0, "winhttp" , "WinHttpGetDefaultProxyConfiguration", {pointer}, bool}, 
  {0, 0, "winhttp" , "WinHttpGetIEProxyConfigForCurrentUser", {pointer}, bool}, 
  {0, 0, "winhttp" , "WinHttpGetProxyForUrl", {pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "winhttp" , "WinHttpOpen", {pointer, dword, pointer, pointer, dword}, pointer}, 
  {0, 0, "winhttp" , "WinHttpOpenRequest", {pointer, pointer, pointer, pointer, pointer, pointer, dword}, pointer}, 
  {0, 0, "winhttp" , "WinHttpQueryAuthSchemes", {pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "winhttp" , "WinHttpQueryDataAvailable", {pointer, pointer}, bool}, 
  {0, 0, "winhttp" , "WinHttpQueryHeaders", {pointer, dword, pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "winhttp" , "WinHttpQueryOption", {pointer, dword, pointer, pointer}, bool}, 
  {0, 0, "winhttp" , "WinHttpReadData", {pointer, pointer, dword, pointer}, bool}, 
  {0, 0, "winhttp" , "WinHttpReceiveResponse", {pointer, pointer}, bool}, 
  {0, 0, "winhttp" , "WinHttpSendRequest", {pointer, pointer, dword, pointer, dword, dword, pointer}, bool}, 
  {0, 0, "winhttp" , "WinHttpSetCredentials", {pointer, dword, dword, pointer, pointer, pointer}, bool}, 
  {0, 0, "winhttp" , "WinHttpSetDefaultProxyConfiguration", {pointer}, bool}, 
  {0, 0, "winhttp" , "WinHttpSetOption", {pointer, dword, pointer, dword}, bool}, 
  {0, 0, "winhttp" , "WinHttpSetStatusCallback", {pointer, pointer, dword, pointer}, pointer}, 
  {0, 0, "winhttp" , "WinHttpSetTimeouts", {pointer, int, int, int, int}, bool}, 
  {0, 0, "winhttp" , "WinHttpTimeFromSystemTime", {pointer, pointer}, bool}, 
  {0, 0, "winhttp" , "WinHttpTimeToSystemTime", {pointer, pointer}, bool}, 
  {0, 0, "winhttp" , "WinHttpWriteData", {pointer, pointer, dword, pointer}, bool}, 
-- Following WinHTTP functions are not exported in Windows 7 Enterprise
-- Present only in latest Windows versions (8, 8.1 and 10)
  {0, 0, "winhttp" , "WinHttpIsHostInProxyBypassList", {pointer, pointer, int, word, bool}, dword}, 
  {0, 0, "winhttp" , "WinHttpQueryAuthParams", {pointer, dword, pointer}, bool}, 
  {0, 0, "winhttp" , "WinHttpCreateProxyResolver", {pointer, pointer}, dword}, 
  {0, 0, "winhttp" , "WinHttpGetProxyForUrlEx", {pointer, pointer, pointer, pointer}, dword}, 
  {0, 0, "winhttp" , "WinHttpGetProxyResult", {pointer, pointer}, dword}, 
  {0, 0, "winhttp" , "WinHttpFreeProxyResult", {pointer}}, 
  {0, 0, "winhttp" , "WinHttpResetAutoProxy", {pointer, dword}, dword}, 
  {0, 0, "winhttp" , "WinHttpWebSocketCompleteUpgrade", {pointer, pointer}, pointer}, 
  {0, 0, "winhttp" , "WinHttpWebSocketSend", {pointer, int, pointer, dword}, dword}, 
  {0, 0, "winhttp" , "WinHttpWebSocketReceive", {pointer, pointer, dword, pointer, pointer}, dword}, 
  {0, 0, "winhttp" , "WinHttpWebSocketShutdown", {pointer, ushort, pointer, dword}, dword}, 
  {0, 0, "winhttp" , "WinHttpWebSocketClose", {pointer, ushort, pointer, dword}, dword}, 
  {0, 0, "winhttp" , "WinHttpWebSocketQueryCloseStatus", {pointer, pointer, pointer, dword, pointer}, dword}, 
  {0, 0, "wininet" , "CommitUrlCacheEntryA", {pointer, pointer, pointer, pointer, dword, pointer, dword, pointer, dword}, bool}, 
  {0, 0, "wininet" , "CommitUrlCacheEntryW", {pointer, pointer, pointer, pointer, dword, pointer, dword, pointer, dword}, bool}, 
  {0, 0, "wininet" , "CreateUrlCacheEntryA", {pointer, dword, pointer, pointer, dword}, bool}, 
  {0, 0, "wininet" , "CreateUrlCacheEntryW", {pointer, dword, pointer, pointer, dword}, bool}, 
  {0, 0, "wininet" , "CreateUrlCacheGroup", {dword, long_pointer}, pointer}, 
  {0, 0, "wininet" , "DeleteUrlCacheEntryA", {pointer}, bool}, 
  {0, 0, "wininet" , "DeleteUrlCacheEntryW", {pointer}, bool}, 
  {0, 0, "wininet" , "DeleteUrlCacheGroup", {pointer, dword, long_pointer}, bool}, 
  {0, 0, "wininet" , "FindCloseUrlCache", {pointer}, bool}, 
  {0, 0, "wininet" , "FindFirstUrlCacheEntryA", {pointer, long_pointer, pointer}, pointer}, 
  {0, 0, "wininet" , "FindFirstUrlCacheEntryW", {pointer, long_pointer, pointer}, pointer}, 
  {0, 0, "wininet" , "FindFirstUrlCacheGroup", {dword, dword, long_pointer, dword, pointer, long_pointer}, pointer}, 
  {0, 0, "wininet" , "FindNextUrlCacheEntryA", {pointer, long_pointer, pointer}, bool}, 
  {0, 0, "wininet" , "FindNextUrlCacheEntryW", {pointer, long_pointer, pointer}, bool}, 
  {0, 0, "wininet" , "FindNextUrlCacheGroup", {pointer, pointer, long_pointer}, bool}, 
  {0, 0, "wininet" , "FtpCommandA", {pointer, bool, dword, pointer, pointer, pointer}, bool}, 
  {0, 0, "wininet" , "FtpCommandW", {pointer, bool, dword, pointer, pointer, pointer}, bool}, 
  {0, 0, "wininet" , "FtpCreateDirectoryA", {pointer, pointer}, bool}, 
  {0, 0, "wininet" , "FtpCreateDirectoryW", {pointer, pointer}, bool}, 
  {0, 0, "wininet" , "FtpDeleteFileA", {pointer, pointer}, bool}, 
  {0, 0, "wininet" , "FtpDeleteFileW", {pointer, pointer}, bool}, 
  {0, 0, "wininet" , "FtpFindFirstFileA", {pointer, pointer, long_pointer, dword, dword}, pointer}, 
  {0, 0, "wininet" , "FtpFindFirstFileW", {pointer, pointer, long_pointer, dword, dword}, pointer}, 
  {0, 0, "wininet" , "FtpGetCurrentDirectoryA", {pointer, pointer, pointer}, bool}, 
  {0, 0, "wininet" , "FtpGetCurrentDirectoryW", {pointer, pointer, pointer}, bool}, 
  {0, 0, "wininet" , "FtpGetFileA", {pointer, pointer, pointer, bool, dword, dword, dword}, bool}, 
  {0, 0, "wininet" , "FtpGetFileSize", {pointer, pointer}, dword}, 
  {0, 0, "wininet" , "FtpGetFileW", {pointer, pointer, pointer, bool, dword, dword, dword}, bool}, 
  {0, 0, "wininet" , "FtpOpenFileA", {pointer, pointer, dword, dword, dword}, pointer}, 
  {0, 0, "wininet" , "FtpOpenFileW", {pointer, pointer, dword, dword, dword}, pointer}, 
  {0, 0, "wininet" , "FtpPutFileA", {pointer, pointer, pointer, dword, dword}, bool}, 
  {0, 0, "wininet" , "FtpPutFileW", {pointer, pointer, pointer, dword, dword}, bool}, 
  {0, 0, "wininet" , "FtpRemoveDirectoryA", {pointer, pointer}, bool}, 
  {0, 0, "wininet" , "FtpRemoveDirectoryW", {pointer, pointer}, bool}, 
  {0, 0, "wininet" , "FtpRenameFileA", {pointer, pointer, pointer}, bool}, 
  {0, 0, "wininet" , "FtpRenameFileW", {pointer, pointer, pointer}, bool}, 
  {0, 0, "wininet" , "FtpSetCurrentDirectoryA", {pointer, pointer}, bool}, 
  {0, 0, "wininet" , "FtpSetCurrentDirectoryW", {pointer, pointer}, bool}, 
  {0, 0, "wininet" , "GetUrlCacheEntryInfoA", {pointer, long_pointer, pointer}, bool}, 
  {0, 0, "wininet" , "GetUrlCacheEntryInfoW", {pointer, long_pointer, pointer}, bool}, 
  {0, 0, "wininet" , "GetUrlCacheGroupAttributeA", {pointer, dword, dword, long_pointer, pointer, long_pointer}, bool}, 
  {0, 0, "wininet" , "GetUrlCacheGroupAttributeW", {pointer, dword, dword, long_pointer, pointer, long_pointer}, bool}, 
  {0, 0, "wininet" , "GopherCreateLocatorA", {pointer, pointer, pointer, pointer, dword, pointer, pointer}, bool}, 
  {0, 0, "wininet" , "GopherCreateLocatorW", {pointer, pointer, pointer, pointer, dword, pointer, pointer}, bool}, 
  {0, 0, "wininet" , "GopherFindFirstFileA", {pointer, pointer, pointer, long_pointer, dword, dword}, pointer}, 
  {0, 0, "wininet" , "GopherFindFirstFileW", {pointer, pointer, pointer, long_pointer, dword, dword}, pointer}, 
  {0, 0, "wininet" , "GopherGetAttributeA", {pointer, pointer, pointer, pointer, dword, pointer, pointer, dword}, bool}, 
  {0, 0, "wininet" , "GopherGetAttributeW", {pointer, pointer, pointer, pointer, dword, pointer, pointer, dword}, bool}, 
  {0, 0, "wininet" , "GopherGetLocatorTypeA", {pointer, pointer}, bool}, 
  {0, 0, "wininet" , "GopherGetLocatorTypeW", {pointer, pointer}, bool}, 
  {0, 0, "wininet" , "GopherOpenFileA", {pointer, pointer, pointer, dword, dword}, pointer}, 
  {0, 0, "wininet" , "GopherOpenFileW", {pointer, pointer, pointer, dword, dword}, pointer}, 
  {0, 0, "wininet" , "HttpAddRequestHeadersA", {pointer, pointer, dword, dword}, bool}, 
  {0, 0, "wininet" , "HttpAddRequestHeadersW", {pointer, pointer, dword, dword}, bool}, 
  {0, 0, "wininet" , "HttpEndRequestA", {pointer, long_pointer, dword, dword}, bool}, 
  {0, 0, "wininet" , "HttpEndRequestW", {pointer, long_pointer, dword, dword}, bool}, 
  {0, 0, "wininet" , "HttpOpenRequestA", {pointer, pointer, pointer, pointer, pointer, pointer, dword, dword}, pointer}, 
  {0, 0, "wininet" , "HttpOpenRequestW", {pointer, pointer, pointer, pointer, pointer, long_pointer, dword, dword}, pointer}, 
  {0, 0, "wininet" , "HttpQueryInfoA", {pointer, dword, pointer, pointer, pointer}, bool}, 
  {0, 0, "wininet" , "HttpQueryInfoW", {pointer, dword, pointer, pointer, pointer}, bool}, 
  {0, 0, "wininet" , "HttpSendRequestA", {pointer, pointer, dword, pointer, dword}, bool}, 
  {0, 0, "wininet" , "HttpSendRequestExA", {pointer, long_pointer, long_pointer, dword, dword}, bool}, 
  {0, 0, "wininet" , "HttpSendRequestExW", {pointer, long_pointer, long_pointer, dword, dword}, bool}, 
  {0, 0, "wininet" , "HttpSendRequestW", {pointer, pointer, dword, pointer, dword}, bool}, 
  {0, 0, "wininet" , "InternetAttemptConnect", {dword}, dword}, 
  {0, 0, "wininet" , "InternetAutodial", {dword, dword}, bool}, 
  {0, 0, "wininet" , "InternetAutodialHangup", {dword}, bool}, 
  {0, 0, "wininet" , "InternetCanonicalizeUrlA", {pointer, pointer, pointer, dword}, bool}, 
  {0, 0, "wininet" , "InternetCanonicalizeUrlW", {pointer, pointer, pointer, dword}, bool}, 
  {0, 0, "wininet" , "InternetCheckConnectionA", {pointer, dword, dword}, bool}, 
  {0, 0, "wininet" , "InternetCheckConnectionW", {pointer, dword, dword}, bool}, 
  {0, 0, "wininet" , "InternetCloseHandle", {pointer}, bool}, 
  {0, 0, "wininet" , "InternetCombineUrlA", {pointer, pointer, pointer, pointer, dword}, bool}, 
  {0, 0, "wininet" , "InternetCombineUrlW", {pointer, pointer, pointer, pointer, dword}, bool}, 
  {0, 0, "wininet" , "InternetConfirmZoneCrossing", {pointer, pointer, pointer, bool}, dword}, 
  {0, 0, "wininet" , "InternetConnectA", {pointer, pointer, pointer, pointer, pointer, dword, dword, dword}, pointer}, 
  {0, 0, "wininet" , "InternetConnectW", {pointer, pointer, pointer, pointer, pointer, dword, dword, dword}, pointer}, 
  {0, 0, "wininet" , "InternetCrackUrlA", {pointer, dword, dword, long_pointer}, bool}, 
  {0, 0, "wininet" , "InternetCrackUrlW", {pointer, dword, dword, long_pointer}, bool}, 
  {0, 0, "wininet" , "InternetCreateUrlA", {long_pointer, dword, pointer, pointer}, bool}, 
  {0, 0, "wininet" , "InternetCreateUrlW", {long_pointer, dword, pointer, pointer}, bool}, 
  {0, 0, "wininet" , "InternetDebugGetLocalTime", {pointer, pointer}, bool}, 
  {0, 0, "wininet" , "InternetDial", {pointer, long_pointer, dword, pointer, dword}, dword}, 
  {0, 0, "wininet" , "InternetErrorDlg", {pointer, pointer, dword, dword, pointer}, dword}, 
  {0, 0, "wininet" , "InternetFindNextFileA", {pointer, pointer}, bool}, 
  {0, 0, "wininet" , "InternetFindNextFileW", {pointer, pointer}, bool}, 
  {0, 0, "wininet" , "InternetGetConnectedState", {pointer, dword}, bool}, 
  {0, 0, "wininet" , "InternetGetCookieA", {pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "wininet" , "InternetGetCookieW", {pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "wininet" , "InternetGetLastResponseInfoA", {pointer, pointer, pointer}, bool}, 
  {0, 0, "wininet" , "InternetGetLastResponseInfoW", {pointer, pointer, pointer}, bool}, 
  {0, 0, "wininet" , "InternetGoOnline", {long_pointer, pointer, dword}, bool}, 
  {0, 0, "wininet" , "InternetHangUp", {dword, dword}, dword}, 
  {0, 0, "wininet" , "InternetOpenA", {pointer, dword, pointer, pointer, dword}, pointer}, 
  {0, 0, "wininet" , "InternetOpenUrlA", {pointer, pointer, pointer, dword, dword, dword}, pointer}, 
  {0, 0, "wininet" , "InternetOpenUrlW", {pointer, pointer, pointer, dword, dword, dword}, pointer}, 
  {0, 0, "wininet" , "InternetOpenW", {pointer, dword, pointer, pointer, dword}, pointer}, 
  {0, 0, "wininet" , "InternetQueryDataAvailable", {pointer, pointer, dword, dword}, bool}, 
  {0, 0, "wininet" , "InternetQueryOptionA", {pointer, dword, pointer, pointer}, bool}, 
  {0, 0, "wininet" , "InternetQueryOptionW", {pointer, dword, pointer, pointer}, bool}, 
  {0, 0, "wininet" , "InternetReadFile", {pointer, pointer, dword, pointer}, bool}, 
  {0, 0, "wininet" , "InternetReadFileExA", {pointer, long_pointer, dword, pointer}, bool}, 
  {0, 0, "wininet" , "InternetReadFileExW", {pointer, long_pointer, dword, pointer}, bool}, 
  {0, 0, "wininet" , "InternetSetCookieA", {pointer, pointer, pointer}, bool}, 
  {0, 0, "wininet" , "InternetSetCookieW", {pointer, pointer, pointer}, bool}, 
  {0, 0, "wininet" , "InternetSetDialState", {long_pointer, dword, dword}, bool}, 
  {0, 0, "wininet" , "InternetSetFilePointer", {pointer, long, pointer, dword, dword}, dword}, 
  {0, 0, "wininet" , "InternetSetOptionA", {pointer, dword, pointer, dword}, bool}, 
  {0, 0, "wininet" , "InternetSetOptionExA", {pointer, dword, pointer, dword, dword}, bool}, 
  {0, 0, "wininet" , "InternetSetOptionExW", {pointer, dword, pointer, dword, dword}, bool}, 
  {0, 0, "wininet" , "InternetSetOptionW", {pointer, dword, pointer, dword}, bool}, 
  {0, 0, "wininet" , "InternetSetStatusCallback", {pointer, pointer}, pointer}, 
  {0, 0, "wininet" , "InternetTimeFromSystemTime", {pointer, dword, pointer, dword}, bool}, 
  {0, 0, "wininet" , "InternetTimeToSystemTime", {pointer, pointer, dword}, bool}, 
  {0, 0, "wininet" , "InternetWriteFile", {pointer, pointer, dword, pointer}, bool}, 
  {0, 0, "wininet" , "ReadUrlCacheEntryStream", {pointer, dword, pointer, pointer, dword}, bool}, 
  {0, 0, "wininet" , "RetrieveUrlCacheEntryFileA", {pointer, long_pointer, pointer, dword}, bool}, 
  {0, 0, "wininet" , "RetrieveUrlCacheEntryFileW", {pointer, long_pointer, pointer, dword}, bool}, 
  {0, 0, "wininet" , "RetrieveUrlCacheEntryStreamA", {pointer, long_pointer, pointer, bool, dword}, pointer}, 
  {0, 0, "wininet" , "RetrieveUrlCacheEntryStreamW", {pointer, long_pointer, pointer, bool, dword}, pointer}, 
  {0, 0, "wininet" , "SetUrlCacheEntryInfoA", {pointer, long_pointer, dword}, bool}, 
  {0, 0, "wininet" , "SetUrlCacheEntryInfoW", {pointer, long_pointer, dword}, bool}, 
  {0, 0, "wininet" , "SetUrlCacheGroupAttributeA", {pointer, dword, dword, long_pointer, long_pointer}, bool}, 
  {0, 0, "wininet" , "SetUrlCacheGroupAttributeW", {pointer, dword, dword, long_pointer, long_pointer}, bool}, 
  {0, 0, "wininet" , "UnlockUrlCacheEntryFile", {pointer, dword}, bool}, 
  {0, 0, "wininet" , "UnlockUrlCacheEntryStream", {pointer, dword}, bool}, 
  {0, 0, "winmm"   , "auxGetDevCapsA", {uint, long_pointer, uint}, uint}, 
  {0, 0, "winmm"   , "auxGetDevCapsW", {uint, long_pointer, uint}, uint}, 
  {0, 0, "winmm"   , "auxGetNumDevs", {}, uint}, 
  {0, 0, "winmm"   , "auxGetVolume", {uint, pointer}, uint}, 
  {0, 0, "winmm"   , "auxOutMessage", {uint, uint, dword, dword}, uint}, 
  {0, 0, "winmm"   , "auxSetVolume", {uint, dword}, uint}, 
  {0, 0, "winmm"   , "CloseDriver", {pointer, long, long}, long}, 
  {0, 0, "winmm"   , "DefDriverProc", {dword, pointer, uint, long, long}, long}, 
  {0, 0, "winmm"   , "DrvGetModuleHandle", {pointer}, pointer}, 
  {0, 0, "winmm"   , "GetDriverModuleHandle", {pointer}, pointer}, 
  {0, 0, "winmm"   , "joyGetDevCapsA", {uint, long_pointer, uint}, uint}, 
  {0, 0, "winmm"   , "joyGetDevCapsW", {uint, long_pointer, uint}, uint}, 
  {0, 0, "winmm"   , "joyGetNumDevs", {}, uint}, 
  {0, 0, "winmm"   , "joyGetPos", {uint, long_pointer}, uint}, 
  {0, 0, "winmm"   , "joyGetPosEx", {uint, long_pointer}, uint}, 
  {0, 0, "winmm"   , "joyGetThreshold", {uint, long_pointer}, uint}, 
  {0, 0, "winmm"   , "joyReleaseCapture", {uint}, uint}, 
  {0, 0, "winmm"   , "joySetCapture", {pointer, uint, uint, bool}, uint}, 
  {0, 0, "winmm"   , "joySetThreshold", {uint, uint}, uint}, 
  {0, 0, "winmm"   , "mciGetCreatorTask", {uint}, pointer}, 
  {0, 0, "winmm"   , "mciGetDeviceIDA", {pointer}, uint}, 
  {0, 0, "winmm"   , "mciGetDeviceIDFromElementIDA", {dword, pointer}, uint}, 
  {0, 0, "winmm"   , "mciGetDeviceIDFromElementIDW", {dword, pointer}, uint}, 
  {0, 0, "winmm"   , "mciGetDeviceIDW", {pointer}, uint}, 
  {0, 0, "winmm"   , "mciGetErrorStringA", {dword, pointer, uint}, bool}, 
  {0, 0, "winmm"   , "mciGetErrorStringW", {dword, pointer, uint}, bool}, 
  {0, 0, "winmm"   , "mciGetYieldProc", {uint, pointer}, pointer}, 
  {0, 0, "winmm"   , "mciSendCommandA", {uint, uint, dword, dword}, dword}, 
  {0, 0, "winmm"   , "mciSendCommandW", {uint, uint, dword, dword}, dword}, 
  {0, 0, "winmm"   , "mciSendStringA", {pointer, pointer, uint, pointer}, dword}, 
  {0, 0, "winmm"   , "mciSendStringW", {pointer, pointer, uint, pointer}, dword}, 
  {0, 0, "winmm"   , "mciSetYieldProc", {uint, pointer, dword}, bool}, 
  {0, 0, "winmm"   , "midiConnect", {pointer, pointer, pointer}, uint}, 
  {0, 0, "winmm"   , "midiDisconnect", {pointer, pointer, pointer}, uint}, 
  {0, 0, "winmm"   , "midiInAddBuffer", {pointer, long_pointer, uint}, uint}, 
  {0, 0, "winmm"   , "midiInClose", {pointer}, uint}, 
  {0, 0, "winmm"   , "midiInGetDevCapsA", {uint, long_pointer, uint}, uint}, 
  {0, 0, "winmm"   , "midiInGetDevCapsW", {uint, long_pointer, uint}, uint}, 
  {0, 0, "winmm"   , "midiInGetErrorTextA", {uint, pointer, uint}, uint}, 
  {0, 0, "winmm"   , "midiInGetErrorTextW", {uint, pointer, uint}, uint}, 
  {0, 0, "winmm"   , "midiInGetID", {pointer, long_pointer}, uint}, 
  {0, 0, "winmm"   , "midiInGetNumDevs", {}, uint}, 
  {0, 0, "winmm"   , "midiInMessage", {pointer, uint, dword, dword}, uint}, 
  {0, 0, "winmm"   , "midiInOpen", {long_pointer, uint, dword, dword, dword}, uint}, 
  {0, 0, "winmm"   , "midiInPrepareHeader", {pointer, long_pointer, uint}, uint}, 
  {0, 0, "winmm"   , "midiInReset", {pointer}, uint}, 
  {0, 0, "winmm"   , "midiInStart", {pointer}, uint}, 
  {0, 0, "winmm"   , "midiInStop", {pointer}, uint}, 
  {0, 0, "winmm"   , "midiInUnprepareHeader", {pointer, long_pointer, uint}, uint}, 
  {0, 0, "winmm"   , "midiOutCacheDrumPatches", {pointer, uint, pointer, uint}, uint}, 
  {0, 0, "winmm"   , "midiOutCachePatches", {pointer, uint, pointer, uint}, uint}, 
  {0, 0, "winmm"   , "midiOutClose", {pointer}, uint}, 
  {0, 0, "winmm"   , "midiOutGetDevCapsA", {uint, long_pointer, uint}, uint}, 
  {0, 0, "winmm"   , "midiOutGetDevCapsW", {uint, long_pointer, uint}, uint}, 
  {0, 0, "winmm"   , "midiOutGetErrorTextA", {uint, pointer, uint}, uint}, 
  {0, 0, "winmm"   , "midiOutGetErrorTextW", {uint, pointer, uint}, uint}, 
  {0, 0, "winmm"   , "midiOutGetID", {pointer, long_pointer}, uint}, 
  {0, 0, "winmm"   , "midiOutGetNumDevs", {}, uint}, 
  {0, 0, "winmm"   , "midiOutGetVolume", {pointer, pointer}, uint}, 
  {0, 0, "winmm"   , "midiOutLongMsg", {pointer, long_pointer, uint}, uint}, 
  {0, 0, "winmm"   , "midiOutMessage", {pointer, uint, dword, dword}, uint}, 
  {0, 0, "winmm"   , "midiOutOpen", {long_pointer, uint, dword, dword, dword}, uint}, 
  {0, 0, "winmm"   , "midiOutPrepareHeader", {pointer, long_pointer, uint}, uint}, 
  {0, 0, "winmm"   , "midiOutReset", {pointer}, uint}, 
  {0, 0, "winmm"   , "midiOutSetVolume", {pointer, dword}, uint}, 
  {0, 0, "winmm"   , "midiOutShortMsg", {pointer, dword}, uint}, 
  {0, 0, "winmm"   , "midiOutUnprepareHeader", {pointer, long_pointer, uint}, uint}, 
  {0, 0, "winmm"   , "midiStreamClose", {pointer}, uint}, 
  {0, 0, "winmm"   , "midiStreamOpen", {long_pointer, long_pointer, dword, dword, dword, dword}, uint}, 
  {0, 0, "winmm"   , "midiStreamOut", {pointer, long_pointer, uint}, uint}, 
  {0, 0, "winmm"   , "midiStreamPause", {pointer}, uint}, 
  {0, 0, "winmm"   , "midiStreamPosition", {pointer, long_pointer, uint}, uint}, 
  {0, 0, "winmm"   , "midiStreamProperty", {pointer, pointer, dword}, uint}, 
  {0, 0, "winmm"   , "midiStreamRestart", {pointer}, uint}, 
  {0, 0, "winmm"   , "midiStreamStop", {pointer}, uint}, 
  {0, 0, "winmm"   , "mixerClose", {pointer}, uint}, 
  {0, 0, "winmm"   , "mixerGetControlDetailsA", {pointer, long_pointer, dword}, uint}, 
  {0, 0, "winmm"   , "mixerGetControlDetailsW", {pointer, long_pointer, dword}, uint}, 
  {0, 0, "winmm"   , "mixerGetDevCapsA", {uint, long_pointer, uint}, uint}, 
  {0, 0, "winmm"   , "mixerGetDevCapsW", {uint, long_pointer, uint}, uint}, 
  {0, 0, "winmm"   , "mixerGetID", {pointer, pointer, dword}, uint}, 
  {0, 0, "winmm"   , "mixerGetLineControlsA", {pointer, long_pointer, dword}, uint}, 
  {0, 0, "winmm"   , "mixerGetLineControlsW", {pointer, long_pointer, dword}, uint}, 
  {0, 0, "winmm"   , "mixerGetLineInfoA", {pointer, long_pointer, dword}, uint}, 
  {0, 0, "winmm"   , "mixerGetLineInfoW", {pointer, long_pointer, dword}, uint}, 
  {0, 0, "winmm"   , "mixerGetNumDevs", {}, uint}, 
  {0, 0, "winmm"   , "mixerMessage", {pointer, uint, dword, dword}, dword}, 
  {0, 0, "winmm"   , "mixerOpen", {long_pointer, uint, dword, dword, dword}, uint}, 
  {0, 0, "winmm"   , "mixerSetControlDetails", {pointer, long_pointer, dword}, uint}, 
  {0, 0, "winmm"   , "mmioAdvance", {pointer, long_pointer, uint}, uint}, 
  {0, 0, "winmm"   , "mmioAscend", {pointer, long_pointer, uint}, uint}, 
  {0, 0, "winmm"   , "mmioClose", {pointer, uint}, uint}, 
  {0, 0, "winmm"   , "mmioCreateChunk", {pointer, long_pointer, uint}, uint}, 
  {0, 0, "winmm"   , "mmioDescend", {pointer, long_pointer, pointer, uint}, uint}, 
  {0, 0, "winmm"   , "mmioFlush", {pointer, uint}, uint}, 
  {0, 0, "winmm"   , "mmioGetInfo", {pointer, long_pointer, uint}, uint}, 
  {0, 0, "winmm"   , "mmioInstallIOProcA", {dword, long_pointer, dword}, long_pointer}, 
  {0, 0, "winmm"   , "mmioInstallIOProcW", {dword, long_pointer, dword}, long_pointer}, 
  {0, 0, "winmm"   , "mmioOpenA", {pointer, long_pointer, dword}, pointer}, 
  {0, 0, "winmm"   , "mmioOpenW", {pointer, long_pointer, dword}, pointer}, 
  {0, 0, "winmm"   , "mmioRead", {pointer, pointer, long}, long}, 
  {0, 0, "winmm"   , "mmioRenameA", {pointer, pointer, long_pointer, dword}, uint}, 
  {0, 0, "winmm"   , "mmioRenameW", {pointer, pointer, long_pointer, dword}, uint}, 
  {0, 0, "winmm"   , "mmioSeek", {pointer, long, int}, long}, 
  {0, 0, "winmm"   , "mmioSendMessage", {pointer, uint, long, long}, long}, 
  {0, 0, "winmm"   , "mmioSetBuffer", {pointer, pointer, long, uint}, uint}, 
  {0, 0, "winmm"   , "mmioSetInfo", {pointer, long_pointer, uint}, uint}, 
  {0, 0, "winmm"   , "mmioStringToFOURCCA", {pointer, uint}, dword}, 
  {0, 0, "winmm"   , "mmioStringToFOURCCW", {pointer, uint}, dword}, 
  {0, 0, "winmm"   , "mmioWrite", {pointer, pointer, long}, long}, 
  {0, 0, "winmm"   , "mmsystemGetVersion", {}, uint}, 
  {0, 0, "winmm"   , "OpenDriver", {pointer, pointer, long}, pointer}, 
  {0, 0, "winmm"   , "PlaySound", {int, int, int}, int}, 
  {0, 0, "winmm"   , "PlaySoundA", {pointer, pointer, dword}, bool}, 
  {0, 0, "winmm"   , "PlaySoundW", {pointer, pointer, dword}, bool}, 
  {0, 0, "winmm"   , "SendDriverMessage", {pointer, uint, long, long}, long}, 
  {0, 0, "winmm"   , "sndPlaySoundA", {pointer, uint}, bool}, 
  {0, 0, "winmm"   , "sndPlaySoundW", {pointer, uint}, bool}, 
  {0, 0, "winmm"   , "timeBeginPeriod", {uint}, uint}, 
  {0, 0, "winmm"   , "timeEndPeriod", {uint}, uint}, 
  {0, 0, "winmm"   , "timeGetDevCaps", {long_pointer, uint}, uint}, 
  {0, 0, "winmm"   , "timeGetSystemTime", {long_pointer, uint}, uint}, 
  {0, 0, "winmm"   , "timeGetTime", {}, dword}, 
  {0, 0, "winmm"   , "timeKillEvent", {uint}, uint}, 
  {0, 0, "winmm"   , "timeSetEvent", {uint, uint, long_pointer, dword, uint}, uint}, 
  {0, 0, "winmm"   , "waveInAddBuffer", {pointer, long_pointer, uint}, uint}, 
  {0, 0, "winmm"   , "waveInClose", {pointer}, uint}, 
  {0, 0, "winmm"   , "waveInGetDevCapsA", {uint, long_pointer, uint}, uint}, 
  {0, 0, "winmm"   , "waveInGetDevCapsW", {uint, long_pointer, uint}, uint}, 
  {0, 0, "winmm"   , "waveInGetErrorTextA", {uint, pointer, uint}, uint}, 
  {0, 0, "winmm"   , "waveInGetErrorTextW", {uint, pointer, uint}, uint}, 
  {0, 0, "winmm"   , "waveInGetID", {pointer, long_pointer}, uint}, 
  {0, 0, "winmm"   , "waveInGetNumDevs", {}, uint}, 
  {0, 0, "winmm"   , "waveInGetPosition", {pointer, long_pointer, uint}, uint}, 
  {0, 0, "winmm"   , "waveInMessage", {pointer, uint, dword, dword}, uint}, 
  {0, 0, "winmm"   , "waveInOpen", {long_pointer, uint, long_pointer, dword, dword, dword}, uint}, 
  {0, 0, "winmm"   , "waveInPrepareHeader", {pointer, long_pointer, uint}, uint}, 
  {0, 0, "winmm"   , "waveInReset", {pointer}, uint}, 
  {0, 0, "winmm"   , "waveInStart", {pointer}, uint}, 
  {0, 0, "winmm"   , "waveInStop", {pointer}, uint}, 
  {0, 0, "winmm"   , "waveInUnprepareHeader", {pointer, long_pointer, uint}, uint}, 
  {0, 0, "winmm"   , "waveOutBreakLoop", {pointer}, uint}, 
  {0, 0, "winmm"   , "waveOutClose", {pointer}, uint}, 
  {0, 0, "winmm"   , "waveOutGetDevCapsA", {uint, long_pointer, uint}, uint}, 
  {0, 0, "winmm"   , "waveOutGetDevCapsW", {uint, long_pointer, uint}, uint}, 
  {0, 0, "winmm"   , "waveOutGetErrorTextA", {uint, pointer, uint}, uint}, 
  {0, 0, "winmm"   , "waveOutGetErrorTextW", {uint, pointer, uint}, uint}, 
  {0, 0, "winmm"   , "waveOutGetID", {pointer, long_pointer}, uint}, 
  {0, 0, "winmm"   , "waveOutGetNumDevs", {}, uint}, 
  {0, 0, "winmm"   , "waveOutGetPitch", {pointer, pointer}, uint}, 
  {0, 0, "winmm"   , "waveOutGetPlaybackRate", {pointer, pointer}, uint}, 
  {0, 0, "winmm"   , "waveOutGetPosition", {pointer, long_pointer, uint}, uint}, 
  {0, 0, "winmm"   , "waveOutGetVolume", {pointer, pointer}, uint}, 
  {0, 0, "winmm"   , "waveOutMessage", {pointer, uint, dword, dword}, uint}, 
  {0, 0, "winmm"   , "waveOutOpen", {long_pointer, uint, long_pointer, dword, dword, dword}, uint}, 
  {0, 0, "winmm"   , "waveOutPause", {pointer}, uint}, 
  {0, 0, "winmm"   , "waveOutPrepareHeader", {pointer, long_pointer, uint}, uint}, 
  {0, 0, "winmm"   , "waveOutReset", {pointer}, uint}, 
  {0, 0, "winmm"   , "waveOutRestart", {pointer}, uint}, 
  {0, 0, "winmm"   , "waveOutSetPitch", {pointer, dword}, uint}, 
  {0, 0, "winmm"   , "waveOutSetPlaybackRate", {pointer, dword}, uint}, 
  {0, 0, "winmm"   , "waveOutSetVolume", {pointer, dword}, uint}, 
  {0, 0, "winmm"   , "waveOutUnprepareHeader", {pointer, long_pointer, uint}, uint}, 
  {0, 0, "winmm"   , "waveOutWrite", {pointer, long_pointer, uint}, uint}, 
  {0, 0, "winspool", "AbortPrinter", {pointer}, bool}, 
  {0, 0, "winspool", "AddFormA", {pointer, dword, pointer}, bool}, 
  {0, 0, "winspool", "AddFormW", {pointer, dword, pointer}, bool}, 
  {0, 0, "winspool", "AddJobA", {pointer, dword, pointer, dword, pointer}, bool}, 
  {0, 0, "winspool", "AddJobW", {pointer, dword, pointer, dword, pointer}, bool}, 
  {0, 0, "winspool", "AddMonitorA", {pointer, dword, pointer}, bool}, 
  {0, 0, "winspool", "AddMonitorW", {pointer, dword, pointer}, bool}, 
  {0, 0, "winspool", "AddPortA", {pointer, pointer, pointer}, bool}, 
  {0, 0, "winspool", "AddPortW", {pointer, pointer, pointer}, bool}, 
  {0, 0, "winspool", "AddPrinterA", {pointer, dword, pointer}, pointer}, 
  {0, 0, "winspool", "AddPrinterConnectionA", {pointer}, bool}, 
  {0, 0, "winspool", "AddPrinterConnectionW", {pointer}, bool}, 
  {0, 0, "winspool", "AddPrinterDriverA", {pointer, dword, pointer}, bool}, 
  {0, 0, "winspool", "AddPrinterDriverW", {pointer, dword, pointer}, bool}, 
  {0, 0, "winspool", "AddPrinterW", {pointer, dword, pointer}, pointer}, 
  {0, 0, "winspool", "AddPrintProcessorA", {pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "winspool", "AddPrintProcessorW", {pointer, pointer, pointer, pointer}, bool}, 
  {0, 0, "winspool", "AddPrintProvidorA", {pointer, dword, pointer}, bool}, 
  {0, 0, "winspool", "AddPrintProvidorW", {pointer, dword, pointer}, bool}, 
  {0, 0, "winspool", "AdvancedDocumentPropertiesA", {pointer, pointer, pointer, pointer, pointer}, long}, 
  {0, 0, "winspool", "AdvancedDocumentPropertiesW", {pointer, pointer, pointer, pointer, pointer}, long}, 
  {0, 0, "winspool", "ClosePrinter", {pointer}, bool}, 
  {0, 0, "winspool", "ConfigurePortA", {pointer, pointer, pointer}, bool}, 
  {0, 0, "winspool", "ConfigurePortW", {pointer, pointer, pointer}, bool}, 
  {0, 0, "winspool", "ConnectToPrinterDlg", {pointer, dword}, pointer}, 
  {0, 0, "winspool", "DeleteFormA", {pointer, pointer}, bool}, 
  {0, 0, "winspool", "DeleteFormW", {pointer, pointer}, bool}, 
  {0, 0, "winspool", "DeleteMonitorA", {pointer, pointer, pointer}, bool}, 
  {0, 0, "winspool", "DeleteMonitorW", {pointer, pointer, pointer}, bool}, 
  {0, 0, "winspool", "DeletePortA", {pointer, pointer, pointer}, bool}, 
  {0, 0, "winspool", "DeletePortW", {pointer, pointer, pointer}, bool}, 
  {0, 0, "winspool", "DeletePrinter", {pointer}, bool}, 
  {0, 0, "winspool", "DeletePrinterConnectionA", {pointer}, bool}, 
  {0, 0, "winspool", "DeletePrinterConnectionW", {pointer}, bool}, 
  {0, 0, "winspool", "DeletePrinterDataA", {pointer, pointer}, dword}, 
  {0, 0, "winspool", "DeletePrinterDataW", {pointer, pointer}, dword}, 
  {0, 0, "winspool", "DeletePrinterDriverA", {pointer, pointer, pointer}, bool}, 
  {0, 0, "winspool", "DeletePrinterDriverW", {pointer, pointer, pointer}, bool}, 
  {0, 0, "winspool", "DeletePrintProcessorA", {pointer, pointer, pointer}, bool}, 
  {0, 0, "winspool", "DeletePrintProcessorW", {pointer, pointer, pointer}, bool}, 
  {0, 0, "winspool", "DeletePrintProvidorA", {pointer, pointer, pointer}, bool}, 
  {0, 0, "winspool", "DeletePrintProvidorW", {pointer, pointer, pointer}, bool}, 
  {0, 0, "winspool", "DocumentPropertiesA", {pointer, pointer, pointer, pointer, pointer, dword}, long}, 
  {0, 0, "winspool", "DocumentPropertiesW", {pointer, pointer, pointer, pointer, pointer, dword}, long}, 
  {0, 0, "winspool", "EndDocPrinter", {pointer}, bool}, 
  {0, 0, "winspool", "EndPagePrinter", {pointer}, bool}, 
  {0, 0, "winspool", "EnumFormsA", {pointer, dword, pointer, dword, pointer, pointer}, bool}, 
  {0, 0, "winspool", "EnumFormsW", {pointer, dword, pointer, dword, pointer, pointer}, bool}, 
  {0, 0, "winspool", "EnumJobsA", {pointer, dword, dword, dword, pointer, dword, pointer, pointer}, bool}, 
  {0, 0, "winspool", "EnumJobsW", {pointer, dword, dword, dword, pointer, dword, pointer, pointer}, bool}, 
  {0, 0, "winspool", "EnumMonitorsA", {pointer, dword, pointer, dword, pointer, pointer}, bool}, 
  {0, 0, "winspool", "EnumMonitorsW", {pointer, dword, pointer, dword, pointer, pointer}, bool}, 
  {0, 0, "winspool", "EnumPortsA", {pointer, dword, pointer, dword, pointer, pointer}, bool}, 
  {0, 0, "winspool", "EnumPortsW", {pointer, dword, pointer, dword, pointer, pointer}, bool}, 
  {0, 0, "winspool", "EnumPrinterDataA", {pointer, dword, pointer, dword, pointer, pointer, pointer, dword, pointer}, dword}, 
  {0, 0, "winspool", "EnumPrinterDataW", {pointer, dword, pointer, dword, pointer, pointer, pointer, dword, pointer}, dword}, 
  {0, 0, "winspool", "EnumPrinterDriversA", {pointer, pointer, dword, pointer, dword, pointer, pointer}, bool}, 
  {0, 0, "winspool", "EnumPrinterDriversW", {pointer, pointer, dword, pointer, dword, pointer, pointer}, bool}, 
  {0, 0, "winspool", "EnumPrintersA", {dword, pointer, dword, pointer, dword, pointer, pointer}, bool}, 
  {0, 0, "winspool", "EnumPrintersW", {dword, pointer, dword, pointer, dword, pointer, pointer}, bool}, 
  {0, 0, "winspool", "EnumPrintProcessorDatatypesA", {pointer, pointer, dword, pointer, dword, pointer, pointer}, bool}, 
  {0, 0, "winspool", "EnumPrintProcessorDatatypesW", {pointer, pointer, dword, pointer, dword, pointer, pointer}, bool}, 
  {0, 0, "winspool", "EnumPrintProcessorsA", {pointer, pointer, dword, pointer, dword, pointer, pointer}, bool}, 
  {0, 0, "winspool", "EnumPrintProcessorsW", {pointer, pointer, dword, pointer, dword, pointer, pointer}, bool}, 
  {0, 0, "winspool", "FindClosePrinterChangeNotification", {pointer}, bool}, 
  {0, 0, "winspool", "FindFirstPrinterChangeNotification", {pointer, dword, dword, pointer}, pointer}, 
  {0, 0, "winspool", "FindNextPrinterChangeNotification", {pointer, pointer, pointer, pointer}, pointer}, 
  {0, 0, "winspool", "FreePrinterNotifyInfo", {pointer}, bool}, 
  {0, 0, "winspool", "GetDefaultPrinterA", {pointer, pointer}, bool}, 
  {0, 0, "winspool", "GetDefaultPrinterW", {pointer, pointer}, bool}, 
  {0, 0, "winspool", "GetFormA", {pointer, pointer, dword, pointer, dword, pointer}, bool}, 
  {0, 0, "winspool", "GetFormW", {pointer, pointer, dword, pointer, dword, pointer}, bool}, 
  {0, 0, "winspool", "GetJobA", {pointer, dword, dword, pointer, dword, pointer}, bool}, 
  {0, 0, "winspool", "GetJobW", {pointer, dword, dword, pointer, dword, pointer}, bool}, 
  {0, 0, "winspool", "GetPrinterA", {pointer, dword, pointer, dword, pointer}, bool}, 
  {0, 0, "winspool", "GetPrinterDataA", {pointer, pointer, pointer, pointer, dword, pointer}, dword}, 
  {0, 0, "winspool", "GetPrinterDataW", {pointer, pointer, pointer, pointer, dword, pointer}, dword}, 
  {0, 0, "winspool", "GetPrinterDriverA", {pointer, pointer, dword, pointer, dword, pointer}, dword}, 
  {0, 0, "winspool", "GetPrinterDriverDirectoryA", {pointer, pointer, dword, pointer, dword, pointer}, dword}, 
  {0, 0, "winspool", "GetPrinterDriverDirectoryW", {pointer, pointer, dword, pointer, dword, pointer}, dword}, 
  {0, 0, "winspool", "GetPrinterDriverW", {pointer, pointer, dword, pointer, dword, pointer}, dword}, 
  {0, 0, "winspool", "GetPrinterW", {pointer, dword, pointer, dword, pointer}, bool}, 
  {0, 0, "winspool", "GetPrintProcessorDirectoryA", {pointer, pointer, dword, pointer, dword, pointer}, dword}, 
  {0, 0, "winspool", "GetPrintProcessorDirectoryW", {pointer, pointer, dword, pointer, dword, pointer}, dword}, 
  {0, 0, "winspool", "OpenPrinterA", {pointer, pointer, long_pointer}, bool}, 
  {0, 0, "winspool", "OpenPrinterW", {pointer, pointer, long_pointer}, bool}, 
  {0, 0, "winspool", "PrinterMessageBoxA", {pointer, dword, pointer, pointer, pointer, dword}, dword}, 
  {0, 0, "winspool", "PrinterMessageBoxW", {pointer, dword, pointer, pointer, pointer, dword}, dword}, 
  {0, 0, "winspool", "PrinterProperties", {pointer, pointer}, bool}, 
  {0, 0, "winspool", "ReadPrinter", {pointer, pointer, dword, pointer}, bool}, 
  {0, 0, "winspool", "ResetPrinterA", {pointer, long_pointer}, bool}, 
  {0, 0, "winspool", "ResetPrinterW", {pointer, long_pointer}, bool}, 
  {0, 0, "winspool", "ScheduleJob", {pointer, dword}, bool}, 
  {0, 0, "winspool", "SetFormA", {pointer, pointer, dword, pointer}, bool}, 
  {0, 0, "winspool", "SetFormW", {pointer, pointer, dword, pointer}, bool}, 
  {0, 0, "winspool", "SetJobA", {pointer, dword, dword, pointer, dword}, bool}, 
  {0, 0, "winspool", "SetJobW", {pointer, dword, dword, pointer, dword}, bool}, 
  {0, 0, "winspool", "SetPrinterA", {pointer, dword, pointer, dword}, bool}, 
  {0, 0, "winspool", "SetPrinterDataA", {pointer, pointer, dword, pointer, dword}, bool}, 
  {0, 0, "winspool", "SetPrinterDataW", {pointer, pointer, dword, pointer, dword}, bool}, 
  {0, 0, "winspool", "SetPrinterW", {pointer, dword, pointer, dword}, bool}, 
  {0, 0, "winspool", "StartDocPrinterA", {pointer, dword, pointer}, dword}, 
  {0, 0, "winspool", "StartDocPrinterW", {pointer, dword, pointer}, dword}, 
  {0, 0, "winspool", "StartPagePrinter", {pointer}, bool}, 
  {0, 0, "winspool", "WaitForPrinterChange", {pointer, dword}, dword}, 
  {0, 0, "winspool", "WritePrinter", {pointer, pointer, dword, pointer}, bool}, 
  {0, 0, "ws2_32"  , "WSAAccept", {pointer, pointer, pointer, long_pointer, dword}, pointer}, 
  {0, 0, "ws2_32"  , "WSAAddressToStringA", {long_pointer, dword, long_pointer, pointer, pointer}, int}, 
  {0, 0, "ws2_32"  , "WSAAddressToStringW", {long_pointer, dword, long_pointer, pointer, pointer}, int}, 
  {0, 0, "ws2_32"  , "WSACleanup", {}, int}, 
  {0, 0, "ws2_32"  , "WSACloseEvent", {pointer}, bool}, 
  {0, 0, "ws2_32"  , "WSAConnect", {pointer, pointer, int, long_pointer, long_pointer, long_pointer, long_pointer}, int}, 
  {0, 0, "ws2_32"  , "WSACreateEvent", {}, pointer}, 
  {0, 0, "ws2_32"  , "WSADuplicateSocketA", {pointer, dword, long_pointer}, int}, 
  {0, 0, "ws2_32"  , "WSADuplicateSocketW", {pointer, dword, long_pointer}, int}, 
  {0, 0, "ws2_32"  , "WSAEnumNameSpaceProvidersA", {pointer, long_pointer}, int}, 
  {0, 0, "ws2_32"  , "WSAEnumNameSpaceProvidersW", {pointer, long_pointer}, int}, 
  {0, 0, "ws2_32"  , "WSAEnumNetworkEvents", {pointer, pointer, long_pointer}, int}, 
  {0, 0, "ws2_32"  , "WSAEnumProtocolsA", {pointer, long_pointer, pointer}, int}, 
  {0, 0, "ws2_32"  , "WSAEnumProtocolsW", {pointer, long_pointer, pointer}, int}, 
  {0, 0, "ws2_32"  , "WSAEventSelect", {pointer, pointer, long}, int}, 
  {0, 0, "ws2_32"  , "WSAGetLastError", {}, int}, 
  {0, 0, "ws2_32"  , "WSAGetOverlappedResult", {pointer, long_pointer, pointer, bool, pointer}, bool}, 
  {0, 0, "ws2_32"  , "WSAGetQOSByName", {pointer, long_pointer, long_pointer}, bool}, 
  {0, 0, "ws2_32"  , "WSAGetServiceClassInfoA", {long_pointer, long_pointer, pointer, long_pointer}, int}, 
  {0, 0, "ws2_32"  , "WSAGetServiceClassInfoW", {long_pointer, long_pointer, pointer, long_pointer}, int}, 
  {0, 0, "ws2_32"  , "WSAGetServiceClassNameByClassIdA", {long_pointer, pointer, pointer}, int}, 
  {0, 0, "ws2_32"  , "WSAGetServiceClassNameByClassIdW", {long_pointer, pointer, pointer}, int}, 
  {0, 0, "ws2_32"  , "WSAHtonl", {pointer, unsigned_long, pointer}, int}, 
  {0, 0, "ws2_32"  , "WSAHtons", {pointer, unsigned_short, pointer}, int}, 
  {0, 0, "ws2_32"  , "WSAInstallServiceClassA", {long_pointer}, int}, 
  {0, 0, "ws2_32"  , "WSAInstallServiceClassW", {long_pointer}, int}, 
  {0, 0, "ws2_32"  , "WSAIoctl", {pointer, dword, long_pointer, dword, long_pointer, dword, pointer, long_pointer, long_pointer}, int}, 
  {0, 0, "ws2_32"  , "WSAJoinLeaf", {pointer, pointer, int, long_pointer, long_pointer, long_pointer, long_pointer, dword}, pointer}, 
  {0, 0, "ws2_32"  , "WSALookupServiceBeginA", {long_pointer, dword, pointer}, int}, 
  {0, 0, "ws2_32"  , "WSALookupServiceBeginW", {long_pointer, dword, pointer}, int}, 
  {0, 0, "ws2_32"  , "WSALookupServiceEnd", {pointer}, int}, 
  {0, 0, "ws2_32"  , "WSALookupServiceNextA", {pointer, dword, pointer, long_pointer}, int}, 
  {0, 0, "ws2_32"  , "WSALookupServiceNextW", {pointer, dword, pointer, long_pointer}, int}, 
  {0, 0, "ws2_32"  , "WSANSPIoctl", {pointer, dword, long_pointer, dword, long_pointer, dword, pointer, long_pointer}, int}, 
  {0, 0, "ws2_32"  , "WSANtohl", {pointer, unsigned_long, pointer}, int}, 
  {0, 0, "ws2_32"  , "WSANtohs", {pointer, unsigned_short, pointer}, int}, 
  {0, 0, "ws2_32"  , "WSAPoll", {pointer, int, int}, int}, 
  {0, 0, "ws2_32"  , "WSARecv", {pointer, long_pointer, dword, pointer, pointer, long_pointer, long_pointer}, int}, 
  {0, 0, "ws2_32"  , "WSARecvDisconnect", {pointer, long_pointer}, int}, 
  {0, 0, "ws2_32"  , "WSARecvFrom", {pointer, long_pointer, dword, pointer, pointer, pointer, pointer, long_pointer, long_pointer}, int}, 
  {0, 0, "ws2_32"  , "WSARemoveServiceClass", {long_pointer}, int}, 
  {0, 0, "ws2_32"  , "WSAResetEvent", {pointer}, bool}, 
  {0, 0, "ws2_32"  , "WSASend", {pointer, long_pointer, dword, pointer, dword, long_pointer, long_pointer}, int}, 
  {0, 0, "ws2_32"  , "WSASendDisconnect", {pointer, long_pointer}, int}, 
  {0, 0, "ws2_32"  , "WSASendTo", {pointer, long_pointer, dword, pointer, dword, pointer, int, long_pointer, long_pointer}, int}, 
  {0, 0, "ws2_32"  , "WSASetEvent", {pointer}, bool}, 
  {0, 0, "ws2_32"  , "WSASetServiceW", {long_pointer, pointer, dword}, int}, 
  {0, 0, "ws2_32"  , "WSASocketA", {int, int, int, long_pointer, pointer, dword}, pointer}, 
  {0, 0, "ws2_32"  , "WSASocketW", {int, int, int, long_pointer, pointer, dword}, pointer}, 
  {0, 0, "ws2_32"  , "WSAStartup", {ushort, pointer}, int}, 
  {0, 0, "ws2_32"  , "WSAStringToAddressA", {pointer, int, long_pointer, long_pointer, pointer}, int}, 
  {0, 0, "ws2_32"  , "WSAStringToAddressW", {pointer, int, long_pointer, long_pointer, pointer}, int}, 
  {0, 0, "ws2_32"  , "WSAWaitForMultipleEvents", {dword, pointer, bool, dword, bool}, dword}, 
  {0, 0, "ws2_32"  , "accept", {int, pointer, pointer}, int}, 
  {0, 0, "ws2_32"  , "bind", {int, pointer, int}, int}, 
  {0, 0, "ws2_32"  , "closesocket", {int}, int}, 
  {0, 0, "ws2_32"  , "connect", {int, pointer, int}, int}, 
  {0, 0, "ws2_32"  , "freeaddrinfo", {pointer}}, 
  {0, 0, "ws2_32"  , "getaddrinfo", {pointer, pointer, pointer, pointer}, int}, 
  {0, 0, "ws2_32"  , "gethostbyname", {pointer}, pointer}, 
  {0, 0, "ws2_32"  , "getpeername", {int, pointer, pointer}, int}, 
  {0, 0, "ws2_32"  , "getservbyname", {pointer, pointer}, pointer}, 
  {0, 0, "ws2_32"  , "getsockname", {int, pointer, pointer}, int}, 
  {0, 0, "ws2_32"  , "getsockopt", {int, int, int, pointer, pointer}, int}, 
  {0, 0, "ws2_32"  , "htonl", {int}, int}, 
  {0, 0, "ws2_32"  , "htons", {short}, short}, 
  {0, 0, "ws2_32"  , "ioctlsocket", {int, int, pointer}, int}, 
  {0, 0, "ws2_32"  , "listen", {int, int}, int}, 
  {0, 0, "ws2_32"  , "recv", {int, pointer, int, int}, int}, 
  {0, 0, "ws2_32"  , "recvfrom", {int, pointer, int, int, pointer, pointer}, int}, 
  {0, 0, "ws2_32"  , "recvmsg", {int, pointer, int}, int}, 
  {0, 0, "ws2_32"  , "select", {int, pointer, pointer, pointer, pointer}, int}, 
  {0, 0, "ws2_32"  , "send", {int, pointer, int, int}, int}, 
  {0, 0, "ws2_32"  , "sendmsg", {int, pointer, int}, int}, 
  {0, 0, "ws2_32"  , "sendto", {int, pointer, int, int, pointer, int}, int}, 
  {0, 0, "ws2_32"  , "setsockopt", {int, int, int, pointer, int}, int}, 
  {0, 0, "ws2_32"  , "shutdown", {int, int}, int}, 
  {0, 0, "ws2_32"  , "socket", {int, int, int}, int}, 
  {0, 0, "wsahelp" , "WSHAddressToString", {long_pointer, int, long_pointer, pointer, pointer}, int}, 
  {0, 0, "wsahelp" , "WSHEnumProtocols", {pointer, pointer, long_pointer, pointer}, int}, 
  {0, 0, "wsahelp" , "WSHGetBroadcastSockaddr", {pointer, pointer, pointer}, int}, 
  {0, 0, "wsahelp" , "WSHGetProviderGuid", {pointer, long_pointer}, int}, 
  {0, 0, "wsahelp" , "WSHGetSockaddrType", {pointer, dword, pointer}, int}, 
  {0, 0, "wsahelp" , "WSHGetSocketInformation", {pointer, pointer, pointer, pointer, int, int, pointer, int}, int}, 
  {0, 0, "wsahelp" , "WSHGetWildcardSockaddr", {pointer, pointer, pointer}, int}, 
  {0, 0, "wsahelp" , "WSHGetWinsockMapping", {pointer, dword}, dword}, 
  {0, 0, "wsahelp" , "WSHGetWSAProtocolInfo", {pointer, pointer, pointer}, int}, 
  {0, 0, "wsahelp" , "WSHIoctl", {pointer, pointer, pointer, pointer, dword, long_pointer, dword, long_pointer, dword, pointer, long_pointer, long_pointer, pointer}, int}, 
  {0, 0, "wsahelp" , "WSHJoinLeaf", {pointer, pointer, pointer, pointer, pointer, pointer, pointer, dword, long_pointer, long_pointer, long_pointer, long_pointer, dword}, int}, 
  {0, 0, "wsahelp" , "WSHNotify", {pointer, pointer, pointer, pointer, dword}, int}, 
  {0, 0, "wsahelp" , "WSHOpenSocket", {pointer, pointer, pointer, pointer, pointer, pointer}, int}, 
  {0, 0, "wsahelp" , "WSHOpenSocket2", {pointer, pointer, pointer, pointer, dword, pointer, pointer, pointer}, int}, 
  {0, 0, "wsahelp" , "WSHSetSocketInformation", {pointer, pointer, pointer, pointer, int, int, pointer, int}, int}, 
  {0, 0, "wsahelp" , "WSHStringToAddress", {pointer, dword, long_pointer, long_pointer, pointer}, int}, 
  {0, 0, "wsock32" , "GetAddressByNameA", {dword, long_pointer, pointer, pointer, dword, long_pointer, long_pointer, pointer, pointer, pointer}, int}, 
  {0, 0, "wsock32" , "GetAddressByNameW", {dword, long_pointer, pointer, pointer, dword, long_pointer, long_pointer, pointer, pointer, pointer}, int}, 
  {0, 0, "wsock32" , "SetServiceA", {dword, dword, dword, long_pointer, long_pointer, pointer}, int}, 
  {0, 0, "wsock32" , "SetServiceW", {dword, dword, dword, long_pointer, long_pointer, pointer}, int}, 
  {0, 0, "wtsapi32", "WTSDisconnectSession", {pointer, dword, bool}, bool}, 
  {0, 0, "wtsapi32", "WTSEnumerateSessionsA", {pointer, dword, dword, pointer, pointer}, bool}, 
  {0, 0, "wtsapi32", "WTSEnumerateSessionsW", {pointer, dword, dword, pointer, pointer}, bool}, 
  {0, 0, "wtsapi32", "WTSFreeMemory", {pointer}}, 
  {0, 0, "wtsapi32", "WTSQuerySessionInformationA", {pointer, dword, pointer, pointer, pointer}, bool}, 
  {0, 0, "wtsapi32", "WTSQuerySessionInformationW", {pointer, dword, pointer, pointer, pointer}, bool}, 
  {0, 0, "wtsapi32", "WTSQueryUserToken", {ulong, pointer}, bool}, 
  {0, 0, "wtsapi32", "WTSRegisterSessionNotification", {pointer, dword}, bool}, 
  {0, 0, "wtsapi32", "WTSUnRegisterSessionNotification", {pointer}, bool}, 
  {0, 0, "wtsapi32", "WTSWaitSystemEvent", {pointer, dword, pointer}, bool}
}

-----------------------------------------------------------------------------

global sequence windows_routines
windows_routines = {}
--<variable>
--<type>sequence</type>
--<name>windows_routines</name>
--<value>{}</value>
--<desc></desc>
--</variable>

-----------------------------------------------------------------------------

function register_w32dll(sequence name)
  integer l
  atom handle
  sequence filename

  handle = -1
  l = find_in_array(name, WINDOWS_LIBRARY_DEFINITION, {{"search_field", LIB_NAME}})
  if l = 0 then
    error_message(sprintf("There is no library named %s!", {name}), 1)
  end if
  filename = WINDOWS_LIBRARY_DEFINITION[l][LIB_FILE]
  handle = open_dll(filename)
  if handle = -1 then
    error_message(sprintf("The library %s could not be opened!\n", {filename}), 1)
  end if
  -- log_printf("Library file = %s\n", {filename})
  -- log_printf("Library handle = #%08x\n", {handle})
  return handle
end function

-----------------------------------------------------------------------------

function register_w32routine(sequence name)
  sequence s, errmsg, rtn
  integer r
  atom handle

  handle = -1
  r = find_in_array(name, WINDOWS_ROUTINE_DEFINITION, {{"search_field", FN_NAME}})
  if r = 0 then
    error_message(sprintf("There is no function named %s!", {name}), 1)
  end if
  rtn = WINDOWS_ROUTINE_DEFINITION[r]
  if not rtn[LIB_HANDLE] then
    rtn[LIB_HANDLE] = register_w32dll(rtn[FN_LIB])
    for i = 1 to length(WINDOWS_ROUTINE_DEFINITION) do
      if equal(WINDOWS_ROUTINE_DEFINITION[i][FN_LIB], name) then
        WINDOWS_ROUTINE_DEFINITION[i][LIB_HANDLE] = handle
      end if
    end for
  end if
  -- analyze_object(rtn, "rtn", {{"output", f_debug}})
  errmsg = {}
  s = {}
  if equal(rtn[FN_PARAMS], {{}}) then
    rtn[FN_PARAMS] = {}
  end if
--  log_printf("lib = %d\n", rtn[LIB_HANDLE])
  if length(rtn) < FN_RETURN then
    -- log_printf("link_c_proc(%d, \"%s\", %s)\n", {rtn[LIB_HANDLE], name, hex_sequence(convert_c_sequence(rtn[FN_PARAMS]))})
    handle = link_c_proc(rtn[LIB_HANDLE], name, convert_c_sequence(rtn[FN_PARAMS]))
  else
    -- log_printf("link_c_func(%d, \"%s\", %s, #%x)\n", {rtn[LIB_HANDLE], name, hex_sequence(convert_c_sequence(rtn[FN_PARAMS])), convert_c_type(rtn[FN_RETURN])})
    handle = link_c_func(rtn[LIB_HANDLE], name, convert_c_sequence(rtn[FN_PARAMS]), convert_c_type(rtn[FN_RETURN]))
  end if
  if handle = -1 then
    errmsg &= sprintf("\nThe routine %s using %s failed !" & 
          "\n\nIf you have recently added this routine to the" & 
          " definition list then verify that" & 
          "\nthe parameters, definition format, and DLL name are" & 
          " all correct." & 
          "\n\nCheck if the correct DLL is available on this system." & 
          "\n\nCheck if the name requires any Ex, A, or W modifier.", 
          {rtn[FN_NAME], rtn[LIB_HANDLE]})
    errmsg &= "\n\n-- This routine definition is expecting the following" & 
          " parameters :\n\n"
    if length(rtn[FN_PARAMS]) then
      s = vlookup(rtn[FN_PARAMS][1], CTYPE_NAMES, 1, 2, "?")
      errmsg &= s
      for i = 2 to length(rtn[FN_PARAMS]) do
        s = vlookup(rtn[FN_PARAMS][i], CTYPE_NAMES, 1, 2, "?")
        errmsg &= ", " & s
      end for
    else
      errmsg &= "    -- No Parameters --"
    end if
    if length(rtn < FN_RETURN) then
      errmsg &= "\n\n-- This function definition's return value is : "
      s = vlookup(rtn[FN_RETURN], CTYPE_NAMES, 1, 2, "?")
      errmsg &= s
    else
      errmsg &= " No Return Value"
    end if
    errmsg &= "\n\n"
    error_message(errmsg, 1)
  end if
--  log_printf("Function handle = #%08x\n", {handle})
  WINDOWS_ROUTINE_DEFINITION[r][FN_HANDLE] = handle
  return r
end function

--------------------------------------------------------------------------------

global function exec_w32func(integer fn_num, sequence params, sequence fn_name)
--<function>
--<name>exec_w32func</name>
--<digest></digest>
--<desc>
--</desc>
--<param>
--<type>integer</type>
--<name>fn_num</name>
--<desc></desc>
--</param>
--<param>
--<type>sequence</type>
--<name>params</name>
--<desc></desc>
--</param>
--<param>
--<type>sequence</type>
--<name>fn_name</name>
--<desc></desc>
--</param>
--<return>
--</return>
--<example>
--</example>
--<see_also>
--</see_also>
--</function>
  object result
  sequence allocations
  atom ptr
  
  if not fn_num then
    fn_num = register_w32routine(fn_name)
  end if

  allocations = {}
  for i = 1 to length(params) do
    if sequence(params[i]) then
      ptr = allocate_string(params[i])  
      allocations = append(allocations, ptr)
      params[i] = ptr
    end if
  end for

  result = c_func(WINDOWS_ROUTINE_DEFINITION[fn_num][FN_HANDLE], params)

  if length(allocations) then
    for i = 1 to length(allocations) do  
      free(allocations[i])
    end for
  end if
  return result
end function

--------------------------------------------------------------------------------

global procedure exec_w32proc(integer fn_num, sequence params, sequence fn_name)
--<procedure>
--<name>exec_w32proc</name>
--<digest></digest>
--<desc>
--</desc>
--<param>
--<type>integer</type>
--<name>fn_num</name>
--<desc></desc>
--</param>
--<param>
--<type>sequence</type>
--<name>params</name>
--<desc></desc>
--</param>
--<param>
--<type>sequence</type>
--<name>fn_name</name>
--<desc></desc>
--</param>
--<example>
--</example>
--<see_also>
--</see_also>
--</procedure>
  sequence allocations
  atom ptr
  
  if not fn_num then
    fn_num = register_w32routine(fn_name)
  end if

  allocations = {}
  for i = 1 to length(params) do
    if sequence(params[i]) then
      ptr = allocate_string(params[i])  
      allocations = append(allocations, ptr)
      params[i] = ptr
    end if
  end for

  c_proc(WINDOWS_ROUTINE_DEFINITION[fn_num][FN_HANDLE], params)

  if length(allocations) then
    for i = 1 to length(allocations) do  
      free(allocations[i])
    end for
  end if
end procedure

--------------------------------------------------------------------------------
-- example of usage

-- integer xInternetConnect
-- xInternetConnect = 0

-- global function InternetConnect(atom hInternet, sequence ServerName, 
--                   integer nServerPort, object UserName, 
--                   object Password, integer dwService, 
--                   integer dwFlags, atom dwContext)
--   atom lpszServerName, lpszUserName, lpszPassword
--   atom result

--   if sequence(ServerName) then
--     lpszServerName = allocate_string(ServerName)
--   else
--     error_msg = "InternetConnect: ServerName should be a sequence"
--     return NULL
--   end if
--   if sequence(UserName) then
--     lpszUserName = allocate_string(UserName)
--   elsif UserName = NULL then
--     lpszUserName = NULL
--   else
--     error_msg = "InternetConnect: UserName should be a sequence or NULL"
--     return NULL
--   end if
--   if sequence(Password) then
--     lpszPassword = allocate_string(Password)
--   elsif Password = NULL then
--     lpszPassword = NULL
--   else
--     error_msg = "InternetConnect: Password should be a sequence or NULL"
--     return NULL
--   end if
--   result = exec_w32func(xInternetConnect, 
--                      {hInternet, lpszServerName, nServerPort, 
--                       lpszUserName, lpszPassword, dwService, 
--                       dwFlags, dwContext}, "InternetConnectA")
--   free(lpszServerName)
--   if lpszUserName != NULL then free(lpszUserName) end if
--   if lpszPassword != NULL then free(lpszPassword) end if
--   if result = NULL then
--     error_msg = "InternetConnect failed"
--   end if
--   return result
-- end function

--------------------------------------------------------------------------------
